!=======================================================================
!     Templates for setup
!
!      Eady problem
!=======================================================================

subroutine set_parameter
 use pyOM_module   
 use fcontrol_module
 implicit none
 real*8 :: fac=1.0
 ! ----------------------------------
 !       set here main parameter
 ! ----------------------------------
 nx  = 32*fac; nz  = 20 *fac; ny  = 30*fac
 dx  = 20e3/fac
 dz  = 100.0 /fac
 dt  = 1200.0 /fac
 A_v = 10.e-4 
 K_v = 1.0e-4 
 eps2D_sor = 1e-9
 enable_hydrostatic          = .true.
 enable_cyclic_x             = .true.
 enable_quicker_advection    = .true.
 enable_quicker_mom_advection= .true.
 enable_biharmonic_friction  = .false.
 enable_biharmonic_diffusion = .false.
 Ahbi  = 5e11/fac**2
 Khbi  = Ahbi
 enable_back_state           = .true.
 enable_back_zonal_flow      = .true.
 runlen = 365*86400.
 snapint =  1.0*86400.0
end subroutine set_parameter


subroutine set_coriolis
 use pyOM_module   
 implicit none
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 coriolis_t(:) = 1e-4
end subroutine set_coriolis


subroutine initial_conditions
 use pyOM_module   
 implicit none
 integer :: i,j,k
 real*8 :: fxa,kx,ky,L_r,U_0,N_0, d ,h,f
 complex :: c1,A
 real*8,parameter :: pi=3.1415   
 
 U_0 = 0.5
 N_0 = 0.004
 
 f=coriolis_t(ny/2)
 L_r = N_0*(nz-2)*dz/(coriolis_t(ny /2)*pi)
 kx=1./L_r
 kx=1.6*coriolis_t(ny /2)/N_0/((nz-2)*dz)
 ky=pi/((ny-2)*dx)

 h = (nz-2)*dz
 d=f/N_0/(kx**2+ky**2)**0.5

 fxa=(exp(h/d)+exp(-h/d))/(exp(h/d)-exp(-h/d))
 c1= (1+0.25*(h/d)**2-h/d*fxa )
 c1=(sqrt(c1)*d/h+0.5)*U_0
 A=(U_0-c1)/U_0*h/d

 do k=1,nz
   do j=1,ny 
      do i=1,nx 
         fxa=1e-2*sin(kx*xt(i))*sin(ky*yt(j))
         fxa=fxa* abs( A/d*sinh(zt(k)/d)+cosh(zt(k)/d)/d )
         b(i,j,k,:)=b(i,j,k,:)+fxa*maskT(i,j,k)
      enddo
   enddo
 enddo

 do k=1,nz
     u0(:,:,k)=(U_0/2+U_0*zt(k)/(nz*dz))*maskU(:,:,k)
 enddo
 back=0.
 do k=1,nz
   do j=1,ny -1
      back(:,j+1,k,1)=back(:,j,k,1)+dx*maskT(:,j,k)*U_0/(nz*dz) *(coriolis_t(j)+coriolis_t(j+1))/2.0
   enddo
 enddo
 do k=1,nz
    back(:,:,k,1)=(back(:,:,k,1)-N_0**2*zt(k))*maskT(:,:,k)
 enddo
 back(:,:,:,2)=back(:,:,:,1)
 back(:,:,:,3)=back(:,:,:,1)
end subroutine initial_conditions


subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine boundary_conditions
end subroutine boundary_conditions

subroutine topography
end subroutine topography

subroutine tracer_sources
end subroutine tracer_sources

 module quasi_stokes_module
 implicit none
 real*8,allocatable :: b_scale(:),harea(:,:,:),htrans(:,:,:),hforc(:,:,:)
 real*8,allocatable :: varea(:,:,:),utrans(:,:,:),vtrans(:,:,:)
 real*8,allocatable :: umean(:,:,:),vmean(:,:,:),wmean(:,:,:),bmean(:,:,:)

 integer :: nb
 ! User input
 real*8 :: b_start=-0.01, b_end=0.08
 logical :: enable_quasi_stokes_ver = .true.
 logical :: enable_quasi_stokes_hor = .false.
 logical :: enable_quasi_stokes_mean = .false.
 ! end user input
 real*8,parameter :: epsln     = 1.0d-20
 integer :: counter=0, quasi_stokes_snapint 
 end module quasi_stokes_module



 subroutine init_quasi_stokes
 use pyOM_module 
 use quasi_stokes_module
 implicit none
 integer :: m

 nb=ny*1.3
 quasi_stokes_snapint = 86400.0 
 if (my_pe==0) then
   print*,' Initializing module for mean quasi stokes streamfunction'
   print*,' using ',nb,' buoyancy levels from ',b_start,' to ',b_end
   print*,' averaging each ',quasi_stokes_snapint,' sec'
   if (enable_quasi_stokes_hor) print*,' calculating horizontal quasi stokes streamfct.'
   if (enable_quasi_stokes_ver) print*,' calculating vertical quasi stokes streamfct.'
   if (enable_quasi_stokes_mean) print*,' calculating also Eulerian means'
 endif

 allocate( b_scale(nb) ); b_scale=0.0
 if (enable_quasi_stokes_hor) then
  allocate( harea(nx,nb,nz),htrans(nx,nb,nz),hforc(nx,nb,nz) )
  harea=0.0;htrans=0.0;hforc=0.0
 endif
 if (enable_quasi_stokes_ver) then
  allocate( varea(nx,ny,nb),utrans(nx,ny,nb),vtrans(nx,ny,nb) )
  varea=0.0;utrans=0.0;vtrans=0.0
 endif

 do m=1,nb
  b_scale(m) = b_start+(m-1)*(b_end-b_start)/(nb-1)
 enddo
 if (enable_quasi_stokes_mean) then
  allocate( umean(nx,ny,nz),vmean(nx,ny,nz),wmean(nx,ny,nz),bmean(nx,ny,nz) )
  umean=0.0;vmean=0.0;wmean=0.0;bmean=0.0
 endif
 counter = 0.0
 call quasi_stokes_read_restart
 if (my_pe==0) then
  print*,' done'
 endif
 end subroutine init_quasi_stokes


 subroutine quasi_stokes
 use pyOM_module 
 use fcontrol_module
 use quasi_stokes_module
 implicit none
 integer :: i,j,k,m,js,je
 real*8 :: bb,fxa,ww
 real*8 :: harea_(nx),htrans_(nx),hforc_(nx)

 if ( mod(itt,int(quasi_stokes_snapint/dt))  == 0)  then
   
  counter = counter + 1
  js=max(2,js_pe); je = min(je_pe,ny-1)

  if (enable_quasi_stokes_mean) then
   umean(:,js:je,:) = umean(:,js:je,:) + u(:,js:je,:,tau) 
   vmean(:,js:je,:) = vmean(:,js:je,:) + v(:,js:je,:,tau) 
   wmean(:,js:je,:) = wmean(:,js:je,:) + w(:,js:je,:,tau) 
   bmean(:,js:je,:) = bmean(:,js:je,:) + b(:,js:je,:,tau) 
  endif

  if (enable_quasi_stokes_hor) then
   do m=1,nb
    do k=2,nz-1
     htrans_=0.0;harea_=0.0;hforc_=0.0
     do j=js,je
      do i=2,nx-1
       bb=b(i,j,k,tau)
       ww=dx*maskT(i,j,k)
       if (bb < b_scale(m) ) ww=0
       harea_(i)  = harea_(i)+ww
       ww=dx*maskU(i,j,k)*u(i,j,k,tau)
       if (bb < b_scale(m) ) ww=0
       htrans_(i) = htrans_(i)+ww
       ww=(w(i,j,k,tau)+w(i,j,k-1,tau))/2.0*dx*maskT(i,j,k)
       if (bb < b_scale(m) ) ww=0
       hforc_(i)  = hforc_(i)+ww
      enddo
     enddo
     call global_sum_vec(harea_,nx )
     call global_sum_vec(htrans_,nx )
     call global_sum_vec(hforc_,nx ) 
     harea(:,m,k) =harea(:,m,k) + harea_
     htrans(:,m,k)=htrans(:,m,k)+ htrans_
     hforc(:,m,k) =hforc(:,m,k) + hforc_
    enddo
   enddo
  endif

  if (enable_quasi_stokes_ver) then
   do m=1,nb
    do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         bb=b(i,j,k,tau)
         if (enable_back_state) bb=bb+back(i,j,k,tau)
         ww=(u(i-1,j,k,tau)*maskU(i-1,j,k)+u(i,j,k,tau)*maskU(i,j,k))/(maskU(i-1,j,k)+maskU(i,j,k)+epsln)
         if( bb<b_scale(m) ) ww=0
         utrans(i,j,m)=utrans(i,j,m)+ww*dz*maskT(i,j,k)
         ww=(v(i,j-1,k,tau)*maskV(i,j-1,k)+v(i,j,k,tau)*maskV(i,j,k))/(maskV(i,j-1,k)+maskV(i,j,k)+epsln)
         if( bb<b_scale(m) ) ww=0
         vtrans(i,j,m)=vtrans(i,j,m)+ww*dz*maskT(i,j,k)
         ww=dz*maskT(i,j,k)
         if( bb<b_scale(m) ) ww=0
         varea(i,j,m)=varea(i,j,m)+ww
        enddo
       enddo
    enddo
   enddo
  endif
 endif
 end subroutine quasi_stokes

 subroutine quasi_stokes_write_restart
!=======================================================================
!    write restart
!=======================================================================
 use pyOM_module 
 use quasi_stokes_module
 implicit none
 integer :: m,io,ierr,j

 if (enable_quasi_stokes_ver) then
  do m=1,nb
   call pe0_recv_2D(nx,ny,utrans(1,1,m))
   call pe0_recv_2D(nx,ny,vtrans(1,1,m))
   call pe0_recv_2D(nx,ny,varea(1,1,m))
  enddo
 endif

 if (enable_quasi_stokes_mean) then
  call pe0_recv_3D(nx,ny,nz,umean)
  call pe0_recv_3D(nx,ny,nz,vmean)
  call pe0_recv_3D(nx,ny,nz,wmean)
  call pe0_recv_3D(nx,ny,nz,bmean)
 endif

 if (my_pe==0) then
     print*,' writing restart file for mean quasi stokes streamfunction'
     call get_free_iounit(io,ierr)
     open(io,file='restart_over.dta', form='unformatted',status='unknown')
     write(io) nx,ny,nz,nb,b_start,b_end
     write(io) counter
     if (enable_quasi_stokes_mean) then
      do j=1,ny
       write(io) umean(:,j,:),vmean(:,j,:),wmean(:,j,:),bmean(:,j,:)
      enddo
     endif
     do m=1,nb
      if (enable_quasi_stokes_ver) write(io) varea(:,:,m),utrans(:,:,m),vtrans(:,:,m)
      if (enable_quasi_stokes_hor) write(io) harea(:,m,:),htrans(:,m,:),hforc(:,m,:)
     enddo
     close(io)
     print*,' done '
 endif
 end subroutine quasi_stokes_write_restart


 subroutine quasi_stokes_read_restart
!=======================================================================
!       read restart
!=======================================================================
 use pyOM_module 
 use quasi_stokes_module
 implicit none
 integer :: m,io,ierr,j
 integer :: nx_,ny_,nz_,nb_
 real*8 :: b_start_,b_end_
 if (my_pe==0) then
     print*,' reading restart file for mean quasi stokes streamfunction'
     call get_free_iounit(io,ierr)
     open(io,file='restart_over.dta', form='unformatted',status='old',err=10)
     read(io) nx_,ny_,nz_,nb_,b_start_,b_end_
     if (nx/=nx_ .or. ny/=ny_ .or. nz/= nz_ .or. nb/= nb_) then 
          print*,' read from restart dimensions: ',nx_,ny_,nz_,nb_
          print*,' does not match dimensions   : ',nx,ny,nz,nb
          goto 10
     endif
     if (b_start_ /= b_start .or. b_end_ /= b_end ) then
        print*,' read buoyancy scale from ',b_start_,' to ',b_end_
        print*,' does not match scale from ',b_start,' to ',b_end 
        goto 10
     endif
     read(io) counter
     print*,' read counter = ',counter
     if (enable_quasi_stokes_mean) then
      do j=1,ny
       read(io) umean(:,j,:),vmean(:,j,:),wmean(:,j,:),bmean(:,j,:)
      enddo
     endif
     do m=1,nb
      if (enable_quasi_stokes_ver) read(io) varea(:,:,m),utrans(:,:,m),vtrans(:,:,m)
      if (enable_quasi_stokes_hor) read(io) harea(:,m,:),htrans(:,m,:),hforc(:,m,:)
     enddo
     close(io)
     goto 20
 10  print*,' error while reading restart file '
 20  continue
 endif
 call bcast_integer(counter,1,0)
 if (enable_quasi_stokes_mean) then
  call pe0_send_3d(nx,ny,nz,umean)
  call pe0_send_3d(nx,ny,nz,vmean)
  call pe0_send_3d(nx,ny,nz,wmean)
  call pe0_send_3d(nx,ny,nz,bmean)
 endif
 if (enable_quasi_stokes_ver) then
  do m=1,nb
   call pe0_send_2d(nx,ny,varea(1,1,m))
   call pe0_send_2d(nx,ny,utrans(1,1,m))
   call pe0_send_2d(nx,ny,vtrans(1,1,m))
  enddo
 endif
 if (enable_quasi_stokes_hor) then
  m=nx*nb*nz
  call bcast_real(harea,m,0)
  call bcast_real(htrans,m,0)
  call bcast_real(hforc,m,0)
 endif
 end subroutine quasi_stokes_read_restart




 subroutine quasi_stokes_write_cdf
!=======================================================================
!      write results to netcdf file
!=======================================================================
 use pyOM_module 
 use fcontrol_module
 use quasi_stokes_module
 implicit none
 integer :: i,j,k,m,js,je
 real*8 :: time,fxa
 include "netcdf.inc"
 integer :: iret,ncid,tdim,tid,ilen,varid,nbdim,nbid
 integer :: corner(4), edges(4),dims(4)
 integer :: xtdim,xudim,ytdim,yudim,ztdim,zudim
 character :: name*24, unit*16
 real*8,parameter :: spval = -1.0d33

 if (enable_quasi_stokes_ver) then
  do m=1,nb
   call pe0_recv_2D(nx,ny,utrans(1,1,m))
   call pe0_recv_2D(nx,ny,vtrans(1,1,m))
   call pe0_recv_2D(nx,ny,varea(1,1,m))
  enddo
 endif
 if (enable_quasi_stokes_mean) then
  call pe0_recv_3D(nx,ny,nz,umean)
  call pe0_recv_3D(nx,ny,nz,vmean)
  call pe0_recv_3D(nx,ny,nz,wmean)
  call pe0_recv_3D(nx,ny,nz,bmean)
 endif

 if (my_pe==0) then 

  call def_grid_cdf('over_ave.cdf')
  iret=nf_open('over_ave.cdf',NF_WRITE,ncid)
  iret=nf_set_fill(ncid, NF_NOFILL, iret)
  call ncredf(ncid, iret)
  nbdim= ncddef(ncid, 'nb', nb, iret)
  nbid = ncvdef (ncid,'nb',NCFLOAT,1,nbdim,iret)
  name = 'buoyancy'; unit = 'm/s^2'
  call ncaptc(ncid,nbid,'long_name',NCCHAR,len_trim(name),name,iret) 
  call ncaptc(ncid,nbid,'units',NCCHAR,len_trim(unit),unit,iret) 

  iret=nf_inq_dimid(ncid,'xt',xtdim)
  iret=nf_inq_dimid(ncid,'xu',xudim)
  iret=nf_inq_dimid(ncid,'yt',ytdim)
  iret=nf_inq_dimid(ncid,'yu',yudim)
  iret=nf_inq_dimid(ncid,'zt',ztdim)
  iret=nf_inq_dimid(ncid,'zu',zudim)
  iret=nf_inq_dimid(ncid,'Time',tdim)

  if (enable_quasi_stokes_hor) then
   dims = (/xtdim, nbdim,ztdim, tdim/)
   varid = ncvdef (ncid,'harea', NCFLOAT,4,dims,iret)
   name = 'Area'; unit = 'm'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 

   dims = (/xtdim, nbdim,ztdim, tdim/)
   varid = ncvdef (ncid,'hforc', NCFLOAT,4,dims,iret)
   name = 'Forcing'; unit = 'm^2/s'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 

   dims = (/xtdim, nbdim,ztdim, tdim/)
   varid = ncvdef (ncid,'htrans', NCFLOAT,4,dims,iret)
   name = 'Transport'; unit = 'm^2/s'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 
  endif

  if (enable_quasi_stokes_ver) then
   dims = (/xtdim, ytdim, nbdim, tdim/)
   varid = ncvdef (ncid,'utrans', NCFLOAT,4,dims,iret)
   name = 'Transport'; unit = 'm^2/s'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 

   dims = (/xtdim, ytdim, nbdim, tdim/)
   varid = ncvdef (ncid,'vtrans', NCFLOAT,4,dims,iret)
   name = 'Transport'; unit = 'm^2/s'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 

   dims = (/xtdim, ytdim, nbdim, tdim/)
   varid = ncvdef (ncid,'varea', NCFLOAT,4,dims,iret)
   name = 'Area'; unit = 'm'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 
  endif

  if (enable_quasi_stokes_mean) then
   dims = (/xudim, ytdim,ztdim, tdim/)
   varid = ncvdef (ncid,'um', NCFLOAT,4,dims,iret)
   name = 'Mean zonal velocity'; unit = 'm/s'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 

   dims = (/xtdim, yudim,ztdim, tdim/)
   varid = ncvdef (ncid,'vm', NCFLOAT,4,dims,iret)
   name = 'Mean meridional velocity'; unit = 'm/s'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 

   dims = (/xtdim, ytdim,zudim, tdim/)
   varid = ncvdef (ncid,'wm', NCFLOAT,4,dims,iret)
   name = 'Mean vertical velocity'; unit = 'm/s'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 

   dims = (/xtdim, ytdim,ztdim, tdim/)
   varid = ncvdef (ncid,'bm', NCFLOAT,4,dims,iret)
   name = 'Mean buoyancy'; unit = 'm/s^2'
   call dvcdf(ncid,varid,name,len_trim(name),unit,len_trim(unit),spval) 
  endif

  call ncendf(ncid, iret)
  iret= nf_put_vara_double(ncid,nbid,1,nb,b_scale)

  iret=nf_inq_dimid(ncid,'Time',tdim)
  iret=nf_inq_dimlen(ncid, tdim,ilen)
  iret=nf_inq_varid(ncid,'Time',tid)
  ilen=ilen+1
  time = itt*dt ! current_time-initial_time
  fxa = time/86400.0 ! time%days + time%seconds/86400.
  iret= nf_put_vara_double(ncid,tid,ilen,1,fxa)

  if (counter>0) then
   if (enable_quasi_stokes_hor) then
     harea=harea/counter
     htrans=htrans/counter
     hforc=hforc/counter
   endif
   if (enable_quasi_stokes_ver) then
     varea=varea/counter
     utrans=utrans/counter
     vtrans=vtrans/counter
   endif
   if (enable_quasi_stokes_mean) then
     umean=umean/counter
     vmean=vmean/counter
     wmean=wmean/counter
     bmean=bmean/counter
   endif
  endif

  Corner = (/1,1,1,ilen/); 
  if (enable_quasi_stokes_hor) then
   edges  = (/nx,nb,nz,1/)
   iret=nf_inq_varid(ncid,'harea',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,harea)
   iret=nf_inq_varid(ncid,'htrans',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,htrans)
   iret=nf_inq_varid(ncid,'hforc',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,hforc)
  endif

  if (enable_quasi_stokes_ver) then
   edges  = (/nx,ny,nb,1/)
   iret=nf_inq_varid(ncid,'varea',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,varea)
   iret=nf_inq_varid(ncid,'utrans',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,utrans)
   iret=nf_inq_varid(ncid,'vtrans',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,vtrans)
  endif

  if (enable_quasi_stokes_mean) then
   edges  = (/nx,ny,nz,1/)
   iret=nf_inq_varid(ncid,'um',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,umean)
   iret=nf_inq_varid(ncid,'vm',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,vmean)
   iret=nf_inq_varid(ncid,'wm',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,wmean)
   iret=nf_inq_varid(ncid,'bm',varid)
   iret= nf_put_vara_double(ncid,varid,corner,edges,bmean)
  endif

  call ncclos (ncid, iret)

  if (enable_quasi_stokes_hor) then
   harea=harea*counter
   htrans=htrans*counter
   hforc=hforc*counter
  endif
  if (enable_quasi_stokes_ver) then
   varea=varea*counter
   utrans=utrans*counter
   vtrans=vtrans*counter
  endif
  if (enable_quasi_stokes_mean) then
   umean=umean*counter
   vmean=vmean*counter
   wmean=wmean*counter
   bmean=bmean*counter
  endif
 endif
 end subroutine quasi_stokes_write_cdf

  subroutine background_state_buoyancy(ierr)
!=======================================================================
!  add effect of a prescribed background stratification in buoyancy
!  to buoyancy budget. Also the effect of background zonal and meridional
!  velocity (but not both).
!
!    the case 
!    b=b'(x,y,z,t) + B(z)
!    p=p'(x,y,t,z)+P(z) with P_z = -B,  P(z=0)=0
!    u=u'(x,y,z,t)+U(z)
!
!    b'_t = -(u'b')_x - (vb')_y - (wb')_z + diffusion(b')+convection(b+B)
!             -(wB)_z-(u'B)_x-(vB)_y-(Ub')_x
!    
!    u'_t =-p_x -(u'u')_x-(vu')_y-(wu')_z+friction(u')  -(Uu')_x  -(u'U)_x-(vU)_y-(wU)_z
!    v'_t =-p_y -(u'v)_x-(vv)_y-(wv)_z+friction(v)  -(Uv)_x
!    w'_t =-p_z -(u'w)_x-(vw)_y-(ww)_z+friction(w)  -(Uw)_x - b 
!
!   with Coriolis force: specify U(z) and B=f y U_z with U(0)=0
!   thus best to set U=U_0 z/h  and B=f y U_0/h 
!
!    P_y = -fU(z)   ->  P(y,z)= - f y U(z) + f(z),  note that U(0)=0, such that P(0)=0
!    P_z = -B, ->  B= f y U_z + f'Q
!
!   numerically consistent:  B_{j+1}=B_{j} + dx*U_z (coriolis_t(j  )+coriolis_t(j+1))/2.0
!
!    U(z), P(y,z), B(y,z)
!
!    b'_t = -(u'b')_x - (vb')_y - (wb')_z + diffusion(b')+convection(b+B)
!             -(wB)_z-(u'B)_x-(vB)_y-(Ub')_x
!    u'_t =fv  -p_x -(u'u')_x-(vu')_y-(wu')_z  -(Uu')_x  -(u'U)_x-(vU)_y-(wU)_z
!    v'_t =-fu' -p_y -(u'v)_x-(vv)_y-(wv)_z  -(Uv)_x 
!
!    non-hydrostatic and U(z), P(y,z) and B(y,z):
!    b'_t = -(u'b')_x - (vb')_y - (wb')_z + diffusion(b')+convection(b+B)
!             -(wB)_z-(u'B)_x-(vB)_y-(Ub')_x
!    u'_t =fv -f_h w -p_x -(u'u')_x-(vu')_y-(wu')_z  -(Uu')_x -(u'U)_x-(vU)_y-(wU)_z
!    v'_t =-fu'      -p_y -(u'v)_x-(vv)_y-(wv)_z     -(Uv)_x 
!    w'_t =f_h u'    -p_z -(u'w)_x-(vw)_y-(ww)_z     -(Uw)_x  -b + f_h U 
!                                  (the last term is not yet implemented!!!!)
!
!=======================================================================
      use pyOM_module   
      implicit none
      integer, intent(out) :: ierr
      integer :: i,j,k,js,je
      real*8 :: adv_fe(nx,ny,nz), adv_ft(nx,ny,nz), adv_fn(nx,ny,nz)
      real*8 :: uback(nx,ny,nz),vback(nx,ny,nz),wback(nx,ny,nz)
      ierr = 0
      js=max(2,js_pe); je = min(je_pe,ny-1)
!---------------------------------------------------------------------------------
!     background stratification  
!---------------------------------------------------------------------------------
      adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0; adv_ft(:,js_pe:je_pe,:)=0
      call adv_flux(nx,ny,nz,adv_fe,adv_fn,adv_ft,back)
      call border_exchg3D(nx,ny,nz,adv_fn,1)
      call setcyclic3D(nx,ny,nz,adv_fe); 
      call setcyclic3D(nx,ny,nz,adv_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*(  &
        -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx &
        -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx &
        -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo

   if (enable_back_zonal_flow) then  
!---------------------------------------------------------------------------------
!     effect of zonal background velocity on density
!---------------------------------------------------------------------------------
      do j=js_pe,je_pe
       uback(:,j,:)=u(:,j,:,tau);
       vback(:,j,:)=v(:,j,:,tau);
       wback(:,j,:)=w(:,j,:,tau);
       u(:,j,:,tau)=u0(:,j,:); v(:,j,:,tau)=0.; w(:,j,:,tau)=0.
      enddo
      adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0; adv_ft(:,js_pe:je_pe,:)=0
      call adv_flux(nx,ny,nz,adv_fe,adv_fn,adv_ft,b)
      u(:,js_pe:je_pe,:,tau)=uback(:,js_pe:je_pe,:)
      v(:,js_pe:je_pe,:,tau)=vback(:,js_pe:je_pe,:)
      w(:,js_pe:je_pe,:,tau)=wback(:,js_pe:je_pe,:)
      call border_exchg3D(nx,ny,nz,adv_fn,1)
      call setcyclic3D(nx,ny,nz,adv_fe); 
      call setcyclic3D(nx,ny,nz,adv_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*(   &
        -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx  &
        -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx  &
        -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
   endif

   if (enable_back_meridional_flow) then  
!---------------------------------------------------------------------------------
!     effect of meridional background velocity on density
!---------------------------------------------------------------------------------
      do j=js_pe,je_pe
       uback(:,j,:)=u(:,j,:,tau);
       vback(:,j,:)=v(:,j,:,tau);
       wback(:,j,:)=w(:,j,:,tau);
       v(:,j,:,tau)=u0(:,j,:); u(:,j,:,tau)=0.;w(:,j,:,tau)=0.
      enddo
      adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0; adv_ft(:,js_pe:je_pe,:)=0
      call adv_flux(nx,ny,nz,adv_fe,adv_fn,adv_ft,b)
      u(:,js_pe:je_pe,:,tau)=uback(:,js_pe:je_pe,:)
      v(:,js_pe:je_pe,:,tau)=vback(:,js_pe:je_pe,:)
      w(:,js_pe:je_pe,:,tau)=wback(:,js_pe:je_pe,:)
      call border_exchg3D(nx,ny,nz,adv_fn,1)
      call setcyclic3D(nx,ny,nz,adv_fe); 
      call setcyclic3D(nx,ny,nz,adv_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*(   &
        -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx  &
        -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx  &
        -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
   endif

!---------------------------------------------------------------------------------
!      Boundary exchange 
!---------------------------------------------------------------------------------
!      call border_exchg3D(nx,ny,nz,b(:,:,:,taup1),2);
!      call setcyclic3D(nx,ny,nz,b(:,:,:,taup1) )
  end subroutine background_state_buoyancy



  subroutine background_state_momentum(ierr)
!-----------------------------------------------------------------------
!    apply effect of background velocity on momentum
!-----------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer, intent(out) :: ierr
      integer :: i,j,k,js,je
      real*8 :: adv_fe(nx,ny,nz), adv_ft(nx,ny,nz), adv_fn(nx,ny,nz)
      ierr = 0
      js=max(2,js_pe); je = min(je_pe,ny-1)

!-----------------------------------------------------------------------
!    zonal momentum equation
!-----------------------------------------------------------------------
   if (enable_back_zonal_flow) then  
      adv_fe(:,js_pe:je_pe,:)=0.0; adv_fn(:,js_pe:je_pe,:)=0.0; adv_ft(:,js_pe:je_pe,:)=0.0; 
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         adv_fe(i,j,k)=2* 0.5*( u0(i  ,j,k) + u0(i+1,j,k) )*   &
              (u(i,j,k,tau)+u(i+1,j,k,tau))   *0.5*maskU(i+1,j,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(nx,ny,nz,adv_fe)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         adv_fn(i,j,k)= 0.5*( u0(i,j,k) + u0(i,j+1,k) )*  &
            (v(i,j,k,tau)+v(i+1,j,k,tau))    *0.5*maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,adv_fn,1); 
      call setcyclic3D(nx,ny,nz,adv_fn)
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         adv_ft(i,j,k)= 0.5*(u0(i,j,k)+u0(i,j,k+1))*  &
                  (w(i,j,k,tau)+w(i+1,j,k,tau))      *0.5*maskU(i,j,k+1)*maskU(i,j,k)
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         fu(i,j,k)= fu(i,j,k)+maskU(i,j,k)*(   &
            -(adv_fe(i,j,k) - adv_fe(i-1,j,k) )/dx   &
            -(adv_fn(i,j,k) - adv_fn(i,j-1,k) )/dx   &
            -(adv_ft(i,j,k) - adv_ft(i,j,k-1) )/dz  )
        enddo
       enddo
      enddo
   endif

   if (enable_back_meridional_flow) then  
      adv_fn(:,js_pe:je_pe,:)=0.0; 
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         adv_fn(i,j,k)= 0.5*( u(i,j,k,tau) + u(i,j+1,k,tau) )*   &
         (u0(i,j,k)+u0(i+1,j,k))   *0.5*maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,adv_fn,1); call setcyclic3D(nx,ny,nz,adv_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         fu(i,j,k)= fu(i,j,k)+maskU(i,j,k)*(-(adv_fn(i,j,k) - adv_fn(i,j-1,k) )/dx )
        enddo
       enddo
      enddo
    endif

!-----------------------------------------------------------------------
!    meridional momentum equation
!-----------------------------------------------------------------------
   if (enable_back_zonal_flow) then  
      adv_fe(:,js_pe:je_pe,:)=0.0; 
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         adv_fe(i,j,k)=  0.5*( v(i  ,j,k,tau) + v(i+1,j,k,tau) )*  &
          (u0(i,j,k)+u0(i,j+1,k))       *0.5*maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(nx,ny,nz,adv_fe)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         fv(i,j,k)= fv(i,j,k)+maskV(i,j,k)*( -(adv_fe(i,j,k) - adv_fe(i-1,j,k) )/dx)
        enddo
       enddo
      enddo
   endif

   if (enable_back_meridional_flow) then  
      adv_fe(:,js_pe:je_pe,:)=0.0; adv_fn(:,js_pe:je_pe,:)=0.0; adv_ft(:,js_pe:je_pe,:)=0.0; 
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         adv_fe(i,j,k)=0.5*( u0(i  ,j,k) + u0(i+1,j,k) )*  &
          (u(i,j,k,tau)+u(i,j+1,k,tau))   *0.5*maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(nx,ny,nz,adv_fe)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         adv_fn(i,j,k)=2* 0.5*( u0(i,j,k) + u0(i,j+1,k) )*  &
         (v(i,j,k,tau)+v(i,j+1,k,tau))     *0.5*maskV(i,j+1,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,adv_fn,1); 
      call setcyclic3D(nx,ny,nz,adv_fn)
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         adv_ft(i,j,k)= 0.5*( u0(i,j,k) + u0(i,j,k+1) )*  &
         (w(i,j,k,tau)+w(i,j+1,k,tau))     *0.5*maskV(i,j,k+1)*maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         fv(i,j,k)= fv(i,j,k)+maskV(i,j,k)*(    &
          -(adv_fe(i,j,k) - adv_fe(i-1,j,k) )/dx    &
          -(adv_fn(i,j,k) - adv_fn(i,j-1,k) )/dx    &
          -(adv_ft(i,j,k) - adv_ft(i,j,k-1) )/dz  )
        enddo
       enddo
      enddo
    endif

   if (.not. enable_hydrostatic) then
!-----------------------------------------------------------------------
!    vertical momentum equation
!-----------------------------------------------------------------------

   if (enable_back_zonal_flow) then  
       adv_fe(:,js_pe:je_pe,:)=0.0
       do k=2,nz-1
        do j=js,je
         do i=1,nx-1
          adv_fe(i,j,k)=  0.5*( w(i  ,j,k,tau) + w(i+1,j,k,tau) )*   &
               (u0(i,j,k)+u0(i,j,k+1))      *0.5*maskW(i+1,j,k)*maskW(i,j,k)
         enddo
        enddo
       enddo
       call setcyclic3D(nx,ny,nz,adv_fe)
       do k=2,nz-1
        do j=js,je
         do i=2,nx-1
          fw(i,j,k)= fw(i,j,k)+maskW(i,j,k)*( -(adv_fe(i,j,k) - adv_fe(i-1,j,k) )/dx)
         enddo
        enddo
       enddo
   endif
   if (enable_back_meridional_flow) then  
      adv_fn(:,js_pe:je_pe,:)=0.0; 
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         adv_fn(i,j,k)=  0.5*( w(i,j,k,tau) + w(i,j+1,k,tau) )*   &
           (u0(i,j,k)+u0(i,j,k+1))     *0.5*maskW(i,j+1,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,adv_fn,1); 
      call setcyclic3D(nx,ny,nz,adv_fn)
      do k=2,nz-1
       do j=js,je
         do i=2,nx-1
          fw(i,j,k)= fw(i,j,k)+maskW(i,j,k)*(-(adv_fn(i,j,k) - adv_fn(i,j-1,k) )/dx)
        enddo
       enddo
      enddo
   endif
   endif


!   if (enable_back_meridional_flow .or. enable_back_zonal_flow) then  
!      call border_exchg3D(nx,ny,nz,fu,1); call setcyclic3D(nx,ny,nz,fu)
!      call border_exchg3D(nx,ny,nz,fv,1); call setcyclic3D(nx,ny,nz,fv)
!      if (.not. enable_hydrostatic) then
!       call border_exchg3D(nx,ny,nz,fw,1); call setcyclic3D(nx,ny,nz,fw)
!      endif
!   endif

  end subroutine background_state_momentum

!=======================================================================
!     Templates for setup
!
!      idealised MOC with freshwater forcing
!=======================================================================


 subroutine set_parameter
      use pyOM_module   
      use fcontrol_module
      implicit none
      real*8 :: RESOLVE=0.25, vRESOLVE=0.5
! ----------------------------------
!       set here main parameter
! ----------------------------------
      nx=64 *RESOLVE
      ny=64 *RESOLVE
      nz=30 *vRESOLVE

      dx=80e3  /RESOLVE
      dt=2400.0  /RESOLVE  
      dz=50.0  /vRESOLVE

      A_h=5.0e4 /RESOLVE**2 ! u_t = A u_xx,  1/T = A /L^2 
      A_v=1e-4
      K_v=1e-4
      K_h=0000.0 
      cdbot = 0e-5!*RESOLVE
      cdint = 2e-6
      eps2D_sor = 1e-9

!      enable_noslip               = .true.
      enable_interior_stress      = .true.
!      enable_bottom_stress        = .true.
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .true.  

      enable_diag_zonalave = .true.
      enable_diag_timeave = .false.

!      runlen = 365*50000*86400.
      runlen = 50*365*86400.
      snapint =  365*86400.*0.5

      enable_diag_tracer    = .true.
      nt=1
      delimit_tracer_fluxes      = .false.
      enable_isopycnal_diffusion = .true.
      K_gm=2000.0
 end subroutine set_parameter


 subroutine set_coriolis
      use pyOM_module   
      implicit none
! ----------------------------------
!      add here initial conditions
! ----------------------------------
      integer :: j
      real*8,parameter :: pi=3.1415   
      real*8,parameter :: radius  = 6370.0e3   ! earth radius
      real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
      real*8,parameter :: phi0 = 0 /180. *pi
      do j=1,ny
      coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
      enddo
 end subroutine set_coriolis


 subroutine boundary_conditions
! ----------------------------------
!    add here boundary conditions
! ----------------------------------
      use pyOM_module   
      implicit none
      integer :: j,k,js,je
      real*8 :: Ly,t_rest,sst(nx ,ny ),sss(nx ,ny ),sig(nx ,ny )
      real*8 :: salt_flux(ny ),t_star(ny )
! ----------------------------------
!      add here restoring zones, surface boundary conditions etc.
! ----------------------------------
      js=max(2,js_pe); je = min(je_pe,ny -1)
      Ly = yt(ny )-yt(1)
      call get_salt_flux(salt_flux)
      t_rest=30*86400
      do j=js,je
       t_star(j)=15*(1-exp(-(yt(j)-yt(ny -1))**2/(Ly/8.)**2 )) 
      enddo
      k=nz-1
      do j=js,je ! sig = 0.8 S - 0.2T ,  T = (0.8S -sig)/0.2
       sig(:,j)=  b(:,j,k,taum1)*1024/9.81
       sss(:,j)= tr(:,j,k,taum1,1)
       sst(:,j) = (0.8*sss(:,j)-sig(:,j)) /0.2
       surface_flux(:,j)=dz/t_rest*(t_star(j)-sst(:,j)) 
       surface_flux(:,j)=(0.8*salt_flux(j)-0.2*surface_flux(:,j))/1024*9.81
      enddo
end subroutine boundary_conditions


subroutine tracer_sources
      use pyOM_module   
      implicit none
      integer :: j,k,js,je
      real*8 :: salt_flux(ny)
! ----------------------------------
!      add here restoring zones, surface boundary conditions etc.
! ----------------------------------
      js=max(2,js_pe); je = min(je_pe,ny-1)
      call get_salt_flux(salt_flux)
      k=nz-1
      do j=js,je
       tr(:,j,k,taup1,1)=tr(:,j,k,taup1,1)+maskT(:,j,k)*c2dt*salt_flux(j)/dz
      enddo
end subroutine tracer_sources


subroutine get_salt_flux(salt_flux)
      use pyOM_module   
      implicit none
      real*8 :: salt_flux(ny )
      integer :: j,js,je
      real*8 :: fxa,Ly
      js=max(2,js_pe); je = min(je_pe,ny -1)
      Ly = yt(ny )-yt(1)
!     surface forcing
      salt_flux(js:je)=0.0
      fxa=0.5/86400.
      do j=js,je
       salt_flux(j)=-fxa*exp(-(yt(j)-yt(ny -1))**2/(Ly/8.)**2 )
      enddo
      fxa=0.; 
      do j=js,je
       fxa=fxa+salt_flux(j)
      enddo; 
      call global_sum(fxa)
      fxa=fxa/(ny -2.)
      salt_flux=salt_flux-fxa
end subroutine get_salt_flux

subroutine initial_conditions
end subroutine initial_conditions

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine topography
end subroutine topography

!=======================================================================
! Meso-scale eddy parameterisation based on pv mixing
! the lateral diffusivity for eddy pv fluxes can be calculated
! using linear stability theory
!=======================================================================

module pv_mixing_module
 use pyOM_module
 implicit none
 integer :: j_constraint
 real*8,parameter :: pi = 3.14159265358979323846264338327950588, grav = 9.81, rho_0 = 1024
 real*8, dimension(:,:,:), allocatable :: vtendu, htendu,theta_u,vtendv, htendv,theta_v
 real*8, dimension(:,:,:), allocatable :: Nsqrw, fNsqrw, K_iso
 real*8, dimension(:,:,:,:), allocatable :: K_rho, K_pv
 real*8, dimension(:,:),   allocatable :: kx_max,ky_max,meanN
 complex*8, allocatable :: om(:,:)
 real*8  :: K_min = 25.0, K_max = 2e4, len_fac=2.0, K_w = 1.0, K_hor_min=0500.0
 real*8  :: u_max     = 1e18 !0.2
 real*8  :: M_min     = 1d-12! 1d-9
 integer :: pv_mixing_calcint = 3*86400.0
 integer :: pv_mixing_diagint = 3*86400.0
 logical :: enable_pv_mixing_read_diff = .false.       ! read diffusivity from file
 logical :: enable_pv_mixing_set_diff  = .false.       ! set diffusivity to constant
 logical :: enable_pv_mixing_calc_diff = .true.        ! calculate diffusivity by linear stability analysis
 logical :: enable_pv_mixing_smooth_backstate = .false.! smooth background state by running mean
 logical :: enable_pv_mixing_smooth_diff      = .false. ! smooth diffusivity
 integer :: k_runmean=5
 logical :: enable_pv_mixing_diag      = .true.
 !
 logical :: enable_pv_mixing_full      = .false. ! enables full pv mixing instead of TRM formulation
 logical :: enable_pv_mixing_beta_term = .true.  ! enables the force by beta term
 logical :: enable_pv_mixing_friction  = .false. ! enables also the lateral friction
 !
 logical :: pv_mixing_initialized       
end module pv_mixing_module


subroutine init_pv_mixing
 use pyOM_module
 use pv_mixing_module
 implicit none

 if (my_pe==0) print*,' ' 
 if (my_pe==0) print*,' initializing pv mixing module' 
 pv_mixing_initialized = .true.

 j_constraint = int( 300e3/dx )
 if (my_pe==0) print*,' pv mixing constraint over ',j_constraint,' grid points'
 allocate(K_rho(nx,ny,nz,2) ); K_rho   = 0.0
 allocate(K_pv(nx,ny,nz,2) );  K_pv    = 0.0
 allocate(Nsqrw(nx,ny,nz) );   Nsqrw   = 0.0
 allocate(fNsqrw(nx,ny,nz) );  fNsqrw  = 0.0

 allocate(htendu(nx,ny,nz) ); htendu=0.0
 allocate(htendv(nx,ny,nz) ); htendv=0.0
 allocate(vtendu(nx,ny,nz) ); vtendu=0.0
 allocate(vtendv(nx,ny,nz) ); vtendv=0.0
 allocate(theta_u(nx,ny,nz) ); theta_u=0.0
 allocate(theta_v(nx,ny,nz) ); theta_v=0.0
 if (my_pe==0) then  
   print*,' K_min     = ',K_min
   print*,' K_max     = ',K_max
   print*,' K_w       = ',K_w
   print*,' len fac   = ',len_fac
   print*,' K_hor_min = ',K_hor_min
   print*,' M_min     = ',M_min
   print*,' N_min     = ',N_min
   print*,' u_max     = ',u_max
 endif
 if (enable_pv_mixing_diag .and. my_pe==0 ) then
   print*,' diagnosing any ',int(pv_mixing_diagint/dt),' time steps'
 endif
 if (enable_pv_mixing_full ) then
   if (my_pe==0) print*,' using full pv mixing' 
   if (enable_pv_mixing_friction .and. my_pe==0) print*,' with lateral friction' 
   if (enable_pv_mixing_beta_term.and. my_pe==0) print*,' with beta term' 
 else
   if (my_pe==0) print*,' using partial pv mixing' 
 endif
 if (enable_pv_mixing_calc_diff ) then
   if (my_pe==0) print*,' calculating diffusivity any ',int(pv_mixing_calcint/dt),' time steps'
   allocate(meanN(nx,ny) );  meanN  = 0.0
   allocate(om(nx,ny) );     om     = cmplx(0.0,0.0)
   allocate(kx_max(nx,ny) ); kx_max = 0.0
   allocate(ky_max(nx,ny) ); ky_max = 0.0
   allocate(K_iso(nx,ny,nz) ); K_iso    = 0.0
 endif
 if (enable_pv_mixing_read_diff) then
      if (my_pe==0) print*,' reading diffusivity'
      call pv_mixing_read_diff()
 endif
 if (enable_pv_mixing_set_diff)  then
      if (my_pe==0) print*,' setting diffusivity'
      call pv_mixing_set_diff()
 endif
 if (enable_pv_mixing_smooth_backstate) then
      if (my_pe==0) print*,' smoothing background state for linear stability analysis'
      if (my_pe==0) print*,' with running mean over ',k_runmean,' grid points'
 endif
 if (enable_pv_mixing_smooth_diff) then
      if (my_pe==0) print*,' smoothing diffusivity from lin. stab. analysis'
      if (my_pe==0) print*,' with running mean over ',k_runmean,' grid points'
 endif
 if  (enable_pv_mixing_diag)  call pv_mixing_diag_init
 if (my_pe==0) print*,' done initializing pv mixing module' 
 if (my_pe==0) print*,' ' 
end subroutine init_pv_mixing


subroutine pv_mixing_main(ierr)
 !=======================================================================
 ! Hauptverteiler funktion
 !=======================================================================
  use pyOM_module
  use fcontrol_module
  use pv_mixing_module
  integer, intent(out) :: ierr
  integer :: i,j,k,js,je

  ierr=0
  js=max(2,js_pe); je = min(je_pe,ny -1)
 !-----------------------------------------------------------------------
 !     stability freq.
 !-----------------------------------------------------------------------
  Nsqrw(:,js:je,:)=0.0
  do k=1,nz-1
       do j=js,je
        Nsqrw(:,j,k)=-(b(:,j,k+1,taum1)-b(:,j,k,taum1))/dz
       enddo
  enddo
  if (enable_back_state) then  
       do k=1,nz-1
        do j=js,je
         Nsqrw(:,j,k)=Nsqrw(:,j,k) -(back(:,j,k+1,taum1)-back(:,j,k,taum1))/dz 
        enddo
       enddo
  endif
 !-----------------------------------------------------------------------
 !     calculate diffusivity
 !-----------------------------------------------------------------------
  if (enable_pv_mixing_calc_diff.and.((mod(itt,int(pv_mixing_calcint/dt))== 0).or.pv_mixing_initialized)) then
        meanN(:,js:je)=0.0
        do k=1,nz-1
         do j=js,je
          do i=2,nx-1
            meanN(i,j)=meanN(i,j)+sqrt(max(0d0,Nsqrw(i,j,k)))*maskT(i,j,k)*dz
          enddo
         enddo
        enddo
        where (ht /=0.0 ) meanN=meanN/ht
        where (ht ==0.0 ) meanN=0.0
        call pv_mixing_calc_diff
        !call pv_mixing_calc_diff_somewhere
  endif
  Nsqrw(:,js:je,:)=max(Nsqrw(:,js:je,:),N_min**2)
  call border_exchg3D(nx,ny,nz,Nsqrw,1); call setcyclic3D(nx,ny,nz,Nsqrw )
 !-----------------------------------------------------------------------
 !     Calculate f**2/N**2 on W grid and bound 
 !-----------------------------------------------------------------------
  do k=1,nz-1
       do j=js,je
        do i=2,nx -1
         fNsqrw(i,j,k)= coriolis_t(j)**2/Nsqrw(i,j,k)
        enddo
       enddo
  enddo
  fNsqrw(:,js:je,:)=min(fNsqrw(:,js:je,:),fNsqr_max)
  call border_exchg3D(nx,ny,nz,fNsqrw,1); call setcyclic3D(nx,ny,nz,fNsqrw )

  if (enable_pv_mixing_full) then
    call pv_mixing_zonal
    call pv_mixing_meridional 
  else
    call pv_mixing_zonal_trm
    call pv_mixing_meridional_trm
  endif
  pv_mixing_initialized = .false.
end subroutine pv_mixing_main




subroutine pv_mixing_set_diff
 !-----------------------------------------------------------------------
 !     set diffusivity 
 !-----------------------------------------------------------------------
 use pyOM_module
 use pv_mixing_module
 implicit none
 integer :: i,j
 do j=1,ny
   do i=1,nx
     K_pv(i,j,:,:) = K_gm
   enddo
 enddo
end subroutine pv_mixing_set_diff



subroutine pv_mixing_read_diff
 !-----------------------------------------------------------------------
 !     read diffusivity from NetCDF file
 !-----------------------------------------------------------------------
      use pyOM_module
      use pv_mixing_module
      implicit none
      include "netcdf.inc"
      integer :: ncid,iret,corner(4), edges(4)
      integer :: varid,i,j,is,ie,js,je,k

      js=max(2,js_pe); je = min(je_pe,ny-1)
      if (my_pe==0) print*,' reading diffusivity from file diff_interp.cdf'
      iret=nf_open('diff_interp.cdf',NF_WRITE,ncid)
      iret=nf_inq_varid(ncid,'DIFF2',varid)
!        if (iret.ne.0) print*,nf_strerror(iret)
      Corner = (/1,1,1,1/); 
      edges  = (/nx,ny,nz,1/)
      iret=nf_get_vara_double(ncid,varid,corner,edges,K_pv(:,:,:,1))
      K_pv(:,:,:,1)=min(max(K_pv(:,:,:,1)*maskT,1d2),5d4)
      K_pv(:,:,:,2) = K_pv(:,:,:,1)
      call ncclos(ncid,iret)
end subroutine pv_mixing_read_diff


subroutine running_mean1(a,b,nx,k)
 implicit none
 integer :: nx,k,i,ii
 real*8 :: a(nx),b(nx)
 b(1)=0.0
 do ii=1,min(nx,1+k)
   b(1)=b(1)+a(ii)
 enddo
 do i=2,nx
   b(i)=b(i-1)
   ii=i-k-1
   if (ii>=1) b(i)=b(i-1)-a(ii)
   ii=i+k
   if (ii<=nx) b(i)=b(i)+a(ii)
 enddo
end subroutine running_mean1


subroutine running_mean2(a,bb,nx_,ny_,k)
 use pyOM_module
 implicit none
 integer :: nx_,ny_,k
 real*8 :: a(nx_,ny_),bb(nx_,ny_),c(nx_,ny_)
 integer :: i,j,js,je 

 js=max(2,js_pe); je = min(je_pe,ny -1)
 c(:,1:js)=0.
 c(:,je+1:ny)=0.
 do j=js,je
  call running_mean1(a(:,j),c(:,j),nx,k)
 enddo
 call border_exchg2D(nx,ny,c,k+1)
 if (k+1>n_pes_j)   call border_exchg2D(nx,ny,c,k+1)
 if (k+1>2*n_pes_j) call border_exchg2D(nx,ny,c,k+1)
 do i=1,nx 
  call running_mean1(c(i,:),bb(i,:),ny,k)
 enddo
end subroutine running_mean2




subroutine pv_mixing_calc_diff
 !-----------------------------------------------------------------------
 ! use linear instability analysis to calculate diffusivity at all points 
 !-----------------------------------------------------------------------
 use pyOM_module
 use pv_mixing_module
 implicit none
 integer :: js,je,i,j,k,nb,ier=0
 real*8 :: rho1(nx,ny,nz),p1(nx,ny,nz),rxytmp(nx,ny)
 real*8, save, allocatable :: rmask(:,:,:)
 real*8 :: rho(nz),ub(nz),vb(nz),beta,f0,Lr(nx,ny)
 real*8 :: fxa,by,bx,amp,gb,umag,qx(nz),qy(nz),kmag
 complex*8 :: phiz(nz),phi(nz),im,c
 logical, save :: first = .true.

  im=cmplx(0,1)
  js=max(2,js_pe); je = min(je_pe,ny -1)
  nb=nz-2
  
  Lr(:,js:je)=0.0
  do j=js,je
   do i=2,nx-1
     Lr(i,j) = meanN(i,j)*ht(i,j)/abs(coriolis_t(j))*maskT(i,j,nz-1)
   enddo
  enddo
 
  rho1=b(:,:,:,tau)*maskT*rho_0/grav
  if (enable_back_state) rho1=rho1+back(:,:,:,tau)*maskT*rho_0/grav
  p1=p_full(:,:,:,tau)*maskT

  if (enable_pv_mixing_smooth_backstate .or. enable_pv_mixing_smooth_diff) then
   if (first) then
       allocate(rmask(nx,ny,nz))
       rmask(:,:,:)=maskT
       call border_exchg3D(nx,ny,nz,rmask,k_runmean+1)
       do k=2,nz-1
        call running_mean2(rmask(:,:,k),rxytmp,nx,ny,k_runmean)    
        rmask(:,:,k)=rxytmp*maskT(:,:,k)
       enddo
   endif
  endif

  if (enable_pv_mixing_smooth_backstate) then 
   ! apply a running mean to background state
   do k=2,nz-1
     call running_mean2(rho1(:,:,k),rxytmp,nx,ny,k_runmean)    
     where (rmask(:,:,k)/=0.0); rho1(:,:,k)=rxytmp/rmask(:,:,k); elsewhere; rho1(:,:,k)=0.0; end where
     call running_mean2(p1(:,:,k),rxytmp,nx,ny,k_runmean)    
     where (rmask(:,:,k)/=0.0); p1(:,:,k)=rxytmp/rmask(:,:,k) ; elsewhere ; p1(:,:,k)=0.0; end where
   enddo
  endif

  K_rho(:,:,:,1)= K_rho(:,:,:,2)
  K_pv (:,:,:,1)= K_pv (:,:,:,2)
  do j=js,je
   do i=2,nx-1
    if (maskT(i,j,nz-1) == 1.0) then
      f0=coriolis_t(j)
      rho(1:nb) = rho1(i,j,nz-1:2:-1) 
      do k=2,nz-1
        ub(k) = - ( (p1(i,j+1,k)-p1(i,j  ,k))/dx*maskV(i,j  ,k)  &
                   +(p1(i,j  ,k)-p1(i,j-1,k))/dx*maskV(i,j-1,k)) &
                        /( ( maskV(i,j,k)+maskV(i,j-1,k)+1e-12)*f0)
        vb(k) =   ( (p1(i+1,j,k)-p1(i  ,j,k))/dx*maskU(i  ,j,k)  &
                   +(p1(i  ,j,k)-p1(i-1,j,k))/dx*maskU(i-1,j,k)) &
                        /( ( maskU(i,j,k)+maskU(i-1,j,k)+1e-12)*f0)
      enddo
      ub(1:nb)=ub(nz-1:2:-1); vb(1:nb)=vb(nz-1:2:-1)
      beta=(coriolis_t(j+1)-coriolis_t(j-1))/(2*dx)
      fxa=max(dx,Lr(i,j))
      call vertical_eigenvalues0b(nb,rho,ub,vb,f0,beta,dz,fxa,om(i,j),phi,kx_max(i,j),ky_max(i,j),qx,qy,ier) 
      phi(nz-1:2:-1)=phi(1:nb)
      ub(nz-1:2:-1)=ub(1:nb); vb(nz-1:2:-1)=vb(1:nb)
      qx(nz-1:2:-1)=qx(1:nb); qy(nz-1:2:-1)=qy(1:nb)
      ! amplitude 
      kmag = sqrt(kx_max(i,j)**2+ky_max(i,j)**2)
      amp = 0.0
      if (kmag/=0.0 .and. imag(om(i,j))>0.0 ) amp = K_w*2*pi*imag(om(i,j))/kmag**2
      !  diffusivity for eddy potential vorticity flux
      do k=2,nz-1
          c=om(i,j)/kmag
          umag = (ub(k)*kx_max(i,j)+vb(k)*ky_max(i,j))/kmag
          fxa = 0.5*amp**2*kmag*imag(c) *abs(phi(k)/(umag-c))**2
          gb=sqrt(qx(k)**2+qy(k)**2)+1e-28
          K_iso(i,j,k) = fxa
          K_pv(i,j,k,2)= fxa * ( (-ky_max(i,j)*Qx(k)+kx_max(i,j)*Qy(k))/kmag)**2/gb**2
          K_pv(i,j,k,2)=K_pv(i,j,k,2)/(1.+u(i,j,k,tau)**2/u_max**2 )
          K_pv(i,j,k,2)=min(K_max,max(K_min, K_pv(i,j,k,2) ))
      enddo
      ! vertical derivative is buoyancy
      do k=2,nz-1
       phiz(k)=(phi(k+1)-phi(k-1))/(2*dz)
      enddo
      phiz(2)=(phi(3)-phi(2))/dz
      phiz(nz-1)=(phi(nz-1)-phi(nz-2))/dz
      ! diffusivity for eddy buoyancy flux
      do k=2,nz-1
          !by   = -(rho1(i,j+1,k)-rho1(i,j-1,k))/(2*dx) *grav/rho_0
          !bx   = -(rho1(i+1,j,k)-rho1(i-1,j,k))/(2*dx) *grav/rho_0
          by   = -grav/rho_0*( (rho1(i,j+1,k)-rho1(i,j,k))/dx *maskV(i,j,k) &
                              +(rho1(i,j,k)-rho1(i,j-1,k))/dx*maskV(i,j-1,k)) &
                                 /( maskV(i,j,k)+maskV(i,j-1,k)+1e-12)
          bx   = -grav/rho_0*( (rho1(i+1,j,k)-rho1(i,j,k))/dx *maskU(i,j,k) &
                              +(rho1(i,j,k)-rho1(i-1,j,k))/dx*maskU(i-1,j,k)) &
                                 /( maskU(i,j,k)+maskU(i-1,j,k)+1e-12)
          gb =    max(M_min, sqrt(bx**2+by**2) )
          fxa = 0.5*amp**2*kmag*f0*real(im*phi(k)*conjg(phiz(k)))/gb
          K_rho(i,j,k,2) =  fxa*(-ky_max(i,j)*bx+kx_max(i,j)*by)/kmag/gb
      enddo
      if (sum(K_rho(i,j,2:nz-1,2))<0.0) then
           K_rho(i,j,:,2)=-K_rho(i,j,:,2) ! choose complex conjugate solution
      endif
      K_rho(i,j,:,2)=K_rho(i,j,:,2)/(1.+u(i,j,:,tau)**2/u_max**2 )
      K_rho(i,j,:,2)=min(K_max,max(K_min, K_rho(i,j,:,2) ))
    endif ! maskT
   enddo
  enddo

 if (enable_pv_mixing_smooth_diff) then
   call setcyclic3D(nx,ny,nz,K_rho(:,:,:,2) )
   call setcyclic3D(nx,ny,nz,K_pv(:,:,:,2) )
   rxytmp=0
   do k=2,nz-1
     call running_mean2(K_rho(:,:,k,2),rxytmp,nx,ny,k_runmean)    
     where (rmask(:,:,k)/=0.0); K_rho(:,:,k,2)=rxytmp/rmask(:,:,k); elsewhere; K_rho(:,:,k,2)=0.0; end where
     call running_mean2(K_pv(:,:,k,2),rxytmp,nx,ny,k_runmean)    
     where (rmask(:,:,k)/=0.0); K_pv(:,:,k,2)=rxytmp/rmask(:,:,k); elsewhere; K_pv(:,:,k,2)=0.0; end where
   enddo
  endif

  call border_exchg3D(nx,ny,nz,K_rho(:,:,:,2),1)
  call setcyclic3D(nx,ny,nz,K_rho(:,:,:,2) )
  call border_exchg3D(nx,ny,nz,K_pv(:,:,:,2),1)
  call setcyclic3D(nx,ny,nz,K_pv(:,:,:,2) )
  if (pv_mixing_initialized)  then
       K_pv (:,:,:,1) = K_pv (:,:,:,2)
       K_rho(:,:,:,1) = K_rho(:,:,:,2)
  endif
  first=.false.
end subroutine pv_mixing_calc_diff





subroutine pv_mixing_calc_diff_somewhere
 !-----------------------------------------------------------------------
 ! use linear instability analysis to calculate diffusivity
 ! at some points and interpolate inbetween
 !-----------------------------------------------------------------------
 use pyOM_module
 use pv_mixing_module
 implicit none
 integer :: js,je,i,j,k,nb,ier=0,ii,jj,jLr
 real*8 :: rho(nz),ub(nz),vb(nz),beta,f0,Lr(nx,ny),mLr
 real*8 :: fxa,by,fxb,uflx,vflx,bx,amp,umag,gb
 real*8 :: xx(nx),yy(ny),diff1(nx,ny,nz),d2(nx,ny),diff2(nx,ny,nz),d3(nx,ny),d4(nx,ny)
 real*8 :: qx(nz),qy(nz),spval = -1d33
 complex*8 :: phiz(nz),phi(nz),im,c,new_om
 logical, save :: first = .true.
 real*8, save, allocatable :: rmask(:,:,:)
 real*8 :: rho1(nx,ny,nz), p1(nx,ny,nz), rxytmp(nx,ny)

  im=cmplx(0,1)
  js=max(2,js_pe); je = min(je_pe,ny -1)
  nb=nz-2
  om=cmplx(1.,1.)*spval; phi=cmplx(1,1)*spval; 
  K_iso=spval
  kx_max=spval; ky_max=spval;
  
  Lr(:,js:je)=0.0
  fxa=0;mLr=0
  do j=js,je
   do i=2,nx-1
     Lr(i,j) = meanN(i,j)*ht(i,j)/abs(coriolis_t(j))*maskT(i,j,nz-1)
     !Lr(i,j) = 100e3
     mLr=mLr+Lr(i,j)*maskT(i,j,nz-1)
     fxa=fxa+maskT(i,j,nz-1)
   enddo
  enddo
  call global_sum(mLr)
  call global_sum(fxa)
  if (fxa/=0.0) mLr=mLr/fxa
  jLr = int(len_fac*mLr/dx);  jLr = max(1,jLr); jLr = min(ny/2,jLr)
  if (my_pe==0) print*,' mean Rossby radius is ',mLr/1e3,' km'
  if (my_pe==0) print*,' calculating diffusivity any',jLr,' grid points'


  rho1=b(:,:,:,tau)*maskT*rho_0/grav
  if (enable_back_state) rho1=rho1+back(:,:,:,tau)*maskT*rho_0/grav
  p1=p_full(:,:,:,tau)*maskT

  if (enable_pv_mixing_smooth_backstate .or. enable_pv_mixing_smooth_diff) then
   if (first) then
      allocate(rmask(nx,ny,nz))
      rmask(:,:,:)=maskT
      call border_exchg3D(nx,ny,nz,rmask,k_runmean+1)
      do k=2,nz-1
       call running_mean2(rmask(:,:,k),rxytmp,nx,ny,k_runmean)    
       rmask(:,:,k)=rxytmp*maskT(:,:,k)
      enddo
   endif
  endif

  if (enable_pv_mixing_smooth_backstate) then 
   ! apply a running mean to background state
   do k=2,nz-1
     call running_mean2(rho1(:,:,k),rxytmp,nx,ny,k_runmean)    
     where (rmask(:,:,k)/=0.0); rho1(:,:,k)=rxytmp/rmask(:,:,k); elsewhere; rho1(:,:,k)=0.0; end where
     call running_mean2(p1(:,:,k),rxytmp,nx,ny,k_runmean)    
     where (rmask(:,:,k)/=0.0); p1(:,:,k)=rxytmp/rmask(:,:,k) ; elsewhere ; p1(:,:,k)=0.0; end where
   enddo
  endif


  diff1(:,:,:)=spval; diff2(:,:,:)=spval ! all rows need to be initialized
  jj=0
  do j=2+jLr/2,ny-1,jLr
   jj=jj+1; ;yy(jj)=yt(j); ii=0;  
   !do i=min(nx-1,2) ,nx-1,jLr
   do i=2+JLr/2,nx-1,jLr
    ii=ii+1; xx(ii)=xt(i)
    if ((maskT(i,j,nz-1) == 1.0) .and. (j>=js .and. j<= je ) ) then
      f0=coriolis_t(j)
      rho(1:nb) = rho1(i,j,nz-1:2:-1) 
      do k=2,nz-1
        ub(k) = - ( (p1(i,j+1,k)-p1(i,j  ,k))/dx*maskV(i,j  ,k)  &
                   +(p1(i,j  ,k)-p1(i,j-1,k))/dx*maskV(i,j-1,k)) &
                        /( ( maskV(i,j,k)+maskV(i,j-1,k)+1e-12)*f0)
        vb(k) =   ( (p1(i+1,j,k)-p1(i  ,j,k))/dx*maskU(i  ,j,k)  &
                   +(p1(i  ,j,k)-p1(i-1,j,k))/dx*maskU(i-1,j,k)) &
                        /( ( maskU(i,j,k)+maskU(i-1,j,k)+1e-12)*f0)
      enddo
      ub(1:nb)=ub(nz-1:2:-1); vb(1:nb)=vb(nz-1:2:-1)
      beta=(coriolis_t(j+1)-coriolis_t(j-1))/(2*dx)
      fxa=max(dx,Lr(i,j))
      call vertical_eigenvalues3(nb,rho,ub,vb,f0,beta,dz,fxa,new_om,phi,kx_max(i,j),ky_max(i,j),qx,qy,ier) 
      if (ier/=0) then
       print*,' ERROR: failed to solve vertical eigenvalue problem at i,j=',i,j
      endif
      ! check if growth rate has changed mare than 20%
      !if (ier==0.and.((imag(new_om)>imag(om(i,j))*1.20).or.(imag(new_om)<imag(om(i,j))*0.80))) then
      if (ier==0) then
        om(ii,jj)=new_om
        phi(nz-1:2:-1)=phi(1:nb)
        ub(nz-1:2:-1)=ub(1:nb); vb(nz-1:2:-1)=vb(1:nb)
        qx(nz-1:2:-1)=qx(1:nb); qy(nz-1:2:-1)=qy(1:nb)
        ! amplitude 
        fxb = sqrt(kx_max(i,j)**2+ky_max(i,j)**2)
        amp = 0.0
        if (fxb/=0.0) amp = K_w*2*pi/fxb*imag(om(ii,jj))/fxb
        !  diffusivity for eddy potential vorticity flux
        do k=2,nz-1
          fxb = sqrt(kx_max(i,j)**2+ky_max(i,j)**2)
          c=om(ii,jj)/fxb
          umag = (ub(k)*kx_max(i,j)+vb(k)*ky_max(i,j))/fxb
          fxa = 0.5*amp**2 *fxb*imag(c) *abs(phi(k)/(umag-c))**2
          gb=sqrt(qx(k)**2+qy(k)**2)+1e-28
          K_iso(i,j,k)=fxa
          diff1(ii,jj,k)= fxa* ( (-ky_max(i,j)*Qx(k)+kx_max(i,j)*Qy(k))/fxb )**2/gb**2
          diff1(ii,jj,k)=min(K_max,max(K_min, diff1(ii,jj,k) ))
        enddo
        ! vertical derivative is buoyancy
        do k=2,nz-1
         phiz(k)=(phi(k+1)-phi(k-1))/(2*dz)
        enddo
        phiz(2)=(phi(3)-phi(2))/dz
        phiz(nz-1)=(phi(nz-1)-phi(nz-2))/dz
        ! diffusivity for eddy buoyancy flux
        do k=2,nz-1
          by   = -(rho1(i,j+1,k)-rho1(i,j-1,k))/(2*dx) /rho_0*grav
          bx   = -(rho1(i+1,j,k)-rho1(i-1,j,k))/(2*dx) /rho_0*grav
          !gb = sqrt(bx**2+by**2)+1e-22
          gb =    max(M_min, sqrt(bx**2+by**2) )
          fxb = sqrt(kx_max(i,j)**2+ky_max(i,j)**2)
          fxa = 0.5*amp**2*fxb*f0*real(im*phi(k)*conjg(phiz(k)))/gb
          diff2(ii,jj,k) =  fxa*(-ky_max(i,j)*bx+kx_max(i,j)*by)/fxb/gb
        enddo
        if (sum(diff2(ii,jj,2:nz-1))<0.0) then
           diff2(ii,jj,:)=-diff2(ii,jj,:) ! choose complex conjugate solution
        endif
        diff2(ii,jj,:)=min(K_max,max(K_min, diff2(ii,jj,:) ))
      else ! growth rate has not changed much, use old estimates
        diff1(ii,jj,:)=K_pv(i,j,:,2)
        diff2(ii,jj,:)=K_rho(i,j,:,2)
        om(ii,jj) = om(i,j)
      endif 
    endif ! maskT
   enddo
  enddo

  ! communication between PEs
  jj=0
  do j=2+jLr/2 ,ny-1,jLr
   jj=jj+1; 
   i=0; if (j>=js .and. j<=je) i=my_pe
   call global_max_int(i,1)
   do k=2,nz-1
    call bcast_real(diff1(1,jj,k),ii,i)
    call bcast_real(diff2(1,jj,k),ii,i)
   enddo
   d2(1:ii,1)=real(om(1:ii,jj)); call bcast_real(d2(1,1),ii,i) 
   d2(1:ii,2)=imag(om(1:ii,jj)); call bcast_real(d2(1,2),ii,i)
   om(1:ii,jj) = cmplx( d2(1:ii,1), d2(1:ii,2) )
  enddo

  ! now interpolate between estimates (done by every pe)
  xx(1:ii+2)=(/xt(1),xx(1:ii),xt(nx)/)
  yy(1:jj+2)=(/yt(1),yy(1:jj),yt(ny)/) 

  ! interpolate growth rate
  d2=spval; d3=0; 
  d2(2:ii+1,2:jj+1)=real( om(1:ii,1:jj) )
  where (d2(2:ii+1,2:jj+1)<-1.0) d2(2:ii+1,2:jj+1)=spval
  if (enable_cyclic_x) then
    d2(1,:)=d2(ii+1,:); d2(ii+2,:)=d2(2,:)
  endif
  call fillgaps(ii+2,jj+2,d2(1:ii+2,1:jj+2),spval)
  call rgrd2(ii+2,jj+2,xx,yy,d2(1:ii+2,1:jj+2),nx,ny,xt,yt,d3,ier)
  d2=spval; d4=0; 
  d2(2:ii+1,2:jj+1)=imag( om(1:ii,1:jj) )
  where (d2(2:ii+1,2:jj+1)<-1.0) d2(2:ii+1,2:jj+1)=spval
  if (enable_cyclic_x) then
    d2(1,:)=d2(ii+1,:); d2(ii+2,:)=d2(2,:)
  endif
  call fillgaps(ii+2,jj+2,d2(1:ii+2,1:jj+2),spval)
  call rgrd2(ii+2,jj+2,xx,yy,d2(1:ii+2,1:jj+2),nx,ny,xt,yt,d4,ier)
  om = cmplx(d3,d4) 

  do k=2,nz-1
   ! interpolate PV diffusivity
   d2=spval
   d2(2:ii+1,2:jj+1)=diff1(1:ii,1:jj,k)
   if (enable_cyclic_x) then
    d2(1,:)=d2(ii+1,:); d2(ii+2,:)=d2(2,:)
   endif
   call fillgaps(ii+2,jj+2,d2(1:ii+2,1:jj+2),spval)
   K_pv(:,:,k,1)= K_pv(:,:,k,2)
   call rgrd2(ii+2,jj+2,xx,yy,d2(1:ii+2,1:jj+2),nx,ny,xt,yt,K_pv(:,:,k,2),ier)
   if (ier/=0) then 
      print*,' Error: interpolation of K_pv failed'
      print*,'ier=',ier
      stop
   endif
   ! interpolate density diffusivity
   d2=spval
   d2(2:ii+1,2:jj+1)=diff2(1:ii,1:jj,k)
   if (enable_cyclic_x) then
    d2(1,:)=d2(ii+1,:); d2(ii+2,:)=d2(2,:)
   endif
   call fillgaps(ii+2,jj+2,d2(1:ii+2,1:jj+2),spval)
   K_rho(:,:,k,1)= K_rho(:,:,k,2)
   call rgrd2(ii+2,jj+2,xx,yy,d2(1:ii+2,1:jj+2),nx,ny,xt,yt,K_rho(:,:,k,2),ier)
  enddo

 if (enable_pv_mixing_smooth_diff) then
   call setcyclic3D(nx,ny,nz,K_rho(:,:,:,2) )
   call setcyclic3D(nx,ny,nz,K_pv(:,:,:,2) )
   rxytmp=0
   do k=2,nz-1
     call running_mean2(K_rho(:,:,k,2),rxytmp,nx,ny,k_runmean)    
     where (rmask(:,:,k)/=0.0); K_rho(:,:,k,2)=rxytmp/rmask(:,:,k); elsewhere; K_rho(:,:,k,2)=0.0; end where
     call running_mean2(K_pv(:,:,k,2),rxytmp,nx,ny,k_runmean)    
     where (rmask(:,:,k)/=0.0); K_pv(:,:,k,2)=rxytmp/rmask(:,:,k); elsewhere; K_pv(:,:,k,2)=0.0; end where
   enddo
  endif


  call border_exchg3D(nx,ny,nz,K_pv(:,:,:,2),1)
  call setcyclic3D(nx,ny,nz,K_pv(:,:,:,2) )
  call border_exchg3D(nx,ny,nz,K_rho(:,:,:,2),1)
  call setcyclic3D(nx,ny,nz,K_rho(:,:,:,2) )
  if (pv_mixing_initialized)  then
       K_rho(:,:,:,1) = K_rho(:,:,:,2)
       K_pv(:,:,:,1)  = K_pv(:,:,:,2)
  endif
  first = .false.
end subroutine pv_mixing_calc_diff_somewhere





subroutine pv_mixing_zonal_trm
 !=======================================================================
 !     calculate only TRM force and add to tendencies for u
 !=======================================================================
  use pyOM_module
  use fcontrol_module
  use pv_mixing_module
  implicit none
  integer :: i,j,k,js,je,n,ne
  real*8 :: fxa,fxb,fxc, tx
  real*8, dimension(nx,ny,nz) :: diff_ft,A_uu,diff_fe,diff_fn

  ! time interpolation factor
  ne = int(pv_mixing_calcint/dt)
  n = itt/ne
  n = itt-n*ne
  tx = (n*1.0)/(1.0*ne)

  js=max(2,js_pe); je = min(je_pe,ny -1)
  vtendu(:,js:je,:)=0.; A_uu(:,js:je,:)=0.0; htendu(:,js:je,:)=0.0
 !-----------------------------------------------------------------------
 !      vertical friction of residual momentum: K(f^2/N^2 u_z)_z
 !      prepare coefficients for implicit part
 !-----------------------------------------------------------------------
  do k=1,nz-1
        do j=js,je
         do i=2,nx -1
          fxb=0.5*(K_rho(i,j,k,2)+K_rho(i+1,j,k,2))
          fxc=0.5*(K_rho(i,j,k,1)+K_rho(i+1,j,k,1))
          fxb = fxb * tx + fxc * (1-tx)
          fxa=0.5*(fNsqrw(i,j,k)+fNsqrw(i+1,j,k))
          A_uu(i,j,k) =fxb*fxa*maskU(i,j,k+1)*maskU(i,j,k)
         enddo
        enddo
  enddo
 !-----------------------------------------------------------------------
 !     now explicit part
 !-----------------------------------------------------------------------
  diff_ft(:,js:je,:)=0.
  do k=1,nz-1
        do j=js,je
         do i=2,nx -1
          diff_ft(i,j,k)=A_uu(i,j,k)*(u(i,j,k+1,taum1)-u(i,j,k,taum1))/dz
         enddo
        enddo
       enddo
       do k=2,nz-1
        do j=js,je
         do i=2,nx -1
          vtendu(i,j,k)=maskU(i,j,k)*(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz
         enddo
        enddo
  enddo
 !-----------------------------------------------------------------------
 ! add also horizontal friction
 !-----------------------------------------------------------------------
 diff_fe(:,js:je,:)=0.0; diff_fn(:,js-1:je,:)=0.0; fxa=A_h;A_h=K_gm
 call harm_hfric_u(nx,ny,nz,diff_fe,diff_fn)
 A_h=fxa
 do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         htendu(i,j,k)=maskU(i,j,k)*( (diff_fn(i,j,k) - diff_fn(i,j-1,k))/dx    &
                                    + (diff_fe(i,j,k) - diff_fe(i-1,j,k))/dx )
        enddo
       enddo
 enddo
 !-----------------------------------------------------------------------
 !     Add to zonal momentum tendencies
 !-----------------------------------------------------------------------
  do k=2,nz-1
      do j=js,je
        do i=2,nx -1
         fu(i,j,k)=fu(i,j,k)+vtendu(i,j,k)*(1-aidif_trm)+htendu(i,j,k)
        enddo
      enddo
  enddo
 !-----------------------------------------------------------------------
 !     implicit part of vertical operator
 !-----------------------------------------------------------------------
  call trm_implicit_umix(nx,ny,nz,A_uu)
end subroutine pv_mixing_zonal_trm




subroutine pv_mixing_meridional_trm
 !=======================================================================
 !     calculate only TRM force and add to tendencies for v
 !=======================================================================
  use pyOM_module
  use fcontrol_module
  use pv_mixing_module
  implicit none
  integer :: i,j,k,js,je,n,ne
  real*8 :: fxa,fxb,fxc,tx
  real*8, dimension(nx,ny,nz) :: diff_ft,A_uu,diff_fe,diff_fn

  ! time interpolation factor
  ne = int(pv_mixing_calcint/dt)
  n = itt/ne
  n = itt-n*ne
  tx = (n*1.0)/(1.0*ne)


  js=max(2,js_pe); je = min(je_pe,ny -1)
  vtendv(:,js:je,:)=0.; A_uu(:,js:je,:)=0.0; htendv(:,js:je,:)=0.0
 !-----------------------------------------------------------------------
 !      vertical friction of residual momentum: (Kf^2/N^2 v_z)_z
 !      prepare coefficients for implicit part
 !-----------------------------------------------------------------------
  do k=1,nz-1
        do j=js,je
         do i=2,nx -1

          fxb=0.5*(K_rho(i,j,k,2)+K_rho(i,j+1,k,2))
          fxc=0.5*(K_rho(i,j,k,1)+K_rho(i,j+1,k,1))
          fxb = fxb * tx + fxc * (1-tx)

          fxa=0.5*(fNsqrw(i,j,k)+fNsqrw(i,j+1,k))
          A_uu(i,j,k) =fxb*fxa*maskV(i,j,k+1)*maskV(i,j,k)
         enddo
        enddo
  enddo
 !-----------------------------------------------------------------------
 !     now explicit part
 !-----------------------------------------------------------------------
  diff_ft(:,js:je,:)=0.
  do k=1,nz-1
        do j=js,je
         do i=2,nx -1
          diff_ft(i,j,k)=A_uu(i,j,k)*(v(i,j,k+1,taum1)-v(i,j,k,taum1))/dz
         enddo
        enddo
       enddo
       do k=2,nz-1
        do j=js,je
         do i=2,nx -1
          vtendv(i,j,k)=maskV(i,j,k)*(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz
         enddo
        enddo
  enddo
 !-----------------------------------------------------------------------
 ! add also horizontal friction
 !-----------------------------------------------------------------------
  diff_fe(:,js:je,:)=0.0; diff_fn(:,js-1:je,:)=0.0; fxa=A_h;A_h=K_gm
  call harm_hfric_v(nx,ny,nz,diff_fe,diff_fn)
  A_h=fxa
  do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         htendv(i,j,k)=maskV(i,j,k)* ( (diff_fn(i,j,k) - diff_fn(i,j-1,k))/dx   &
                                     + (diff_fe(i,j,k) - diff_fe(i-1,j,k))/dx )
        enddo
       enddo
  enddo
 !-----------------------------------------------------------------------
 !     Add to meridional momentum tendencies
 !-----------------------------------------------------------------------
  do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fv(i,j,k)=fv(i,j,k)+vtendv(i,j,k)*(1-aidif_trm) +htendv(i,j,k)
        enddo
       enddo
  enddo
 !-----------------------------------------------------------------------
 !     implicit part of vertical operator
 !-----------------------------------------------------------------------
  call trm_implicit_vmix(nx,ny,nz,A_uu)
end subroutine pv_mixing_meridional_trm



subroutine pv_mixing_zonal
 !=======================================================================
 !     calculate all forces and add to tendencies for u
 !=======================================================================
  use pyOM_module
  use fcontrol_module
  use pv_mixing_module
  implicit none
  integer :: i,j,k,js,je,jj,ii,n,ne
  real*8 :: fxa,fxb,fxc,tx
  real*8, dimension(nx,ny,nz) :: diff_ft,diff_fe,diff_fn,A_uu,A2_uu
  logical, save :: first = .false.
  real*8, allocatable, save :: rmask(:,:,:)
  real*8 :: rxytmp(nx,ny)

  ! time interpolation factor
  ne = int(pv_mixing_calcint/dt)
  n = itt/ne
  n = itt-n*ne
  tx = (n*1.0)/(1.0*ne)

  js=max(2,js_pe); je = min(je_pe,ny -1)
  vtendu(:,js:je,:)=0.; htendu(:,js:je,:)=0; theta_u(:,js:je,:) = 0
  A_uu(:,js:je,:)=0.0;A2_uu(:,js:je,:)=0 ! A_uu is factor inside 2. derivative, A2_uu outside
 !-----------------------------------------------------------------------
 !      vertical friction of residual momentum: K(f^2/N^2 u_z)_z
 !      prepare coefficients for implicit part
 !-----------------------------------------------------------------------
  do k=1,nz-1
        do j=js,je
         do i=2,nx -1
          fxb=0.5*(K_pv(i,j,k,2)+K_pv(i+1,j,k,2))
          fxc=0.5*(K_pv(i,j,k,1)+K_pv(i+1,j,k,1))
          fxb = fxb * tx + fxc * (1-tx)

          fxa=0.5*(fNsqrw(i,j,k)+fNsqrw(i+1,j,k))
          A2_uu(i,j,k)=fxb
          A_uu(i,j,k) =fxa*maskU(i,j,k+1)*maskU(i,j,k)
         enddo
        enddo
  enddo
 !-----------------------------------------------------------------------
 !     now explicit part
 !-----------------------------------------------------------------------
  diff_ft(:,js:je,:)=0.
  do k=1,nz-1
        do j=js,je
         do i=2,nx -1
          diff_ft(i,j,k)=A_uu(i,j,k)*(u(i,j,k+1,taum1)-u(i,j,k,taum1))/dz
         enddo
        enddo
       enddo
       do k=2,nz-1
        do j=js,je
         do i=2,nx -1
          vtendu(i,j,k)=maskU(i,j,k)*A2_uu(i,j,k)*(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz
         enddo
        enddo
  enddo
 !-----------------------------------------------------------------------
 !     horizontal friction and beta term: K(u_yy+u_xx-beta)
 !-----------------------------------------------------------------------
  if (enable_pv_mixing_beta_term) then
   do k=2,nz-1
     do j=js,je
       do i=2,nx -1
         fxb=0.5*(K_pv(i,j,k,2)+K_pv(i+1,j,k,2))
         fxc=0.5*(K_pv(i,j,k,1)+K_pv(i+1,j,k,1))
         fxa = fxb * tx + fxc * (1-tx) 
         fxb = (coriolis_t(j+1)-coriolis_t(j-1) )/(2*dx)
         htendu(i,j,k)=fxa*maskU(i,j,k)*( - fxb)
        enddo
     enddo
   enddo
  endif

  if (enable_pv_mixing_friction) then
    diff_fe(:,js:je,:)=0.0; diff_fn(:,js-1:je,:)=0.0; fxa=A_h;A_h=1.0
    call harm_hfric_u(nx,ny,nz,diff_fe,diff_fn)
    A_h=fxa
    do k=2,nz-1
     do j=js,je
       do i=2,nx -1
         fxb=0.5*(K_pv(i,j,k,2)+K_pv(i+1,j,k,2))
         fxc=0.5*(K_pv(i,j,k,1)+K_pv(i+1,j,k,1))
         fxa = fxb * tx + fxc * (1-tx) 
         fxa = min( K_hor_min, fxa  )
         htendu(i,j,k)=fxa*maskU(i,j,k)*( (diff_fn(i,j,k) - diff_fn(i,j-1,k))/dx    &
                                        + (diff_fe(i,j,k) - diff_fe(i-1,j,k))/dx )
        enddo
     enddo
   enddo
  endif

 !-----------------------------------------------------------------------
 !     integrate Reynolds stress and substract mean force
 !     theta = 1/(V) int dv (K(u_yy+u_xx-beta)+K_z f b_y 
 !-----------------------------------------------------------------------
  if (first) then
    allocate(rmask(nx,ny,nz))
    rmask(:,:,:)=maskU
    do k=2,nz-1
       call running_mean2(rmask(:,:,k),rxytmp,nx,ny,j_constraint)    
       rmask(:,:,k)=rxytmp*maskU(:,:,k)
    enddo
  endif
  do k=2,nz-1
    call running_mean2(vtendu(:,:,k)+htendu(:,:,k),rxytmp,nx,ny,j_constraint)    
    where (rmask(:,:,k)/=0.0) theta_u(:,:,k)=rxytmp/rmask(:,:,k)
  enddo

  fxb=0.0;fxc=0.0
  do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fxa=dz*dx**2*maskU(i,j,k)
         fxb=fxb+fxa*(vtendu(i,j,k)+htendu(i,j,k)-theta_u(i,j,k))
         fxc=fxc+fxa
        enddo
       enddo
  enddo
  call global_sum(fxb)
  call global_sum(fxc)
  if (fxc/=0.0) theta_u(:,js:je,:)=theta_u(:,js:je,:)+fxb/fxc   

 !-----------------------------------------------------------------------
 !     Add to zonal momentum tendencies
 !-----------------------------------------------------------------------
  do k=2,nz-1
      do j=js,je
        do i=2,nx -1
         fu(i,j,k)=fu(i,j,k)+vtendu(i,j,k)*(1-aidif_trm)+htendu(i,j,k)-theta_u(i,j,k)
        enddo
      enddo
  enddo
 !-----------------------------------------------------------------------
 !     implicit part of vertical operator
 !-----------------------------------------------------------------------
  call pv_mixing_implicit_umix(nx,ny,nz,A_uu,A2_uu)
  first = .false.
end subroutine pv_mixing_zonal








subroutine pv_mixing_meridional
 !=======================================================================
 !     calculate all forces and add to tendencies for v
 !=======================================================================
  use pyOM_module
  use fcontrol_module
  use pv_mixing_module
  implicit none
  integer :: i,j,k,js,je,jj,ii,n,ne
  real*8 :: fxa,fxb,fxc,tx
  real*8, dimension(nx,ny,nz) :: diff_ft,diff_fe,diff_fn,A_uu,A2_uu
  logical, save :: first = .false.
  real*8, allocatable, save :: rmask(:,:,:)
  real*8 :: rxytmp(nx,ny)

  ! time interpolation factor
  ne = int(pv_mixing_calcint/dt)
  n = itt/ne
  n = itt-n*ne
  tx = (n*1.0)/(1.0*ne)

  js=max(2,js_pe); je = min(je_pe,ny -1)
  vtendv(:,js:je,:)=0.; htendv(:,js:je,:)=0; theta_v(:,js:je,:) = 0
  A_uu(:,js:je,:)=0.0;A2_uu(:,js:je,:)=0 ! A_uu is factor inside 2. derivative, A2_uu outside
 !-----------------------------------------------------------------------
 !      vertical friction of residual momentum: K(f^2/N^2 v_z)_z
 !      prepare coefficients for implicit part
 !-----------------------------------------------------------------------
  do k=1,nz-1
        do j=js,je
         do i=2,nx -1
          fxb=0.5*(K_pv(i,j,k,2)+K_pv(i,j+1,k,2))
          fxc=0.5*(K_pv(i,j,k,1)+K_pv(i,j+1,k,1))
          fxb =fxb * tx + fxc * (1-tx) 
          fxa=0.5*(fNsqrw(i,j,k)+fNsqrw(i,j+1,k))
          A2_uu(i,j,k)=fxb
          A_uu(i,j,k) =fxa*maskV(i,j,k+1)*maskV(i,j,k)
         enddo
        enddo
  enddo
 !-----------------------------------------------------------------------
 !     now explicit part
 !-----------------------------------------------------------------------
  diff_ft(:,js:je,:)=0.
  do k=1,nz-1
        do j=js,je
         do i=2,nx -1
          diff_ft(i,j,k)=A_uu(i,j,k)*(v(i,j,k+1,taum1)-v(i,j,k,taum1))/dz
         enddo
        enddo
       enddo
       do k=2,nz-1
        do j=js,je
         do i=2,nx -1
          vtendv(i,j,k)=maskV(i,j,k)*A2_uu(i,j,k)*(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz
         enddo
        enddo
  enddo
 !-----------------------------------------------------------------------
 !     horizontal friction and no beta term: K(v_yy+v_xx)
 !-----------------------------------------------------------------------
  if (enable_pv_mixing_friction) then
   diff_fe(:,js:je,:)=0.0; diff_fn(:,js-1:je,:)=0.0; fxa=A_h;A_h=1.0
   call harm_hfric_v(nx,ny,nz,diff_fe,diff_fn)
   A_h=fxa
   do k=2,nz-1
        do j=js,je
         do i=2,nx -1
          fxb=0.5*(K_pv(i,j,k,2)+K_pv(i,j+1,k,2))
          fxc=0.5*(K_pv(i,j,k,1)+K_pv(i,j+1,k,1))
          fxa = min( K_hor_min, fxb * tx + fxc * (1-tx)  )
          htendv(i,j,k)=fxa*maskV(i,j,k)* ( (diff_fn(i,j,k) - diff_fn(i,j-1,k))/dx   &
                                          + (diff_fe(i,j,k) - diff_fe(i-1,j,k))/dx )
         enddo
        enddo
   enddo
  endif
 !-----------------------------------------------------------------------
 !     integrate Reynolds stress and substract mean force
 !     theta = 1/(V) int dv (K(v_yy+v_xx)-K_z f b_x 
 !-----------------------------------------------------------------------

  if (first) then
    allocate(rmask(nx,ny,nz))
    rmask(:,:,:)=maskV
    do k=2,nz-1
       call running_mean2(rmask(:,:,k),rxytmp,nx,ny,j_constraint)    
       rmask(:,:,k)=rxytmp*maskV(:,:,k)
    enddo
  endif
  do k=2,nz-1
    call running_mean2(vtendv(:,:,k)+htendv(:,:,k),rxytmp,nx,ny,j_constraint)    
    where (rmask(:,:,k)/=0.0) theta_v(:,:,k)=rxytmp/rmask(:,:,k)
  enddo

  fxb=0.0;fxc=0.0
  do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fxa=dz*dx**2*maskV(i,j,k)
         fxb=fxb+fxa*(vtendv(i,j,k)+htendv(i,j,k)-theta_v(i,j,k))
         fxc=fxc+fxa
        enddo
       enddo
  enddo
  call global_sum(fxb)
  call global_sum(fxc)
  if (fxc/=0.0) theta_v(:,js:je,:)=theta_v(:,js:je,:)+fxb/fxc   
 !-----------------------------------------------------------------------
 !     Add to meridional momentum tendencies
 !-----------------------------------------------------------------------
  do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fv(i,j,k)=fv(i,j,k)+vtendv(i,j,k)*(1-aidif_trm) +htendv(i,j,k)-theta_v(i,j,k)
        enddo
       enddo
  enddo
 !-----------------------------------------------------------------------
 !     implicit part of vertical operator
 !-----------------------------------------------------------------------
  call pv_mixing_implicit_vmix(nx,ny,nz,A_uu,A2_uu)
  first=.false.
 end subroutine pv_mixing_meridional



subroutine pv_mixing_diag
 !-----------------------------------------------------------------------
 !    diagnostic
 !-----------------------------------------------------------------------
 use pyOM_module
 use pv_mixing_module
 use fcontrol_module
 implicit none
      include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      real*8 :: a(nx,js_pe:je_pe,nz),fxa,time,fxb,tx
      integer :: itdimid,ilen,itimeid
      integer :: id,i,j,k,ne
      integer :: js,je
      character :: name*24
      real*8,parameter :: spval = -1.0d33


   if (.not. enable_pv_mixing_diag ) return

   if  (mod(itt,int(pv_mixing_diagint/dt))  == 0)  then


     ! time interpolation factor
      ne = int(pv_mixing_calcint/dt)
      n = itt/ne
      n = itt-n*ne
      tx = (n*1.0)/(1.0*ne)

      js=max(2,js_pe); je = min(je_pe,ny -1)
      do npe=0,n_pes
       if (my_pe==npe) then
        iret=nf_open('pvmix.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_varid(ncid,'vtendu',id)
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        if (my_pe==0) then
         ilen=ilen+1
         time = itt*dt ! current_time-initial_time
         fxa = time/86400.0 ! time%days + time%seconds/86400.
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
        endif
        Corner = (/1,js_pe,1,ilen/); 
        edges  = (/nx,je_pe-js_pe+1,nz,1/)

        iret=nf_inq_varid(ncid,'K_pv',id)
        a(:,js_pe:je_pe,:)=K_pv(:,js_pe:je_pe,:,2) *tx + K_pv(:,js_pe:je_pe,:,1) *(1-tx)
        where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a)

        iret=nf_inq_varid(ncid,'K_rho',id)
        a(:,js_pe:je_pe,:)=K_rho(:,js_pe:je_pe,:,2) *tx + K_rho(:,js_pe:je_pe,:,1) *(1-tx)
        where( maskT(:,js_pe:je_pe,:) == 0.) a(:,js_pe:je_pe,:) = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a)

        if (enable_pv_mixing_calc_diff) then 

         iret=nf_inq_varid(ncid,'K_iso',id)
         a(:,js_pe:je_pe,:)=K_iso(:,js_pe:je_pe,:) 
         where( maskT(:,js_pe:je_pe,:) == 0.) a(:,js_pe:je_pe,:) = spval
         iret= nf_put_vara_double(ncid,id,corner,edges,a)

         Corner = (/1,js_pe,ilen,1/); 
         edges  = (/nx,je_pe-js_pe+1,1,1/)
         iret=nf_inq_varid(ncid,'om_i',id)
         a(:,js_pe:je_pe,1)=imag(om(:,js_pe:je_pe) )
         where( maskT(:,js_pe:je_pe,nz-1) == 0.) a(:,js_pe:je_pe,1) = spval
         iret= nf_put_vara_double(ncid,id,corner,edges,a)

         iret=nf_inq_varid(ncid,'kx_max',id)
         a(:,js_pe:je_pe,1)=kx_max(:,js_pe:je_pe) 
         where( maskT(:,js_pe:je_pe,nz-1) == 0.) a(:,js_pe:je_pe,1) = spval
         iret= nf_put_vara_double(ncid,id,corner,edges,a)

         iret=nf_inq_varid(ncid,'ky_max',id)
         a(:,js_pe:je_pe,1)=ky_max(:,js_pe:je_pe) 
         where( maskT(:,js_pe:je_pe,nz-1) == 0.) a(:,js_pe:je_pe,1) = spval
         iret= nf_put_vara_double(ncid,id,corner,edges,a)


        endif
        call ncclos (ncid, iret)
       endif
       call fortran_barrier
      enddo
    endif
end subroutine pv_mixing_diag



subroutine pv_mixing_diag_init
 !-----------------------------------------------------------------------
 !    diagnostic
 !-----------------------------------------------------------------------
 use pyOM_module
 use pv_mixing_module
 implicit none

     include "netcdf.inc"
      integer :: ncid,iret,n
      integer :: lon_tdim,z_tdim,itimedim,lat_tdim
      integer :: lon_udim,z_udim,lat_udim,id
      integer :: dims(4)
      character :: name*24, unit*16
      real*8,parameter :: spval = -1.0d33

   if (.not. enable_pv_mixing_diag ) return

   if (my_pe == 0) then

      call def_grid_cdf('pvmix.cdf')
      iret=nf_open('pvmix.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'xu',lon_udim)
      iret=nf_inq_dimid(ncid,'yu',lat_udim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)
      dims = (/Lon_udim,lat_tdim, z_tdim, iTimedim/)

      dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
      id = ncvdef (ncid,'K_pv', NCFLOAT,4,dims,iret)
      name = 'lateral diffusivity'; unit = 'm^2/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      id = ncvdef (ncid,'K_rho', NCFLOAT,4,dims,iret)
      name = 'diffusivity'; unit = 'm^2/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      if (enable_pv_mixing_calc_diff) then 

       id = ncvdef (ncid,'K_iso', NCFLOAT,4,dims,iret)
       name = 'diffusivity'; unit = 'm^2/s'
       call dvcdf(ncid,id,name,24,unit,16,spval)

       dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
       id = ncvdef (ncid,'kx_max', NCFLOAT,3,dims,iret)
       name = 'wavenumber'; unit = '1/m'
       call dvcdf(ncid,id,name,24,unit,16,spval)

       id = ncvdef (ncid,'ky_max', NCFLOAT,3,dims,iret)
       name = 'wavenumber'; unit = '1/m'
       call dvcdf(ncid,id,name,24,unit,16,spval)

       id = ncvdef (ncid,'om_i', NCFLOAT,3,dims,iret)
       name = 'growth rate'; unit = '1/s'
       call dvcdf(ncid,id,name,24,unit,16,spval)
      endif

      call ncclos (ncid, iret)
   endif

   call fortran_barrier
end subroutine pv_mixing_diag_init






subroutine pv_mixing_implicit_umix(nx_,ny_,nz_,A_uu,A2_uu)
 !=======================================================================
 !     implicit vertical friction
 !
 !     u^{n+1} = u^{n-1} + 2 dt ( ... + K ( N u_z )_z  )
 !
 !     K( N u_z )_z = K [N^{k+1/2}(u^{k+1}-u^k)/dz - N^{k-1/2}(u^k-u^{k-1})/dz]/dz
 !     K( N u_z )_z = K N^{k+1/2}/dz^2 u^{k+1} - K (N^{k+1/2}+N^{k-1/2})/dz^2 u^k 
 !                    + K N^{k-1/2}/dz^2 u^{k-1}
 !
 !     u^{n+1} = u^* + 2 dt K(N u_z^{n+1})_z
 !     u^k   = u^* + 2 dt/dz^2 K ( N^{k+1/2} u^{k+1} - (N^{k+1/2}+N^{k-1/2}) u^k 
 !                               + N^{k-1/2} u^{k-1} )
 !     u^k (1+ 2 dt/dz^2 K (N^{k+1/2}+K^{k-1/2}) ) = 
 !            u^*+ 2 dt/dz^2 (K^k N^{k+1/2} u^{k+1} + K^k N^{k-1/2} u^{k-1})
 !
 !     upper boundary condition
 !     K ( N u_z )_z  =ca.  [F - K N^{k-1/2}(u^k-u^{k-1})/dz]/dz
 !     K ( N b_z )_z  =   F/dz - K N^{k-1/2}/dz^2 u^k + K N^{k-1/2}/dz^2 u^{k-1}
 !     u^k   = u^* +  2 dt/dz^2 ( F dz - K N^{k-1&2} u^k + K N^{k-1/2} u^{k-1})
 !     u^k (1+ 2 dt/dz^2 K N^{k-1/2} ) = u^*+ F 2dt/dz + 2 dt/dz^2  K N^{k-1/2} u^{k-1}
 !
 !     lower boundary condition
 !     K(N u_z )_z  =  K [N^{k+1/2}(u^{k+1}-u^k)/dz]/dz
 !     K(N u_z )_z  =  K N^{k+1/2}/dz^2 u^{k+1} - K N^{k+1/2}/dz^2 u^k 
 !     u^k (1+ 2 dt/dz^2 K N^{k+1/2} ) = u^*+ 2 dt/dz^2 K N^{k+1/2} u^{k+1} 
 !=======================================================================
      use pyOM_module
      implicit none
      integer :: nx_,ny_,nz_
      integer :: j,k,js,je
      real*8 :: A_uu(nx_,ny_,nz_) ,A2_uu(nx_,ny_,nz_)
      real*8 :: a(nx ,nz),bb(nx ,nz),c(nx ,nz),bet(nx )
      real*8 :: pu(nx ,nz),gam(nx ,nz),fxa,r(nx ,nz)

      js=max(2,js_pe); je = min(je_pe,ny -1)
 !---------------------------------------------------------------------------------
 !      first fake integrate du/dt = F_u, then solve for rest
 !---------------------------------------------------------------------------------
      u(:,js:je,:,taup1)= u(:,js:je,:,taum1) +c2dt*fu(:,js:je,:)*maskU(:,js:je,:)
      do j=js,je
       fxa = aidif_trm*c2dt/dz**2
       bb(:,1) = 1+fxa * A2_uu(:,j,1)*A_uu(:,j,1)
       c(:,1)  =  -fxa * A2_uu(:,j,1)*A_uu(:,j,1)
       do k=2,nz-1
         a(:,k)  =  -fxa * A2_uu(:,j,k)* A_uu(:,j,k-1)
         bb(:,k) = 1+fxa * A2_uu(:,j,k)*(A_uu(:,j,k)+A_uu(:,j,k-1) )
         c(:,k)  =  -fxa * A2_uu(:,j,k)* A_uu(:,j,k)
       enddo
       a(:,nz)  =  -fxa * A2_uu(:,j,nz)* A_uu(:,j,nz-1)
       bb(:,nz) = 1+fxa * A2_uu(:,j,nz)* A_uu(:,j,nz-1) 
       pu=0.0;gam=0.0
       r=u(:,j,:,taup1)*maskU(:,j,:)
       bet=bb(:,1)
       where (bet/=0.0) pu(:,1)=r(:,1)/bet
       do k=2,nz
        where (bet/=0.0) gam(:,k)=c(:,k-1)/bet
        bet=bb(:,k)-a(:,k)*gam(:,k)
        where(bet/=0.0) pu(:,k)=(r(:,k)-a(:,k)*pu(:,k-1))/bet
       enddo
       do k=nz-1,1,-1
        pu(:,k)=pu(:,k)-gam(:,k+1)*pu(:,k+1)
       enddo
       u(:,j,:,taup1)=pu
      enddo
      fu(:,js:je,:)=(u(:,js:je,:,taup1) -u(:,js:je,:,taum1))/c2dt*maskU(:,js:je,:)
end subroutine pv_mixing_implicit_umix


subroutine pv_mixing_implicit_vmix(nx_,ny_,nz_,A_uu,A2_uu)
 !---------------------------------------------------------------------------------
 !     same for v
 !---------------------------------------------------------------------------------
      use pyOM_module
      implicit none
      integer :: nx_,ny_,nz_
      integer :: j,k,js,je
      real*8 :: A_uu(nx_,ny_,nz_) ,A2_uu(nx_,ny_,nz_)
      real*8 :: a(nx ,nz),bb(nx ,nz),c(nx ,nz),bet(nx )
      real*8 :: pu(nx ,nz),gam(nx ,nz),fxa,r(nx ,nz)

      js=max(2,js_pe); je = min(je_pe,ny -1)
 !---------------------------------------------------------------------------------
 !      first fake integrate dv/dt = F_v, then solve for rest
 !---------------------------------------------------------------------------------
      v(:,js:je,:,taup1)= v(:,js:je,:,taum1) +c2dt*fv(:,js:je,:)*maskV(:,js:je,:)

      do j=js,je
       fxa = aidif_trm*c2dt/dz**2
       bb(:,1) = 1+fxa * A2_uu(:,j,1)*A_uu(:,j,1)
       c(:,1)  =  -fxa * A2_uu(:,j,1)*A_uu(:,j,1)
       do k=2,nz-1
         a(:,k)  =  -fxa * A2_uu(:,j,k)* A_uu(:,j,k-1)
         bb(:,k) = 1+fxa * A2_uu(:,j,k)*(A_uu(:,j,k)+A_uu(:,j,k-1) )
         c(:,k)  =  -fxa * A2_uu(:,j,k)* A_uu(:,j,k)
       enddo
       a(:,nz)  =  -fxa * A2_uu(:,j,nz)* A_uu(:,j,nz-1)
       bb(:,nz) = 1+fxa * A2_uu(:,j,nz)* A_uu(:,j,nz-1) 
       pu=0.0;gam=0.0
       r=v(:,j,:,taup1)*maskV(:,j,:)
       bet=bb(:,1)
       where (bet/=0.0) pu(:,1)=r(:,1)/bet
       do k=2,nz
        where (bet/=0.0) gam(:,k)=c(:,k-1)/bet
        bet=bb(:,k)-a(:,k)*gam(:,k)
        where(bet/=0.0) pu(:,k)=(r(:,k)-a(:,k)*pu(:,k-1))/bet
       enddo
       do k=nz-1,1,-1
        pu(:,k)=pu(:,k)-gam(:,k+1)*pu(:,k+1)
       enddo
       v(:,j,:,taup1)=pu
      enddo
      fv(:,js:je,:)=(v(:,js:je,:,taup1) -v(:,js:je,:,taum1))/c2dt*maskV(:,js:je,:)
end subroutine pv_mixing_implicit_vmix






subroutine vertical_eigenvalues0b(nb,rho,u,v,f0,beta,dz,Lr,omax,psimax,kx_max,ky_max,Qx,Qy,ier) 
!------------------------------------------------------------------------
! approx. quasi geostrophic vertical eigenvalue problem after
!------------------------------------------------------------------------
 implicit none
 real*8, parameter :: rho_0 = 1024, grav = 9.81,N_min=0.001,drho_min = (N_min**2)*rho_0/grav
 integer :: nb,k,ier,info,lwork,n,nk=16
 real*8 :: rho(nb),u(nb),v(nb),beta,f0,dz,Lr,Qy(nb),Qx(nb)
 real*8 :: kx_max,ky_max
 real*8 :: Nsqr(nb) ,drho(nb)
 complex*8 :: cmax,omax,psimax(nb),H1(nb),H2(nb),H3(nb)

 real*8 :: Gij(nb,nb),Bij(nb,nb),Aij(nb,nb),Cij(nb,nb),eigv
 real*8 :: omr(nb),omi(nb),mu(nb),um,vm,uvm,uum,vvm,fxa,kmax,fxb,h0,theta
 real*8 :: uk(nb),kh_appr,kh2,betas
 complex*8 :: c0,c1,ps1(nb),pp(nb),q,h1s(nb)
 real*8, allocatable :: work(:)

 ier=0
 ! check for unstable profile
 do k=1,nb-1
  drho(k)=max( rho(k+1)-rho(k), drho_min )
 enddo
 ! vertical differencing operator
 Gij=0.0
 Gij(1,1) = -1/drho(1)/dz;
 Gij(1,2) =  1/drho(1)/dz;
 do k = 2,nb-1
     Gij(k,k-1) = 1/drho(k-1)/dz;
     Gij(k,k)   = (-1/drho(k-1) -1/drho(k))/dz;
     Gij(k,k+1) =  1/drho(k) /dz;
 enddo
 Gij(nb,nb)   = -1/drho(nb-1) /dz;
 Gij(nb,nb-1) =  1/drho(nb-1) /dz;
 Gij          = Gij*f0**2*rho_0/grav
 ! background PV gradient
 do k=1,nb
   Qy(k) = beta
   Qx(k) = 0.0
   do n=1,nb
       Qy(k) = Qy(k)-Gij(k,n)*u(n)
       Qx(k) = Qx(k)+Gij(k,n)*v(n)
   enddo
 enddo
 ! stability frequency
 Nsqr(1)= -(rho(1)-rho(2))/(dz) /rho_0*grav
 do k=2,nb-1
  Nsqr(k)= -(rho(k-1)-rho(k+1))/(2*dz) /rho_0*grav
 enddo
 Nsqr(nb)=-(rho(nb-1)-rho(nb))/(dz) /rho_0*grav
 do k=1,nb
  Nsqr(k) = max(N_min**2,Nsqr(k))
 enddo

! direction of approximate minimum
 h0=dz*nb
 um = sum(u*dz)/h0
 vm = sum(v*dz)/h0
 uvm= sum(u*v*dz)/h0
 uum = sum(u**2*dz)/h0
 vvm = sum(v**2*dz)/h0
 theta = 0.5*atan2(2*(uvm-um*vm), uum-um**2-vvm+vm**2)
 uk=u*cos(theta)+v*sin(theta)

 ! magnitude of wave number of approximate minimum
 c0 = um**2 - uum
 c0 = um + sqrt(c0)
 ps1(1)=0. 
 do k=2,nb
  ps1(k) = ps1(k-1)+dz*(c0-uk(k))**2 
 enddo
 pp(1)=0
 do k=2,nb
  pp(k) = pp(k-1)+dz*( Nsqr(k)/(f0**2*(c0-uk(k))**2)*ps1(k) )
 enddo
 q = 2*c0*sum(Uk*pp*dz)/h0 -c0**2*sum(pp*dz)/h0 - sum(Uk**2*pp*dz)/h0
 q = q/( 2*(c0-sum(Uk*dz)/h0))
 fxa = -imag(c0)/(3*imag(q))  
 if (fxa > 0) then
   kh_appr=  sqrt(fxa) 
 else
    kh_appr=  1.6/Lr
 endif
 !kh_appr= real( sqrt(-imag(c0)/(3*imag(q)) )) 
 kh_appr = min(5.0/Lr, max( 0.1/Lr, kh_appr)  ) ! limit wavenumber
 kx_max=kh_appr*cos(theta)
 ky_max=kh_appr*sin(theta)
 kh2 = kx_max**2 + ky_max**2

 ! eigenvalue at that wavenumber
 betas = beta * kx_max  /kh_appr 
 c0 = (sum(Uk*dz)/h0)**2-sum(Uk**2*dz)/h0+(betas/(2*kh2))**2 
 c0 = sum(Uk*dz)/h0 -betas/(2*kh2) + sqrt( c0 )
 h1s(1)=0.0
 do k=2,nb
  h1s(k)=h1s(k-1) + dz*( (c0-Uk(k))**2*kh2 +betas* (c0-Uk(k)))  
 enddo
 h1(1)=0.0
 do k=2,nb
  h1(k)=h1(k-1) + dz*( h1s(k)*Nsqr(k)/( f0**2*(c0-Uk(k))**2 ) )  
 enddo
 c1 = c0*(c0+betas/kh2)*sum(h1*dz)/h0 &
         -(2*c0+betas/kh2)*sum(h1*Uk*dz)/h0 +sum(h1*Uk**2*dz)/h0
 c1 =-c1/(betas/kh2+2*(c0-sum(Uk*dz)/h0) )
 cmax = c0+c1
 if (imag(cmax)<0) cmax = conjg(cmax)
 fxa = imag(cmax) ! limit imaginary phase speed
 cmax = cmplx(real(cmax), min( 0.2/(kh_appr*86400.0) , fxa ) ) 
 omax = cmax*kh_appr 

 ! eigenfunction for that wavenumber and eigenvalue
 if (imag(omax)>0) then 
   H1(1)=0.0
   do k=2,nb
     H1(k)=H1(k-1)+dz*(cmax-uk(k))*(kh2*(cmax-uk(k))+betas) 
   enddo
   do k=2,nb
    H1(k) = H1(k-1)+dz*Nsqr(k)/f0**2/(cmax-uk(k))**2*H1(k)
   enddo
   H2(1)=0.0
   do k=2,nb
     H2(k)=H2(k-1)+dz*H1(k)*(cmax-uk(k))*(kh2*(cmax-uk(k))+betas) 
   enddo
   do k=2,nb
    H2(k) = H2(k-1)+dz*Nsqr(k)/f0**2/(cmax-uk(k))**2*H2(k)
   enddo
   H3(1)=0.0
   do k=2,nb
     H3(k)=H3(k-1)+dz*H2(k)*(cmax-uk(k))*(kh2*(cmax-uk(k))+betas) 
   enddo
   do k=2,nb
    H3(k) = H3(k-1)+dz*Nsqr(k)/f0**2/(cmax-uk(k))**2*H3(k)
   enddo
   psimax = (1+H1+H2+H3)*(uk-cmax)
   psimax=psimax/maxval(abs(real(psimax)) + abs(imag(psimax)) )
 else
   psimax = cmplx(0,0); 
 endif

end subroutine vertical_eigenvalues0b




subroutine vertical_eigenvalues0(nb,rho,u,v,f0,beta,dz,Lr,omax,psimax,kx_max,ky_max,Qx,Qy,ier) 
!------------------------------------------------------------------------
! approx. quasi geostrophic vertical eigenvalue problem after
!------------------------------------------------------------------------
 implicit none
 real*8, parameter :: rho_0 = 1024, grav = 9.81,N_min=0.001,drho_min = (N_min**2)*rho_0/grav
 integer :: nb,k,ier,info,lwork,n,nk=16
 real*8 :: rho(nb),u(nb),v(nb),beta,f0,dz,Lr,Qy(nb),Qx(nb)
 real*8 :: kx_max,ky_max
 real*8 :: kmag,uu(nb),Nsqr(nb) ,drho(nb)
 complex*8 :: cmax,omax,psimax(nb),H1(nb),H2(nb),H3(nb),betas

 real*8 :: Gij(nb,nb),Bij(nb,nb),Aij(nb,nb),Cij(nb,nb),eigv
 real*8 :: omr(nb),omi(nb),mu(nb),um,vm,umag,fxa,kmax,fxb
 real*8, allocatable :: work(:)


 ier=0
 ! check for unstable profile
 do k=1,nb-1
  drho(k)=max( rho(k+1)-rho(k), drho_min )
 enddo
 ! vertical differencing operator
 Gij=0.0
 Gij(1,1) = -1/drho(1)/dz;
 Gij(1,2) =  1/drho(1)/dz;
 do k = 2,nb-1
     Gij(k,k-1) = 1/drho(k-1)/dz;
     Gij(k,k)   = (-1/drho(k-1) -1/drho(k))/dz;
     Gij(k,k+1) =  1/drho(k) /dz;
 enddo
 Gij(nb,nb)   = -1/drho(nb-1) /dz;
 Gij(nb,nb-1) =  1/drho(nb-1) /dz;
 Gij          = Gij*f0**2*rho_0/grav
 ! background PV gradient
 do k=1,nb
   Qy(k) = beta
   Qx(k) = 0.0
   do n=1,nb
       Qy(k) = Qy(k)-Gij(k,n)*u(n)
       Qx(k) = Qx(k)+Gij(k,n)*v(n)
   enddo
 enddo
 ! stability frequency
 Nsqr(1)= -(rho(1)-rho(2))/(dz) /rho_0*grav
 do k=2,nb-1
  Nsqr(k)= -(rho(k-1)-rho(k+1))/(2*dz) /rho_0*grav
 enddo
 Nsqr(nb)=-(rho(nb-1)-rho(nb))/(dz) /rho_0*grav
 do k=1,nb
  Nsqr(k) = max(N_min**2,Nsqr(k))
 enddo


 ! choose wavenumber vector parallel to depth averaged flow
 um=0.0;vm=0.0
 do k=1,nb
  um=um+u(k)*dz
  vm=vm+v(k)*dz
 enddo
 um=um/(nb*dz)
 vm=vm/(nb*dz)
 umag = sqrt(um**2+vm**2)
 if (umag>0.0001) then
  um=um/umag; vm=vm/umag
 else 
  um=1; vm=0
 endif
 kmax=1.6
 kx_max=kmax/Lr*um; ky_max=kmax/Lr*vm
 kmag=sqrt(kx_max**2+ky_max**2)
 uu=(kx_max*u+ky_max*v)/kmag
 
 fxa=0;fxb=0
 do k=1,nb
  fxa=fxa+uu(k)*dz
  fxb=fxb+uu(k)**2*dz
 enddo
 fxa=fxa/(nb*dz); fxb=fxb/(nb*dz); 

 betas = beta*kx_max/kmag;
 cmax = (betas/(2*kmag**2) )**2 - fxb + fxa**2
 cmax= fxa -betas/(2*kmag**2) + sqrt(cmax)
 cmax=cmplx(real(cmax),abs(imag(cmax)))
 omax = cmax*kmag
 

 ! loop over wavenumbers to get maximal eigenvalue
 !omax=cmplx(0,0); kmax=1.6
 !do k=1,nk
 !  kx_max=4.2*(k-0.0)/(1.*nk)  /Lr*um; ky_max=4.2*(k-0.0)/(1.*nk)  /Lr*vm
 !  kmag=sqrt(kx_max**2+ky_max**2)
 !  uu=(kx_max*u+ky_max*v)/kmag
 !  ! construct matrixes and solve eigenvalue problem
 !  Cij=0.0; Aij=0.0
 !  Bij=Gij
 !  do n=1,nb
 !      Bij(n,n)=Bij(n,n)-kmag**2
 !      Cij(n,n)=kx_max*u(n)+ky_max*v(n)
 !  enddo
 !  Aij = matmul(Cij,Bij)
 !  do n=1,nb
 !      Aij(n,n)=Aij(n,n)+kx_max*Qy(n)-ky_max*Qx(n)
 !  enddo
 !  lwork=20*nb;allocate(work(lwork))
 !  call DGGEV('N','N',nb,Aij,nb,Bij,nb,omr,omi,mu,eigv,nb,eigv,nb,WORK,LWORK,INFO)
 !  deallocate(work)
 !  if (info/=0) then
 !            print*,' Error in DGGEV (1) info :',info
 !            omi=0.0;omr=0.0
 !  endif
 !  do n=1,nb
 !      if (mu(n)==0.0) then
 !         print*,' Error: mu=0 in DGGEV (1)'
 !          omr(n)=0.0;omi(n)=0.0
 !      else
 !          omr(n)=omr(n)/mu(n)
 !          omi(n)=omi(n)/mu(n)
 !      endif
 !  enddo
 !  n=maxloc(omi,1)
 !  if (omi(n)> imag(omax) ) then
 !     omax=cmplx(omr(n),omi(n))
 !     kmax= 4.2*(k-0.0)/(1.*nk)
 !  endif
 !enddo
 !kx_max=kmax/Lr*um; ky_max=kmax/Lr*vm

 if (imag(omax)>0) then 

   kmag=sqrt(kx_max**2+ky_max**2)
   uu=(kx_max*u+ky_max*v)/kmag
   cmax = omax/kmag
   betas = beta*kx_max/kmag;
   H1(1)=0.0
   do k=2,nb
     H1(k)=H1(k-1)+dz*(cmax-uu(k))*(kmag**2*(cmax-uu(k))+betas) 
   enddo
   do k=2,nb
    H1(k) = H1(k-1)+dz*Nsqr(k)/f0**2/(cmax-uu(k))**2*H1(k)
   enddo
   H2(1)=0.0
   do k=2,nb
     H2(k)=H2(k-1)+dz*H1(k)*(cmax-uu(k))*(kmag**2*(cmax-uu(k))+betas) 
   enddo
   do k=2,nb
    H2(k) = H2(k-1)+dz*Nsqr(k)/f0**2/(cmax-uu(k))**2*H2(k)
   enddo
   H3(1)=0.0
   do k=2,nb
     H3(k)=H3(k-1)+dz*H2(k)*(cmax-uu(k))*(kmag**2*(cmax-uu(k))+betas) 
   enddo
   do k=2,nb
    H3(k) = H3(k-1)+dz*Nsqr(k)/f0**2/(cmax-uu(k))**2*H3(k)
   enddo
   psimax = (1+H1+H2+H3)*(uu-cmax)
   psimax=psimax/maxval(abs(real(psimax)) + abs(imag(psimax)) )
 else
   psimax = cmplx(0,0)
 endif

end subroutine vertical_eigenvalues0







subroutine vertical_eigenvalues1(nb,rho,u,v,f0,beta,dz,Lr,omax,psimax,kx_max,ky_max,Qx,Qy,ier) 
!------------------------------------------------------------------------
! approx. quasi geostrophic vertical eigenvalue problem after
!------------------------------------------------------------------------
 implicit none
 real*8, parameter :: rho_0 = 1024, grav = 9.81, N_min = 0.001, kx_span=4.0, ky_span=4.0
 integer, parameter :: nk=16,nl=32
 integer :: nb,k,n,l,ier
 real*8 :: rho(nb),u(nb),v(nb),beta,f0,dz,Lr,Qy(nb),Qx(nb)
 real*8 :: kx_max,ky_max,kx,ky
 real*8 :: kmag,uu(nb),Nsqr(nb) ,betas,Nso(nb),ell(nb),zeta,uzu,uzl,u0,tzeta
 complex*8 :: cmax,omax,psimax(nb),c0,H1(nb),H2(nb),H3(nb),H4(nb)

 ier=0
 Nsqr(1)= -(rho(1)-rho(2))/(dz) /rho_0*grav
 do k=2,nb-1
  Nsqr(k)= -(rho(k-1)-rho(k+1))/(2*dz) /rho_0*grav
 enddo
 Nsqr(nb)= -(rho(nb-1)-rho(nb))/(dz) /rho_0*grav
 Nsqr = max(N_min**2,Nsqr)
 Nso  = sqrt(Nsqr)

 ! loop over wavenumbers and find maximum
 omax=cmplx(0,0); kx_max=0.2/Lr; ky_max=0.
 do k=1,nk
   kx=(0+ (k-1.0)/nk*kx_span) /Lr
   do l=1,nl
       ky=((l-1.0)/nl-0.5)*2 *ky_span/Lr

       ! solve eigenvalue problem approximately
       kmag=sqrt(kx**2+ky**2)
       uu=(kx*u+ky*v)/kmag
       ell=abs(f0)/kmag/Nso
       zeta=0.
       do n=1,nb
        zeta= zeta-1./ell(n)*dz
       enddo
       tzeta=0.0; if (zeta/=0.0) tzeta=1./tanh(zeta)
       uzu=ell(1 )*(uu(1   )-uu(2 ))/dz
       uzl=ell(nb)*(uu(nb-1)-uu(nb))/dz
       u0 = uu(1)+uu(nb)-(uzl-uzu)*tzeta
       c0=U0**2/4 +uzu*uzl-uu(1)*uu(nb)+(uu(1)*uzl-uu(nb)*uzu)*tzeta
       c0=u0/2+sqrt(c0)
       c0=cmplx(real(c0),abs(imag(c0)))

       if (imag(c0*kmag)>imag(omax)) then
          kx_max = kx; ky_max = ky; omax=c0*kmag; cmax=c0
       endif
      enddo
   enddo

 if (imag(omax)>0) then 
   kmag=sqrt(kx_max**2+ky_max**2)
   uu=(kx_max*u+ky_max*v)/kmag;
   betas = beta*kx_max/kmag;
   H1(1)=0.0
   do k=2,nb
     H1(k)=H1(k-1)+dz*(cmax-uu(k))*(kmag**2*(cmax-uu(k))+betas) 
   enddo
   do k=2,nb
    H1(k) = H1(k-1)+dz*Nsqr(k)/f0**2/(cmax-uu(k))**2*H1(k)
   enddo
   H2(1)=0.0
   do k=2,nb
     H2(k)=H2(k-1)+dz*H1(k)*(cmax-uu(k))*(kmag**2*(cmax-uu(k))+betas) 
   enddo
   do k=2,nb
    H2(k) = H2(k-1)+dz*Nsqr(k)/f0**2/(cmax-uu(k))**2*H2(k)
   enddo
   H3(1)=0.0
   do k=2,nb
     H3(k)=H3(k-1)+dz*H2(k)*(cmax-uu(k))*(kmag**2*(cmax-uu(k))+betas) 
   enddo
   do k=2,nb
    H3(k) = H3(k-1)+dz*Nsqr(k)/f0**2/(cmax-uu(k))**2*H3(k)
   enddo
   psimax = (1+H1+H2+H3)*(uu-cmax)
   psimax=psimax/maxval(abs(real(psimax)) + abs(imag(psimax)) )
 else
   psimax = cmplx(0,0)
 endif

end subroutine vertical_eigenvalues1






subroutine vertical_eigenvalues2(nb,rho,u,v,f0,beta,dz,Lr,omaxx,psimaxx,kx_max,ky_max,Qx,Qy,ier) 
!------------------------------------------------------------------------
! quasi geostrophic vertical eigenvalue problem after
! Smith (2007) "The Geography of Linear Baroclinic 
! Instability in Earth’s Oceans", J. Mar. Res., 65 (5), 655-683
!------------------------------------------------------------------------
 implicit none
 real*8, parameter :: rho_0 = 1024, grav = 9.81, drho_min = (0.002**2)*rho_0/grav
 integer, parameter :: nk=16,nl=16
 integer :: nb,k,n,l,lwork,info,ii(2),ier
 real*8 :: rho(nb),u(nb),v(nb),beta,f0,dz,Lr,Qy(nb),Qx(nb)
 complex*8 :: omaxx,psimaxx(nb),omax(nk,nl)!,psimax(nk,nl,nb)
 real*8 :: Gij(nb,nb),kx,ky,Bij(nb,nb),Aij(nb,nb),Cij(nb,nb)
 real*8 :: omr(nb),omi(nb),mu(nb),eigv(nb,nb),eps(nb)
 real*8, allocatable :: work(:)
 real*8    :: kx_max,ky_max,k_span=4.2,eins=1.0, null=0.0,drho(nb)
 real*8 :: kmag,uu(nb),Nsqr(nb) ,betas
 complex*8 :: H1(nb),c,H2(nb),H3(nb),H4(nb)

 ier=0
 ! check for unstable profile
 do k=1,nb-1
  drho(k)=max( rho(k+1)-rho(k), drho_min )
 enddo
 ! vertical differencing operator
 Gij=0.0
 Gij(1,1) = -1/drho(1)/dz;
 Gij(1,2) =  1/drho(1)/dz;
 do k = 2,nb-1
     Gij(k,k-1) = 1/drho(k-1)/dz;
     Gij(k,k)   = (-1/drho(k-1) -1/drho(k))/dz;
     Gij(k,k+1) =  1/drho(k) /dz;
 enddo
 Gij(nb,nb)   = -1/drho(nb-1) /dz;
 Gij(nb,nb-1) =  1/drho(nb-1) /dz;
 Gij          = Gij*f0**2*rho_0/grav
 ! background PV gradient
 do k=1,nb
   Qy(k) = beta
   Qx(k) = 0.0
   do n=1,nb
       Qy(k) = Qy(k)-Gij(k,n)*u(n)
       Qx(k) = Qx(k)+Gij(k,n)*v(n)
   enddo
 enddo
 lwork=20*nb;allocate(work(lwork))

 ! loop over wavenumbers on coarse large grid
 omax=cmplx(0,0); Cij=0.0; Aij=0.0
 do k=1,nk/2
   kx=((k-1.0)/nk)*2 *k_span/Lr
   do l=1,nl
       ky=((l-1.0)/nl-0.5)*2 *k_span/Lr
       ! construct matrixes and solve eigenvalue problem
       Bij=Gij
       do n=1,nb
        Bij(n,n)=Bij(n,n)-(kx**2+ky**2)
        Cij(n,n)=kx*u(n)+ky*v(n)
       enddo
       Aij = matmul(Cij,Bij)
       do n=1,nb
        Aij(n,n)=Aij(n,n)+kx*Qy(n)-ky*Qx(n)
       enddo
       call DGGEV('N','N',nb,Aij,nb,Bij,nb,omr,omi,mu,eigv,nb,eigv,nb,WORK,LWORK,INFO)
       if (info/=0) then
           print*,' Error in DGGEV (1) info :',info,'ky,kx=',ky*Lr,kx*Lr
           omi=0.0;omr=0.0
       endif
       do n=1,nb
     if (mu(n)==0.0) then
        print*,' Error: mu=0 in DGGEV (1)'
         omr(n)=0.0;omi(n)=0.0
     else
         omr(n)=omr(n)/mu(n)
         omi(n)=omi(n)/mu(n)
     endif
       enddo
       n=maxloc(omi,1)
       omax(k,l)=cmplx(omr(n),omi(n))
     enddo
 enddo
 ii=maxloc(imag(omax))
 omaxx=omax(ii(1),ii(2))
 kx_max = ((ii(1)-1.)/nk)*2 *k_span/Lr
 ky_max = ((ii(2)-1.)/nl-0.5)*2 *k_span/Lr


 ! loop over wavenumbers on finer grid around maximum
 omax=cmplx(0,0); Cij=0.0; Aij=0.0
 do k=1,nk
   kx=kx_max+ ((k-1.0)/nk-0.5)*2 *k_span/Lr /nk*2
   do l=1,nl
       ky=ky_max+ ((l-1.0)/nl-0.5)*2 *k_span/Lr /nl*2
       ! construct matrixes and solve eigenvalue problem
       Bij=Gij
       do n=1,nb
        Bij(n,n)=Bij(n,n)-(kx**2+ky**2)
        Cij(n,n)=kx*u(n)+ky*v(n)
       enddo
       Aij = matmul(Cij,Bij)
       do n=1,nb
        Aij(n,n)=Aij(n,n)+kx*Qy(n)-ky*Qx(n)
       enddo
       call DGGEV('N','N',nb,Aij,nb,Bij,nb,omr,omi,mu,eigv,nb,eigv,nb,WORK,LWORK,INFO)
       if (info/=0) then
           print*,' Error in DGGEV (2) info :',info,'ky,kx=',ky*Lr,kx*Lr
           omi=0.0;omr=0.0
       endif
       do n=1,nb
     if (mu(n)==0.0) then
        print*,' Error: mu=0 in DGGEV (2)'
         omr(n)=0.0;omi(n)=0.0
     else
         omr(n)=omr(n)/mu(n)
         omi(n)=omi(n)/mu(n)
     endif
       enddo
       n=maxloc(omi,1)
       omax(k,l)=cmplx(omr(n),omi(n))
     enddo
 enddo
 ii=maxloc(imag(omax))
 omaxx=omax(ii(1),ii(2))
 kx_max=kx_max+ ((ii(1)-1.0)/nk-0.5)*2 *k_span/Lr /nk*2
 ky_max=ky_max+ ((ii(2)-1.0)/nl-0.5)*2 *k_span/Lr /nl*2


 ! now get eigenvector of fastest growing mode
 !Bij=Gij; Cij=0.0; Aij=0.0
 !do n=1,nb
 !  Bij(n,n)=Bij(n,n)-(kx_max**2+ky_max**2)
 !  Cij(n,n)=kx_max*u(n)+ky_max*v(n)
 !enddo
 !Aij = matmul(Cij,Bij)
 !do n=1,nb
 !   Aij(n,n)=Aij(n,n)+kx_max*Qy(n)-ky_max*Qx(n)
 !enddo
 !eigv=0.0; 
 !call DGGEV('N','V',nb,Aij,nb,Bij,nb,omr,omi,mu,eigv,nb,eigv,nb,WORK,LWORK,INFO)
 !      if (info/=0) then
 !          print*,' Error in DGGEV (3) info :',info,'ky,kx=',ky*Lr,kx*Lr
 !          omi=0.0;omr=0.0;eigv=0.0
 !          ier=-1
 !      endif
 !n=maxloc(omi,1)
 !psimaxx=cmplx(eigv(:,n),eigv(:,n+1) )


 kmag=sqrt(kx_max**2+ky_max**2)
 uu=(kx_max*u+ky_max*v)/kmag;
 betas = beta*kx_max/kmag;
 c=omaxx/kmag;

 Nsqr(1)= -(rho(1)-rho(2))/(dz) /rho_0*grav
 do k=2,nb-1
  Nsqr(k)= -(rho(k-1)-rho(k+1))/(2*dz) /rho_0*grav
 enddo
 Nsqr(nb)= -(rho(nb-1)-rho(nb))/(dz) /rho_0*grav
 H1(1)=0.0
 do k=2,nb
   H1(k)=H1(k-1)+dz*(c-uu(k))*(kmag**2*(c-uu(k))+betas) 
 enddo
 do k=2,nb
  H1(k) = H1(k-1)+dz*Nsqr(k)/f0**2/(c-uu(k))**2*H1(k)
 enddo
 H2(1)=0.0
 do k=2,nb
   H2(k)=H2(k-1)+dz*H1(k)*(c-uu(k))*(kmag**2*(c-uu(k))+betas) 
 enddo
 do k=2,nb
  H2(k) = H2(k-1)+dz*Nsqr(k)/f0**2/(c-uu(k))**2*H2(k)
 enddo
 H3(1)=0.0
 do k=2,nb
   H3(k)=H3(k-1)+dz*H2(k)*(c-uu(k))*(kmag**2*(c-uu(k))+betas) 
 enddo
 do k=2,nb
  H3(k) = H3(k-1)+dz*Nsqr(k)/f0**2/(c-uu(k))**2*H3(k)
 enddo
 psimaxx = (1+H1+H2+H3)*(uu-c)
 psimaxx=psimaxx/maxval(abs(real(psimaxx)) + abs(imag(psimaxx)) )
 deallocate(work)
end subroutine vertical_eigenvalues2



subroutine vertical_eigenvalues3(nb,rho,u,v,f0,beta,dz,Lr,omax,psimax,kx_max,ky_max,Qx,Qy,ier) 
!------------------------------------------------------------------------
! quasi geostrophic vertical eigenvalue problem after
! Smith (2007) "The Geography of Linear Baroclinic 
! Instability in Earth’s Oceans", J. Mar. Res., 65 (5), 655-683
!------------------------------------------------------------------------
 implicit none
 real*8, parameter :: rho_0 = 1024, grav = 9.81, drho_min = (0.0005**2)*rho_0/grav
 real*8 :: A_h = 50.0,drho(nb)
 integer, parameter :: nk=16,nl=16
 integer :: nb,k,n,l,lwork,info,ier
 real*8 :: rho(nb),u(nb),v(nb),beta,f0,dz,Lr,Qy(nb),Qx(nb)
 complex*8 :: omax,psimax(nb)
 real*8 :: Gij(nb,nb),kx,ky
 real*8    :: kx_max,ky_max,k_span=4.2,eins=1.0, null=0.0
 ! variables for lapack
 complex :: Bij(nb,nb),Aij(nb,nb),Cij(nb,nb),om(nb),mu(nb),eigv(nb,nb)
 complex, allocatable :: work(:)
 real, allocatable :: rwork(:)

 ier=0
 ! check for unstable profile
 do k=1,nb-1
  drho(k)=max( rho(k+1)-rho(k), drho_min )
 enddo
 ! vertical differencing operator
 Gij=0.0
 Gij(1,1) = -1/drho(1)/dz;
 Gij(1,2) =  1/drho(1)/dz;
 do k = 2,nb-1
     Gij(k,k-1) = 1/drho(k-1)/dz;
     Gij(k,k)   = (-1/drho(k-1) -1/drho(k))/dz;
     Gij(k,k+1) =  1/drho(k) /dz;
 enddo
 Gij(nb,nb)   = -1/drho(nb-1) /dz;
 Gij(nb,nb-1) =  1/drho(nb-1) /dz;
 Gij          = Gij*f0**2*rho_0/grav
 ! background PV gradient
 do k=1,nb
   Qy(k) = beta
   Qx(k) = 0.0
   do n=1,nb
       Qy(k) = Qy(k)-Gij(k,n)*u(n)
       Qx(k) = Qx(k)+Gij(k,n)*v(n)
   enddo
 enddo
 lwork=20*nb;allocate(work(lwork),rwork(8*nb) )

 ! loop over wavenumbers on coarse grid
 omax=cmplx(0,0); kx_max=0.; ky_max=0.; Cij=0.0; Aij=0.0
 do k=1,nk/2
   kx=(k-1.0)/nk*2 *k_span/Lr
   do l=1,nl
       ky=((l-1.0)/nl-0.5)*2 *k_span/Lr
       ! construct matrixes and solve eigenvalue problem
       Bij=Gij
       do n=1,nb
        Bij(n,n)=Bij(n,n)-(kx**2+ky**2)
        Cij(n,n)=kx*u(n)+ky*v(n) - cmplx(0.,1.)*A_h*(kx**2+ky**2)
       enddo
       Aij = matmul(Cij,Bij)
       do n=1,nb
        Aij(n,n)=Aij(n,n)+kx*Qy(n)-ky*Qx(n)
       enddo
       call CGGEV('N','N',nb,Aij,nb,Bij,nb,om,mu,eigv,nb,eigv,nb,WORK,LWORK,RWORK,INFO)
       if (info/=0) then
           print*,' Error in CGGEV (1) info :',info,'ky,kx=',ky*Lr,kx*Lr
           om=cmplx(0.0,0.0)
       endif
       do n=1,nb
        if (abs(mu(n))==0.0) then
           print*,' Error: mu=0 in CGGEV (1) n=',n,'ky,kx=',ky*Lr,kx*Lr
           om(n)=cmplx(0.0,0.0)
        else
           om(n)=om(n)/mu(n)
        endif
       enddo
       n=maxloc(imag(om) ,1)
       if (imag(om(n))>imag(omax)) then
          kx_max = kx; ky_max = ky; omax=om(n)
       endif
     enddo
 enddo

 ! loop over wavenumbers on finer grid around maximum
 Cij=0.0; Aij=0.0
 do k=1,nk
   kx=kx_max+ ((k-1.0)/nk-0.5)*2 *k_span/Lr /nk*2
   do l=1,nl
       ky=ky_max+ ((l-1.0)/nl-0.5)*2 *k_span/Lr /nl*2
       ! construct matrixes and solve eigenvalue problem
       Bij=Gij
       do n=1,nb
        Bij(n,n)=Bij(n,n)-(kx**2+ky**2)
        Cij(n,n)=kx*u(n)+ky*v(n) - cmplx(0.,1.)*A_h*(kx**2+ky**2)
       enddo
       Aij = matmul(Cij,Bij)
       do n=1,nb
        Aij(n,n)=Aij(n,n)+kx*Qy(n)-ky*Qx(n)
       enddo
       call CGGEV('N','N',nb,Aij,nb,Bij,nb,om,mu,eigv,nb,eigv,nb,WORK,LWORK,RWORK,INFO)
       if (info/=0) then
           print*,' Error in CGGEV (1) info :',info,'ky,kx=',ky*Lr,kx*Lr
           om=cmplx(0.0,0.0)
       endif
       do n=1,nb
        if (abs(mu(n))==0.0) then
           print*,' Error: mu=0 in CGGEV (2) n=',n,'ky,kx=',ky*Lr,kx*Lr
           om(n)=cmplx(0.0,0.0)
        else
           om(n)=om(n)/mu(n)
        endif
       enddo
       n=maxloc(imag(om) ,1)
       if (imag(om(n))>imag(omax)) then
          kx_max = kx; ky_max = ky; omax=om(n)
       endif
     enddo
 enddo

 ! now get eigenvector of fastest growing mode
 Bij=Gij; Cij=0.0; Aij=0.0
 do n=1,nb
   Bij(n,n)=Bij(n,n)-(kx_max**2+ky_max**2)
   Cij(n,n)=kx_max*u(n)+ky_max*v(n) - cmplx(0.,1.)*A_h*(kx_max**2+ky_max**2)
 enddo
 Aij = matmul(Cij,Bij)
 do n=1,nb
    Aij(n,n)=Aij(n,n)+kx_max*Qy(n)-ky_max*Qx(n)
 enddo
 eigv=0.0; 
 call CGGEV('N','V',nb,Aij,nb,Bij,nb,om,mu,eigv,nb,eigv,nb,WORK,LWORK,RWORK,INFO)
 if (info/=0) then
           print*,' Error in CGGEV (3) info :',info,'ky,kx=',ky*Lr,kx*Lr
           om=cmplx(0.0,0.0)
           eigv=cmplx(0.0,0.0)
           ier=-1
 endif
 do n=1,nb
    if (abs(mu(n))==0.0) then
           print*,' Error: mu=0 in CGGEV (3) n=',n,'ky,kx=',ky*Lr,kx*Lr
           om(n)=cmplx(0.0,0.0)
    else
           om(n)=om(n)/mu(n)
    endif
 enddo
 n=maxloc(imag(om),1)
 omax=om(n)
 if (imag(omax)<0.0) then
    omax=cmplx(0.0,0.0)
    psimax=cmplx(0.0,0.0)
 else 
  psimax=eigv(:,n) 
 endif
 deallocate(work,rwork)
end subroutine vertical_eigenvalues3










subroutine fillgaps(nx, ny, dat, spval)
!------------------------------------------------------------------------
!------------------------------------------------------------------------
      implicit none
      integer :: nx, ny
      integer :: i,j,n,ngaps,is,js,ie,je
      integer,allocatable :: igap(:), jgap(:)    ! gap coordinates
      real*8 :: dat(nx,ny) , spval, sum   ,isum

!     Count gaps
!     ----------
   allocate( igap(nx*ny), jgap(nx*ny) )
   igap = 0
   jgap = 0
   ngaps = 0

   do j=1, ny
        do i=1, nx
          if (dat(i,j)==spval) then
            ngaps = ngaps + 1
            igap(ngaps) = i                     ! register position
            jgap(ngaps) = j
          end if
        end do
  end do
  !     Fill gaps with average of nearest neighbours
  !     use all 8 adjacent grid points, unless gap is at boundary
  if (ngaps /= 0) then
          do n=1, ngaps
              is = max(igap(n)-1, 1)
              ie = min(igap(n)+1, nx)
              js = max(jgap(n)-1, 1)
              je = min(jgap(n)+1, ny)
              sum  = 0.
              isum = 0

              do j=js, je
                do i=is, ie
                  if (dat(i,j)/=spval) then
                     sum = sum + dat(i,j)
                    isum = isum + 1.0
                  end if
                end do
              end do
              if (isum/=0.0) dat(igap(n),jgap(n)) = sum/isum
          end do          
  end if              
  deallocate(igap,jgap)
end subroutine fillgaps



subroutine rgrd2(nx,ny,x,y,p,mx,my,xx,yy,q,ier)
!------------------------------------------------------------------------
!     subroutine rgrd2 interpolates the values p(i,j) on the orthogonal
!     grid (x(i),y(j)) for i=1,...,nx and j=1,...,ny onto q(ii,jj) on the
!     orthogonal grid (xx(ii),yy(jj)) for ii=1,...,mx and jj=1,...,my.
!
!     each of the x,y grids must be strictly montonically increasing
!     and each of the xx,yy grids must be montonically increasing (see
!     ier = 4).  in addition the (X,Y) region
!
!          [xx(1),xx(mx)] X [yy(1),yy(my)]
!
!     must lie within the (X,Y) region
!
!          [x(1),x(nx)] X [y(1),y(ny)].
!
!     extrapolation is not allowed (see ier=3).  
!
!     an integer error flag set as follows:
!
!     ier = 0 if no errors in input arguments are detected
!
!     ier = 1 if  min0(mx,my) < 1
!
!     ier = 2 if nx < 2 when intpol(1)=1 or nx < 4 when intpol(1)=3 (or)
!                ny < 2 when intpol(2)=1 or ny < 4 when intpol(2)=3
!
!     ier = 3 if xx(1) < x(1) or x(nx) < xx(mx) (or)
!                yy(1) < y(1) or y(ny) < yy(my) (or)
!
!     John C. Adams (NCAR 1994), C.Eden (2011)
!------------------------------------------------------------------------
      implicit integer (i-n) 
      implicit real*8 (a-h,o-z)
      dimension x(nx),y(ny),p(nx,ny),xx(mx),yy(my),q(mx,my)
      ! automatic arrays
      dimension jy(my),dy(my),ix(mx),dx(mx)
      dimension pj(mx),pjp(mx)
      dimension dxm(mx),dxp(mx),dxpp(mx)
 
!     check input arguments
      ier = 1
!     check (xx,yy) grid resolution
      if (min0(mx,my) .lt. 1) return
!     check (x,y) grid resolution
      ier = 2
      if (nx.lt.2) return
      if (ny.lt.2) return
!     check (xx,yy) grid contained in (x,y) grid
      ier = 3
      if (xx(1).lt.x(1) .or. xx(mx).gt.x(nx)) return
      if (yy(1).lt.y(1) .or. yy(my).gt.y(ny)) return
!     check montonicity of grids
      ier = 4
      do  i=2,nx
        if (x(i-1).ge.x(i)) return
      enddo
      do j=2,ny
        if (y(j-1).ge.y(j)) return
      enddo
      do  ii=2,mx
        if (xx(ii-1).gt.xx(ii)) return
      enddo
      do jj=2,my
        if (yy(jj-1).gt.yy(jj)) return
      enddo
!     arguments o.k.
      ier = 0
!     linearly interpolate in y
!     set y interpolation indices and scales and linearly interpolate
      call linmx(ny,y,my,yy,jy,dy)
!     set indices which depend on x interpolation
      call linmx(nx,x,mx,xx,ix,dx)
      call lint2(nx,ny,p,mx,my,q,jy,dy,pj,pjp,ix,dxm,dx,dxp,dxpp)
end subroutine rgrd2


subroutine lint2(nx,ny,p,mx,my,q,jy,dy,pj,pjp,ix,dxm,dx,dxp,dxpp)
     implicit integer (i-n) 
     implicit real*8 (a-h,o-z)
     dimension p(nx,ny)
     dimension q(mx,my)
     dimension pj(mx),pjp(mx),jy(my),dy(my)
     dimension ix(mx),dxm(mx),dx(mx),dxp(mx),dxpp(mx)
!    linearly interpolate in y
     jsave = -1
     do jj=1,my
      j = jy(jj)
      if (j.eq.jsave) then
!     j pointer has not moved since last pass (no updates or interpolation)
      else if (j.eq.jsave+1) then
!     update j and interpolate j+1
       do  ii=1,mx
        pj(ii) = pjp(ii)
       enddo
       call lint1(nx,p(1,j+1),mx,pjp,ix,dx)
      else
!      interpolate j,j+1in pj,pjp on xx mesh
       call lint1(nx,p(1,j),mx,pj,ix,dx)
       call lint1(nx,p(1,j+1),mx,pjp,ix,dx)
      end if
!     save j pointer for next pass
      jsave = j
!     linearly interpolate q(ii,jj) from pjp,pj in y direction
      do ii=1,mx
        q(ii,jj) = pj(ii)+dy(jj)*(pjp(ii)-pj(ii))
      enddo
     enddo
end subroutine lint2

subroutine lint1(nx,p,mx,q,ix,dx)
     implicit integer (i-n) 
     implicit real*8 (a-h,o-z)
     dimension p(nx),q(mx),ix(mx),dx(mx)
!    linearly interpolate p on x onto q on xx
     do ii=1,mx
      i = ix(ii)
      q(ii) = p(i)+dx(ii)*(p(i+1)-p(i))
     enddo
end subroutine lint1

subroutine linmx(nx,x,mx,xx,ix,dx)
   implicit integer (i-n) 
   implicit real*8 (a-h,o-z)
!  set x grid pointers for xx grid and interpolation scale terms
   dimension x(nx),xx(mx)
   dimension ix(mx),dx(mx)
   isrt = 1
   do ii=1,mx
!    find x(i) s.t. x(i) < xx(ii) <= x(i+1)
     do i=isrt,nx-1
            if (x(i+1) .ge. xx(ii)) then
               isrt = i
               ix(ii) = i
               go to 3
            end if
     enddo
 3   continue
    enddo
!   set linear scale term
    do ii=1,mx
         i = ix(ii)
         dx(ii) = (xx(ii)-x(i))/(x(i+1)-x(i))
    enddo
end subroutine linmx

!=======================================================================
!     Templates for setup
!     Exp. Ridge in Olbers and Eden, JPO, 2003
!     Impact of topography on gyre circulation
!=======================================================================

 subroutine set_parameter
      use pyOM_module
      use fcontrol_module
      implicit none

      nx=20;nz=12;ny=20
      dx=2.0*60*1852.0
      dz=500.0
      dt=3600.0*2
      K_h=00.0
      K_v=1.e-4
      A_h=2e5
      A_v=1.e-3
      eps2D_sor = 1e-9
      enable_noslip               = .true.
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .true.
      enable_quicker_mom_advection= .false.
      enable_back_state           = .true.
      runlen=10*365.0*86400.
      snapint = 5.0*86400.
 end subroutine set_parameter

subroutine set_coriolis
      use pyOM_module   
      implicit none
! ----------------------------------
!      add here initial conditions
! ----------------------------------
   integer :: j
   real*8,parameter :: pi=3.1415   
   real*8,parameter :: radius  = 6370.0e3   ! earth radius
   real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
   real*8,parameter :: phi0 = 30.0 /180. *pi
   do j=1,ny
    coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
   enddo
end subroutine set_coriolis

subroutine initial_conditions
      use pyOM_module
      implicit none
      integer :: i,j,k
      real*8 :: N_0=2.6e-3
      do k=1,nz
       do j=1,ny
        do i=1,nx
         back(i,j,k,:) = (-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
     enddo
end subroutine initial_conditions


subroutine boundary_conditions
   use pyOM_module
   implicit none
   integer :: i,j
   real*8 :: y, pi=3.1415   
! units are m^2/s^3  
! since  b_z = N^2   b[m/s^2]   b_t = F_z   [m/s^3]=[ m^2/s^3]_z
      do j=1,ny
       do i=1,nx
        y = (yu(j)-yu(1))/ (yu(ny)-yu(1))
        surface_taux(i,j) = -0.5e-4*cos(2*pi*y)*maskU(i,j,nz-1)
        surface_tauy(i,j) = 0.0*maskV(i,j,nz-1)
       enddo
      enddo
end subroutine boundary_conditions


subroutine topography
   use pyOM_module
   implicit none
   integer :: i,k
   real*8 :: z,h0
   h0 = -zt(1)
   do k=2,nz-1
     do i=1,nx
      z=H0*(1-0.3*exp(-(xt(i)-xt(nx/2))**2/800e3**2 ) )
     if (zt(k).lt.-z) maskT(i,:,k)=0.0
     enddo
    enddo
end subroutine topography

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources

    
!=======================================================================
!      Different advection schemes for buoyancy and other tracers
!=======================================================================


subroutine adv_flux(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
!=======================================================================
!       advective tracer flux:  call different schemes
!=======================================================================
      use pyOM_module   
      implicit none
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: adv_fn(nx_,ny_,nz_), var(nx_,ny_,nz_,3)
      integer :: nx_,ny_,nz_

      if (enable_quicker_advection) then
       call setcyclic3D_j2(nx_,ny_,nz_,var(:,:,:,taum1) )
       call adv_flux_quicker(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
      else if (enable_4th_advection) then
       call setcyclic3D_j2(nx_,ny_,nz_,var(:,:,:,tau) )
       call adv_flux_4th(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
      else if (enable_upwind_advection) then
       call adv_flux_upw(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
      else
       call adv_flux_2th(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
      endif
end subroutine adv_flux




subroutine adv_flux_2th(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
!=======================================================================
!      2th order advective tracer flux
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: adv_fn(nx_,ny_,nz_), var(nx_,ny_,nz_,3)
      real*8 :: totvel

      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         totvel = u(i,j,k,tau)
         adv_fe(i,j,k)=0.5*(var(i,j,k,tau) + var(i+1,j,k,tau) )*totvel*maskU(i,j,k)
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         totvel = v(i,j,k,tau)
         adv_fn(i,j,k)=0.5*( var(i,j,k,tau) + var(i,j+1,k,tau) )*totvel*maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         totvel = w(i,j,k,tau)
         adv_ft(i,j,k)=0.5*( var(i,j,k,tau) + var(i,j,k+1,tau) )*totvel*maskW(i,j,k)
        enddo
       enddo
      enddo
end subroutine adv_flux_2th





subroutine adv_flux_4th(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
!=======================================================================
!      4th order advective tracer flux
!      author:   r.c.pacanowski       e-mail rcp@gfdl.gov
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: adv_fn(nx_,ny_,nz_), var(nx_,ny_,nz_,3)
      integer :: i,j,k,js,je,ip2,im1,jp2,jm1,kp2,km1
      real*8,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real*8,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0
      real*8 :: mask

      js=max(2,js_pe); je=min(je_pe,ny-1)

      do j=js,je
       do k=2,nz-1
        do i=1,nx-1
         ip2=i+2
         if (ip2>nx.and..not.enable_cyclic_x) ip2=nx
         if (ip2>nx.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=nx-2
         mask = maskT(im1,j,k)*maskT(ip2,j,k)
         adv_fe(i,j,k) = 0.5*u(i,j,k,tau)*( &
             (a2nd*(1.0-mask) + a4th*mask)*(var(i,  j,k,tau) +var(i+1,j,k,tau))+ &
             (b2nd*(1.0-mask) + b4th*mask)*(var(im1,j,k,tau) +var(ip2,j,k,tau)))
        enddo
       enddo
      enddo

      do j=js,je
       do k=2,nz-1
        do i=2,nx-1
         jp2=j+2
         if (jp2>ny.and..not.enable_cyclic_y) jp2=ny
         if (jp2>ny.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=ny-2
         mask = maskT(i,jm1,k)*maskT(i,jp2,k)
         adv_fn(i,j,k) = 0.5*v(i,j,k,tau)*(  &
             (a2nd*(1.0-mask) + a4th*mask)*(var(i,  j,k,tau) + var(i,j+1,k,tau))+  &
             (b2nd*(1.0-mask) + b4th*mask)*(var(i,jm1,k,tau) + var(i,jp2,k,tau)))
        enddo
       enddo
      enddo
 
      do j=js,je
       do k=1,nz-1
        do i=2,nx-1
         kp2=min(k+2,nz)
         km1=max(1,k-1)
         mask = maskT(i,j,km1)*maskT(i,j,kp2)
         adv_ft(i,j,k) = 0.5*w(i,j,k,tau)*(   &
               (a2nd*(1.0-mask) + a4th*mask)*(var(i,j,  k,tau) + var(i,j,k+1,tau))+   &
               (b2nd*(1.0-mask) + b4th*mask)*(var(i,j,km1,tau) + var(i,j,kp2,tau)))
        enddo
       enddo
      enddo

end subroutine adv_flux_4th






subroutine adv_flux_quicker(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
!=======================================================================
!      3th order advective tracer flux
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: adv_fn(nx_,ny_,nz_), var(nx_,ny_,nz_,3)
      integer :: i,j,k,ip2,jp2,kp2,im1,jm1,km1,js,je
      real*8 :: totvel,upos,uneg,eastmsk,westmsk

      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         ip2=i+2
         if (ip2>nx.and..not.enable_cyclic_x) ip2=nx
         if (ip2>nx.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=nx-2

         totvel = u(i,j,k,tau)
         upos = .5*(totvel + abs(totvel))  *maskt(i,j,k)*maskt(i+1,j,k)
         uneg = .5*(totvel - abs(totvel))  *maskt(i+1,j,k)*maskt(i,j,k)
         eastmsk=maskt(i,j,k)*(1-maskt(im1,j,k))
         westmsk=maskt(i+1,j,k)*(1-maskt(ip2,j,k))
         adv_fe(i,j,k) = 0.5*totvel*(var(i,j,k,tau)+var(i+1,j,k,tau))    &
              - 0.5*upos*(0.25*var(i+1,j,k,taum1)-0.5*var(i,j,k,taum1)    &
                     +0.25*(var(im1,j,k,taum1)*(1-eastmsk) +var(i,j,k,taum1)*eastmsk))    &
              - 0.5*uneg*(0.25*(var(ip2,j,k,taum1)*(1-westmsk)+    &
                var(i+1,j,k,taum1)*westmsk)-0.5*var(i+1,j,k,taum1) +0.25*var(i,j,k,taum1))
          enddo
        enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         jp2=j+2
         if (jp2>ny.and..not.enable_cyclic_y) jp2=ny
         if (jp2>ny.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=ny-2

         totvel = v(i,j,k,tau)
         upos = .5*(totvel + abs(totvel))  *maskt(i,j,k)*maskt(i,j+1,k)
         uneg = .5*(totvel - abs(totvel))  *maskt(i,j+1,k)*maskt(i,j,k)
         eastmsk=maskt(i,j,k)*(1-maskt(i,jm1,k))
         westmsk=maskt(i,j+1,k)*(1-maskt(i,jp2,k))
         adv_fn(i,j,k) = 0.5*totvel*(var(i,j,k,tau)+var(i,j+1,k,tau))    &
              - 0.5*upos*(0.25*var(i,j+1,k,taum1)-0.5*var(i,j,k,taum1)    &
                     +0.25*(var(i,jm1,k,taum1)*(1-eastmsk) +var(i,j,k,taum1)*eastmsk))    &
              - 0.5*uneg*(0.25*(var(i,jp2,k,taum1)*(1-westmsk)+    &
                var(i,j+1,k,taum1)*westmsk)-0.5*var(i,j+1,k,taum1)  +0.25*var(i,j,k,taum1))
          enddo
        enddo
      enddo
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         kp2=min(k+2,nz)
         km1=max(1,k-1)
         totvel = w(i,j,k,tau)
         upos = .5*(totvel + abs(totvel))     *maskt(i,j,k)*maskt(i,j,k+1)
         uneg = .5*(totvel - abs(totvel))     *maskt(i,j,k+1)*maskt(i,j,k)
         eastmsk=maskt(i,j,k)*(1-maskt(i,j,km1))
         westmsk=maskt(i,j,k+1)*(1-maskt(i,j,kp2))
         adv_ft(i,j,k) = 0.5*totvel*(var(i,j,k,tau)+var(i,j,k+1,tau))    &
              - 0.5*upos*(0.25*var(i,j,k+1,taum1)-0.5*var(i,j,k,taum1)    &
                     +0.25*(var(i,j,km1,taum1)*(1-eastmsk)   +var(i,j,k,taum1)*eastmsk))    &
              - 0.5*uneg*(0.25*(var(i,j,kp2,taum1)*(1-westmsk)+    &
                var(i,j,k+1,taum1)*westmsk)-0.5*var(i,j,k+1,taum1)  +0.25*var(i,j,k,taum1))
          enddo
        enddo
      enddo
end subroutine adv_flux_quicker




subroutine adv_flux_upw(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft,var)
!=======================================================================
!        upwind tracer flux:   F = U b^i 
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: adv_fn(nx_,ny_,nz_), var(nx_,ny_,nz_,3)
      integer :: i,j,k,js,je
      real*8 :: totvel

      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         totvel = u(i,j,k,tau)
         adv_fe(i,j,k)=maskU(i,j,k)*(0.5*totvel*(var(i,j,k,taum1)+var(i+1,j,k,taum1)) &
         - 0.5*abs(totvel)*(var(i+1,j,k,taum1)-var(i,j,k,taum1) ) )
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         totvel = v(i,j,k,tau)
         adv_fn(i,j,k)=maskV(i,j,k)*(0.5*totvel*(var(i,j,k,taum1)+var(i,j+1,k,taum1))  &
         - 0.5*abs(totvel)*(var(i,j+1,k,taum1)-var(i,j,k,taum1) ) )
        enddo
       enddo
      enddo
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         totvel = w(i,j,k,tau)
         adv_ft(i,j,k)=maskW(i,j,k)*( 0.5*totvel*(var(i,j,k,taum1)+var(i,j,k+1,taum1))  &
         - 0.5*abs(totvel)*(var(i,j,k+1,taum1)-var(i,j,k,taum1) ) )
        enddo
       enddo
      enddo
end subroutine adv_flux_upw

module pyOM_module   
!=======================================================================
!      Main module for pyOM
!=======================================================================
      implicit none
      real*8, parameter :: version = 1.1
!---------------------------------------------------------------------------------
!      variable model parameter
!---------------------------------------------------------------------------------
      integer  :: nx=0,nz=0,ny=0         ! Number of grid points in x,y,z direction
      real*8 :: dx=0,dz=0,dt=0           ! Delta z, Delta x in m and Delta t in s
      real*8 :: K_h=0, K_v=0             ! horizontal and vertical diffusivitis in m^2/s
      real*8 :: A_h=0, A_v=0             ! horizontal and vertical viscosities in m^2/s
      real*8 :: cdbot=0                  ! Bottom friction in 1/s
      real*8 :: cdint=0                  ! interior friction in 1/s
      real*8 :: Khbi = .0, Kvbi =.0      ! hor/vert biharmonic diffusivities in m^4/s
      real*8 :: Ahbi = .0, Avbi=.0       ! same for biharmonic viscosities
      real*8 :: eps2d_sor=0              ! cut off values for 2-D Poisson solver
      real*8 :: eps3d_sor=0.             ! cut off values for 3-D Poisson solver
      real*8 :: gamma=0.01               ! value for Roberts time filter
      real*8 :: dtex                     ! time step for external mode 
!---------------------------------------------------------------------------------
!      domain decomposition for parallel execution
!---------------------------------------------------------------------------------
      integer :: n_pes_j = 1    ! number of PEs in meridional (y) direction
      integer :: my_blk_j= 1    ! number of domain in meridional (y) direction
      integer :: js_pe   = 1    ! start j-index of domain of this PE
      integer :: je_pe   = 1    ! end of j_index of domain of this PE
      integer :: j_blk   = 1    ! number of j-rows at this PE
      integer :: my_pe          ! ordinal number of PE
      integer :: n_pes          ! total number of PEs
      integer :: my_comm=0      ! MPI communication for PEs
!---------------------------------------------------------------------------------
!      main model variables, units are SI
!---------------------------------------------------------------------------------
      real*8, allocatable, dimension(:,:,:,:)   :: u,v,w   ! velocicity components for three time levels
      real*8, allocatable, dimension(:,:,:,:)   :: b       ! (negative) buoyancy for three time levels
      real*8, allocatable, dimension(:,:,:,:)   :: p_full  ! full pressure for three time levels
      real*8, allocatable, dimension(:,:,:)     :: p_hydro ! hydrostatic pressure at time level tau
      real*8, allocatable, dimension(:,:,:)     :: psi     ! non-hdrostatic pressure at time level tau
      real*8, allocatable, dimension(:,:)       :: p_surf  ! surface pressure
      real*8, allocatable, dimension(:,:,:)     :: eta     ! free surface elevation
      real*8, allocatable, dimension(:,:,:)     :: bu   ! barotropic zonal velocity  (only for enable_expl_free_surf)
      real*8, allocatable, dimension(:,:,:)     :: bv   ! barotropic meridonal velocity (only for enable_expl_free_surf)
!---------------------------------------------------------------------------------
!      auxilliary model variables 
!---------------------------------------------------------------------------------
      real*8, allocatable, dimension(:,:,:)     :: K_b     ! vertical diffusivity set in case of static instability
      real*8, allocatable, dimension(:,:,:)     :: maskT   ! mask for T-grid (1 in water, 0 at land)
      real*8, allocatable, dimension(:,:,:)     :: maskU   ! same for U-grid
      real*8, allocatable, dimension(:,:,:)     :: maskV   ! same for V-grid
      real*8, allocatable, dimension(:,:,:)     :: maskW   ! same for W-grid
      real*8, allocatable, dimension(:,:,:)     :: fu      ! time tendency of u except pressure gradient
      real*8, allocatable, dimension(:,:,:)     :: fv      ! time tendency of v except pressure gradient
      real*8, allocatable, dimension(:,:,:)     :: fw      ! time tendency of w except pressure gradient
      real*8, allocatable, dimension(:)         :: coriolis_t    ! vertical coriolis parameter
      real*8, allocatable, dimension(:)         :: coriolis_hor  ! horizontal coriolis parameter
      real*8, allocatable,dimension(:,:)        :: surface_flux  ! surface buoyancy flux
      real*8, allocatable,dimension(:,:)        :: bottom_flux   ! bottom buoyancy flux
      real*8, allocatable,dimension(:,:)        :: surface_taux  ! surface flux of zonal momentum 
      real*8, allocatable,dimension(:,:)        :: surface_tauy  ! surface flux of meridional momentum 
      real*8, allocatable,dimension(:,:)        :: bottom_taux   ! bottom flux of zonal momentum
      real*8, allocatable,dimension(:,:)        :: bottom_tauy   ! bottom flux of meridional momentum 
      real*8, allocatable :: cf2D(:,:,:,:)      ! array containing coefficients to solve 2D Poisson equation
      real*8, allocatable :: cf3D(:,:,:,:,:,:)  ! array containing coefficients to solve 3D Poisson equation
!---------------------------------------------------------------------------------
!      model grid variables  
!---------------------------------------------------------------------------------
      real*8, allocatable, dimension(:)   :: zt  ! depth of T-grid point  (positive upward) in meters
      real*8, allocatable, dimension(:)   :: zw  ! depth of W-grid point in meters
      real*8, allocatable, dimension(:)   :: xt  ! zonal (x) coordinate of T-grid point in meters
      real*8, allocatable, dimension(:)   :: xu  ! zonal (x) coordinate of U-grid point in meters
      real*8, allocatable, dimension(:)   :: yt  ! meridional (y) coordinate of T-grid point in meters
      real*8, allocatable, dimension(:)   :: yu  ! meridional (y) coordinate of V-grid point in meters
      real*8, allocatable, dimension(:,:) :: hu  ! depth of water column at U-grid points
      real*8, allocatable, dimension(:,:) :: hv  ! depth of water column at V-grid points
      real*8, allocatable, dimension(:,:) :: ht  ! depth of water column at T-grid points
      integer,allocatable,dimension(:,:)  :: k_bottom_u ! number of verticel levels at U grid points
      integer,allocatable,dimension(:,:)  :: k_bottom_v ! number of verticel levels at V grid points
!---------------------------------------------------------------------------------
!       switches to configure model setup
!---------------------------------------------------------------------------------
      logical :: enable_noslip                = .false.  ! no lateral slip for momentum
      logical :: enable_bottom_noslip         = .false.  ! also for bottom 
      logical :: enable_cyclic_x              = .false.  ! periodic boundary condition in x
      logical :: enable_cyclic_y              = .false.  ! periodic boundary condition in y
      logical :: enable_quicker_advection     = .false.  ! quicker advection scheme for buoyancy
      logical :: enable_4th_advection         = .false.  ! 4. order advection scheme for buoyancy
      logical :: enable_upwind_advection      = .false.  ! upwind advection scheme for buoyancy
      logical :: enable_4th_mom_advection     = .false.  ! momentum advection
      logical :: enable_quicker_mom_advection = .false.  ! momentum advection
      logical :: enable_no_mom_advection      = .false.  ! no momentum advection at all
      logical :: enable_bottom_stress         = .false.  ! Bottom stress
      logical :: enable_interior_stress       = .false.  ! interior stress
      logical :: enable_biharmonic_friction   = .false.  ! biharmonic horizontal friction
      logical :: enable_vert_biha_friction    = .false.  ! biharmonic vertical  friction
      logical :: enable_biharmonic_diffusion  = .false.  ! same for diffusion
      logical :: enable_vert_biha_diffusion   = .false.  ! biharmonic vertical friction
      logical :: enable_free_surface          = .false.  ! implicit free surface
      logical :: enable_hydrostatic           = .true.   ! hydrostatic approximation
      logical :: enable_expl_free_surf        = .false.  ! explicit free surface
!---------------------------------------------------------------------------------
!      other stuff
!---------------------------------------------------------------------------------
      integer     :: tau,taum1,taup1   ! pointer for time levels
      real*8      :: c2dt              ! two times time step 
      integer     :: sor2D_itts        ! number of iterations of 2D Poisson solver
      integer     :: sor3D_itts        ! number of iterations of 3D Poisson solver
!-----------------------------------------------------------------------
!     residual momentum formulation
!-----------------------------------------------------------------------
      logical :: enable_vert_friction_trm   = .false.  ! vertical friction for residual momentum formulation
      real*8, allocatable :: A_trm(:,:,:) ! vertical viscosity
      real*8 :: K_gm      = 1000.0        ! GM mixing parameter
      real*8 :: aidif_trm = 1.0           ! choose implicit (=1)/explicit(=0) formulation 
      real*8 :: N_min     = 1d-5          ! minimal threshold for stability freq. N
      real*8 :: fNsqr_max = 0.01          ! limit f^2/N^2 by this value
!-----------------------------------------------------------------------
!     background stratification
!-----------------------------------------------------------------------
      logical :: enable_back_state           = .false.
      logical :: enable_back_zonal_flow      = .false.
      logical :: enable_back_meridional_flow = .false.
      real*8, allocatable :: back(:,:,:,:)  ! background stratification B, depends on
                                            ! time and x/y only for technical reasons
      real*8, allocatable :: u0(:,:,:)      ! background zonal/meridional advection U
!-----------------------------------------------------------------------
!     passive tracer stuff
!-----------------------------------------------------------------------
      real*8, allocatable, dimension(:,:,:,:,:) :: tr ! passive tracers
      integer :: nt=0                                 ! number of passive tracer
      logical :: enable_diag_tracer         = .false. ! passive tracer 
      logical :: delimit_tracer_fluxes      = .false. ! prevent spurious under shooting by advection of passive tracer
                                                      ! works only for positive tracer like concentrations
      logical :: enable_isopycnal_diffusion = .false. ! use isopycnal diffusion for effect of meso-scale eddies
      real*8 :: iso_dslope=0.0008          ! parameters controlling max allowed isopycnal slopes
      real*8 :: iso_slopec=0.005           ! parameters controlling max allowed isopycnal slopes
 end module pyOM_module   



 subroutine check_pyOM_module(ierr)
!---------------------------------------------------------------------------------
! some mild checks
!---------------------------------------------------------------------------------
 use pyOM_module   
 implicit none
 integer, intent(out) :: ierr

 ierr = 0

 if (nx==0 .or. ny==0 .or. nz==0) then
   print*,' ERROR: model dimensions are not defined'
   ierr=-3
   return
 endif

 if (tau>3 .or. tau<1 .or. taup1>3 .or. taup1<1 .or. taum1>3 .or. taum1<1 ) then
   print*,' ERROR: time levels are not valid'
   ierr=-4
   return
 endif

 if (allocated(u)) then
  if ( size(u,1)/=nx .or. size(u,2)/=ny .or. size(u,3)/=nz .or. size(u,4)/=3 ) then
   print*,' ERROR: dimension of variable u does not match'
   ierr=-2
   return  
  endif
 else
   print*,' ERROR: variable u is not allocated'
   ierr=-1
   return
 endif

 if (allocated(v)) then
  if ( size(v,1)/=nx .or. size(v,2)/=ny .or. size(v,3)/=nz .or. size(v,4)/=3 ) then
   print*,' ERROR: dimension of variable v does not match'
   ierr=-2
   return  
  endif
 else
   print*,' ERROR: variable v is not allocated'
   ierr=-1
   return
 endif

 if (allocated(w)) then
  if ( size(w,1)/=nx .or. size(w,2)/=ny .or. size(w,3)/=nz .or. size(w,4)/=3 ) then
   print*,' ERROR: dimension of variable w does not match'
   ierr=-2
   return  
  endif
 else
   print*,' ERROR: variable w is not allocated'
   ierr=-1
   return
 endif

 if (allocated(b)) then
  if ( size(b,1)/=nx .or. size(b,2)/=ny .or. size(b,3)/=nz .or. size(b,4)/=3 ) then
   print*,' ERROR: dimension of variable b does not match'
   ierr=-2
   return  
  endif
 else
   print*,' ERROR: variable b is not allocated'
   ierr=-1
   return
 endif
 
 if (allocated(p_full)) then
  if ( size(p_full,1)/=nx .or. size(p_full,2)/=ny .or. size(p_full,3)/=nz .or. size(p_full,4)/=3 ) then
   print*,' ERROR: dimension of variable p_full does not match'
   ierr=-2
   return  
  endif
 else
   print*,' ERROR: variable p_full is not allocated'
   ierr=-1
   return
 endif

 end subroutine check_pyOM_module   

!=======================================================================
!  1. exp. in Wardle and Marshall 2000, "Representation of eddies in 
!  primitive equation models by a PV flux" JPO, 30
!=======================================================================

 subroutine set_parameter
      use pyOM_module   
      use fcontrol_module
      implicit none
! ----------------------------------
!       set here main parameter
! ----------------------------------
      nx=32;nz=92;ny=26
      dx=20.0e3
      dz=50.0
      dt=600.0
      K_h=000.0
      K_v=0.0e-4
      A_h=0000.0
      A_v=1.e-4
      eps2D_sor = 1e-12
      enable_noslip              = .true.
      enable_cyclic_x            = .true.
      enable_quicker_advection   = .true.
      enable_bottom_stress       = .true.
      enable_biharmonic_friction = .true.
      Ahbi = 1e11
      cdbot=8e-5
      runlen=365.0*86400.
      snapint = 1.0*86400.
end subroutine set_parameter


subroutine set_coriolis
      use pyOM_module   
      implicit none
! ----------------------------------
!      add here initial conditions
! ----------------------------------
   integer :: j
   real*8,parameter :: pi=3.1415   
   real*8,parameter :: radius  = 6370.0e3   ! earth radius
   real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
   real*8,parameter :: phi0 = 45.0 /180. *pi
   do j=1,ny
      coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
   enddo
end subroutine set_coriolis

subroutine initial_conditions
   use pyOM_module   
   implicit none
   integer :: i,j,k
   real :: x,y,B0,N_0, pi=3.1415   

   N_0     = 0.0022
   do k=1,nz
       do j=1,ny
        do i=1,nx
         x=float(i)/float(nx)
         y=float(j)/float(ny)
         B0=1e-6*sin(x*2.5*pi)*cos(y*4*pi)
         b(i,j,k,:) = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
   enddo
end subroutine initial_conditions

subroutine boundary_conditions
   use pyOM_module   
   implicit none
   integer :: i,j
   real :: y, pi=3.1415   
      do j=1,ny
       do i=1,nx
        y = (yu(j)-yu(2))/ (yu(ny-1)-yu(2))
        surface_taux(i,j) = .2e-3*sin(pi*y)*maskU(i,j,nz-1)
       enddo
      enddo
end subroutine boundary_conditions

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine topography
end subroutine topography

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!      Boundary conditions and PE exchange
!=======================================================================


 subroutine my_mpi_init(comm_,ierr)
!--------------------------------------------------------------
!     intitialize mpi system for model
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer, intent(out) :: ierr
      integer :: comm_,nlen
      include "mpif.h"
      character (len=MPI_MAX_PROCESSOR_NAME) :: pname
      ierr=0
      if (comm_ == MPI_COMM_NULL) then
        print *, 'You passed MPI_COMM_NULL !!!'
        ierr=1
        return
       end if
       my_comm=comm_
       call MPI_Comm_rank(my_comm, my_pe, ierr)
       if (ierr/=0) return
       call MPI_Comm_size(my_comm, n_pes, ierr)
       if (ierr/=0) return
       call MPI_Get_processor_name(pname, nlen, ierr)
       if (ierr/=0) return
       print*,'this is process ', my_pe,' of ', n_pes,' on ', pname(1:nlen)
       call my_mpi_test(my_comm,ierr)
 end subroutine my_mpi_init


subroutine halt_stop(string)
!--------------------------------------------------------------
!     controlled stop, should not be called from python
!--------------------------------------------------------------
      implicit none
      character*(*) :: string
      integer :: ierr,code,my_pe
      include "mpif.h"
      call mpi_comm_rank(MPI_COMM_WORLD,my_pe,ierr)
      print*,' global pe #',my_pe,' : ',string
      print*,' global pe #',my_pe,' aborting '
      code=99
      call MPI_ABORT(mpi_comm_world, code, IERR)
end subroutine halt_stop



subroutine fortran_barrier
!--------------------------------------------------------------
!     A barrier for the local sub domain
!     for use in fortran part only
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: ierr
      call mpi_barrier(my_comm, ierr)
end subroutine fortran_barrier



 subroutine my_mpi_test(my_comm,ierr)
!--------------------------------------------------------------
!     test some basic mpi routines
!--------------------------------------------------------------
      implicit none
      integer, intent(out) :: ierr
      integer :: my_comm
      integer :: my_pe=-1,all_pes,xint,xint2
      real*8    :: xreal,xreal2
      include "mpif.h"
!   get some mpi infos first
      ierr=0
      call mpi_comm_rank(my_comm       ,my_pe,ierr)
      if (ierr/=0) return
      call mpi_comm_size(my_comm       ,all_pes,ierr)
      if (ierr/=0) return
!   try first global barrier
      print*,'tyring first global barrier for PE #',my_pe
      call mpi_barrier(my_comm       , ierr)
      if (ierr/=0) return
!   try broadcasting
      print*,'tyring global broadcast for PE #',my_pe
      xreal = 1.0
      call mpi_bcast(xreal,1,mpi_real8,0,my_comm       ,ierr)
      if (ierr/=0) return
      xint = 1
      call mpi_bcast(xint,1,mpi_integer,0,my_comm       ,ierr)
      if (ierr/=0) return
!   check results of broadcasting
      if (xreal /= 1.0 ) then
       print*,'fatal: MPI test failed on broadcasting reals for PE #',my_pe
       ierr=-1 ; return
      endif
      if (xint /= 1 ) then
       print*,'fatal: MPI test failed on broadcasting integer for PE #',my_pe
       ierr=-1 ; return
      endif
      call mpi_barrier(my_comm       , ierr)
      if (ierr/=0) return
!   try global sum
      xreal = 2.0
      call mpi_allreduce(xreal,xreal2,1,mpi_real8,MPI_SUM,my_comm       ,ierr)
      if (ierr/=0) return
      xint = 2.0
      call mpi_allreduce(xint,xint2,1,mpi_integer,MPI_SUM,my_comm       ,ierr)
      if (ierr/=0) return
!   check results 
      xreal = xreal2/all_pes
      if (xreal /= 2.0 ) then
       print*,'fatal: MPI test failed on global sum (real) for PE #',my_pe
       ierr=-1 ; return
      endif
      xint = xint2/all_pes
      if (xint /= 2.0 ) then
       print*,'fatal: MPI test failed on global sum (int) for PE #',my_pe
       ierr=-1 ; return
      endif
      call mpi_barrier(my_comm       , ierr)
      if (ierr/=0) return
      print*,' my_pe=',my_pe,' ierr = ',ierr
      return
 end subroutine my_mpi_test



 subroutine print_mpi_error(ierr)
!--------------------------------------------------------------
!     print out MPI error message
!--------------------------------------------------------------
      implicit none
      integer :: ierr,ierr2,len
      character*80 :: string
      if (ierr/=0) then
       call MPI_ERROR_STRING(ierr,string, LEN, ierr2)
       print*,' MPI ERROR:',ierr
       print*,'           ',string(1:len)
      endif
 end subroutine print_mpi_error



  subroutine exchg_prog3Dfield_complete(nx_,ny_,nz_,a)
      implicit none
      integer :: nx_,ny_,nz_
      real*8  :: a(nx_,ny_,nz_,3)
      call setcyclic3D(nx_,ny_,nz_,a(1,1,1,1) )
      call setcyclic3D(nx_,ny_,nz_,a(1,1,1,2) )
      call setcyclic3D(nx_,ny_,nz_,a(1,1,1,3) )
      call border_exchg3D(nx_,ny_,nz_,a(1,1,1,1),2)
      call border_exchg3D(nx_,ny_,nz_,a(1,1,1,2),2)
      call border_exchg3D(nx_,ny_,nz_,a(1,1,1,3),2)
  end subroutine exchg_prog3Dfield_complete

  subroutine exchg_prog2Dfield_complete(nx_,ny_,a)
      implicit none
      integer :: nx_,ny_
      real*8  :: a(nx_,ny_,3)
      call setcyclic2D(nx_,ny_,a(1,1,1) )
      call setcyclic2D(nx_,ny_,a(1,1,2) )
      call setcyclic2D(nx_,ny_,a(1,1,3) )
      call border_exchg2D(nx_,ny_,a(1,1,1),2)
      call border_exchg2D(nx_,ny_,a(1,1,2),2)
      call border_exchg2D(nx_,ny_,a(1,1,3),2)
  end subroutine exchg_prog2Dfield_complete

  subroutine exchg_3Dfield_complete(nx_,ny_,nz_,a)
      implicit none
      integer :: nx_,ny_,nz_
      real*8  :: a(nx_,ny_,nz_)
      call setcyclic3D(nx_,ny_,nz_,a)
      call border_exchg3D(nx_,ny_,nz_,a,2)
  end subroutine exchg_3Dfield_complete

  subroutine exchg_2Dfield_complete(nx_,ny_,a)
      implicit none
      integer :: nx_,ny_
      real*8  :: a(nx_,ny_)
      call setcyclic2D(nx_,ny_,a)
      call border_exchg2D(nx_,ny_,a,2)
  end subroutine exchg_2Dfield_complete



  subroutine setcyclic3D(nx_,ny_,nz_,p1)
!--------------------------------------------------------------
!       set cyclic boundary conditions for 3D array
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      real*8 :: p1(nx_,ny_,nz_)
      integer :: j,nx_,ny_,nz_
      include "mpif.h"
      integer  :: tag=0, ier, Sta(MPI_STATUS_SIZE),len
      if (enable_cyclic_x) then
        do j=max(1,js_pe-1),min(ny,je_pe+1)
          p1(1  ,j,:)=p1(nx-1,j,:); 
          p1(nx,j,:)=p1(2    ,j,:)
         enddo
      endif
      if (enable_cyclic_y) then
       if ( n_pes_j > 1) then
        len=nx*nz
        call mpi_barrier(my_comm       ,ier)
        if (my_pe ==0 ) then
         call mpi_send(p1(:,2,:),len,mpi_real8,n_pes-1,tag,my_comm       ,ier)
         call mpi_recv(p1(:,1,:),len,mpi_real8,n_pes-1,tag,my_comm       ,Sta,ier)
        endif
        if (my_pe == n_pes-1) then 
         call mpi_recv(p1(:,ny  ,:),len,mpi_real8,0,tag,my_comm       ,Sta,ier)
         call mpi_send(p1(:,ny-1,:),len,mpi_real8,0,tag,my_comm       ,ier)
        endif
        call mpi_barrier(my_comm       ,ier)
       else
        p1(:,1  ,:)=p1(:,ny-1,:); 
        p1(:,ny,:)=p1(:,2    ,:)
       endif
      endif
 end subroutine setcyclic3D



 subroutine setcyclic3D_j2(nx_,ny_,nz_,p1)
!--------------------------------------------------------------
!       set cyclic boundary conditions for 3D array
!       communicate 2 rows in meridional direction
!       needed for higher order advection schemes
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      real*8 :: p1(nx_,ny_,nz_)
      integer :: nx_,ny_,nz_
      include "mpif.h"
      integer  :: tag=0, ier, Sta(MPI_STATUS_SIZE),len
      if (enable_cyclic_y .and. n_pes_j > 1) then
        len=nx*nz
        call mpi_barrier(my_comm       ,ier)
        if (my_pe ==0 ) then 
         call mpi_send(p1(:,3   ,:),len,mpi_real8,n_pes-1,tag,my_comm       ,ier)
         call mpi_recv(p1(:,ny-2,:),len,mpi_real8,n_pes-1,tag,my_comm       ,Sta,ier)
        endif
        if (my_pe == n_pes-1) then 
         call mpi_recv(p1(:,3   ,:),len,mpi_real8,0,tag,my_comm       ,Sta,ier)
         call mpi_send(p1(:,ny-2,:),len,mpi_real8,0,tag,my_comm       ,ier)
        endif
        call mpi_barrier(my_comm       ,ier)
      endif
 end subroutine setcyclic3D_j2



 subroutine setcyclic2D(nx_,ny_,p1)
!--------------------------------------------------------------
!       set cyclic boundary conditions for 2D array
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      real*8 :: p1(nx_,ny_)
      integer :: j,nx_,ny_
      include "mpif.h"
      integer  :: tag=0, ier, Sta(MPI_STATUS_SIZE)
      if (enable_cyclic_x) then
        do j=max(1,js_pe-1),min(ny,je_pe+1)
         p1(1  ,j)=p1(nx-1,j); 
         p1(nx,j)=p1(2    ,j)
        enddo
      endif
      if (enable_cyclic_y) then
       if ( n_pes_j > 1) then
        call mpi_barrier(my_comm       ,ier)
        if (my_pe ==0 ) then
         call mpi_send(p1(:,2),nx,mpi_real8,n_pes-1,tag,my_comm       ,ier)
         call mpi_recv(p1(:,1),nx,mpi_real8,n_pes-1,tag,my_comm       ,Sta,ier)
        endif
        if (my_pe == n_pes-1) then 
         call mpi_recv(p1(:,ny  ),nx,mpi_real8,0,tag,my_comm       ,Sta,ier)
         call mpi_send(p1(:,ny-1),nx,mpi_real8,0,tag,my_comm       ,ier)
        endif
        call mpi_barrier(my_comm       ,ier)
       else
        p1(:,1  )=p1(:,ny-1); 
        p1(:,ny)=p1(:,2    )
       endif
      endif
 end subroutine setcyclic2D


 subroutine border_exchg3D(nx_,ny_,nz_,a,jx)
!--------------------------------------------------------------
!     Exchange overlapping areas of 3D array a in all PEs of sub 
!     domain. Number of overlapping indicees are given by jx.
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: jx,nx_,ny_,nz_,jj
      real*8  :: a(nx_,ny_,nz_)
      integer  ::  j, tag, ierr,len
      include "mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      tag  = 0; len=nx*nz
      call mpi_barrier(my_comm       ,ierr)
      if ( n_pes_j > 1) then
!     Austausch von Norden nach Sueden
        if (my_blk_j /=1 ) then
         do j=2*jx-1,jx,-1
          jj=min(ny_, js_pe+j-jx)
          call mpi_send(a(:,jj,:),len,mpi_real8,my_pe-1,tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /= n_pes_j) then 
         do j=0,jx-1
          jj=min(ny_, je_pe+jx-j)
          call mpi_recv(a(:,jj,:),len,mpi_real8,my_pe+1,tag,my_comm,Status,ierr)
         enddo
       endif
!      Austausch von Sueden nach Norden
       if (my_blk_j /= n_pes_j) then 
         do j=jx,2*jx-1
          jj=max(0, je_pe+jx-j)
          call mpi_send(a(:,jj,:),len,mpi_real8,my_pe+1,tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /=1 ) then
         do j=jx-1,0,-1
          jj=max(0, js_pe-jx+j)
          call mpi_recv(a(:,jj,:),len,mpi_real8,my_pe-1,tag,my_comm,Status,ierr)
         enddo
        endif
      endif
      call mpi_barrier(my_comm,ierr)
 end subroutine border_exchg3D


 subroutine border_exchg2D(nx_,ny_,a,jx)
!--------------------------------------------------------------
!     Exchange overlapping areas of 2D array a in all PEs of sub 
!     domain. Number of overlapping indicees are given by jx.
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: jx,nx_,ny_,jj
      real*8  :: a(nx_,ny_)
      integer  ::  j, tag, ierr
      include "mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      tag  = 0
      call mpi_barrier(my_comm ,ierr)
      if ( n_pes_j > 1) then
!       Austausch von Norden nach Sueden
        if (my_blk_j /=1 ) then
         do j=2*jx-1,jx,-1
          jj=min(ny_,js_pe+j-jx)
          call mpi_send(a(1,jj),nx,mpi_real8,my_pe-1,tag,my_comm ,ierr)
         enddo
        endif
        if (my_blk_j /= n_pes_j) then 
         do j=0,jx-1 
          jj=min(ny_, je_pe+jx-j )
          call mpi_recv(a(1,jj),nx,mpi_real8,my_pe+1,tag,my_comm ,Status,ierr)
         enddo
       endif
!      Austausch von Sueden nach Norden
       if (my_blk_j /= n_pes_j) then 
         do j=jx,2*jx-1
          jj=max(1, je_pe+jx-j )
          call mpi_send(a(1,jj),nx,mpi_real8,my_pe+1,tag,my_comm ,ierr)
         enddo
        endif
        if (my_blk_j /=1 ) then
         do j=jx-1,0,-1   
          jj=max(1, js_pe-jx+j)
          call mpi_recv(a(1,jj),nx,mpi_real8,my_pe-1,tag,my_comm ,Status,ierr)
         enddo
        endif
      endif
      call mpi_barrier(my_comm ,ierr)
 end subroutine border_exchg2D



 subroutine border_exchg_merid(ny_,nz_,a,jx)
!--------------------------------------------------------------
!     Exchange overlapping areas of array a in all PEs of sub 
!     domain. Number of overlapping indicees are given by jx.
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: jx,ny_,nz_,jj
      real*8  :: a(ny_,nz_)
      integer  ::  j, tag, ierr,len
      include "mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      tag  = 0; len=nz
      call mpi_barrier(my_comm       ,ierr)
      if ( n_pes_j > 1) then
!    Austausch von Norden nach Sueden
        if (my_blk_j /=1 ) then
         do j=2*jx-1,jx,-1
          jj=min(ny_, js_pe+j-jx)
          call mpi_send(a(jj,:),len,mpi_real8,my_pe-1,tag,my_comm ,ierr)
         enddo
        endif
        if (my_blk_j /= n_pes_j) then 
         do j=0,jx-1
          jj=min(ny_, je_pe+jx-j)
          call mpi_recv(a(jj,:),len,mpi_real8,my_pe+1,tag,my_comm ,Status,ierr)
         enddo
       endif
!     Austausch von Sueden nach Norden
       if (my_blk_j /= n_pes_j) then 
         do j=jx,2*jx-1
          jj=max(1, je_pe+jx-j)
          call mpi_send(a(jj,:),len,mpi_real8,my_pe+1,tag,my_comm ,ierr)
         enddo
        endif
        if (my_blk_j /=1 ) then
         do j=jx-1,0,-1
          jj=max(1, js_pe-jx+j)
          call mpi_recv(a(jj,:),len,mpi_real8,my_pe-1,tag,my_comm ,Status,ierr)
         enddo
        endif
      endif
      call mpi_barrier(my_comm ,ierr)
 end subroutine border_exchg_merid


 subroutine pe0_recv_3D(nx_,ny_,nz_,a)
!--------------------------------------------------------------
!     all PEs send their data of a 3D array to PE0
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8  :: a(nx_,ny_,nz_)
      integer                     :: js,je,iproc
      integer                     :: tag=0, ierr,len
      include "mpif.h"
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm       ,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,mpi_integer,0,tag,my_comm       ,ierr)
        call mpi_send(je,1,mpi_integer,0,tag,my_comm       ,ierr)
        len=nx*(je-js+1)*nz
        call mpi_send(a(:,js:je,:),len,mpi_real8,0,tag,my_comm       ,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        call mpi_recv(je,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        len=nx*(je-js+1)*nz
        call mpi_recv(a(:,js:je,:),len,mpi_real8,iproc,tag,my_comm       ,Status,ierr)
       endif
       call mpi_barrier(my_comm       ,ierr)
      enddo
 end subroutine pe0_recv_3D


 subroutine pe0_send_3D(nx_,ny_,nz_,a)
!--------------------------------------------------------------
!     all PEs gets data of a 3D array from PE0
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8  :: a(nx_,ny_,nz_)
      integer                      :: js,je,iproc
      integer                      :: tag=0, ierr,len
      include "mpif.h"
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm       ,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,mpi_integer,0,tag,my_comm       ,ierr)
        call mpi_send(je,1,mpi_integer,0,tag,my_comm       ,ierr)
        len=nx*(je-js+1)*nz
        call mpi_recv(a(:,js:je,:),len,mpi_real8,0,tag,my_comm       ,status,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        call mpi_recv(je,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        len=nx*(je-js+1)*nz
        call mpi_send(a(:,js:je,:),len,mpi_real8,iproc,tag,my_comm       ,ierr)
       endif
       call mpi_barrier(my_comm       ,ierr)
      enddo
 end subroutine pe0_send_3D




 subroutine pe0_recv_2D(nx_,ny_,a)
!--------------------------------------------------------------
!     all PEs send their data of a 2D array to PE0
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: nx_,ny_
      real*8  :: a(nx_,ny_)
      integer                     :: js,je,iproc
      integer                     :: tag=0, ierr,len
      include "mpif.h"
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm       ,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,mpi_integer,0,tag,my_comm       ,ierr)
        call mpi_send(je,1,mpi_integer,0,tag,my_comm       ,ierr)
        len=nx*(je-js+1)
        call mpi_send(a(:,js:je),len,mpi_real8,0,tag,my_comm       ,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        call mpi_recv(je,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        len=nx*(je-js+1)
        call mpi_recv(a(:,js:je),len,mpi_real8,iproc,tag,my_comm       ,Status,ierr)
       endif
       call mpi_barrier(my_comm       ,ierr)
      enddo
 end subroutine pe0_recv_2D


 subroutine pe0_send_2D(nx_,ny_,a)
!--------------------------------------------------------------
!     all PEs gets data of a 2D array from PE0
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: nx_,ny_
      real*8  :: a(nx_,ny_)
      integer                      :: js,je,iproc
      integer                      :: tag=0, ierr,len
      include "mpif.h"
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm       ,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,mpi_integer,0,tag,my_comm       ,ierr)
        call mpi_send(je,1,mpi_integer,0,tag,my_comm       ,ierr)
        len=nx*(je-js+1)
        call mpi_recv(a(:,js:je),len,mpi_real8,0,tag,my_comm       ,status,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        call mpi_recv(je,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        len=nx*(je-js+1)
        call mpi_send(a(:,js:je),len,mpi_real8,iproc,tag,my_comm       ,ierr)
       endif
       call mpi_barrier(my_comm       ,ierr)
      enddo
 end subroutine pe0_send_2D


 subroutine pe0_recv_1D(nx_,a)
!--------------------------------------------------------------
!     all PEs send their data of a 1D array to PE0
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: nx_
      real*8  :: a(nx_)
      integer                     :: js,je,iproc
      integer                     :: tag=0, ierr,len
      include "mpif.h"
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm       ,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,mpi_integer,0,tag,my_comm       ,ierr)
        call mpi_send(je,1,mpi_integer,0,tag,my_comm       ,ierr)
        len=(je-js+1)
        call mpi_send(a(js:je),len,mpi_real8,0,tag,my_comm       ,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        call mpi_recv(je,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        len=(je-js+1)
        call  mpi_recv(a(js:je),len,mpi_real8,iproc,tag,my_comm       ,Status,ierr)
       endif
       call mpi_barrier(my_comm       ,ierr)
      enddo
 end subroutine pe0_recv_1D


 subroutine pe0_send_1D(nx_,a)
!--------------------------------------------------------------
!     all PEs gets data of a 1D array from PE0
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: nx_
      real*8  :: a(nx_)
      integer                      :: js,je,iproc
      integer                      :: tag=0, ierr,len
      include "mpif.h"
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm       ,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,mpi_integer,0,tag,my_comm       ,ierr)
        call mpi_send(je,1,mpi_integer,0,tag,my_comm       ,ierr)
        len=(je-js+1)
        call mpi_recv(a(js:je),len,mpi_real8,0,tag,my_comm       ,status,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        call mpi_recv(je,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
        len=(je-js+1)
        call mpi_send(a(js:je),len,mpi_real8,iproc,tag,my_comm       ,ierr)
       endif
       call mpi_barrier(my_comm       ,ierr)
      enddo
 end subroutine pe0_send_1D

 subroutine pe0_recv_int(a)
!--------------------------------------------------------------
!     all PEs send integer to PE0
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: a
      include "mpif.h"
      integer :: iproc,ierr, status(MPI_STATUS_SIZE),tag=0
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm       ,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(a,1,mpi_integer,0,tag,my_comm       ,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(a,1,mpi_integer,iproc,tag,my_comm       ,Status,ierr)
       endif
       call mpi_barrier(my_comm       ,ierr)
      enddo
 end subroutine pe0_recv_int


 subroutine pe0_send_int(a)
!--------------------------------------------------------------
!     all PEs gets integer from PE0
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: a
      include "mpif.h"
      integer :: iproc,ierr, status(MPI_STATUS_SIZE),tag=0
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm       ,ierr)
       if ( my_pe == iproc ) then
        call mpi_recv(a,1,mpi_integer,0,tag,my_comm       ,Status,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_send(a,1,mpi_integer,iproc,tag,my_comm       ,ierr)
       endif
       call mpi_barrier(my_comm       ,ierr)
      enddo
 end subroutine pe0_send_int



 subroutine global_max(x)
!--------------------------------------------------------------
!     Get the max of real x over all PEs in sub domain
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      real*8    :: x, x_sym,x_sym2
      integer :: ierr
      include "mpif.h"
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,1,mpi_real8,MPI_MAX,my_comm       ,ierr)
      x = x_sym2
 end subroutine global_max



 subroutine global_max_int(x,len)
!--------------------------------------------------------------
!     Get the max of integer x over all PEs in sub domain
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      include "mpif.h"
      integer  :: x(len), x_sym(len),x_sym2(len)
      integer :: ierr,len
!     skip this copying overhead  here
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,len,mpi_integer,MPI_MAX,my_comm,ierr)
!      call print_mpi_error(ierr)
      x = x_sym2
 end subroutine global_max_int


 subroutine global_sum(x)
!--------------------------------------------------------------
!     Do a sum of real x over all PEs in sub domain
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      real*8    :: x,x_sym,x_sym2
      integer :: ierr
      include "mpif.h"
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,1,mpi_real8,MPI_SUM,my_comm       ,ierr)
      x = x_sym2
 end subroutine global_sum


 subroutine global_sum_vec(x,len)
!--------------------------------------------------------------
!     Do a sum of real vecter x(len) over all PEs in sub domain
!--------------------------------------------------------------
      use pyOM_module
      implicit none
      include "mpif.h"
      integer :: ierr,len
      real*8  :: x(len), x_sym(len),x_sym2(len)
      x_sym(1:len) = x(1:len)
      call mpi_allreduce(x_sym,x_sym2,len,mpi_real8,MPI_SUM,my_comm,ierr)
      x(1:len) = x_sym2(1:len)
end subroutine global_sum_vec


 subroutine bcast_integer(x,len,pe)
!--------------------------------------------------------------
!     Broadcast a integer vector to the local sub domain
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer len,ierr,pe
      integer x(len)
      include "mpif.h"
      call mpi_barrier(my_comm, ierr)
      call mpi_bcast(x,len,mpi_integer,pe,my_comm,ierr)
 end subroutine bcast_integer


 subroutine bcast_real(x,len,pe)
!--------------------------------------------------------------
!     Broadcast a real vector to all sub domains
!--------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer len,ierr,pe
      real*8 x(len)
      include "mpif.h"
      call mpi_barrier(my_comm, ierr)
      call mpi_bcast(x,len,mpi_real8,pe,my_comm,ierr)
 end subroutine bcast_real

subroutine diagnose
 !=======================================================================
 ! Diagnostic routines
 !=======================================================================
 use pyOM_module   
 use fcontrol_module
 implicit none
 if ( mod(itt,int(snapint/dt))  == 0)  then
  if (my_pe==0) print'(a,i10.10,a,e8.2,a,i5,i5,a)', &
               ' diagnosing at itt=',itt,', ',itt*dt,'s, SOR itts = (',sor2D_itts,sor3D_itts,')'
  call diag_snap
 endif
end subroutine diagnose


subroutine init_snap_cdf
 !-----------------------------------------------------------------------
 !     initialize NetCDF snapshot file
 !-----------------------------------------------------------------------
 use pyOM_module   
 use fcontrol_module   
 implicit none
 include "netcdf.inc"
 integer :: ncid,iret
 integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
 integer :: lat_tdim,lat_udim,id
 integer :: dims(4)
 character :: name*24, unit*16
 real*8, parameter :: spval = -1.0d33

      call def_grid_cdf(snap_file)
      iret=nf_open(snap_file,NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'xu',lon_udim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'yu',lat_udim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)

!     2 dim variables on t grid
      dims = (/Lon_udim,lat_tdim, z_tdim, iTimedim/)
      id  = ncvdef (ncid,'u', NCFLOAT,4,dims,iret)
      name = 'Zonal velocity         '; unit = 'm/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_udim, z_tdim, iTimedim/)
      id  = ncvdef (ncid,'v', NCFLOAT,4,dims,iret)
      name = 'Meridional velocity  '; unit = 'm/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, z_udim, iTimedim/)
      id  = ncvdef (ncid,'w', NCFLOAT,4,dims,iret)
      name = 'Vertical velocity  '; unit = 'm/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
      id  = ncvdef (ncid,'b', NCFLOAT,4,dims,iret)
      name = 'Buoyancy      '; unit = 'm/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      id  = ncvdef (ncid,'p', NCFLOAT,4,dims,iret)
      name = 'Pressure      '; unit = 'm^2/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
      id = ncvdef (ncid,'ps', NCFLOAT,3,dims,iret)
      if (enable_free_surface.or.enable_expl_free_surf) then
       name = 'Surface height'; unit = 'm'
      else
       name = 'Surface pressure'; unit = 'm^2/s^2'
      endif
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, z_udim, iTimedim/)
      if (enable_hydrostatic) then
       id  = ncvdef (ncid,'K_b', NCFLOAT,4,dims,iret)
       name = 'Vertical diffusivity'; unit = 'm^2/s'
       call dvcdf(ncid,id,name,24,unit,16,spval)
      else
       id  = ncvdef (ncid,'psi', NCFLOAT,4,dims,iret)
       name = 'Non-hydrostatic pressure'; unit = 'm^2/s^2'
       call dvcdf(ncid,id,name,24,unit,16,spval)
      endif

      dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
      id = ncvdef (ncid,'surf_flux', NCFLOAT,3,dims,iret)
      name = 'Surface buoyancy flux'; unit = 'm^2/s^3'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
      id = ncvdef (ncid,'taux', NCFLOAT,3,dims,iret)
      name = 'Zonal wind stress'; unit = 'm^2/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
      id = ncvdef (ncid,'tauy', NCFLOAT,3,dims,iret)
      name = 'Meridional wind stress'; unit = 'm^2/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)


if (enable_back_state) then
      dims = (/Lon_tdim,lat_tdim, z_tdim, 0/)
      id  = ncvdef (ncid,'back', NCFLOAT,3,dims,iret)
      name = 'Background buoyancy '; unit = 'm/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)
endif
if (enable_back_state.and. enable_back_zonal_flow) then
      dims = (/Lon_udim,lat_tdim, z_tdim, 0/)
      id  = ncvdef (ncid,'u0', NCFLOAT,3,dims,iret)
      name = 'Background zonal velocity'; unit = 'm/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)
endif
if (enable_back_state.and. enable_back_meridional_flow) then
      dims = (/Lon_tdim,lat_udim, z_tdim, 0/)
      id  = ncvdef (ncid,'v0', NCFLOAT,3,dims,iret)
      name = 'Background meridional velocity'; unit = 'm/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)
endif


      call ncclos (ncid, iret)

if (enable_back_state) then
      iret=nf_open(snap_file,NF_WRITE,ncid)
      iret=nf_inq_varid(ncid,'back',id)
      iret= nf_put_vara_double(ncid,id,(/1,1,1/),(/nx,ny,nz/),back(:,:,:,1))
      call ncclos (ncid, iret)
endif

if (enable_back_state.and. enable_back_zonal_flow) then
      iret=nf_open(snap_file,NF_WRITE,ncid)
      iret=nf_inq_varid(ncid,'u0',id)
      iret= nf_put_vara_double(ncid,id,(/1,1,1/),(/nx,ny,nz/),u0(:,:,:))
      call ncclos (ncid, iret)
endif

if (enable_back_state.and. enable_back_meridional_flow) then
      iret=nf_open(snap_file,NF_WRITE,ncid)
      iret=nf_inq_varid(ncid,'v0',id)
      iret= nf_put_vara_double(ncid,id,(/1,1,1/),(/nx,ny,nz/),u0(:,:,:))
      call ncclos (ncid, iret)
endif
end subroutine init_snap_cdf


subroutine diag_snap
 !-----------------------------------------------------------------------
 !     write to NetCDF snapshot file
 !-----------------------------------------------------------------------
 use pyOM_module   
 use fcontrol_module
 implicit none
 include "netcdf.inc"
 integer :: ncid,iret,corner(4), edges(4)
 real*8 :: a(nx,ny,nz)
 integer :: itdimid,ilen,pid,rid,uid,wid,itimeid
 integer :: js,je,vid,sflid,kbid,id
 real*8 :: fxa,time
 real*8, parameter :: spval = -1.0d33

      js=max(2,js_pe); je = min(je_pe,ny-1)

      call pe0_recv_3D(nx,ny,nz,u(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,v(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,w(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,b(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,p_full(:,:,:,tau) )
      if (enable_hydrostatic) then
        call pe0_recv_3D(nx,ny,nz,K_b)
      else 
        call pe0_recv_3D(nx,ny,nz,psi)
      endif
      if (enable_free_surface.or.enable_expl_free_surf) then
        call pe0_recv_2D(nx,ny,eta(:,:,tau) )
      else 
        call pe0_recv_2D(nx,ny,p_surf )
      endif
      call pe0_recv_2D(nx,ny,surface_flux)
      call pe0_recv_2D(nx,ny,surface_taux)
      call pe0_recv_2D(nx,ny,surface_tauy)

      if (my_pe==0) then
        iret=nf_open(snap_file,NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)

        iret=nf_inq_varid(ncid,'b',rid)
        iret=nf_inq_varid(ncid,'p',pid)
        iret=nf_inq_varid(ncid,'u',uid)
        iret=nf_inq_varid(ncid,'v',vid)
        iret=nf_inq_varid(ncid,'w',wid)
        iret=nf_inq_varid(ncid,'ps',sflid)
        if (enable_hydrostatic) then
         iret=nf_inq_varid(ncid,'K_b',kbid)
        else
         iret=nf_inq_varid(ncid,'psi',kbid)
        endif
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        ilen=ilen+1
        time = itt*dt
        fxa = time/86400.0
!        print*,' writing snapshot at ',time,' s, time steps in file : ',ilen
        iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)

        Corner = (/1,1,1,ilen/); !edges  = (/nx ,j_blk,nz,1/)
        edges  = (/nx,ny,nz,1/)

        a=b(:,:,:,tau)
        where( maskT == 0.) a = spval
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)

        a=p_full(:,:,:,tau)
        where( maskT == 0.) a = spval
        iret= nf_put_vara_double(ncid,pid,corner,edges,a)

        a=u(:,:,:,tau)
        where( maskU == 0.) a = spval
        iret= nf_put_vara_double(ncid,uid,corner,edges,a)

        a=v(:,:,:,tau)
        where( maskV == 0.) a = spval
        iret= nf_put_vara_double(ncid,vid,corner,edges,a)

        a=w(:,:,:,tau)
        where( maskW == 0.) a = spval
        iret= nf_put_vara_double(ncid,wid,corner,edges,a)

        if (enable_hydrostatic) then
         a=K_b(:,:,:)+K_v
         where( maskW == 0.) a = spval
        else
         a=psi(:,:,:)
         where( maskT == 0.) a = spval
        endif
        iret= nf_put_vara_double(ncid,kbid,corner,edges,a)

        Corner = (/1,1,ilen,1/); edges  = (/nx,ny,1,1/)
        if (enable_free_surface.or.enable_expl_free_surf) then
         a(:,:,nz-1)=eta(:,:,tau)
        else
         a(:,:,nz-1)=p_surf
        endif
        where( maskT== 0.) a = spval
        iret= nf_put_vara_double(ncid,sflid,corner,edges,a(:,:,nz-1))

        Corner = (/1,1,ilen,1/); edges  = (/nx ,ny,1,1/)
        iret=nf_inq_varid(ncid,'surf_flux',id)
        a(:,:,nz-1)=surface_flux(:,:)
        where( maskT == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a(:,:,nz-1))

        iret=nf_inq_varid(ncid,'taux',id)
        a(:,:,nz-1)=surface_taux
        where( maskU == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a(:,:,nz-1))

        iret=nf_inq_varid(ncid,'tauy',id)
        a(:,:,nz-1)=surface_tauy
        where( maskV == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a(:,:,nz-1))
        call ncclos (ncid, iret)
       endif
end subroutine diag_snap


subroutine init_tracer_diag
 !-----------------------------------------------------------------------
 !     initialize NetCDF snapshot file
 !-----------------------------------------------------------------------
 use pyOM_module   
 implicit none
      include "netcdf.inc"
      integer :: ncid,iret,n
      integer :: lon_tdim,z_tdim,itimedim
      integer :: lat_tdim,tr_id(nt)
      integer :: dims(4)
      character :: name*24, unit*16
      real*8,parameter :: spval = -1.0d33

      call def_grid_cdf('tracer.cdf')
      iret=nf_open('tracer.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)
      dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
      do n=1,nt
       write(name, '("tr",i2)') n
       call replace_space_zero(name)
       tr_id(n) = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
       name = 'passive tracer'; unit = ' '
       call dvcdf(ncid,tr_id(n),name,24,unit,16,spval)
      enddo
      call ncclos (ncid, iret)
end subroutine init_tracer_diag


subroutine diag_tracer
 !-----------------------------------------------------------------------
 !     write to NetCDF snapshot file
 !-----------------------------------------------------------------------
 use pyOM_module   
 use fcontrol_module
 implicit none
      include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      real*8 :: a(nx,js_pe:je_pe,nz),fxa,time
      integer :: itdimid,ilen,itimeid
      integer :: tr_id(nt)
      integer :: js,je
      character :: name*24
      real*8,parameter :: spval = -1.0d33

   if ( mod(itt,int(snapint/dt))  == 0)  then

      js=max(2,js_pe); je = min(je_pe,ny -1)
      do npe=0,n_pes
       if (my_pe==npe) then
        iret=nf_open('tracer.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        do n=1,nt
         write(name, '("tr",i2)') n
         call replace_space_zero(name)
         iret=nf_inq_varid(ncid,name,tr_id(n))
        enddo
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        if (my_pe==0) then
         ilen=ilen+1
         time = itt*dt ! current_time-initial_time
         fxa = time/86400.0 ! time%days + time%seconds/86400.
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
        endif
        Corner = (/1,js_pe,1,ilen/); 
        edges  = (/nx,je_pe-js_pe+1,nz,1/)
        do n=1,nt
         a=tr(:,js_pe:je_pe,:,tau,n)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,tr_id(n),corner,edges,a)
        enddo
        call ncclos (ncid, iret)
       endif
       call fortran_barrier
      enddo
   endif
end subroutine diag_tracer



subroutine def_grid_cdf(filename)
 !-----------------------------------------------------------------------
 !      Define standard grid in netcdf file
 !-----------------------------------------------------------------------
 use pyOM_module   
 implicit none
 include "netcdf.inc"
      character*(*) filename
      integer :: ncid,iret
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lon_tid,lon_uid,z_tid,z_uid,itimeid
      integer :: lat_tdim,lat_udim,lat_uid,lat_tid
      character :: name*24, unit*16

      ncid = nccre (filename, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
!     dimensions
      lon_tdim  = ncddef(ncid, 'xt', nx , iret)
      Lon_udim  = ncddef(ncid, 'xu', nx , iret)
      lat_tdim  = ncddef(ncid, 'yt', ny , iret)
      Lat_udim  = ncddef(ncid, 'yu', ny , iret)
      z_tdim    = ncddef(ncid, 'zt',  nz, iret)
      z_udim    = ncddef(ncid, 'zu',  nz, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
!     grid variables
      Lon_tid  = ncvdef (ncid,'xt',NCFLOAT,1,lon_tdim,iret)
      Lon_uid  = ncvdef (ncid,'xu',NCFLOAT,1,lon_udim,iret)
      Lat_tid  = ncvdef (ncid,'yt',NCFLOAT,1,lat_tdim,iret)
      Lat_uid  = ncvdef (ncid,'yu',NCFLOAT,1,lat_udim,iret)
      z_tid  = ncvdef (ncid,'zt', NCFLOAT,1,z_tdim,iret)
      z_uid  = ncvdef (ncid,'zu', NCFLOAT,1,z_udim,iret)
      itimeid  = ncvdef (ncid,'Time', NCFLOAT,1,itimedim,iret)
!     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'm'
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'm'
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid     '; unit = 'm'
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid     '; unit = 'm'
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
!      name = 'Depth on T grid      '; unit = 'm'
      name = 'Height on T grid      '; unit = 'm'
      call ncaptc(ncid, z_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, z_tid, 'units',     NCCHAR, 16, unit, iret) 
!      name = 'Depth on U grid      '; unit = 'm'
      name = 'Height on U grid      '; unit = 'm'
      call ncaptc(ncid, z_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, z_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time '; unit = 'days'
      call ncaptc(ncid, itimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, itimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,'01-JAN-1900 00:00:00', iret)

      call ncendf(ncid, iret)
      iret= nf_put_vara_double(ncid,lon_Tid,1,nx ,xt)
      iret= nf_put_vara_double(ncid,lon_uid,1,nx ,xu)
      iret= nf_put_vara_double(ncid,lat_Tid,1,ny ,yt)
      iret= nf_put_vara_double(ncid,lat_uid,1,ny ,yu)
      iret= nf_put_vara_double(ncid,z_tid,1,nz,zt)
      iret= nf_put_vara_double(ncid,z_uid,1,nz,zw)
      call ncclos (ncid, iret)
end subroutine def_grid_cdf




subroutine dvcdf(ncid,ivarid,name,iname,unit,iunit,spval)
 !-----------------------------------------------------------------------
 !     define some standard attributes of variable ivarid in NetCDF file ncid 
 !-----------------------------------------------------------------------
 implicit none
 integer ncid,ivarid,iname,iunit,iret
 character (len=*) :: name, unit
 real*8 :: spval, vv
 include "netcdf.inc"
 vv=spval
 call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
 if (iret.ne.0) print*,nf_strerror(iret)
 call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
 if (iret.ne.0) print*,nf_strerror(iret)
 call ncapt (ncid,ivarid, 'missing_value',NCDOUBLE,1,vv,iret)
 if (iret.ne.0) print*,nf_strerror(iret)
 call ncapt (ncid,ivarid, '_FillValue', NCDOUBLE, 1,vv, iret)
 if (iret.ne.0) print*,nf_strerror(iret)
end subroutine dvcdf

    

!=======================================================================
!       Bolus velocity and isopycnal diffusion
!       linked in the code in pyOM.f90
!=======================================================================


 module bolus_module
!-----------------------------------------------------------------------
!     module for bolus velocities
!-----------------------------------------------------------------------
      implicit none
      real*8, allocatable :: ub(:,:,:)
      real*8, allocatable :: vb(:,:,:)
      real*8, allocatable :: wb(:,:,:)
      real*8, allocatable :: psix(:,:,:)
      real*8, allocatable :: psiy(:,:,:)
      real*8, allocatable :: ahthk(:,:,:)
      real*8, parameter :: epsln = 1.0d-20 ! a small parameter
      logical :: enable_bolus_diag                     = .false. ! write output to netcdf file
 end module bolus_module
 

 subroutine init_bolus
!-----------------------------------------------------------------------
!     initialize module
!-----------------------------------------------------------------------
      use pyOM_module   
      use bolus_module
      implicit none
      real*8 :: fxa

      if (my_pe==0) print*,' Initializing bolus velocity module '
      allocate( ub(nx ,ny ,nz) ); ub=0.
      allocate( vb(nx ,ny ,nz) ); vb=0.
      allocate( wb(nx ,ny ,nz) ); wb=0.
      allocate( psix(nx ,ny ,nz) ); psix=0.
      allocate( psiy(nx ,ny ,nz) ); psiy=0.
      allocate( ahthk(nx ,ny ,nz) ); ahthk=0.
      ahthk = K_gm

 if (enable_bolus_diag) then
      if (my_pe==0) call init_bolus_diag
 else
      if (my_pe==0) print*,' no diagnostic output '
 endif
!
!-----------------------------------------------------------------------
!     Compute the grid factors which set the maximum slopes available
!     for the mixing schemes. 
!-----------------------------------------------------------------------
!
      fxa = dz*dx/(4*K_gm*dt+epsln)
      if (my_pe==0) then
       print*,' steepest slope possible for linear stab = ',fxa
       print*,' critical slope specified as               ',iso_slopec
      print*,' K_gm  = ',k_gm,' m^2/s'
      endif
      if (my_pe==0) print*,' done initializing GM module '
 end subroutine init_bolus




 subroutine bolus_velocity
!-----------------------------------------------------------------------
!     Verteiler funktion
!-----------------------------------------------------------------------
      use pyOM_module   
      use bolus_module
      use fcontrol_module
      implicit none
      integer :: n

      call calculate_bolus
      call add_bolus(b)
      if (enable_back_state) call add_bolus_back

      if (enable_diag_tracer ) then
       do n=1,nt
        call add_bolus(tr(:,:,:,:,n))
       enddo
      endif
      if (enable_bolus_diag .and. mod(itt,int(snapint/dt))  == 0)  then
        call diag_bolus
      endif
 end subroutine bolus_velocity


! subroutine bolus_set_ahthk(diff)
!-----------------------------------------------------------------------
!     set thickness diffusivity from other module
!-----------------------------------------------------------------------
!      use pyOM_module   
!      use bolus_module
!      implicit none
!      real*8 :: diff(nx ,ny ,nz)
!      call border_exchg3D(nx,ny,nz,ahthk,1); 
!      call setcyclic3D(nx,ny,nz,ahthk)
! end subroutine bolus_set_ahthk



 subroutine calculate_bolus
!-----------------------------------------------------------------------
!     calculate bolus velocities using diffusivity ahthk
!-----------------------------------------------------------------------
      use pyOM_module   
      use bolus_module
      implicit none
      integer :: i,j,k,js,je
      real*8 :: fxa,fxb,sx(nx ,ny ,nz),bz(nx ,ny ,nz),sy(nx ,ny ,nz),a(nx ,ny ,nz)

      js=max(2,js_pe); je = min(je_pe,ny -1)
!-----------------------------------------------------------------------
!     vertical derivative of buoyancy
!-----------------------------------------------------------------------
      bz(:,js_pe:je_pe,:)=0
      do k=1,nz-1
       do j=js,je
        do i=2,nx -1
         bz(i,j,k)= (b(i,j,k+1,taum1)-b(i,j,k,taum1))/dz*maskW(i,j,k) 
        enddo
       enddo
      enddo
      if (enable_back_state) then  
       do k=1,nz-1
        do j=js,je
         do i=2,nx -1
          bz(i,j,k)= bz(i,j,k)+ (back(i,j,k+1,taum1)-back(i,j,k,taum1))/dz*maskW(i,j,k) 
         enddo
        enddo
       enddo
      endif
      call border_exchg3D(nx,ny,nz,bz,1); call setcyclic3D(nx,ny,nz,bz)
!-----------------------------------------------------------------------
!     zonal component of streamfunction
!-----------------------------------------------------------------------
      a(:,js_pe:je_pe,:)=0
      sx(:,js_pe:je_pe,:)=0
      psix(:,js_pe:je_pe,:)=0
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         a(i,j,k)=(b(i+1,j,k,taum1)-b(i,j,k,taum1))/dx*maskU(i,j,k)
        enddo
       enddo
      enddo
      if (enable_back_state) then  
       do k=2,nz-1
        do j=js,je
         do i=2,nx -1
          a(i,j,k)=a(i,j,k)+ (back(i+1,j,k,taum1)-back(i,j,k,taum1))/dx*maskU(i,j,k)
         enddo
        enddo
       enddo
      endif
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fxa=(a(i,j,k+1)+a(i,j,k))/(maskU(i,j,k)+maskU(i,j,k+1)+epsln)
         fxb=(bz(i+1,j,k)+bz(i,j,k))/(maskW(i+1,j,k)+maskW(i,j,k)+epsln)
         fxa=fxa*sign(dble(1.),fxb)/(abs(fxb)+epsln)
!         sx(i,j,k)=fxa*0.5*(1.+tanh((-abs(fxa)+iso_slopec)/iso_dslope))   
         sx(i,j,k)= max(min(fxa,iso_slopec),-iso_slopec)
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fxa=ahthk(i,j,k)+ahthk(i+1,j,k)+ahthk(i,j,k+1)+ahthk(i+1,j,k+1)
         psix(i,j,k)=fxa/4.*sx(i,j,k)*maskW(i,j,k)*maskU(i,j,k)  *maskU(i,j,k+1)*maskW(i+1,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,psix,1); call setcyclic3D(nx,ny,nz,psix)
!-----------------------------------------------------------------------
!     meridional component of streamfunction
!-----------------------------------------------------------------------
      a(:,js_pe:je_pe,:)=0
      sy(:,js_pe:je_pe,:)=0
      psiy(:,js_pe:je_pe,:)=0
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         a(i,j,k)=(b(i,j+1,k,taum1)-b(i,j,k,taum1))/dx*maskV(i,j,k)
        enddo
       enddo
      enddo
      if (enable_back_state) then  
       do k=2,nz-1
        do j=js,je
         do i=2,nx -1
          a(i,j,k)=a(i,j,k)+(back(i,j+1,k,taum1)-back(i,j,k,taum1))/dx*maskV(i,j,k)
         enddo
        enddo
       enddo
      endif
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fxa=(a(i,j,k+1)+a(i,j,k))/(maskV(i,j,k)+maskV(i,j,k+1)+epsln)
         fxb=(bz(i,j+1,k)+bz(i,j,k))/(maskW(i,j+1,k)+maskW(i,j,k)+epsln)
         fxa=fxa*sign(dble(1.),fxb)/(abs(fxb)+epsln)
!         sy(i,j,k)=fxa*0.5*(1.+tanh((-abs(fxa)+iso_slopec)/iso_dslope))   
         sy(i,j,k)= max(min(fxa,iso_slopec),-iso_slopec)
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fxa=ahthk(i,j,k)+ahthk(i,j+1,k)+ahthk(i,j,k+1)+ahthk(i,j+1,k+1)
         psiy(i,j,k)=fxa/4.0*sy(i,j,k)*maskW(i,j,k)*maskV(i,j,k)  *maskV(i,j,k+1)*maskW(i,j+1,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,psiy,1); call setcyclic3D(nx,ny,nz,psiy)
!-----------------------------------------------------------------------
!        bolus velocities
!-----------------------------------------------------------------------
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         ub(i,j,k)=(psix(i,j,k)-psix(i,j,k-1))/dz*maskU(i,j,k)
         vb(i,j,k)=(psiy(i,j,k)-psiy(i,j,k-1))/dz*maskV(i,j,k)
         wb(i,j,k)=(-(psiy(i,j,k)-psiy(i,j-1,k))/dx  -(psix(i,j,k)-psix(i-1,j,k))/dx)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,ub,1); call setcyclic3D(nx,ny,nz,ub)
      call border_exchg3D(nx,ny,nz,vb,1); call setcyclic3D(nx,ny,nz,vb)
      call border_exchg3D(nx,ny,nz,wb,1); call setcyclic3D(nx,ny,nz,wb)
 end subroutine calculate_bolus


 subroutine add_bolus(tr_)
!-----------------------------------------------------------------------
!     add divergence of advective eddy fluxes to tracer tr_
!-----------------------------------------------------------------------
      use pyOM_module   
      use bolus_module
      implicit none
      real*8 :: tr_(nx ,ny ,nz,3)
      real*8 :: adv_fe(nx ,ny ,nz), adv_ft(nx ,ny ,nz)
      real*8 :: adv_fn(nx ,ny ,nz)
      integer :: i,j,k,js,je


      js=max(2,js_pe); je = min(je_pe,ny -1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx -1
         adv_fe(i,j,k)= 0.5*(tr_(i,j,k,tau)+tr_(i+1,j,k,tau) )*ub(i,j,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      adv_fn(:,1,:)=0
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         adv_fn(i,j,k)=0.5*(tr_(i,j,k,tau)+tr_(i,j+1,k,tau) )*vb(i,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=1,nz-1
       do j=js,je
        do i=2,nx -1
         adv_ft(i,j,k)=0.5*(tr_(i,j,k,tau)+tr_(i,j,k+1,tau) )*wb(i,j,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,adv_fn,1)
      call setcyclic3D(nx,ny,nz,adv_fe)
      call setcyclic3D(nx,ny,nz,adv_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         tr_(i,j,k,taup1)=tr_(i,j,k,taup1)+maskT(i,j,k)*c2dt*(    &
                          -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx   &
                          -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx   &
                          -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,tr_(:,:,:,taup1),2);
      call setcyclic3D(nx,ny,nz,tr_(:,:,:,taup1) )
 end subroutine add_bolus




 subroutine add_bolus_back
!-----------------------------------------------------------------------
!     add advection of background density
!-----------------------------------------------------------------------
      use pyOM_module   
      use bolus_module
      implicit none
      real*8 :: adv_fe(nx ,ny ,nz), adv_ft(nx ,ny ,nz), adv_fn(nx ,ny ,nz)
      integer :: i,j,k,js,je

      js=max(2,js_pe); je = min(je_pe,ny -1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx -1
         adv_fe(i,j,k)= 0.5*(back(i,j,k,tau)+back(i+1,j,k,tau) )*ub(i,j,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      adv_fn(:,1,:)=0
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         adv_fn(i,j,k)=0.5*(back(i,j,k,tau)+back(i,j+1,k,tau) )*vb(i,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=1,nz-1
       do j=js,je
        do i=2,nx -1
         adv_ft(i,j,k)=0.5*(back(i,j,k,tau)+back(i,j,k+1,tau) )*wb(i,j,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,adv_fn,1)
      call setcyclic3D(nx,ny,nz,adv_fe)
      call setcyclic3D(nx,ny,nz,adv_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*(    &
                          -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx   &
                          -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx   &
                          -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,b(:,:,:,taup1),2);
      call setcyclic3D(nx,ny,nz,b(:,:,:,taup1) )
 end subroutine add_bolus_back







 subroutine init_bolus_diag
!-----------------------------------------------------------------------
!     initialize NetCDF snapshot file
!-----------------------------------------------------------------------
      use pyOM_module   
      use bolus_module
      implicit none
      include "netcdf.inc"
      integer :: ncid,iret
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lat_tdim,lat_udim,varid
      integer :: dims(4)
      character :: name*24, unit*16
      real*8, parameter :: spval = -1.0d33

      call def_grid_cdf('bolus.cdf')
      iret=nf_open('bolus.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'xu',lon_udim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'yu',lat_udim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)

!     2 dim variables on t grid
      dims = (/Lon_tdim,lat_udim, z_udim, iTimedim/)
      varid  = ncvdef (ncid,'psiy', NCFLOAT,4,dims,iret)
      name = 'Meridional streamfct'; unit = 'm^2/s'
      call dvcdf(ncid,varid,name,24,unit,16,spval)

      dims = (/Lon_udim,lat_tdim, z_udim, iTimedim/)
      varid  = ncvdef (ncid,'psix', NCFLOAT,4,dims,iret)
      name = 'Zonal streamfct'; unit = 'm^2/s'
      call dvcdf(ncid,varid,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
      varid  = ncvdef (ncid,'ahthk', NCFLOAT,4,dims,iret)
      name = 'thickness diffusivity'; unit = 'm^2/s'
      call dvcdf(ncid,varid,name,24,unit,16,spval)

      call ncclos (ncid, iret)
 end subroutine init_bolus_diag


 subroutine diag_bolus
!-----------------------------------------------------------------------
!     write to NetCDF snapshot file
!-----------------------------------------------------------------------
      use pyOM_module   
      use bolus_module
      use fcontrol_module
      implicit none
      include "netcdf.inc"
      integer :: ncid,iret,npe, corner(4), edges(4)
      real*8 :: a(nx ,js_pe:je_pe,nz)
      integer :: itdimid,ilen,rid,itimeid
      integer :: js,je
      real*8 :: fxa,time
      real*8, parameter :: spval = -1.0d33

      js=max(2,js_pe); je = min(je_pe,ny -1)

      do npe=0,n_pes
       if (my_pe==npe) then

        iret=nf_open('bolus.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        if (my_pe==0) then
         ilen=ilen+1
         time = itt*dt
         fxa = time/86400.0
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
        endif

        Corner = (/1,js_pe,1,ilen/); 
        edges  = (/nx ,je_pe-js_pe+1,nz,1/)
        iret=nf_inq_varid(ncid,'psiy',rid)
        a=psiy(:,js_pe:je_pe,:)
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)

        iret=nf_inq_varid(ncid,'psix',rid)
        a=psix(:,js_pe:je_pe,:)
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)

        iret=nf_inq_varid(ncid,'ahthk',rid)
        a=ahthk(:,js_pe:je_pe,:)
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)

        call ncclos (ncid, iret)
       endif
       call fortran_barrier
      enddo
 end subroutine diag_bolus


    

 
 subroutine integrate(ierr)
!=======================================================================
!       solve prognostic equations for u,v and w
!       boundary exchange and apply roberts time filter
!=======================================================================
      use pyOM_module   
      implicit none
      integer, intent(out) :: ierr
      integer :: i,j,k,js,je,n
      real*8 :: bv0(nx,ny),bu0(nx,ny)
      ierr=0
      js=max(2,js_pe); je = min(je_pe,ny-1)
!---------------------------------------------------------------------------------
!      du/dt = F_u - p_x 
!---------------------------------------------------------------------------------
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         u(i,j,k,taup1) = u(i,j,k,taum1) + maskU(i,j,k)*c2dt*(   &
           fu(i,j,k)-(p_full(i+1,j,k,tau)-p_full(i,j,k,tau))/dx)
        enddo
       enddo
      enddo
      if (enable_expl_free_surf) then
!---------------------------------------------------------------------------------
!      correct barotropic mode
!---------------------------------------------------------------------------------
        bu0(:,js_pe:je_pe)=0.
        do k=1,nz-1
         do j=js,je
          do i=2,nx-1
           bu0(i,j)=bu0(i,j)+u(i,j,k,taup1)*maskU(i,j,k)*dz
          enddo
         enddo
        enddo
        do k=1,nz-1
         do j=js,je
          do i=2,nx-1
           u(i,j,k,taup1)=u(i,j,k,taup1)+(bu(i,j,taup1)-bu0(i,j))/(1e-18+hu(i,j))*maskU(i,j,k)
          enddo
         enddo
        enddo
      endif
      call border_exchg3D(nx,ny,nz,u(:,:,:,taup1),2)
      call setcyclic3D(nx,ny,nz,u(:,:,:,taup1) )
!---------------------------------------------------------------------------------
!      dv/dt = F_v - p_y  
!---------------------------------------------------------------------------------
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         v(i,j,k,taup1) = v(i,j,k,taum1) + maskV(i,j,k)*c2dt*(   &
           fv(i,j,k)-(p_full(i,j+1,k,tau)-p_full(i,j,k,tau))/dx)
        enddo
       enddo
      enddo
      if (enable_expl_free_surf) then
!---------------------------------------------------------------------------------
!      correct barotropic mode
!---------------------------------------------------------------------------------
        bv0(:,js_pe:je_pe)=0.
        do k=1,nz-1
         do j=js,je
          do i=2,nx-1
           bv0(i,j)=bv0(i,j)+v(i,j,k,taup1)*maskV(i,j,k)*dz
          enddo
         enddo
        enddo
        do k=1,nz-1
         do j=js,je
          do i=2,nx-1
           v(i,j,k,taup1)=v(i,j,k,taup1)+(bv(i,j,taup1)-bv0(i,j))/(1e-18+hv(i,j))*maskV(i,j,k)
          enddo
         enddo
        enddo
      endif
      call border_exchg3D(nx,ny,nz,v(:,:,:,taup1),2)
      call setcyclic3D(nx,ny,nz,v(:,:,:,taup1) )

      if (.not. enable_hydrostatic) then
!---------------------------------------------------------------------------------
!       dw/dt = F_w - psi_z 
!---------------------------------------------------------------------------------
       do k=2,nz-1
        do j=js,je
         do i=2,nx-1
          w(i,j,k,taup1) = w(i,j,k,taum1)+maskW(i,j,k)*c2dt*(fw(i,j,k)-(psi(i,j,k+1)-psi(i,j,k))/dz)
         enddo
        enddo
       enddo
       call border_exchg3D(nx,ny,nz,w(:,:,:,taup1),2)
       call setcyclic3D(nx,ny,nz,w(:,:,:,taup1) )
      endif
!---------------------------------------------------------------------------------
!      apply roberts time filter on time levels 
!---------------------------------------------------------------------------------
      do j=js,je
       u(:,j,:,tau) = u(:,j,:,tau) + gamma*(0.5*(u(:,j,:,taup1) + u(:,j,:,taum1)) - u(:,j,:,tau)) 
       v(:,j,:,tau) = v(:,j,:,tau) + gamma*(0.5*(v(:,j,:,taup1) + v(:,j,:,taum1)) - v(:,j,:,tau)) 
       if (.not. enable_hydrostatic) then
        w(:,j,:,tau) = w(:,j,:,tau) + gamma*(0.5*(w(:,j,:,taup1) + w(:,j,:,taum1)) - w(:,j,:,tau)) 
       endif
       b(:,j,:,tau) = b(:,j,:,tau) + gamma*(0.5*(b(:,j,:,taup1) + b(:,j,:,taum1)) - b(:,j,:,tau)) 
      enddo
      call border_exchg3D(nx,ny,nz,u(:,:,:,tau),2)
      call setcyclic3D(nx,ny,nz,u(:,:,:,tau) )
      call border_exchg3D(nx,ny,nz,v(:,:,:,tau),2)
      call setcyclic3D(nx,ny,nz,v(:,:,:,tau) )
      if (.not.enable_hydrostatic) then
       call border_exchg3D(nx,ny,nz,w(:,:,:,tau),2)
       call setcyclic3D(nx,ny,nz,w(:,:,:,tau) )
      endif
      call border_exchg3D(nx,ny,nz,b(:,:,:,tau),2)
      call setcyclic3D(nx,ny,nz,b(:,:,:,tau) )
      if (enable_diag_tracer) then
!---------------------------------------------------------------------------------
!        boundary exchange and apply roberts time filter on time levels 
!---------------------------------------------------------------------------------
      do n=1,nt
       call border_exchg3D(nx,ny,nz,tr(:,:,:,taup1,n),2)
       call setcyclic3D(nx,ny,nz,tr(:,:,:,taup1,n) )
       do j=js,je
       tr(:,j,:,tau,n) = tr(:,j,:,tau,n) + gamma*(0.5*(tr(:,j,:,taup1,n)+tr(:,j,:,taum1,n))-tr(:,j,:,tau,n)) 
       enddo
       call border_exchg3D(nx,ny,nz,tr(:,:,:,tau,n),2)
       call setcyclic3D(nx,ny,nz,tr(:,:,:,tau,n) )
      enddo
     endif

 end subroutine integrate


 
 subroutine vertical_velocity(ierr)
!=======================================================================
!       vertical velocity from continuity : 
!       \int_0^z w_z dz =w(z)-w(0) = - \int dz (u_x +v_y)  
!        w(z)=-int dz u_x + v_y
!=======================================================================
      use pyOM_module   
      implicit none
      integer, intent(out) :: ierr
      integer :: i,j,k,js,je
      ierr=0
      js=max(2,js_pe); je = min(je_pe,ny-1)
      w(:,js_pe:je_pe,1,tau) = 0.0
      do k=2,nz
       do j=js,je
        do i=2,nx-1
          w(i,j,k,tau) = w(i,j,k-1,tau)-maskW(i,j,k)*dz*(   &
            (u(i,j,k,tau)-u(i-1,j,k,tau))/dx +(v(i,j,k,tau)-v(i,j-1,k,tau))/dx)
        enddo
       enddo
      enddo
      do j=js,je
       w(:,j,:,tau) = w(:,j,:,tau)*maskW(:,j,:)
      enddo
      call border_exchg3D(nx,ny,nz,w(:,:,:,tau),2)
      call setcyclic3D(nx,ny,nz,w(:,:,:,tau) )
 end subroutine vertical_velocity






 subroutine read_restart(itt_,filename)
! ----------------------------------
!       read the restart file
! ----------------------------------
      use pyOM_module   
      implicit none
      integer, intent(out) :: itt_
      integer :: ierr
      integer :: j,io,nx_,ny_,nz_
      character*(*),intent(in) :: filename
      ierr=0

    if (my_pe==0) then
      print*,' reading from restart file ',filename(1:len_trim(filename))
      call get_free_iounit(io,ierr)
      if (ierr/=0) goto 10
      open(io,file=filename,form='unformatted',status='old',err=10)
      read(io,err=10) nx_,ny_,nz_
      if (nx/=nx_ .or. ny/=ny_ .or. nz/= nz_) then 
        print*,' read from restart dimensions: ',nx_,ny_,nz_
        print*,' does not match dimensions   : ',nx,ny,nz
        goto 10
      endif
      read(io,err=10) itt_ !,restart_time_in
      print*,' itt        = ',itt_
      do j=1,ny
        read(io,err=10) u(:,j,:,tau),v(:,j,:,tau),w(:,j,:,tau), u(:,j,:,taum1),v(:,j,:,taum1),w(:,j,:,taum1)
        read(io,err=10) b(:,j,:,tau),   b(:,j,:,taum1)
        read(io,err=10) eta(:,j,tau),   eta(:,j,taum1), psi(:,j,:)
        read(io,err=10) p_full(:,j,:,tau), p_full(:,j,:,taum1) ! this is new
        if (enable_expl_free_surf) then
         read(io,err=10) bu(:,j,tau),bv(:,j,tau)
         read(io,err=10) bu(:,j,taum1),bv(:,j,taum1)
        endif
      enddo
      goto 20
      10 ierr=-1
      print*,' Warning: error reading restart file'
      20 close(io)
    endif

    call pe0_send_int(ierr)
    if (ierr/=0) return

      call pe0_send_int(itt_)
      call pe0_send_3D(nx,ny,nz,u(:,:,:,tau) )
      call pe0_send_3D(nx,ny,nz,v(:,:,:,tau) )
      call pe0_send_3D(nx,ny,nz,w(:,:,:,tau) )
      call pe0_send_3D(nx,ny,nz,u(:,:,:,taum1) )
      call pe0_send_3D(nx,ny,nz,v(:,:,:,taum1) )
      call pe0_send_3D(nx,ny,nz,w(:,:,:,taum1) )
      call pe0_send_3D(nx,ny,nz,b(:,:,:,tau) )
      call pe0_send_3D(nx,ny,nz,b(:,:,:,taum1) )
      call pe0_send_2D(nx,ny,eta(:,:,tau) )
      call pe0_send_2D(nx,ny,eta(:,:,taum1) )
      call pe0_send_3D(nx,ny,nz,psi)
      call pe0_send_3D(nx,ny,nz,p_full(:,:,:,tau) )
      call pe0_send_3D(nx,ny,nz,p_full(:,:,:,taum1) )
      if (enable_expl_free_surf) then
        call pe0_send_2D(nx,ny,bu(:,:,tau) )
        call pe0_send_2D(nx,ny,bv(:,:,tau) )
        call pe0_send_2D(nx,ny,bu(:,:,taum1) )
        call pe0_send_2D(nx,ny,bv(:,:,taum1) )
      endif

      call exchg_prog3Dfield_complete(nx,ny,nz,b)
      call exchg_prog3Dfield_complete(nx,ny,nz,u)
      call exchg_prog3Dfield_complete(nx,ny,nz,v)
      call exchg_prog3Dfield_complete(nx,ny,nz,w)
      call exchg_prog3Dfield_complete(nx,ny,nz,p_full)
      call exchg_prog2Dfield_complete(nx,ny,eta)
      call exchg_3Dfield_complete(nx,ny,nz,psi)
      if (enable_expl_free_surf) then
         call exchg_prog2Dfield_complete(nx,ny,bu)
         call exchg_prog2Dfield_complete(nx,ny,bv)
      endif

      if (my_pe==0) print*,' done reading restart'
 end subroutine read_restart


  subroutine write_restart(itt_,filename)
! ----------------------------------
!      write a restart file
! ----------------------------------
      use pyOM_module   
      implicit none
      integer :: ierr
      integer, intent(in) :: itt_
      character*(*),intent(in) :: filename
      integer :: j,io

      ierr=0
      if (my_pe==0) print*,' writing restart file ',filename(1:len_trim(filename)),' at itt=',itt_

      call pe0_recv_3D(nx,ny,nz,u(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,v(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,w(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,u(:,:,:,taum1) )
      call pe0_recv_3D(nx,ny,nz,v(:,:,:,taum1) )
      call pe0_recv_3D(nx,ny,nz,w(:,:,:,taum1) )
      call pe0_recv_3D(nx,ny,nz,b(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,b(:,:,:,taum1) )
      call pe0_recv_2D(nx,ny,eta(:,:,tau) )
      call pe0_recv_2D(nx,ny,eta(:,:,taum1) )
      call pe0_recv_3D(nx,ny,nz,psi)
      call pe0_recv_3D(nx,ny,nz,p_full(:,:,:,tau) )
      call pe0_recv_3D(nx,ny,nz,p_full(:,:,:,taum1) )
      if (enable_expl_free_surf) then
        call pe0_recv_2D(nx,ny,bu(:,:,tau) )
        call pe0_recv_2D(nx,ny,bv(:,:,tau) )
        call pe0_recv_2D(nx,ny,bu(:,:,taum1) )
        call pe0_recv_2D(nx,ny,bv(:,:,taum1) )
      endif

      if (my_pe==0) then
       call get_free_iounit(io,ierr)
       if (ierr/=0) goto 10
       open(io,file=filename,form='unformatted',status='unknown')
       write(io,err=10) nx,ny,nz
       write(io,err=10) itt_ !,current_time
       do j=1,ny
        write(io,err=10) u(:,j,:,tau),v(:,j,:,tau),w(:,j,:,tau), u(:,j,:,taum1),v(:,j,:,taum1),w(:,j,:,taum1)
        write(io,err=10) b(:,j,:,tau),   b(:,j,:,taum1)
        write(io,err=10) eta(:,j,tau),   eta(:,j,taum1), psi(:,j,:)
        write(io,err=10) p_full(:,j,:,tau), p_full(:,j,:,taum1) ! this is new
        if (enable_expl_free_surf) then
         write(io,err=10) bu(:,j,tau),  bv(:,j,tau)
         write(io,err=10) bu(:,j,taum1),  bv(:,j,taum1)
        endif
       enddo
       close(io)
!       open(io,file='ritt',form='formatted',status='unknown',err=10)
!       write(io,*,err=10) itt
!       close(io)
       goto 20
       10 ierr=-1
       print*,' Warning: error during writing restart file'
       20 continue
      endif
 end subroutine write_restart




 subroutine get_free_iounit (nu,ierr)
!-----------------------------------------------------------------------
!     returns the first free IO unit number in nu
!-----------------------------------------------------------------------
      implicit none
      integer nu,n,ierr
      logical in_use
      character (len=80) :: name
      ierr=0
      do n=7,99
        inquire (n, OPENED=in_use, NAME=name)
        if (.not. in_use) then
          nu = n
          go to 10
         endif
      enddo
      print *,'Error: exhausted available fortran unit numbers'
      print *,'             Are you forgetting to close units?'
      ierr=-1
10    continue
 end subroutine get_free_iounit

 subroutine replace_space_zero(name)
      implicit none
      character (len=*) :: name
      integer  :: i
      do i=1,len_trim(name)
          if (name(i:i)==' ')name(i:i)='0'
      enddo
 end subroutine replace_space_zero

!=======================================================================
!     Templates for setup
!
!    internal wave beams
!=======================================================================

subroutine set_parameter
      use pyOM_module
      use fcontrol_module
      implicit none
      real :: fac=1.0
! ----------------------------------
!       set here main parameter
! ----------------------------------

      nx=64*fac;nz=60*fac;ny=3
      dx=0.25/fac
      dz=0.25/fac
      dt=0.025/fac

      eps2d_sor = 1e-7
      eps3d_sor = 1e-7
      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
      enable_quicker_advection   =.true.
      enable_hydrostatic         =.false.
      enable_biharmonic_friction =.true.
      enable_vert_biha_friction  =.true.
      enable_biharmonic_diffusion=.true.
      enable_vert_biha_diffusion =.true.
      Ahbi = (5e-3/fac**2)*dx**2
      Khbi = Ahbi
      Avbi = (5e-3/fac**2)*dx**2
      Kvbi = Avbi
      A_h = 00e-3/fac**2
      A_v = A_h
      K_h = 0
      K_v = 0

      enable_back_state  =.true.
      runlen=150. !/ fac**2
      snapint = dt*10
 end subroutine set_parameter


subroutine set_coriolis
end subroutine set_coriolis


subroutine initial_conditions
      use pyOM_module
      implicit none
      integer :: i,j,k
      real*8 :: N_0=2*3.1415/10.0
! ----------------------------------
!      add here initial conditions
! ----------------------------------
      do k=1,nz
       do j=1,ny
        do i=1,nx
         back(i,j,k,:) = -N_0**2*zt(k)*maskT(i,j,k)
        enddo
       enddo
      enddo
end subroutine initial_conditions


subroutine momentum_restoring_zones
   use pyOM_module
   use fcontrol_module
   implicit none
   integer :: i,j,k,js,je
   real*8 :: B0,om0 = 1./(1.5*10),time, pi=3.1415
! ----------------------------------
!      add here restoring zones for momentum
! ----------------------------------
      js=max(2,js_pe); je = min(je_pe,ny-1)
      time = itt*dt
      B0 =  1./(100*60.*dt)*sin( 2*pi*om0*time )
      do k=nz/2,nz/2+0
       do i=nx/2,nx/2+0
        do j=js,je
         fu(i,j,k)= fu(i,j,k)+maskU(i,j,k)*B0
        enddo
       enddo
      enddo
 end subroutine momentum_restoring_zones

subroutine restoring_zones
end subroutine restoring_zones

subroutine boundary_conditions
end subroutine boundary_conditions

subroutine topography
end subroutine topography

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!       integrate passive tracers
!=======================================================================



subroutine integrate_tracer(ierr)
!=======================================================================
!     solve prognostic equation for tracers
!=======================================================================
      use pyOM_module   
      implicit none
      integer, intent(out) :: ierr
      integer :: i,j,k,js,je,n
      real*8 :: adv_fe(nx,ny,nz), adv_ft(nx,ny,nz)
      real*8 :: adv_fn(nx,ny,nz), diff_fn(nx,ny,nz)
      real*8 :: diff_fe(nx,ny,nz),diff_ft(nx,ny,nz),fxa
      real*8 :: uback(nx,ny,nz),vback(nx,ny,nz),wback(nx,ny,nz)

      ierr=0
      js=max(2,js_pe); je = min(je_pe,ny-1)
      do n=1,nt
!---------------------------------------------------------------------------------
!        advection
!---------------------------------------------------------------------------------
       adv_fe(:,js_pe:je_pe,:)=0
       adv_fn(:,js_pe:je_pe,:)=0
       adv_ft(:,js_pe:je_pe,:)=0
       call adv_flux(nx,ny,nz,adv_fe,adv_fn,adv_ft,tr(:,:,:,:,n))
       call border_exchg3D(nx,ny,nz,adv_fn,1)
       call setcyclic3D(nx,ny,nz,adv_fe)
       call setcyclic3D(nx,ny,nz,adv_fn)
       if (delimit_tracer_fluxes) call delimit_adv_flux(nx,ny,nz,n,adv_fe,adv_fn,adv_ft)
!---------------------------------------------------------------------------------
!      horizontal diffusion
!---------------------------------------------------------------------------------
       diff_fe(:,js_pe:je_pe,:)=0
       diff_fn(:,js_pe:je_pe,:)=0
       diff_ft(:,js_pe:je_pe,:)=0
       do k=2,nz-1
        do j=js,je
         do i=1,nx-1
          fxa=K_h*maskU(i,j,k)
          diff_fe(i,j,k)=fxa*(tr(i+1,j,k,taum1,n)-tr(i,j,k,taum1,n))/dx
         enddo
        enddo
       enddo
       call setcyclic3D(nx,ny,nz,diff_fe)
       do k=2,nz-1
        do j=js,je 
         do i=2,nx-1
          fxa=K_h*maskV(i,j,k)
          diff_fn(i,j,k)=fxa*(tr(i,j+1,k,taum1,n)-tr(i,j,k,taum1,n))/dx
         enddo
        enddo
       enddo
       call border_exchg3D(nx,ny,nz,diff_fn,1)
       call setcyclic3D(nx,ny,nz,diff_fn)
!---------------------------------------------------------------------------------
!      vertical diffusion
!---------------------------------------------------------------------------------
       do k=1,nz-1
        do j=js,je
         do i=2,nx-1
          fxa=K_v*maskW(i,j,k)
          diff_ft(i,j,k)=fxa*(tr(i,j,k+1,taum1,n)-tr(i,j,k,taum1,n))/dz
         enddo
        enddo
       enddo
!---------------------------------------------------------------------------------
!       time tendency of b
!---------------------------------------------------------------------------------
       do k=2,nz-1
        do j=js,je
         do i=2,nx-1
          tr(i,j,k,taup1,n)=tr(i,j,k,taum1,n)+maskT(i,j,k)*c2dt*(    &
        -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx   &
        -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx   &
        -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz   &
        +(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz   &
        +(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx   &
        +(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx  )
         enddo
        enddo
       enddo
!---------------------------------------------------------------------------------
!       Biharmonic diffusion (horizontal and vertical)
!---------------------------------------------------------------------------------
       if (enable_biharmonic_diffusion) call biha_mix(nx,ny,nz,diff_fe,diff_fn,diff_ft,tr(:,:,:,:,n))
!---------------------------------------------------------------------------------
!      effect of zonal background velocity on tracer
!---------------------------------------------------------------------------------
       if (enable_back_state .and. enable_back_zonal_flow) then  
       do j=js_pe,je_pe
        uback(:,j,:)=u(:,j,:,tau);
        vback(:,j,:)=v(:,j,:,tau);
        wback(:,j,:)=w(:,j,:,tau);
        u(:,j,:,tau)=u0(:,j,:); v(:,j,:,tau)=0.; w(:,j,:,tau)=0.
       enddo
       adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0; adv_ft(:,js_pe:je_pe,:)=0
       call adv_flux(nx,ny,nz,adv_fe,adv_fn,adv_ft,tr(:,:,:,:,n) )
       u(:,js_pe:je_pe,:,tau)=uback(:,js_pe:je_pe,:)
       v(:,js_pe:je_pe,:,tau)=vback(:,js_pe:je_pe,:)
       w(:,js_pe:je_pe,:,tau)=wback(:,js_pe:je_pe,:)
       call border_exchg3D(nx,ny,nz,adv_fn,1)
       call setcyclic3D(nx,ny,nz,adv_fe); 
       call setcyclic3D(nx,ny,nz,adv_fn)
       do k=2,nz-1
        do j=js,je
         do i=2,nx-1
          tr(i,j,k,taup1,n)=tr(i,j,k,taup1,n)+maskT(i,j,k)*c2dt*(   &
         -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx  &
         -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx  &
         -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
         enddo
        enddo
       enddo
       endif
!---------------------------------------------------------------------------------
!      effect of meridional background velocity on tracer
!---------------------------------------------------------------------------------
       if (enable_back_state .and. enable_back_meridional_flow) then  
       do j=js_pe,je_pe
        uback(:,j,:)=u(:,j,:,tau);
        vback(:,j,:)=v(:,j,:,tau);
        wback(:,j,:)=w(:,j,:,tau);
        v(:,j,:,tau)=u0(:,j,:); u(:,j,:,tau)=0.;w(:,j,:,tau)=0.
       enddo
       adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0; adv_ft(:,js_pe:je_pe,:)=0
       call adv_flux(nx,ny,nz,adv_fe,adv_fn,adv_ft,tr(:,:,:,:,n) )
       u(:,js_pe:je_pe,:,tau)=uback(:,js_pe:je_pe,:)
       v(:,js_pe:je_pe,:,tau)=vback(:,js_pe:je_pe,:)
       w(:,js_pe:je_pe,:,tau)=wback(:,js_pe:je_pe,:)
       call border_exchg3D(nx,ny,nz,adv_fn,1)
       call setcyclic3D(nx,ny,nz,adv_fe); 
       call setcyclic3D(nx,ny,nz,adv_fn)
       do k=2,nz-1
        do j=js,je
         do i=2,nx-1
          tr(i,j,k,taup1,n)=tr(i,j,k,taup1,n)+maskT(i,j,k)*c2dt*(   &
         -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx  &
         -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx  &
         -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
         enddo
        enddo
       enddo
       endif
!---------------------------------------------------------------------------------
!     account for convection
!---------------------------------------------------------------------------------
       if (enable_hydrostatic)  call implicit_tracer_mix(nx,ny,nz,tr(:,:,:,:,n),K_b)
      enddo
end subroutine integrate_tracer




subroutine isopycnal_diffusion(ierr)
!=======================================================================
!   Isopycnal diffusion for tracer
!=======================================================================
    use pyOM_module   
    implicit none
    integer, intent(out) :: ierr
    integer :: i,j,k,js,je,n
    real*8 :: diff_fn(nx ,ny ,nz),K_iso(nx ,ny ,nz)
    real*8 :: diff_fe(nx ,ny ,nz),diff_ft(nx ,ny ,nz)
    real*8 :: Tz(nx ,ny ,nz),bz(nx ,ny ,nz),sl,fxa
    real*8 :: Tx(nx ,ny ,nz),bx(nx ,ny ,nz)
    real*8 :: Ty(nx ,ny ,nz),by(nx ,ny ,nz)
    real*8, parameter :: epsln = 1.0d-20 ! a small parameter

    ierr=0
    js=max(2,js_pe); je = min(je_pe,ny -1)
!-----------------------------------------------------------------------
!   derivatives of buoyancy
!-----------------------------------------------------------------------
    bz(:,js_pe:je_pe,:)=0; bx(:,js_pe:je_pe,:)=0; by(:,js_pe:je_pe,:)=0
    do k=1,nz-1
       do j=js,je
        do i=1,nx -1
         bx(i,j,k)= (b(i+1,j,k,taum1)-b(i,j,k,taum1))/dx*maskU(i,j,k) 
         by(i,j,k)= (b(i,j+1,k,taum1)-b(i,j,k,taum1))/dx*maskV(i,j,k) 
         bz(i,j,k)= (b(i,j,k+1,taum1)-b(i,j,k,taum1))/dz*maskW(i,j,k) 
        enddo
       enddo
    enddo
    if (enable_back_state) then  
      do k=1,nz-1
       do j=js,je
        do i=1,nx -1
         bx(i,j,k)= bx(i,j,k)+(back(i+1,j,k,taum1)-back(i,j,k,taum1))/dx*maskU(i,j,k) 
         by(i,j,k)= by(i,j,k)+(back(i,j+1,k,taum1)-back(i,j,k,taum1))/dx*maskV(i,j,k) 
         bz(i,j,k)= bz(i,j,k)+(back(i,j,k+1,taum1)-back(i,j,k,taum1))/dz*maskW(i,j,k) 
        enddo
       enddo
      enddo
    endif
    call border_exchg3D(nx,ny,nz,bx,1); call setcyclic3D(nx,ny,nz,bx)
    call border_exchg3D(nx,ny,nz,by,1); call setcyclic3D(nx,ny,nz,by)
    call border_exchg3D(nx,ny,nz,bz,1); call setcyclic3D(nx,ny,nz,bz)

    diff_fe(:,js_pe:je_pe,:)=0; diff_fn(:,js_pe:je_pe,:)=0; diff_ft(:,js_pe:je_pe,:)=0
    K_iso(:,js_pe:je_pe,:)=0; 
    do n=1,nt
!-----------------------------------------------------------------------
!     derivatives of tracer
!-----------------------------------------------------------------------
      Tz(:,js_pe:je_pe,:)=0; Tx(:,js_pe:je_pe,:)=0; Ty(:,js_pe:je_pe,:)=0
      do k=1,nz-1
       do j=js,je
        do i=1,nx -1
         Tx(i,j,k)= (tr(i+1,j,k,taum1,n)-tr(i,j,k,taum1,n))/dx*maskU(i,j,k) 
         Ty(i,j,k)= (tr(i,j+1,k,taum1,n)-tr(i,j,k,taum1,n))/dx*maskV(i,j,k) 
         Tz(i,j,k)= (tr(i,j,k+1,taum1,n)-tr(i,j,k,taum1,n))/dz*maskW(i,j,k) 
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,Tx,1); call setcyclic3D(nx,ny,nz,Tx)
      call border_exchg3D(nx,ny,nz,Ty,1); call setcyclic3D(nx,ny,nz,Ty)
      call border_exchg3D(nx,ny,nz,Tz,1); call setcyclic3D(nx,ny,nz,Tz)

!-----------------------------------------------------------------------
!     diff_fe =  K (T_x - b_x/b_z T_z)
!-----------------------------------------------------------------------
      do k=2,nz-1
       do j=js,je
        do i=1,nx -1
         fxa=(bz(i,j,k)+bz(i,j,k-1)+bz(i+1,j,k)+bz(i+1,j,k-1))   &
                    /(maskW(i,j,k  )+maskW(i+1,j,k) +maskW(i,j,k-1)+maskW(i+1,j,k-1)+epsln)
         sl=bx(i,j,k)*sign(dble(1.),fxa)/(abs(fxa)+epsln)
         sl=sl*0.5*(1.+tanh((-abs(sl)+iso_slopec)/iso_dslope))   
         fxa=(Tz(i,j,k)+Tz(i,j,k-1)+Tz(i+1,j,k)+Tz(i+1,j,k-1))  &
               /(maskW(i,j,k  )+maskW(i+1,j,k) +maskW(i,j,k-1)+maskW(i+1,j,k-1)+epsln)
         diff_fe(i,j,k)=(Tx(i,j,k)-sl*fxa)    *maskU(i,j,k) *K_gm ! *ahthk(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(nx,ny,nz,diff_fe)
!-----------------------------------------------------------------------
!     diff_fn =  K (T_y - b_y/b_z T_z)
!-----------------------------------------------------------------------
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fxa=(bz(i,j,k)+bz(i,j,k-1)+bz(i,j+1,k)+bz(i,j+1,k-1))   &
          /(maskW(i,j,k  )+maskW(i,j+1,k) +maskW(i,j,k-1)+maskW(i,j+1,k-1)+epsln)
         sl=by(i,j,k)*sign(dble(1.),fxa)/(abs(fxa)+epsln)
         sl=sl*0.5*(1.+tanh((-abs(sl)+iso_slopec)/iso_dslope))   
         fxa=(Tz(i,j,k)+Tz(i,j,k-1)+Tz(i,j+1,k)+Tz(i,j+1,k-1))   &
          /(maskW(i,j,k  )+maskW(i,j+1,k)  +maskW(i,j,k-1)+maskW(i,j+1,k-1)+epsln)
         diff_fn(i,j,k)=(Ty(i,j,k)-sl*fxa)   *maskV(i,j,k)*K_gm ! *ahthk(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,diff_fn,1); call setcyclic3D(nx,ny,nz,diff_fn)
!-----------------------------------------------------------------------
!     diff_fb =  - K(b_x/b_z T_x +b_y/b_z T_y) 
!                  + T_z K((bx/bz)**2+(by/bz))**2
!      second term is done implicitly
!-----------------------------------------------------------------------
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         fxa=(bx(i,j,k)+bx(i-1,j,k)+bx(i,j,k+1)+bx(i-1,j,k+1))  &
          /(maskU(i,j,k  )+maskU(i-1,j,k  ) +maskU(i,j,k+1)+maskU(i-1,j,k+1)+epsln)
         sl=fxa*sign(dble(1.),bz(i,j,k))/(abs(bz(i,j,k))+epsln)
         sl=sl*0.5*(1.+tanh((-abs(sl)+iso_slopec)/iso_dslope))   
         fxa=(Tx(i,j,k)+Tx(i-1,j,k)+Tx(i,j,k+1)+Tx(i-1,j,k+1))  &
          /(maskU(i,j,k  )+maskU(i-1,j,k  )  +maskU(i,j,k+1)+maskU(i-1,j,k+1)+epsln)
         diff_ft(i,j,k)=(-sl*fxa)*maskW(i,j,k) *K_gm !*ahthk(i,j,k)
         K_iso(i,j,k)=sl**2*maskW(i,j,k) * K_gm !*ahthk(i,j,k)

         fxa=(by(i,j,k)+by(i,j-1,k  )+by(i,j,k+1)+by(i,j-1,k+1))   &
          /(maskV(i,j,k  )+maskV(i,j-1,k  ) +maskV(i,j,k+1)+maskV(i,j-1,k+1)+epsln)
         sl=fxa*sign(dble(1.),bz(i,j,k))/(abs(bz(i,j,k))+epsln)
         sl=sl*0.5*(1.+tanh((-abs(sl)+iso_slopec)/iso_dslope))   
         fxa=(Ty(i,j,k)+Ty(i,j-1,k)+Ty(i,j,k+1)+Ty(i,j-1,k+1))    &
          /(maskV(i,j,k  )+maskV(i,j-1,k  ) +maskV(i,j,k+1)+maskV(i,j-1,k+1)+epsln)
         diff_ft(i,j,k)=diff_ft(i,j,k)  +(-sl*fxa)*maskW(i,j,k) *K_gm !*ahthk(i,j,k)
         K_iso(i,j,k)=K_iso(i,j,k)+   sl**2*maskW(i,j,k) *K_gm !*ahthk(i,j,k)
        enddo
       enddo
      enddo

 if (delimit_tracer_fluxes) then
       diff_fe(:,js_pe:je_pe,:)=-diff_fe(:,js_pe:je_pe,:)
       diff_fn(:,js_pe:je_pe,:)=-diff_fn(:,js_pe:je_pe,:)
       diff_ft(:,js_pe:je_pe,:)=-diff_ft(:,js_pe:je_pe,:)
       call border_exchg3D(nx,ny,nz,diff_fn,1);
       call delimit_adv_flux_taup1(nx,ny,nz,n,diff_fe,diff_fn,diff_ft)
       diff_fe(:,js_pe:je_pe,:)=-diff_fe(:,js_pe:je_pe,:)
       diff_fn(:,js_pe:je_pe,:)=-diff_fn(:,js_pe:je_pe,:)
       diff_ft(:,js_pe:je_pe,:)=-diff_ft(:,js_pe:je_pe,:)
       call border_exchg3D(nx,ny,nz,diff_fn,1);
 endif
!---------------------------------------------------------------------------------
!     add explicit part 
!---------------------------------------------------------------------------------
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
          tr(i,j,k,taup1,n)=tr(i,j,k,taup1,n)+maskT(i,j,k)*c2dt*(   &
                +(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz  &
                +(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx  &
                +(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx      )  
        enddo
       enddo
      enddo
!---------------------------------------------------------------------------------
!     add implicit part 
!---------------------------------------------------------------------------------
      call implicit_tracer_mix(nx,ny,nz,tr(:,:,:,:,n) ,K_iso)
      call border_exchg3D(nx,ny,nz,tr(:,:,:,taup1,n),2)
      call setcyclic3D(nx,ny,nz,tr(:,:,:,taup1,n) )
    enddo ! n
end subroutine isopycnal_diffusion






subroutine delimit_adv_flux(nx_,ny_,nz_,n,adv_fe,adv_fn,adv_ft)
!-----------------------------------------------------------------------
!   delimit advective fluxes for passive tracers
!   using the multidimensional positive definite
!   advection scheme (MPDCD) by Lafore, et al 1998
!-----------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer, intent(in) :: n,nx_,ny_,nz_
      integer :: js,je,i,j,k
      real*8 :: adv_fe(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: betaf(nx,ny,nz), denom
      real*8, parameter :: small = 1.d-15

      js=max(2,js_pe); je=min(je_pe,ny -1)
!    compute delimiter for outgoing flux
      betaf(:,js_pe:je_pe,:)=2.
      do j=js,je
        do k=2,nz-1
          do i=2,nx -1
           denom =       max(0d0,adv_fe(i  ,j,k)/dx)
           denom = denom-min(0d0,adv_fe(i-1,j,k)/dx) 
           denom = denom+max(0d0,adv_fn(i,j,k  )/dx)
           denom = denom-min(0d0,adv_fn(i,j-1,k)/dx)
           denom = denom+max(0d0,adv_ft(i,j,k)/dz)
           denom = denom-min(0d0,adv_ft(i,j,k-1)/dz)
           denom=denom*c2dt
           denom = sign(dble(1.) ,denom)*max(small,abs(denom)) ! should be positive anyway
           betaf(i,j,k)=tr(i,j,k,taum1,n)/denom
          enddo
        enddo
      enddo
      call border_exchg3D(nx,ny,nz,betaf,1); call setcyclic3D(nx,ny,nz,betaf)
!   delimit zonal flux
      do j=js,je
        do k=2,nz-1
          do i=1,nx -1
           adv_fe(i,j,k)=min(1d0,betaf(i ,j ,k))*max(0d0,adv_fe(i,j,k)) &
                        +min(1d0,betaf(i+1,j,k))*min(0d0,adv_fe(i,j,k))
          enddo
        enddo
      enddo
!   delimit meridional flux
      do j=js-1,je
        do k=2,nz-1
          do i=2,nx -1
           adv_fn(i,j,k)=min(1d0,betaf(i,j,k  ))*max(0d0,adv_fn(i,j,k)) & 
                        +min(1d0,betaf(i,j+1,k))*min(0d0,adv_fn(i,j,k))
          enddo
        enddo
      enddo
!   delimit vertical flux
      do j=js,je
        do k=1,nz-1
          do i=2,nx -1
           adv_ft(i,j,k)=min(1d0,betaf(i,j,k))*max(0d0,adv_ft(i,j,k)) &
                        +min(1d0,betaf(i,j,k+1))*min(0d0,adv_ft(i,j,k))
          enddo
        enddo
      enddo
end subroutine delimit_adv_flux



 subroutine delimit_adv_flux_taup1(nx_,ny_,nz_,n,adv_fe,adv_fn,adv_ft)
!-----------------------------------------------------------------------
!   same as above but cares for tracer at taup1
!-----------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer, intent(in) :: n,nx_,ny_,nz_
      integer :: js,je,i,j,k
      real*8 :: adv_fe(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: betaf(nx,ny,nz), denom
      real*8, parameter :: small = 1.d-15

      js=max(2,js_pe); je=min(je_pe,ny-1)
!    compute delimiter for outgoing flux
      betaf(:,js_pe:je_pe,:)=2.
      do j=js,je
        do k=2,nz-1
          do i=2,nx-1
           denom =       max(0d0,adv_fe(i  ,j,k)/dx)
           denom = denom-min(0d0,adv_fe(i-1,j,k)/dx) 
           denom = denom+max(0d0,adv_fn(i,j,k  )/dx)
           denom = denom-min(0d0,adv_fn(i,j-1,k)/dx)
           denom = denom+max(0d0,adv_ft(i,j,k)/dz)
           denom = denom-min(0d0,adv_ft(i,j,k-1)/dz)
           denom=denom*c2dt
           denom = sign(dble(1.),denom)*max(small,abs(denom)) ! should be positive anyway
           betaf(i,j,k)=tr(i,j,k,taup1,n)/denom
          enddo
        enddo
      enddo
      call border_exchg3D(nx,ny,nz,betaf,1); call setcyclic3D(nx,ny,nz,betaf)
!   delimit zonal flux
      do j=js,je
        do k=2,nz-1
          do i=1,nx-1
           adv_fe(i,j,k)= min(1d0,betaf(i ,j ,k))*max(0d0,adv_fe(i,j,k)) &
                         +min(1d0,betaf(i+1,j,k))*min(0d0,adv_fe(i,j,k))
          enddo
        enddo
      enddo
!   delimit meridional flux
      do j=js-1,je
        do k=2,nz-1
          do i=2,nx-1
           adv_fn(i,j,k)=min(1d0,betaf(i,j,k  ))*max(0d0,adv_fn(i,j,k)) &
                        +min(1d0,betaf(i,j+1,k))*min(0d0,adv_fn(i,j,k))
          enddo
        enddo
      enddo
!   delimit vertical flux
      do j=js,je
        do k=1,nz-1
          do i=2,nx-1
           adv_ft(i,j,k)=min(1d0,betaf(i,j,k))*max(0d0,adv_ft(i,j,k)) &
                        +min(1d0,betaf(i,j,k+1))*min(0d0,adv_ft(i,j,k))
          enddo
        enddo
      enddo
 end subroutine delimit_adv_flux_taup1





subroutine tracer_read_restart(filename)
!=======================================================================
!     read tracer from restart file
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: ierr
      integer :: j,io,n,nx_,ny_,nz_,nt_
      character*(*),intent(in) :: filename
      ierr=0
      if (my_pe==0) print*,' reading tracer from restart file ',filename(1:len_trim(filename))
      call get_free_iounit(io,ierr)
      if (ierr/=0) goto 10
      open(io,file=filename,form='unformatted',status='old',err=10)
      read(io,err=10) nx_,ny_,nz_,nt_
      if (nx/=nx_ .or. ny/=ny_ .or. nz/= nz_) then 
        print*,' read from restart dimensions: ',nx_,ny_,nz_
        print*,' does not match dimensions   : ',nx,ny,nz
        goto 10
      endif
      if (nt/=nt_ ) then 
        print*,' read number of tracer: ',nt_
        print*,' does not match nt= ',nt
        goto 10
      endif
      do n=1,nt
       do j=1,ny
        read(io,err=10) tr(:,j,:,tau,n),  tr(:,j,:,taum1,n)
       enddo
      enddo
      close(io)
      return
  10  ierr=-1
      close(io)
      if (my_pe==0) print*,' error reading tracer restart file'
end subroutine tracer_read_restart


subroutine tracer_write_restart(filename)
!=======================================================================
!     write restart to file
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: ierr
      character*(*),intent(in) :: filename
      integer :: j,io,n
      ierr=0
      if (my_pe==0) print*,' writing tracer restart to file ',filename(1:len_trim(filename))
      do n=1,nt
       call pe0_recv_3D(nx,ny,nz,tr(:,:,:,tau  ,n) )
       call pe0_recv_3D(nx,ny,nz,tr(:,:,:,taum1,n) )
      enddo
      if (my_pe==0) then 
       call get_free_iounit(io,ierr)
       if (ierr/=0) goto 10
       open(io,file=filename,form='unformatted',status='unknown',err=10)
       write(io,err=10) nx,ny,nz,nt
       do n=1,nt
         do j=1,ny
          write(io,err=10) tr(:,j,:,tau,n), tr(:,j,:,taum1,n)
         enddo
       enddo
       close(io)
      endif
      return
  10  ierr=-1
      if (my_pe==0) print*,' error writing tracer restart file'
end subroutine tracer_write_restart

!=======================================================================
! timing module
! stores elapsed time between calls of tic/toc subroutines
! there is the need to specify a time measurement routine below
!=======================================================================

 module timing_module
 implicit none
 integer, parameter, private :: max_counter = 1000
 integer,private             :: act_counter = 0
 character (len=80),private  :: ref_counter(max_counter)
 real,private              :: counter(0:max_counter),now(0:max_counter)

 private elapsed
 public tic,toc
 contains

 function elapsed()
 real :: elapsed
!
!  elapsed should give the elasped cpu (user) time
!  a function which gives elapsed cpu time is needed here
!
! this works for linux and many other unix machines
       real (kind=4) :: etime,tarray(2),fxa
       fxa=etime(tarray)
       elapsed = tarray(1)
! NEC
!       real*8 tarray(2),etime,sec
!       sec=etime(tarray)
!       elapsed=tarray(1)
! AIX
!       REAL (kind=4) :: etime_
!       TYPE TB_TYPE
!         SEQUENCE
!         REAL (kind=4) :: USRTIME
!         REAL (kind=4) :: SYSTIME
!       END TYPE
!       TYPE (TB_TYPE) ETIME_STRUCT
!       elapsed = etime_(ETIME_STRUCT)
!       elapsed = etime_struct%usrtime
 end function elapsed


 subroutine tic(ref)
 character (len=*), intent(in)  :: ref
 integer :: n,len
 now(0)=elapsed()
 len=len_trim(ref)
 do n=1,act_counter
    if (ref(1:len) == ref_counter(n)(1:len) ) then
         now(n) = now(0)
         counter(0) = counter(0)+elapsed()-now(0)
         return
    endif
 enddo
 if (act_counter == max_counter ) then
        print*,' ERROR:'
        print*,' number of counters exceeds max_counter = ',max_counter
        print*,' in tic'
        print*,' ref = ',ref
 endif
 act_counter = act_counter + 1
 ref_counter(act_counter) = ref
 now(act_counter) = elapsed()
 counter(0) = counter(0)+elapsed()-now(0)
 end subroutine tic

 subroutine toc(ref)
 character (len=*), intent(in) :: ref
 integer :: n,len

 now(0)=elapsed()
 len=len_trim(ref)
 do n=1,act_counter
        if (ref(1:len) == ref_counter(n)(1:len) ) then
         counter(n) = counter(n)+now(0)-now(n)
         counter(0) = counter(0)+elapsed()-now(0)
         return
        endif
 enddo
 print*,' ERROR:'
 print*,' cannot find ',ref(1:len),' in my list'
 print*,' in toc'
 end subroutine toc

 function timing_secs(ref)
 character (len=*), intent(in) :: ref
 real :: timing_secs
 integer :: n,len
 if (ref=='tictoc') then
       timing_secs = counter(0)
       return
  endif
  len=len_trim(ref)
  do n=1,act_counter
        if (ref(1:len) == ref_counter(n)(1:len) ) then
         timing_secs = counter(n)
         return
        endif
  enddo
  print*,' ERROR:'
  print*,' cannot find ',ref(1:len),' in my list'
  print*,' in timing_secs'
  end function timing_secs

  end module timing_module
 

!=======================================================================
!  closed eddying domain with restoring zones at side walls
!  Experiment BASIN in Eden (2010), Ocean modeling 32 (2010) 58–71
!=======================================================================

module config_module
 ! use this module only locally in this file
 implicit none
 real*8,parameter :: hRESOLVE = 0.5   ! 2 in original model
 real*8,parameter :: vRESOLVE = 1.0   ! 2 in original model
 real*8,parameter :: rho_0 =1024.0, g=9.81
 real*8,parameter :: M_0     = sqrt(0.5*1e-5*0.1/rho_0*g)
 real*8,parameter :: N_0     = 0.004
 real*8,parameter :: pi      = 3.14159265358979323846264338327950588
 real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
 real*8,parameter :: radius  = 6370.0e3,degtom = radius/180.0*pi
end module config_module

subroutine set_parameter
 ! ----------------------------------
 !       set here main parameter
 ! ----------------------------------
 use pyOM_module
 use fcontrol_module
 use config_module
 implicit none
 nx = 128*hRESOLVE 
 nz = 20 *vRESOLVE;
 ny = 128*hRESOLVE
 dx = 1./3.*degtom*cos(30./180.*pi)/hRESOLVE
 dz = 100.0 /vRESOLVE
 dt = 1200.0/hRESOLVE
 K_h=000.0 /hRESOLVE
 K_v=1.0e-4/vRESOLVE
 A_h=0000.0/hRESOLVE
 A_v=10.e-4/vRESOLVE
!      enable_biharmonic_friction    = .true. ! enabled in original model
 Ahbi  = 1.25e11!/RESOLVE**4
 Khbi  = Ahbi
 enable_bottom_stress     = .true.
 enable_bottom_noslip     = .true.
 cdbot = 2e-4/dz
 enable_free_surface      = .true.
 eps2D_sor = 1e-9
 enable_noslip            = .true.
 enable_hydrostatic       = .true.
 enable_quicker_advection = .true.
 enable_4th_mom_advection = .true.
 enable_pv_mixing         = .true.  ! this was off in original model
 runlen   = 36.5*5 *86400.0 ! 365.0/RESOLVE**3
 snapint  = 5.0 *86400.0 
end subroutine set_parameter

subroutine set_coriolis
 use pyOM_module   
 use config_module
 implicit none
 integer :: j
 real*8 :: phi0 
 phi0 = 30.0 /180. *pi
 do j=1,ny
      coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
 enddo
end subroutine set_coriolis

subroutine initial_conditions
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module
 use config_module
 implicit none
 integer :: i,j,k
 real*8 :: B0,x,y
 do k=1,nz
   do j=1,ny
      do i=1,nx
         x=float(i)/float(nx)
         y = (yt(j)-yt(2))/ (yt(ny-1)-yt(2))
         B0=(M_0)**2*yt(j) !    +0.5e-3*sin(x*8.5*pi)*exp(-(y-0.5)**2/0.5**2)
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
      enddo
    enddo
 enddo
end subroutine initial_conditions

subroutine restoring_zones
 use pyOM_module
 use config_module
 implicit none
 integer :: i,j,k,js,je, spg_width 
 real :: T_rest=1./(5.*86400),B0,qq,MM
 ! ----------------------------------
 !      add here restoring zones
 ! ----------------------------------
 js=max(2,js_pe); je = min(je_pe,ny-1)
 spg_width = 3*hRESOLVE
 if (my_blk_j==1) then
   do k=1,nz
      do j=2,spg_width+1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt*t_rest/(j-1.)*(B0-b(:,j,k,taum1))
      enddo
   enddo
 endif
 if (my_blk_j==n_pes_j) then
   do k=1,nz
      do j=ny-1,ny-spg_width,-1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt*t_rest/(-1.*(j-ny))*(B0-b(:,j,k,taum1))
      enddo
   enddo
 endif
end subroutine restoring_zones

subroutine topography
 use pyOM_module
 use config_module
 implicit none
 real*8 :: h,h0,L_x,h_t,L_y
 integer :: i,j,k

 h0=(nz-2)*dz
 h_t=h0/10.
 L_y= 1000e3
 L_x= 1000e3
 do k=1,nz
    do j=1,ny
      do i=1,nx
         h=h0-h_t*cos(yt(j)/L_y*2*pi)
         if (zt(k).lt.-h) maskT(i,j,k)=0.0
      enddo
    enddo
 enddo
 maskT(1,:,:)=0.0
 maskT(nx,:,:)=0.0
 maskT(:,1,:)=0.0
 maskT(:,ny,:)=0.0
end subroutine topography

subroutine boundary_conditions
end subroutine boundary_conditions

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!  idealised Southern Ocean, same as in Viebahn and Eden (2010) Ocean modeling
!======================================================================= 


module config_module
 ! use this module only locally in this file
 implicit none
 real*8,parameter :: hRESOLVE = 0.5   ! 1 in original model
 real*8,parameter :: vRESOLVE = 1.0   ! 1 in original model
 real*8,parameter :: N_0     = 0.004
 real*8,parameter :: pi      = 3.14159265358979323846264338327950588
 real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
 real*8,parameter :: radius  = 6370.0e3
end module config_module


subroutine set_parameter
 ! ----------------------------------
 !       set here main parameter
 ! ----------------------------------
 use pyOM_module   
 use fcontrol_module
 use config_module
 implicit none
      nx   = 128*hRESOLVE 
      nz   = 20 *vRESOLVE;
      ny   = 128*hRESOLVE
      dx    = 20e3/hRESOLVE
      dz    = 50.0 /vRESOLVE
      dt    = 1200.0/hRESOLVE

      K_h=0000.0 /hRESOLVE
      A_h=0000.0 /hRESOLVE
!      A_h=10000.0!/hRESOLVE  ! for coarse model version
      Ahbi  = 5e11/hRESOLVE**2
      Khbi  = Ahbi

      K_v=1.0e-4/vRESOLVE
      A_v=10.e-4/vRESOLVE
      cdbot = 1e-5*vRESOLVE

      eps2D_sor = 1e-9

      enable_noslip               = .true.
      enable_cyclic_x             = .true.
      enable_bottom_stress        = .true.
      !enable_biharmonic_friction  = .true.  ! was on in original model
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .true.  
      enable_pv_mixing            = .true.   ! was off in original model

      !enable_vert_friction_trm = .true. ! for coarse model version
      !enable_bolus_velocity    = .true. ! for coarse model version
      !enable_pv_mixing         = .true. ! for coarse model version
      !K_gm=2000.0 ! for coarse model version
      !enable_diag_zonalave = .true.
      !enable_diag_timeave  = .true.
      runlen = 365*86400.*20   ! was  one year in original model
      snapint =  3.*86400.     ! was 3 days in original model
end subroutine set_parameter


subroutine set_coriolis
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: j
 real*8:: phi0 
 phi0 = -25.0 /180. *pi
 do j=1,ny
      coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
 enddo
end subroutine set_coriolis


subroutine initial_conditions
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: i,j,k
 real*8 :: bstar,B0,x,y
 do j=1,ny
   call b_surface(bstar,j)
   do k=1,nz
     do i=1,nx
         x=float(i)/float(nx)
         y = (yt(j)-yt(2))/ (yt(ny-1)-yt(2))
         B0=0.0e-3*sin(x*8.5*pi)*exp(-(y-0.5)**2/0.5**2)
         b(i,j,k,:)  = (-30e-3+B0-N_0**2*zt(k))*maskT(i,j,k)
     enddo
   enddo
 enddo
end subroutine initial_conditions


subroutine b_surface(bstar,j)
 use pyOM_module   
 use config_module   
 implicit none
 integer :: j
 real*8 :: db,bstar,y2,L_y
 L_y = yt(ny )-yt(1)
 db = -30e-3
 bstar=db
 if (yt(j)<L_y/2.0) then
       bstar=db*yt(j)/(L_y/2.0)
 endif
 y2=L_y*0.75
 if (yt(j)>y2) then
       bstar=db*(1-(yt(j)-y2)/(yt(ny )-y2) )
 endif
end subroutine b_surface


subroutine boundary_conditions
 ! ----------------------------------
 !    add here boundary conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: i,j
 real*8 :: L_y,y,t_rest,bstar
 L_y = yt(ny )-yt(1)
 t_rest=30*86400
 do j=1,ny 
   call b_surface(bstar,j)
   do i=1,nx 
     if (yt(j)<L_y/2.0) then
         y = yu(j)/L_y
         surface_taux(i,j) = .1e-3*sin(2*pi*y)*maskU(i,j,nz-1)
     endif
     surface_flux(i,j)=dz/t_rest*(bstar-b(i,j,nz-1,tau)) 
   enddo
 enddo
end subroutine boundary_conditions

subroutine topography
 ! ----------------------------------
 !      Add here topography  
 ! ----------------------------------
 use pyOM_module   
 implicit none
 integer :: i,j
 real*8 :: L_x,L_y
 L_x = xt(nx )-xt(1)
 L_y = yt(ny )-yt(1)
 do i=1,nx 
   do j=1,ny 
        if ((yt(j)>L_y/2.0).and. (xt(i)>L_x*.75.or.xt(i)<L_x*.25))  maskT(i,j,:)=0.0
   enddo
 enddo
end subroutine topography

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!  idealised Southern Ocean, same as in Viebahn and Eden (2010) Ocean modeling
!======================================================================= 


module config_module
 ! use this module only locally in this file
 implicit none
 real*8,parameter :: pi      = 3.14159265358979323846264338327950588
 real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
 real*8,parameter :: radius  = 6370.0e3

 real*8 :: lat0, N_0=0.002, tau0=1.0, K0gm = 2000.0
end module config_module


subroutine set_parameter
 ! ----------------------------------
 !       set here main parameter
 ! ----------------------------------
 use pyOM_module   
 use fcontrol_module
 use config_module
 implicit none
 include "netcdf.inc"
 integer :: iret,ncid,xdim,ydim,vid,n
 real *8, allocatable :: lat(:)
 namelist /real_acc/ N_0,tau0,K0gm

      open(10,file='namelist',form='formatted',status='old')
      read(10, nml = real_acc )
      close(10)
      if (my_pe==0) write(6, nml=real_acc)

      iret=nf_open('real_global_topo.cdf',NF_NOWRITE,ncid)
      iret=nf_inq_dimid(ncid,'Longitude_t',xdim)
      iret=nf_inq_dimid(ncid,'Latitude_t',ydim)
      iret=nf_inq_dimlen(ncid,xdim,nx)
      iret=nf_inq_dimlen(ncid,ydim,ny)
      iret=nf_inq_varid(ncid,'Latitude_t',vid)
      allocate(lat(ny))
      iret= nf_get_vara_double(ncid,vid,1,ny,lat)
      n = minloc( (lat+30)**2 ,1)
      dx = (lat(2)-lat(1))*radius/180.*pi
      lat0 = lat(n/2)/180.*pi

      deallocate(lat) 
      ny=n+1
      call ncclos (ncid, iret)

      dz    = 100.0 
      nz    = int(6000.0/dz)+2
      dt    = 3600.0

      A_h=4.0e4
      K_v=1.0e-4
      A_v=1.0e-4
      eps2D_sor = 1e-9

      enable_noslip               = .true.
      enable_bottom_noslip        = .true.
      enable_cyclic_x             = .true.
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .true.  
      enable_bolus_velocity  = .true. 
      K_gm=K0gm

      runlen = 365*86400.*50   
      snapint =  365./12.*86400.     

      enable_back_state = .true.
      enable_diag_barbi = .true.
end subroutine set_parameter


subroutine set_coriolis
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: j
 real*8 :: y0

 if (my_pe==0) print*,' reference latitude is ',lat0/pi*180.,' deg'
 do j=1,ny
  !y0 = lat0*radius
  y0 = yt(ny/2)
  coriolis_t(j) = 2*omega*sin(lat0) + 2*omega*cos(lat0)/radius*(yt(j)-y0)
 enddo
end subroutine set_coriolis


subroutine initial_conditions
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: i,j,k
 back=0.
 do k=1,nz
    back(:,:,k,1)=(back(:,:,k,1)-N_0**2*zt(k))*maskT(:,:,k)
 enddo
 back(:,:,:,2)=back(:,:,:,1)
 back(:,:,:,3)=back(:,:,:,1)
end subroutine initial_conditions



subroutine boundary_conditions
 ! ----------------------------------
 !    add here boundary conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 include "netcdf.inc"
 integer :: i,j,k,iret,ncid,vid
 real *8 :: taux(nx,ny),tauy(nx,ny)

 iret=nf_open('real_global_wind.cdf',NF_NOWRITE,ncid)
 iret=nf_inq_varid(ncid,'taux',vid)
 iret= nf_get_vara_double(ncid,vid,(/1,1,1/),(/nx,ny,1/),taux)
 iret=nf_inq_varid(ncid,'tauy',vid)
 iret= nf_get_vara_double(ncid,vid,(/1,1,1/),(/nx,ny,1/),tauy)
 call ncclos (ncid, iret)
 ! dyn/cm^2  = 10^-5 N/cm^2 = 10^-1 N/m^2 = 1 kg m/s^2 /m^2 
 ! N/m^2 /rho = 1 kg m/s^2 /m^2  m^3/kg = 1m^2/s^2 
 where( taux <= -1e10 ) taux = 0.0
 where( tauy <= -1e10 ) tauy = 0.0
 do j=1,ny 
   do i=1,nx 
    surface_taux(i,j) = tau0*(taux(i,j)+taux(i,j-1))/2. /1e4  ! m^2/s^2 
    surface_tauy(i,j) = tau0*(tauy(i,j)+tauy(i-1,j))/2. /1e4  ! m^2/s^2 
   enddo
 enddo
end subroutine boundary_conditions

subroutine topography
 ! ----------------------------------
 !      Add here topography  
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 include "netcdf.inc"
 integer :: i,j,k,iret,ncid,vid
 real *8 :: topo(nx,ny)

 iret=nf_open('real_global_topo.cdf',NF_NOWRITE,ncid)
 iret=nf_inq_varid(ncid,'rose',vid)
 iret= nf_get_vara_double(ncid,vid,(/1,1/),(/nx,ny/),topo)
 call ncclos (ncid, iret)
 do j=1,ny 
   do i=1,nx 
     k= minloc( (zt+topo(i,j))**2,1)
     k=min(nz,max(1,k))
     maskT(i,j,1:k) = 0.0
   enddo
 enddo
end subroutine topography

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!      Advection schemes for momentum
!=======================================================================


 subroutine adv_flux_u_2nd(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of zonal momentum
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      integer :: i,j,k,js,je
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: adv_fn(nx_,ny_,nz_) 

      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         adv_fe(i,j,k)=0.5*( u(i  ,j,k,tau) + u(i+1,j,k,tau) )*  &
         (u(i,j,k,tau)+u(i+1,j,k,tau)) *0.5*maskU(i+1,j,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         adv_fn(i,j,k)= 0.5*( u(i,j,k,tau) + u(i,j+1,k,tau) )*   &
         (v(i,j,k,tau)+v(i+1,j,k,tau)) *0.5*maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         adv_ft(i,j,k)= 0.5*(u(i,j,k,tau)+u(i,j,k+1,tau))*   &
         (w(i,j,k,tau)+w(i+1,j,k,tau))*0.5*maskU(i,j,k+1)*maskU(i,j,k)
        enddo
       enddo
      enddo
 end subroutine adv_flux_u_2nd


 subroutine adv_flux_v_2nd(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of meridional momentum
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      integer :: i,j,k,js,je
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_)
      real*8 :: adv_fn(nx_,ny_,nz_) 
      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         adv_fe(i,j,k)= 0.5*( v(i  ,j,k,tau) + v(i+1,j,k,tau) )*  &
          (u(i,j,k,tau)+u(i,j+1,k,tau)) *0.5*maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         adv_fn(i,j,k)= 0.5*( v(i,j,k,tau) + v(i,j+1,k,tau) )*  &
         (v(i,j,k,tau)+v(i,j+1,k,tau)) *0.5*maskV(i,j+1,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         adv_ft(i,j,k)= 0.5*( v(i,j,k,tau) + v(i,j,k+1,tau) )*  &
         (w(i,j,k,tau)+w(i,j+1,k,tau)) *0.5*maskV(i,j,k+1)*maskV(i,j,k)
        enddo
       enddo
      enddo
 end subroutine adv_flux_v_2nd




 subroutine adv_flux_w_2nd(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of vertical momentum
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_) 
      integer :: i,j,k,js,je
      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         adv_fe(i,j,k)= 0.5*( w(i  ,j,k,tau) + w(i+1,j,k,tau) )*  &
               (u(i,j,k,tau)+u(i,j,k+1,tau)) *0.5*maskW(i+1,j,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         adv_fn(i,j,k)= 0.5*( w(i,j,k,tau) + w(i,j+1,k,tau) )*  &
           (v(i,j,k,tau)+v(i,j,k+1,tau)) *0.5*maskW(i,j+1,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         adv_ft(i,j,k)= 0.5*( w(i,j,k,tau) + w(i,j,k+1,tau) )*  &
           (w(i,j,k,tau)+w(i,j,k+1,tau)) *0.5*maskW(i,j,k+1)*maskW(i,j,k)
        enddo
       enddo
      enddo
 end subroutine adv_flux_w_2nd







subroutine adv_flux_u_4th(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of zonal momentum 4th order
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_) 
      integer :: i,j,k,js,je,ip2,im1,jp2,jm1,kp2,km1
      real*8,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real*8,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0
      real*8 :: mask,totvel

      js=max(2,js_pe); je=min(je_pe,ny-1)

      do j=js,je
       do k=2,nz-1
        do i=1,nx-1
         ip2=i+2
         if (ip2>nx.and..not.enable_cyclic_x) ip2=nx
         if (ip2>nx.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=nx-2
         mask = maskU(im1,j,k)*maskU(ip2,j,k)
         totvel = (u(i+1,j,k,tau)*maskU(i+1,j,k) +u(i,j,k,tau)*maskU(i,j,k))/2.0
         adv_fe(i,j,k) = 0.5*totvel*( &
             (a2nd*(1.0-mask) + a4th*mask)*(u(i,  j,k,tau) +  u(i+1,j,k,tau))+ &
             (b2nd*(1.0-mask) + b4th*mask)*(u(im1,j,k,tau) +  u(ip2,j,k,tau)))
        enddo
       enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)

      do j=js,je
       do k=2,nz-1
        do i=2,nx-1
         jp2=j+2
         if (jp2>ny.and..not.enable_cyclic_y) jp2=ny
         if (jp2>ny.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=ny-2
         mask = maskU(i,jm1,k)*maskU(i,jp2,k)
         totvel = (v(i+1,j,k,tau)*maskV(i+1,j,k)      +v(i,j,k,tau)*maskV(i,j,k))/2.0
         adv_fn(i,j,k) = 0.5*totvel*(  &
             (a2nd*(1.0-mask) + a4th*mask)*(u(i,  j,k,tau) +    u(i,j+1,k,tau))+  &
             (b2nd*(1.0-mask) + b4th*mask)*(u(i,jm1,k,tau) +    u(i,jp2,k,tau)))
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)
 
      do j=js,je
       do k=1,nz-1
        do i=2,nx-1
         kp2=min(k+2,nz)
         km1=max(1,k-1)
         mask = maskU(i,j,km1)*maskU(i,j,kp2)
         totvel = (w(i+1,j,k,tau)*maskW(i+1,j,k)  +w(i,j,k,tau)*maskW(i,j,k))/2.0
         adv_ft(i,j,k) = 0.5*totvel*(  &
               (a2nd*(1.0-mask) + a4th*mask)*(u(i,j,  k,tau) +  u(i,j,k+1,tau))+  &
               (b2nd*(1.0-mask) + b4th*mask)*(u(i,j,km1,tau) +  u(i,j,kp2,tau)))
        enddo
       enddo
      enddo
end subroutine adv_flux_u_4th



subroutine adv_flux_v_4th(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of meridional momentum 4th order
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_) 
      integer :: i,j,k,js,je,ip2,im1,jp2,jm1,kp2,km1
      real*8,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real*8,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0
      real*8 :: mask,totvel

      js=max(2,js_pe); je=min(je_pe,ny-1)

      do j=js,je
       do k=2,nz-1
        do i=1,nx-1
         ip2=i+2
         if (ip2>nx.and..not.enable_cyclic_x) ip2=nx
         if (ip2>nx.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=nx-2
         mask = maskV(im1,j,k)*maskV(ip2,j,k)
         totvel = (u(i,j+1,k,tau)*maskU(i,j+1,k)  +u(i,j,k,tau)*maskU(i,j,k))/2.0
         adv_fe(i,j,k) = 0.5*totvel*(  &
             (a2nd*(1.0-mask) + a4th*mask)*(v(i,  j,k,tau) + v(i+1,j,k,tau))+  &
             (b2nd*(1.0-mask) + b4th*mask)*(v(im1,j,k,tau) + v(ip2,j,k,tau)))
        enddo
       enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)

      do j=js,je
       do k=2,nz-1
        do i=2,nx-1
         jp2=j+2
         if (jp2>ny.and..not.enable_cyclic_y) jp2=ny
         if (jp2>ny.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=ny-2
         mask = maskV(i,jm1,k)*maskV(i,jp2,k)
         totvel = (v(i,j+1,k,tau)*maskV(i,j+1,k) +v(i,j,k,tau)*maskV(i,j,k))/2.0
         adv_fn(i,j,k) = 0.5*totvel*(   &
             (a2nd*(1.0-mask) + a4th*mask)*(v(i,  j,k,tau) +  v(i,j+1,k,tau))+   &
             (b2nd*(1.0-mask) + b4th*mask)*(v(i,jm1,k,tau) +  v(i,jp2,k,tau)))
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)
 
      do j=js,je
       do k=1,nz-1
        do i=2,nx-1
         kp2=min(k+2,nz)
         km1=max(1,k-1)
         mask = maskV(i,j,km1)*maskV(i,j,kp2)
         totvel = (w(i,j+1,k,tau)*maskW(i,j+1,k) +w(i,j,k,tau)*maskW(i,j,k))/2.0
         adv_ft(i,j,k) = 0.5*totvel*(   &
               (a2nd*(1.0-mask) + a4th*mask)*(v(i,j,  k,tau) + v(i,j,k+1,tau))+   &
               (b2nd*(1.0-mask) + b4th*mask)*(v(i,j,km1,tau) + v(i,j,kp2,tau)))
        enddo
       enddo
      enddo
end subroutine adv_flux_v_4th




subroutine adv_flux_w_4th(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of vertical momentum 4th order
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_) 
      integer :: i,j,k,js,je,ip2,im1,jp2,jm1,kp2,km1
      real*8,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real*8,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0
      real*8 :: mask,totvel

      js=max(2,js_pe); je=min(je_pe,ny-1)

      do j=js,je
       do k=2,nz-1
        do i=1,nx-1
         ip2=i+2
         if (ip2>nx.and..not.enable_cyclic_x) ip2=nx
         if (ip2>nx.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=nx-2
         mask = maskW(im1,j,k)*maskW(ip2,j,k)
         totvel = (u(i,j,k+1,tau)*maskU(i,j,k+1) +u(i,j,k,tau)*maskU(i,j,k))/2.0
         adv_fe(i,j,k) = 0.5*totvel*(  &
             (a2nd*(1.0-mask) + a4th*mask)*(w(i,  j,k,tau) +   w(i+1,j,k,tau))+  &
             (b2nd*(1.0-mask) + b4th*mask)*(w(im1,j,k,tau) +   w(ip2,j,k,tau)))
        enddo
       enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)

      do j=js,je
       do k=2,nz-1
        do i=2,nx-1
         jp2=j+2
         if (jp2>ny.and..not.enable_cyclic_y) jp2=ny
         if (jp2>ny.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=ny-2
         mask = maskW(i,jm1,k)*maskW(i,jp2,k)
         totvel = (v(i,j,k+1,tau)*maskV(i,j,k+1) +v(i,j,k,tau)*maskV(i,j,k))/2.0
         adv_fn(i,j,k) = 0.5*totvel*(  &
             (a2nd*(1.0-mask) + a4th*mask)*(w(i,  j,k,tau) +  w(i,j+1,k,tau))+  &
             (b2nd*(1.0-mask) + b4th*mask)*(w(i,jm1,k,tau) +  w(i,jp2,k,tau)))
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)
 
      do j=js,je
       do k=1,nz-1
        do i=2,nx-1
         kp2=min(k+2,nz)
         km1=max(1,k-1)
         mask = maskW(i,j,km1)*maskW(i,j,kp2)
         totvel = (w(i,j,k+1,tau)*maskW(i,j,k+1) +w(i,j,k,tau)*maskW(i,j,k))/2.0
         adv_ft(i,j,k) = 0.5*totvel*(  &
               (a2nd*(1.0-mask) + a4th*mask)*(w(i,j,  k,tau) +  w(i,j,k+1,tau))+  &
               (b2nd*(1.0-mask) + b4th*mask)*(w(i,j,km1,tau) +  w(i,j,kp2,tau)))
        enddo
       enddo
      enddo
end subroutine adv_flux_w_4th




subroutine adv_flux_u_quicker(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of zonal momentum,   3th order upwind
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_) 
      integer :: i,j,k,ip2,jp2,kp2,im1,jm1,km1,js,je
      real*8 :: totvel,upos,uneg,eastmsk,westmsk
      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         ip2=i+2
         if (ip2>nx.and..not.enable_cyclic_x) ip2=nx
         if (ip2>nx.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=nx-2

         totvel = 0.5*(u(i+1,j,k,tau)+u(i,j,k,tau))
         upos = .5*(totvel + abs(totvel)) *maskU(i,j,k)*maskU(i+1,j,k)
         uneg = .5*(totvel - abs(totvel)) *maskU(i+1,j,k)*maskU(i,j,k)
         eastmsk=maskU(i,j,k)*(1-maskU(im1,j,k))
         westmsk=maskU(i+1,j,k)*(1-maskU(ip2,j,k))
         adv_fe(i,j,k) = 0.5*totvel*(u(i,j,k,tau)+u(i+1,j,k,tau))   &
              - 0.5*upos*(0.25*u(i+1,j,k,taum1)-0.5*u(i,j,k,taum1)   &
                     +0.25*(u(im1,j,k,taum1)*(1-eastmsk) +u(i,j,k,taum1)*eastmsk))   &
              - 0.5*uneg*(0.25*(u(ip2,j,k,taum1)*(1-westmsk)+   &
                u(i+1,j,k,taum1)*westmsk)-0.5*u(i+1,j,k,taum1) +0.25*u(i,j,k,taum1))
          enddo
        enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)

      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         jp2=j+2
         if (jp2>ny.and..not.enable_cyclic_y) jp2=ny
         if (jp2>ny.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=ny-2

         totvel = 0.5*(v(i+1,j,k,tau)+v(i,j,k,tau))
         upos = .5*(totvel + abs(totvel)) *maskU(i,j,k)*maskU(i,j+1,k)
         uneg = .5*(totvel - abs(totvel)) *maskU(i,j+1,k)*maskU(i,j,k)
         eastmsk=maskU(i,j,k)*(1-maskU(i,jm1,k))
         westmsk=maskU(i,j+1,k)*(1-maskU(i,jp2,k))
         adv_fn(i,j,k) = 0.5*totvel*(u(i,j,k,tau)+u(i,j+1,k,tau))   &
              - 0.5*upos*(0.25*u(i,j+1,k,taum1)-0.5*u(i,j,k,taum1)   &
                     +0.25*(u(i,jm1,k,taum1)*(1-eastmsk) +u(i,j,k,taum1)*eastmsk))   &
              - 0.5*uneg*(0.25*(u(i,jp2,k,taum1)*(1-westmsk)+   &
                u(i,j+1,k,taum1)*westmsk)-0.5*u(i,j+1,k,taum1) +0.25*u(i,j,k,taum1))
          enddo
        enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)

      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         kp2=min(k+2,nz)
         km1=max(1,k-1)
         totvel = 0.5*(w(i+1,j,k,tau)+w(i,j,k,tau))
         upos = .5*(totvel + abs(totvel)) *maskU(i,j,k)*maskU(i,j,k+1)
         uneg = .5*(totvel - abs(totvel)) *maskU(i,j,k+1)*maskU(i,j,k)
         eastmsk=maskU(i,j,k)*(1-maskU(i,j,km1))
         westmsk=maskU(i,j,k+1)*(1-maskU(i,j,kp2))
         adv_ft(i,j,k) = 0.5*totvel*(u(i,j,k,tau)+u(i,j,k+1,tau))   &
              - 0.5*upos*(0.25*u(i,j,k+1,taum1)-0.5*u(i,j,k,taum1)   &
                     +0.25*(u(i,j,km1,taum1)*(1-eastmsk) +u(i,j,k,taum1)*eastmsk))   &
              - 0.5*uneg*(0.25*(u(i,j,kp2,taum1)*(1-westmsk)+   &
                u(i,j,k+1,taum1)*westmsk)-0.5*u(i,j,k+1,taum1) +0.25*u(i,j,k,taum1))
          enddo
        enddo
      enddo
end subroutine adv_flux_u_quicker





subroutine adv_flux_v_quicker(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of meridional momentum,   3th order upwind
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_) 
      integer :: i,j,k,ip2,jp2,kp2,im1,jm1,km1,js,je
      real*8 :: totvel,upos,uneg,eastmsk,westmsk
      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         ip2=i+2
         if (ip2>nx.and..not.enable_cyclic_x) ip2=nx
         if (ip2>nx.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=nx-2

         totvel = 0.5*(u(i,j+1,k,tau)+u(i,j,k,tau))
         upos = .5*(totvel + abs(totvel)) *maskV(i,j,k)*maskV(i+1,j,k)
         uneg = .5*(totvel - abs(totvel)) *maskV(i+1,j,k)*maskV(i,j,k)
         eastmsk=maskV(i,j,k)*(1-maskV(im1,j,k))
         westmsk=maskV(i+1,j,k)*(1-maskV(ip2,j,k))
         adv_fe(i,j,k) = 0.5*totvel*(v(i,j,k,tau)+v(i+1,j,k,tau))  &
              - 0.5*upos*(0.25*v(i+1,j,k,taum1)-0.5*v(i,j,k,taum1)  &
                     +0.25*(v(im1,j,k,taum1)*(1-eastmsk) +v(i,j,k,taum1)*eastmsk))  &
              - 0.5*uneg*(0.25*(v(ip2,j,k,taum1)*(1-westmsk)+  &
                v(i+1,j,k,taum1)*westmsk)-0.5*v(i+1,j,k,taum1) +0.25*v(i,j,k,taum1))
          enddo
        enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)

      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         jp2=j+2
         if (jp2>ny.and..not.enable_cyclic_y) jp2=ny
         if (jp2>ny.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=ny-2

         totvel = 0.5*(v(i,j+1,k,tau)+v(i,j,k,tau))
         upos = .5*(totvel + abs(totvel)) *maskV(i,j,k)*maskV(i,j+1,k)
         uneg = .5*(totvel - abs(totvel)) *maskV(i,j+1,k)*maskV(i,j,k)
         eastmsk=maskV(i,j,k)*(1-maskV(i,jm1,k))
         westmsk=maskV(i,j+1,k)*(1-maskV(i,jp2,k))
         adv_fn(i,j,k) = 0.5*totvel*(v(i,j,k,tau)+v(i,j+1,k,tau))  &
              - 0.5*upos*(0.25*v(i,j+1,k,taum1)-0.5*v(i,j,k,taum1)  &
                     +0.25*(v(i,jm1,k,taum1)*(1-eastmsk) +v(i,j,k,taum1)*eastmsk))  &
              - 0.5*uneg*(0.25*(v(i,jp2,k,taum1)*(1-westmsk)+  &
                v(i,j+1,k,taum1)*westmsk)-0.5*v(i,j+1,k,taum1) +0.25*v(i,j,k,taum1))
          enddo
        enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)

      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         kp2=min(k+2,nz)
         km1=max(1,k-1)
         totvel = 0.5*(w(i,j+1,k,tau)+w(i,j,k,tau))
         upos = .5*(totvel + abs(totvel)) *maskV(i,j,k)*maskV(i,j,k+1)
         uneg = .5*(totvel - abs(totvel)) *maskV(i,j,k+1)*maskV(i,j,k)
         eastmsk=maskV(i,j,k)*(1-maskV(i,j,km1))
         westmsk=maskV(i,j,k+1)*(1-maskV(i,j,kp2))
         adv_ft(i,j,k) = 0.5*totvel*(v(i,j,k,tau)+v(i,j,k+1,tau))  &
              - 0.5*upos*(0.25*v(i,j,k+1,taum1)-0.5*v(i,j,k,taum1)  &
                     +0.25*(v(i,j,km1,taum1)*(1-eastmsk) +v(i,j,k,taum1)*eastmsk))  &
              - 0.5*uneg*(0.25*(v(i,j,kp2,taum1)*(1-westmsk)+  &
                v(i,j,k+1,taum1)*westmsk)-0.5*v(i,j,k+1,taum1) +0.25*v(i,j,k,taum1))
          enddo
        enddo
      enddo
end subroutine adv_flux_v_quicker



subroutine adv_flux_w_quicker(nx_,ny_,nz_,adv_fe,adv_fn,adv_ft)
!=======================================================================
!       advection of vertical momentum,   3th order upwind
!       fluxes are stored in adv_fe,adv_fn and adv_ft
!=======================================================================
      use pyOM_module   
      implicit none
      integer :: nx_,ny_,nz_
      real*8 :: adv_fe(nx_,ny_,nz_), adv_ft(nx_,ny_,nz_), adv_fn(nx_,ny_,nz_) 
      integer :: i,j,k,ip2,jp2,kp2,im1,jm1,km1,js,je
      real*8 :: totvel,upos,uneg,eastmsk,westmsk
      js=max(2,js_pe); je = min(je_pe,ny-1)
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         ip2=i+2
         if (ip2>nx.and..not.enable_cyclic_x) ip2=nx
         if (ip2>nx.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=nx-2

         totvel = 0.5*(u(i,j,k+1,tau)+u(i,j,k,tau))
         upos = .5*(totvel + abs(totvel)) *maskW(i,j,k)*maskW(i+1,j,k)
         uneg = .5*(totvel - abs(totvel)) *maskW(i+1,j,k)*maskW(i,j,k)
         eastmsk=maskW(i,j,k)*(1-maskW(im1,j,k))
         westmsk=maskW(i+1,j,k)*(1-maskW(ip2,j,k))
         adv_fe(i,j,k) = 0.5*totvel*(w(i,j,k,tau)+w(i+1,j,k,tau))  &
              - 0.5*upos*(0.25*w(i+1,j,k,taum1)-0.5*w(i,j,k,taum1)  &
                     +0.25*(w(im1,j,k,taum1)*(1-eastmsk) +w(i,j,k,taum1)*eastmsk))  &
              - 0.5*uneg*(0.25*(w(ip2,j,k,taum1)*(1-westmsk)+  &
                w(i+1,j,k,taum1)*westmsk)-0.5*w(i+1,j,k,taum1) +0.25*w(i,j,k,taum1))
          enddo
        enddo
      enddo
      call setcyclic3D(nx_,ny_,nz_,adv_fe)

      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         jp2=j+2
         if (jp2>ny.and..not.enable_cyclic_y) jp2=ny
         if (jp2>ny.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=ny-2

         totvel = 0.5*(v(i,j,k+1,tau)+v(i,j,k,tau))
         upos = .5*(totvel + abs(totvel))   *maskW(i,j,k)*maskW(i,j+1,k)
         uneg = .5*(totvel - abs(totvel))   *maskW(i,j+1,k)*maskW(i,j,k)
         eastmsk=maskW(i,j,k)*(1-maskW(i,jm1,k))
         westmsk=maskW(i,j+1,k)*(1-maskW(i,jp2,k))
         adv_fn(i,j,k) =  0.5*totvel*(w(i,j,k,tau)+w(i,j+1,k,tau))  &
              - 0.5*upos*(0.25*w(i,j+1,k,taum1)-0.5*w(i,j,k,taum1)  &
                     +0.25*(w(i,jm1,k,taum1)*(1-eastmsk)     +w(i,j,k,taum1)*eastmsk))  &
              - 0.5*uneg*(0.25*(w(i,jp2,k,taum1)*(1-westmsk)+  &
                w(i,j+1,k,taum1)*westmsk)-0.5*w(i,j+1,k,taum1)  +0.25*w(i,j,k,taum1))
          enddo
        enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,adv_fn,1); call setcyclic3D(nx_,ny_,nz_,adv_fn)

      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         kp2=min(k+2,nz)
         km1=max(1,k-1)
         totvel = 0.5*(w(i,j,k+1,tau)+w(i,j,k,tau))
         upos = .5*(totvel + abs(totvel))    *maskW(i,j,k)*maskW(i,j,k+1)
         uneg = .5*(totvel - abs(totvel))    *maskW(i,j,k+1)*maskW(i,j,k)
         eastmsk=maskW(i,j,k)*(1-maskW(i,j,km1))
         westmsk=maskW(i,j,k+1)*(1-maskW(i,j,kp2))
         adv_ft(i,j,k) = 0.5*totvel*(w(i,j,k,tau)+w(i,j,k+1,tau))   &
              - 0.5*upos*(0.25*w(i,j,k+1,taum1)-0.5*w(i,j,k,taum1)   &
                     +0.25*(w(i,j,km1,taum1)*(1-eastmsk)    +w(i,j,k,taum1)*eastmsk))   &
              - 0.5*uneg*(0.25*(w(i,j,kp2,taum1)*(1-westmsk)+   &
                w(i,j,k+1,taum1)*westmsk)-0.5*w(i,j,k+1,taum1) +0.25*w(i,j,k,taum1))
          enddo
        enddo
      enddo
end subroutine adv_flux_w_quicker

!=======================================================================
!  A high resolution horizontal gyre circulation
!  with a shelf at western boundary
!=======================================================================


module config_module
 ! use this module only locally in this file
 implicit none
 real*8,parameter :: hRESOLVE = 2.0  ! 2 in original model 
 real*8,parameter :: vRESOLVE = 2.0  ! 2 in original model
 real*8,parameter :: rho_0 =1024.0, g=9.81
 real*8,parameter :: pi      = 3.14159265358979323846264338327950588
 real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
 real*8,parameter :: radius  = 6370.0e3,degtom = radius/180.0*pi
 real*8 :: N_0 = 5e-3, phi0 = 30. , tau0 = -0.1 
end module config_module


subroutine set_parameter
 use pyOM_module
 use fcontrol_module
 use config_module
 implicit none
 real*8 :: beta,uu,mlen,ilen,blen,rlen
 nx   = 80*hRESOLVE 
 ny   = 80*hRESOLVE
 nz   = 20*vRESOLVE
 dx   = 20.0e3/hRESOLVE
 dz   = 150.000/vRESOLVE
 dt   = 2400.0/hRESOLVE
 K_h=00.0
 A_h=000!  zero in original model
 K_v=1.e-4
 A_v=1.e-3
 Ahbi = 0.5e12 /hRESOLVE**4
 Khbi  = Ahbi

 eps2D_sor = 1e-9
 enable_hydrostatic          = .true.
 enable_noslip               = .true.
 enable_biharmonic_friction  = .true. ! was on in original model
 enable_quicker_advection    = .true.
 enable_back_state           = .true.
 !enable_pv_mixing            = .true. ! was off in original model

 runlen  = 365.0*86400. ! 1 year in original model
 snapint = 3.0*86400.

 beta =  2*omega*cos(phi0/180.*pi)/radius
 uu   =  abs(tau0)/(rho_0*dz*nx*dx*beta) 
 ! (A psi/L^4, Apsi/L^6) = beta psi/L  -> (L^3,L^5) =A/beta
 mlen  = max( (A_h/beta)**(1./3.), (Ahbi/beta)**(1./5.) )
 ilen  =  (uu/beta)**(1./2.)
 rlen = N_0*dz*(nz-2)/( 2*omega*sin(phi0/180.*pi) *pi)
 if (my_pe==0) then
  print*,' grid scale     = ', dx/1e3 , ' km'
  print*,' Rossby radius  = ', rlen /1e3,' km'
  print*,' Munk scale     = ', mlen/1e3 , ' km'
  print*,' Velocity scale = ', uu ,' m/s'
  print*,' Inertial scale = ', ilen/1e3,' km'
  ! U U/L = (A U/L^2, A U/L^4),  Re = (U L/A, U L^3/A  )
  print*,' Grid Reynolds number       = ', min( uu*dx/max(1.d0,A_h) ,  uu*dx**3/ahbi) 
  print*,' Reynolds number munk scale = ', min( uu*mlen/max(1.d0,A_h) ,  uu*mlen**3/ahbi) 
  print*,' Reynolds number Rossby rad.= ', min( uu*rlen/max(1.d0,A_h) ,  uu*rlen**3/ahbi) 
  print*,' Reynolds number basin scale = ', min( uu*dx*nx/max(1.d0,A_h) ,  uu*(nx*dx)**3/ahbi) 
 endif
end subroutine set_parameter


subroutine set_coriolis
 use pyOM_module   
 use config_module
 implicit none
 integer :: j
 do j=1,ny
  coriolis_t(j) = 2*omega*sin(phi0/180.*pi) + 2*omega*cos(phi0/180.*pi)/radius*yt(j)
 enddo
end subroutine set_coriolis


subroutine initial_conditions
 use pyOM_module
 use config_module
 implicit none
 integer :: i,j,k
 do k=1,nz
  do j=1,ny
    do i=1,nx
      back(i,j,k,:) = (-N_0**2*zt(k))*maskT(i,j,k)
    enddo
  enddo
 enddo
end subroutine initial_conditions


subroutine boundary_conditions
 use pyOM_module
 use config_module
   implicit none
   integer :: i,j
   real*8 :: y
! units are m^2/s^3  
! since  b_z = N^2   b[m/s^2]   b_t = F_z   [m/s^3]=[ m^2/s^3]_z
      do j=1,ny
       do i=1,nx
        y = (yu(j)-yu(1))/ (yu(ny)-yu(1))
        surface_taux(i,j) = tau0/rho_0 *cos(2*pi*y)*maskU(i,j,nz-1)
        surface_tauy(i,j) = 0.0*maskV(i,j,nz-1)
       enddo
      enddo
end subroutine boundary_conditions

subroutine topography
   use pyOM_module
   implicit none
   integer :: i,k
   real*8 :: z,h0
   h0 = zt(1)
   do k=2,nz-1
    do i=1,nx
     z=h0*min(1.d0,xt(i)/200e3)    ! 200e3 in original model
     if (zt(k).lt.z) maskT(i,:,k)=0.0
    enddo
   enddo
end subroutine topography

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!      Biharmonic friction and diffusion
!=======================================================================

 subroutine biha_hfric_u (nx_,ny_,nz_,diff_fe,diff_fn)
!---------------------------------------------------------------------------------
!      horizontal biharmonic friction for zonal momentum
!      no slip condition is possible
!---------------------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      integer :: nx_,ny_,nz_
      real*8 :: diff_fe(nx_,ny_,nz_), diff_fn(nx_,ny_,nz_) 
      real*8 :: del2(nx,ny,nz),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k) = (diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k) = (diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,ny-1)
      diffx = sqrt(abs(ahbi))
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=1,nz
       do j=js,je
        do i=1,nx-1
         diff_fe(i,j,k)=diffx*(u(i+1,j,k,taum1)-u(i,j,k,taum1))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fe,1); call setcyclic3D(nx_,ny_,nz_,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=1,nx
         diff_fn(i,j,k)=diffx*(u(i,j+1,k,taum1)-u(i,j,k,taum1))/dx*maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js-1,je
         diff_fn(:,j,:)=diff_fn(:,j,:)-2*diffx*u(:,j,:,taum1)/dx  &
            *(1-maskU(:,j+1,:))*maskU(:,j,:)+2*diffx*u(:,j+1,:,taum1)/dx*(1-maskU(:,j,:))*maskU(:,j+1,:)
       enddo
      endif
      call border_exchg3D(nx_,ny_,nz_,diff_fn,1); call setcyclic3D(nx_,ny_,nz_,diff_fn)
      del2(:,js_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,del2,1); call setcyclic3D(nx_,ny_,nz_,del2)
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         diff_fe(i,j,k) =diffx*(del2(i+1,j,k)-del2(i,j,k))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fe,1); call setcyclic3D(nx_,ny_,nz_,diff_fe)
      do k=1,nz-1
       do j=js-1,je
        do i=2,nx-1
         diff_fn(i,j,k) = diffx*(del2(i,j+1,k) - del2(i,j,k))/dx*maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js-1,je
         diff_fn(:,j,:)=diff_fn(:,j,:)-2*diffx*del2(:,j,:)/dx  &
          *(1-maskU(:,j+1,:))*maskU(:,j,:)+2*diffx*del2(:,j+1,:)/dx*(1-maskU(:,j,:))*maskU(:,j+1,:)
       enddo
      endif
      call border_exchg3D(nx_,ny_,nz_,diff_fn,1); call setcyclic3D(nx_,ny_,nz_,diff_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         fu(i,j,k)=fu(i,j,k)-maskU(i,j,k)*(DIFF_Tx(i,j,k)+DIFF_Ty(i,j,k))
        enddo
       enddo
      enddo
 end subroutine biha_hfric_u




 subroutine biha_hfric_v (nx_,ny_,nz_,diff_fe,diff_fn)
!---------------------------------------------------------------------------------
!      horizontal biharmonic friction for meridional momentum
!      no slip condition is possible
!---------------------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      integer :: nx_,ny_,nz_
      real*8 :: diff_fe(nx_,ny_,nz_), diff_fn(nx_,ny_,nz_) 
      real*8 :: del2(nx,ny,nz),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,ny-1)
      diffx = sqrt(abs(ahbi))
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=1,nz
       do j=js,je
        do i=1,nx-1
         diff_fe(i,j,k)=diffx*(v(i+1,j,k,taum1)-v(i,j,k,taum1))/dx*maskV(i,j,k)*maskV(i+1,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js,je
       do i=1,nx-1
         diff_fe(i,j,:)=diff_fe(i,j,:)-2*diffx*v(i,j,:,taum1)/dx  &
           *(1-maskV(i+1,j,:))*maskV(i,j,:)+2*diffx*v(i+1,j,:,taum1)/dx*(1-maskV(i,j,:))*maskV(i+1,j,:)
       enddo
       enddo
      endif
      call border_exchg3D(nx_,ny_,nz_,diff_fe,1); call setcyclic3D(nx_,ny_,nz_,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=1,nx
         diff_fn(i,j,k)=diffx*(v(i,j+1,k,taum1)-v(i,j,k,taum1))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fn,1); call setcyclic3D(nx_,ny_,nz_,diff_fn)
      del2(:,je_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,del2,1); call setcyclic3D(nx_,ny_,nz_,del2)
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         diff_fe(i,j,k) =diffx*(del2(i+1,j,k)-del2(i,j,k))/dx*maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js,je
       do i=1,nx-1
         diff_fe(i,j,:)=diff_fe(i,j,:)-2*diffx*del2(i,j,:)/dx*(1-maskV(i+1,j,:))*maskV(i,j,:) &
                     +2*diffx*del2(i+1,j,:)/dx*(1-maskV(i,j,:))*maskV(i+1,j,:)
       enddo
       enddo
      endif
      call border_exchg3D(nx_,ny_,nz_,diff_fe,1); call setcyclic3D(nx_,ny_,nz_,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         diff_fn(i,j,k) = diffx*(del2(i,j+1,k) - del2(i,j,k))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fn,1); call setcyclic3D(nx_,ny_,nz_,diff_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          fv(i,j,k)= fv(i,j,k)+maskV(i,j,k)*(-DIFF_Tx(i,j,k) - DIFF_Ty(i,j,k))
        enddo
       enddo
      enddo
 end subroutine biha_hfric_v





 subroutine biha_hfric_w (nx_,ny_,nz_,diff_fe,diff_fn)
!---------------------------------------------------------------------------------
!      horizontal biharmonic friction for vertical momentum
!---------------------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      integer :: nx_,ny_,nz_
      real*8 :: diff_fe(nx_,ny_,nz_), diff_fn(nx_,ny_,nz_) 
      real*8 :: del2(nx,ny,nz),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,ny-1)
      diffx = sqrt(abs(ahbi))
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=1,nz
       do j=js,je
        do i=1,nx-1
         diff_fe(i,j,k)=diffx*(w(i+1,j,k,taum1)-w(i,j,k,taum1))/dx*maskW(i,j,k)*maskW(i+1,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fe,1); call setcyclic3D(nx_,ny_,nz_,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=1,nx
         diff_fn(i,j,k)=diffx*(w(i,j+1,k,taum1)-w(i,j,k,taum1))/dx*maskW(i,j,k)*maskW(i,j+1,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fn,1); call setcyclic3D(nx_,ny_,nz_,diff_fn)
      del2(:,je_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,del2,1); call setcyclic3D(nx_,ny_,nz_,del2)
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         diff_fe(i,j,k) =diffx*(del2(i+1,j,k)-del2(i,j,k))/dx*maskW(i+1,j,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fe,1); call setcyclic3D(nx_,ny_,nz_,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         diff_fn(i,j,k) = diffx*(del2(i,j+1,k) - del2(i,j,k))/dx*maskW(i,j+1,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fn,1); call setcyclic3D(nx_,ny_,nz_,diff_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          fw(i,j,k)= fw(i,j,k)+maskW(i,j,k)*(-DIFF_Tx(i,j,k) - DIFF_Ty(i,j,k))
        enddo
       enddo
      enddo
end subroutine biha_hfric_w



 subroutine biha_vfric_u (nx_,ny_,nz_,diff_ft)
!---------------------------------------------------------------------------------
!       vertical biharmonic friction for zonal momentum component 
!       result is added to ff
!---------------------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      integer :: nx_,ny_,nz_
      real*8, dimension(nx_,ny_,nz_) :: diff_ft
      real*8 :: del2(nx,ny,nz),diff_tz,diffx
      DIFF_Tz(i,j,k)=(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz

      js=max(2,js_pe); je = min(je_pe,ny-1)
      diffx = sqrt(abs(Avbi))
      diff_ft(:,je_pe:je_pe,:)=0.0
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         diff_ft(i,j,k)=diffx*(u(i,j,k+1,taum1)-u(i,j,k,taum1))/dz*masku(i,j,k)*masku(i,j,k+1)
        enddo
       enddo
      enddo
      del2(:,je_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          del2(i,j,k) = DIFF_Tz(i,j,k)*masku(i,j,k)
        enddo
       enddo
      enddo
      diff_ft(:,je_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         diff_ft(i,j,k) =diffx*(del2(i,j,k+1)-del2(i,j,k))/dz*masku(i,j,k+1)*masku(i,j,k)
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          fu(i,j,k)= fu(i,j,k)-masku(i,j,k)*DIFF_Tz(i,j,k) 
        enddo
       enddo
      enddo
 end subroutine biha_vfric_u



 subroutine biha_vfric_v (nx_,ny_,nz_,diff_ft)
!---------------------------------------------------------------------------------
!       vertical biharmonic friction for  momentum component n
!       result is added to ff
!---------------------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      integer :: nx_,ny_,nz_
      real*8, dimension(nx_,ny_,nz_) :: diff_ft
      real*8 :: del2(nx,ny,nz),diff_tz,diffx
      DIFF_Tz(i,j,k)=(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz

      js=max(2,js_pe); je = min(je_pe,ny-1)
      diffx = sqrt(abs(Avbi))
      diff_ft(:,je_pe:je_pe,:)=0.0
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         diff_ft(i,j,k)=diffx*(v(i,j,k+1,taum1)-v(i,j,k,taum1))/dz*maskV(i,j,k)*maskV(i,j,k+1)
        enddo
       enddo
      enddo
      del2(:,je_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          del2(i,j,k) = DIFF_Tz(i,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      diff_ft(:,je_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         diff_ft(i,j,k) =diffx*(del2(i,j,k+1)-del2(i,j,k))/dz*maskV(i,j,k+1)*maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          fv(i,j,k)= fv(i,j,k)-maskV(i,j,k)*DIFF_Tz(i,j,k) 
        enddo
       enddo
      enddo
 end subroutine biha_vfric_v


 subroutine biha_vfric_w (nx_,ny_,nz_,diff_ft)
!---------------------------------------------------------------------------------
!       vertical biharmonic friction for  momentum component n
!       result is added to ff
!---------------------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      integer :: nx_,ny_,nz_
      real*8, dimension(nx_,ny_,nz_) :: diff_ft
      real*8 :: del2(nx,ny,nz),diff_tz,diffx
      DIFF_Tz(i,j,k)=(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz

      js=max(2,js_pe); je = min(je_pe,ny-1)
      diffx = sqrt(abs(Avbi))
      diff_ft(:,je_pe:je_pe,:)=0.0
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         diff_ft(i,j,k)=diffx*(w(i,j,k+1,taum1)-w(i,j,k,taum1))/dz*maskW(i,j,k)*maskW(i,j,k+1)
        enddo
       enddo
      enddo
      del2(:,je_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          del2(i,j,k) = DIFF_Tz(i,j,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      diff_ft(:,je_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         diff_ft(i,j,k) =diffx*(del2(i,j,k+1)-del2(i,j,k))/dz*maskW(i,j,k+1)*maskW(i,j,k)
        enddo
       enddo
      enddo
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          fw(i,j,k)= fw(i,j,k)-maskW(i,j,k)*DIFF_Tz(i,j,k) 
        enddo
       enddo
      enddo
 end subroutine biha_vfric_w




 subroutine biha_mix (nx_,ny_,nz_,diff_fe,diff_fn,diff_ft,var)
!---------------------------------------------------------------------------------
!      horizontal biharmonic diffusion of buoyancy
!      also vertical biha. diff. if requested
!---------------------------------------------------------------------------------
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      integer :: nx_,ny_,nz_
      real*8 :: var(nx_,ny_,nz_,3)
      real*8 :: diff_fe(nx_,ny_,nz_), diff_fn(nx_,ny_,nz_) 
      real*8 :: diff_ft(nx_,ny_,nz_)  ,diffz
      real*8 :: del2(nx,ny,nz),diff_tx,diff_ty,diffx,diff_tz
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx
      DIFF_Tz(i,j,k)=(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz

      js=max(2,js_pe); je = min(je_pe,ny-1)
      diffx = sqrt(abs(Khbi))
      diffz = sqrt(abs(Kvbi))
      diff_fe(:,js_pe:je_pe,:)=0.0; diff_fn(:,js_pe:je_pe,:)=0.0
      do k=1,nz
       do j=js,je
        do i=1,nx-1
         diff_fe(i,j,k)=diffx*(var(i+1,j,k,taum1)-var(i,j,k,taum1))/dx*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fe,1); call setcyclic3D(nx_,ny_,nz_,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=1,nx
         diff_fn(i,j,k)=diffx*(var(i,j+1,k,taum1)-var(i,j,k,taum1))/dx*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fn,1); call setcyclic3D(nx_,ny_,nz_,diff_fn)
      del2(:,js_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,del2,1); call setcyclic3D(nx_,ny_,nz_,del2)
      diff_fe(:,js_pe:je_pe,:)=0.0; diff_fn(:,js_pe:je_pe,:)=0.0
      do k=2,nz-1
       do j=js,je
        do i=1,nx-1
         diff_fe(i,j,k) =diffx*(del2(i+1,j,k)-del2(i,j,k))/dx*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fe,1); call setcyclic3D(nx_,ny_,nz_,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=2,nx-1
         diff_fn(i,j,k) = diffx*(del2(i,j+1,k) - del2(i,j,k))/dx*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx_,ny_,nz_,diff_fn,1); call setcyclic3D(nx_,ny_,nz_,diff_fn)
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
          var(i,j,k,taup1)= var(i,j,k,taup1)+c2dt*maskT(i,j,k)*(-DIFF_Tx(i,j,k) - DIFF_Ty(i,j,k))
        enddo
       enddo
      enddo
      if (enable_vert_biha_diffusion) then
       diff_ft(:,js_pe:je_pe,:)=0.0
       do k=1,nz-1
        do j=js,je
         do i=2,nx-1
          diff_ft(i,j,k)=diffz*(var(i,j,k+1,taum1)-var(i,j,k,taum1))/dz *maskW(i,j,k)
         enddo
        enddo
       enddo
       del2(:,js_pe:je_pe,:)=0.0
       do k=2,nz-1
        do j=js,je
         do i=2,nx-1
          del2(i,j,k) = DIFF_Tz(i,j,k)*maskT(i,j,k)
         enddo
        enddo
       enddo
       diff_ft(:,js_pe:je_pe,:)=0.0
       do k=2,nz-1
        do j=js,je
         do i=2,nx-1
          diff_ft(i,j,k) =diffz*(del2(i,j,k+1)-del2(i,j,k))/dz *maskW(i,j,k)
         enddo
        enddo
       enddo
       do k=2,nz-1
        do j=js,je
         do i=2,nx-1
          var(i,j,k,taup1)=var(i,j,k,taup1) -c2dt*maskT(i,j,k)*DIFF_Tz(i,j,k) 
         enddo
        enddo
       enddo
      endif
end subroutine biha_mix

!=======================================================================
! Setup as in Nurser and Lee (2004) "Isopycnal Averaging at Constant 
! Height. Part I: The Formulation and a Case Study" JPO (34)
!=======================================================================


module config_module
 ! use this module only locally in this file
 implicit none
 real*8,parameter :: hRESOLVE = 1.0  ! 2 in original model 
 real*8,parameter :: vRESOLVE = 1.0  ! 2 in original model
 real*8,parameter :: rho_0 =1024.0, g=9.81
 real*8,parameter :: pi      = 3.14159265358979323846264338327950588
 real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
 real*8,parameter :: radius  = 6370.0e3,degtom = radius/180.0*pi
 real*8 :: M_0, N_0
end module config_module


subroutine set_parameter
 use pyOM_module
 use fcontrol_module
 use config_module
 implicit none
 real :: f_0,Ro,delta,s,fxa
 nx   = 31*hRESOLVE 
 ny   = 51*hRESOLVE
 nz   = 26*vRESOLVE

 dx    = 20.0e3/hRESOLVE
 dz    = 40.000/vRESOLVE
 dt    = 1200.0/hRESOLVE

 K_h=0000.0/hRESOLVE**2
 K_v=1.0e-4/vRESOLVE
 A_h=0.0e+4/hRESOLVE**2
 A_v=10.e-4/vRESOLVE

 Ahbi  = 1.25e11 /(hRESOLVE/2)**4  ! U/T = A U/L^4 
 Khbi  = Ahbi
 cdbot = 1e-5*vRESOLVE

 eps2D_sor = 1e-7
 runlen   = 365.0*86400.0
 snapint  = 3.0*86400.0

 enable_noslip               = .true.
 enable_cyclic_x             = .true.
 enable_bottom_stress        = .true.
 enable_biharmonic_friction  = .true.
 enable_hydrostatic          = .true.
 enable_quicker_advection    = .true.

 N_0     = ((0.01915234375+0.047880859375)/2-0) /((nz-2)*dz) 
 M_0     = (0.047880859375/2-0.01915234375/2)   /((ny-2)*dx)

end subroutine set_parameter

subroutine set_coriolis
 use pyOM_module   
 use config_module
 implicit none
 integer :: j
 real*8 :: phi0 
 phi0 = -49.3126877545132  /180. *pi
 do j=1,ny
      coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
 enddo
end subroutine set_coriolis

subroutine initial_conditions
 use pyOM_module
 use fcontrol_module
 use config_module
 implicit none
 integer :: i,j,k
 real :: B0,x,y,bS,bN,BSz,BNz
 bS=-0.01915234375
 bN=-0.047880859375
 do k=1,nz
      BSz=bS*(zt(k)-zt(1))/(zt(nz)-zt(1))
      BNz=bN*(zt(k)-zt(1))/(zt(nz)-zt(1))
      do j=1,ny
        B0=(BSz*(yt(ny-1)-yt(j))+BNz*(yt(j)-yt(2)))/ (yt(ny-1)-yt(2))
        do i=1,nx
          x=float(i)/float(nx)
          y = (yt(j)-yt(2))/ (yt(ny-1)-yt(2))
          b(i,j,k,:) = (B0+0.5e-3*sin(x*8.5*pi)*exp(-(y-0.5)**2/0.5**2))*maskT(i,j,k)
      enddo
    enddo
 enddo
end subroutine initial_conditions

subroutine restoring_zones
 use pyOM_module
 use fcontrol_module
 use config_module
 implicit none
 integer :: i,j,k,js,je,spg_width
 real :: t_rest,B0,bS,bN
 spg_width = 5*hRESOLVE
 t_rest=1./(2.*86400)
 bS=-0.01915234375
 bN=-0.047880859375

 js=max(2,js_pe); je = min(je_pe,ny-1)
 if (my_blk_j==1) then
  do k=1,nz
    B0=bS*(zt(k)-((zt(2)+zt(1))/2))/(zt(nz)-((zt(2)+zt(1))/2))
    do j=2,spg_width+1
     b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt*t_rest*(1.*(spg_width+1-1.*j))/(spg_width+1-2)  &
                    *(B0-b(:,j,k,taum1))
    enddo
  enddo
 endif
 if (my_blk_j==n_pes_j) then
  do k=1,nz
   B0=bN*(zt(k)-((zt(2)+zt(1))/2))/(zt(nz)-((zt(2)+zt(1))/2))
   do j=ny-1,ny-spg_width,-1
    b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt*t_rest*(1.*(ny-spg_width-1.*j))/(ny-spg_width-ny+1)  &
                     *(B0-b(:,j,k,taum1))
   enddo
  enddo
 endif
end subroutine restoring_zones

subroutine boundary_conditions
 use pyOM_module
 use fcontrol_module
 use config_module
 implicit none
 integer :: i,j,spg_width
 real :: t_rest,bstar,bS,bN,L_y,y,db
 spg_width = 5*hRESOLVE
 t_rest=7*86400
 bS=-0.01915234375
 bN=-0.047880859375

 do j=1,spg_width
        surface_flux(:,j)=0.0
 enddo
 do j=spg_width+1,ny-spg_width
      bstar=(bS*(ny-1-j)+bN*(j-2))/(ny-1-2)
      do i=1,nx
        surface_flux(i,j)=dz/t_rest*(bstar-b(i,j,nz-1,tau))
      enddo
 enddo
 do j=ny-spg_width+1,ny
        surface_flux(:,j)=0.0
 enddo
end subroutine boundary_conditions

subroutine topography
end subroutine topography

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!     Templates for setup
!=======================================================================

  subroutine set_parameter
      use pyOM_module   
      use fcontrol_module
      implicit none
      real*8 :: fac=0.5
! ----------------------------------
!       set here main parameter
! ----------------------------------
      nx=3*64*fac;nz=40*fac
      ny=3
      dx=0.25/fac 
      dz=0.25/fac 
      dt=0.025/fac
      eps2d_sor = 1e-6
      eps3d_sor = 1e-6
      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
      enable_hydrostatic         =.false.

!      enable_quicker_advection       =.true.
!      enable_quicker_mom_advection   =.true.

      enable_biharmonic_friction =.true.
      enable_vert_biha_friction  =.true.
      enable_biharmonic_diffusion=.true.
      enable_vert_biha_diffusion =.true.
      Ahbi = (5e-3/fac**2)*dx**2
      Khbi = Ahbi
      Avbi = (5e-3/fac**2)*dx**2
      Kvbi = Avbi

!      A_h = 20e-3/fac**2
!      K_h = A_h
!      A_v = A_h
!      K_v = A_h

      runlen=360.; snapint=0.25
  end subroutine set_parameter


 subroutine set_coriolis
 end subroutine set_coriolis


 subroutine initial_conditions
      use pyOM_module   
      implicit none
      integer :: i,j,k
      real*8 :: fxa,pi=3.1415
      do k=1,nz
       do j=1,ny
        do i=1,nx
         fxa=1e-3*zt(1)*sin(xt(i)/(20*dx)*pi)
         b(i,j,k,:)=1e-2*tanh( (fxa+zt(k)-zt(nz/2) ) /zt(1)*100 )
         b(i,j,k,:)=b(i,j,k,:)*maskT(i,j,k)
         u(i,j,k,:)= 2+tanh( (zt(k)-zt(nz/2))/zt(1)*100)
        enddo
       enddo
      enddo
 end subroutine initial_conditions



 subroutine restoring_zones
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      real*8 :: T_rest,B0
! ----------------------------------
!      add here restoring zones
! ----------------------------------
      js=max(2,js_pe); je = min(je_pe,ny -1)
      T_rest=1./(15.*dt)
      do k=1,nz
       do i=2,nx/8
        do j=js,je
         b0=1e-2*tanh( (zt(k)-zt(nz/2) ) /zt(1)*100 )
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*  t_rest*(B0-b(i,j,k,taum1))
        enddo
       enddo
      enddo
 end subroutine restoring_zones


 subroutine momentum_restoring_zones
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      real*8 :: T_rest,B0
! ----------------------------------
!      add here restoring zones for momentum
! ----------------------------------

      js=max(2,js_pe); je = min(je_pe,ny-1)
      T_rest=1./(15.*dt)
      do k=1,nz
       do i=2,nx/8
        do j=js,je
         B0=2+tanh( (zt(k)-zt(nz/2))/zt(1)*100)
         fu(i,j,k)= fu(i,j,k)+maskU(i,j,k)* T_rest*(B0-u(i,j,k,taum1))
        enddo
       enddo
      enddo
end subroutine momentum_restoring_zones


subroutine boundary_conditions
end subroutine boundary_conditions

subroutine topography
end subroutine topography

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!       time averaging diagnostics
!       linked in the code in driver only
!       Reference buoyancy profile given by N_0 
!=======================================================================


module time_averages_module
!=======================================================================
!        Main module for time averages
!=======================================================================
      implicit none
      integer :: nitts

      logical :: diag_eddy_fluxes           =.false.
      logical :: diag_eddy_flux_tendency    =.false.
      logical :: diag_potential_vorticity   =.false.
      logical :: remove_back_stratification =.false.

      real*8, allocatable :: umean(:,:,:),vmean(:,:,:),wmean(:,:,:)
      real*8, allocatable :: bmean(:,:,:),pmean(:,:,:)
      real*8, allocatable :: bs(:,:,:),ps(:,:,:),b3(:,:,:)
      real*8, allocatable :: uvar(:,:,:),vvar(:,:,:),wvar(:,:,:)
      real*8, allocatable :: bvar(:,:,:), pvar(:,:,:), uv(:,:,:,:)

      real*8, allocatable :: ub(:,:,:,:),vb(:,:,:,:),wb(:,:,:,:)
      real*8, allocatable :: ubb(:,:,:,:),vbb(:,:,:,:),wbb(:,:,:,:)
      real*8, allocatable :: ub3(:,:,:,:),vb3(:,:,:,:),wb3(:,:,:,:)

      real*8, allocatable :: ugeo1(:,:,:),ugeo2(:,:,:)
      real*8, allocatable :: vgeo1(:,:,:),vgeo2(:,:,:)
      real*8, allocatable :: bpx(:,:,:,:),bpy(:,:,:,:)
      real*8, allocatable :: bfv(:,:,:,:),bfu(:,:,:,:)
      real*8, allocatable :: uwN(:,:,:,:),vwN(:,:,:,:)

      integer :: nr_tr  = 0  ! numbers of tracers to be considered
      real*8, allocatable :: tmean(:,:,:,:),tvar(:,:,:,:),t3(:,:,:,:)
      real*8, allocatable :: ut(:,:,:,:,:),vt(:,:,:,:,:),wt(:,:,:,:,:)
      real*8, allocatable :: utt(:,:,:,:,:),vtt(:,:,:,:,:),wtt(:,:,:,:,:)
      real*8, allocatable :: ut3(:,:,:,:,:),vt3(:,:,:,:,:),wt3(:,:,:,:,:)
      real*8, allocatable :: rv(:,:,:),pv(:,:,:)
      real*8, allocatable :: qmean(:,:,:),qvar(:,:,:),q3(:,:,:)
      real*8, allocatable :: uq(:,:,:,:),vq(:,:,:,:),wq(:,:,:,:)
      real*8, allocatable :: uqq(:,:,:,:),vqq(:,:,:,:),wqq(:,:,:,:)
      real*8, allocatable :: uq3(:,:,:,:),vq3(:,:,:,:),wq3(:,:,:,:)
      real*8,parameter :: epsln     = 1.0d-20
      real*8,parameter :: spval = -1.0d33

      real*8, allocatable, dimension(:) :: b_r, p_r
      real*8,parameter :: N_0 = 0.004
end module time_averages_module


subroutine init_time_averages
!=======================================================================
!      Initialize time mean diagnostics
!=======================================================================
      use pyOM_module   
      use time_averages_module
      use fcontrol_module
      implicit none
      logical :: file_exists = .false.
      integer :: n,k,ierr

      ierr=0
      if (enable_diag_tracer) nr_tr = nt
      if (my_pe==0) then
       print*,' Initializing time averaging module '
       print*,' found ',nr_tr,' tracer '
      endif
      allocate( b_r(nz) ); b_r=0.0
      allocate( p_r(nz) ); p_r=0.0
 if (remove_back_stratification) then
      b_r = -zt*N_0**2
      p_r(nz) = 0
      do k=nz-1,1,-1
       p_r(k)=p_r(k+1)+0.5*(b_r(k+1)+b_r(k))*dz
      enddo
 endif
      allocate(bs(nx ,ny ,nz),ps(nx ,ny ,nz) );bs=0.;ps=0.
      allocate(umean(nx ,ny ,nz),vmean(nx ,ny ,nz),wmean(nx ,ny ,nz))
      allocate(bmean(nx ,ny ,nz),pmean(nx ,ny ,nz))
      allocate(uvar(nx ,ny ,nz),vvar(nx ,ny ,nz),wvar(nx ,ny ,nz))
      allocate(bvar(nx ,ny ,nz),pvar(nx ,ny ,nz),uv(nx ,ny ,nz,4))
      allocate(b3(nx ,ny ,nz))
 if (diag_eddy_fluxes) then
      allocate(ub(nx ,ny ,nz,2),vb(nx ,ny ,nz,2))
      allocate(ubb(nx ,ny ,nz,2),vbb(nx ,ny ,nz,2))
      allocate(wb(nx ,ny ,nz,2),wbb(nx ,ny ,nz,2))
      allocate(ub3(nx ,ny ,nz,2),vb3(nx ,ny ,nz,2))
      allocate(wb3(nx ,ny ,nz,2))
 endif
 if (diag_eddy_flux_tendency) then
      allocate(bpx(nx ,ny ,nz,3),bpy(nx ,ny ,nz,3))
      allocate(bfv(nx ,ny ,nz,6),bfu(nx ,ny ,nz,6))
      allocate(ugeo1(nx ,ny ,nz),ugeo2(nx ,ny ,nz) );ugeo1=0.;ugeo2=0.
      allocate(vgeo1(nx ,ny ,nz),vgeo2(nx ,ny ,nz) );vgeo1=0.;vgeo2=0.
      allocate(uwN(nx ,ny ,nz,4),vwN(nx ,ny ,nz,4))
 endif
      allocate(tmean(nx ,ny ,nz,nr_tr),tvar(nx ,ny ,nz,nr_tr))
      allocate(t3(nx ,ny ,nz,nr_tr) )
 if (diag_eddy_fluxes) then
      allocate(ut(nx ,ny ,nz,2,nr_tr),vt(nx ,ny ,nz,2,nr_tr))
      allocate(utt(nx ,ny ,nz,2,nr_tr),vtt(nx ,ny ,nz,2,nr_tr))
      allocate(wt(nx ,ny ,nz,2,nr_tr),wtt(nx ,ny ,nz,2,nr_tr))
      allocate(ut3(nx ,ny ,nz,2,nr_tr),vt3(nx ,ny ,nz,2,nr_tr))
      allocate(wt3(nx ,ny ,nz,2,nr_tr))
 endif
 if (diag_potential_vorticity) then
      allocate(rv(nx ,ny ,nz),pv(nx ,ny ,nz))
      allocate(qmean(nx ,ny ,nz),qvar(nx ,ny ,nz),q3(nx ,ny ,nz))
      allocate(uq(nx ,ny ,nz,2),vq(nx ,ny ,nz,2))
      allocate(uqq(nx ,ny ,nz,2),vqq(nx ,ny ,nz,2))
      allocate(wq(nx ,ny ,nz,2),wqq(nx ,ny ,nz,2))
      allocate(uq3(nx ,ny ,nz,2),vq3(nx ,ny ,nz,2))
      allocate(wq3(nx ,ny ,nz,2))
 endif
      inquire( FILE='restart_ave.dta', EXIST=file_exists )
      if (file_exists) then 
       call read_time_averages_restart(ierr)
      else
       if (my_pe==0) print*,' cannot find restart file '
       nitts=0
       umean=0;vmean=0;wmean=0;bmean=0;pmean=0
       uvar=0;vvar=0;wvar=0;bvar=0;pvar=0; uv=0.;b3=0
 if (diag_eddy_fluxes) then
       ub=0;vb=0;wb=0; ubb=0;vbb=0;wbb=0
       ub3=0;vb3=0;wb3=0.
 endif
 if (diag_eddy_flux_tendency) then
       bpx=0;bpy=0;bfv=0;bfu=0;uwN=0;vwN=0
 endif
       do n=1,nr_tr
        tmean(:,:,:,n)=0;tvar(:,:,:,n)=0;t3(:,:,:,n)=0
 if (diag_eddy_fluxes) then
        ut(:,:,:,:,n)=0;vt(:,:,:,:,n)=0;wt(:,:,:,:,n)=0; 
        utt(:,:,:,:,n)=0;vtt(:,:,:,:,n)=0;wtt(:,:,:,:,n)=0
        ut3(:,:,:,:,n)=0;vt3(:,:,:,:,n)=0;wt3(:,:,:,:,n)=0
 endif
       enddo
 if (diag_potential_vorticity) then
       qmean=0;qvar=0;q3=0
       uq=0;vq=0;wq=0;wqq=0;uqq=0;vqq=0
       vq3=0;uq3=0;wq3=0
 endif
      endif
      if (my_pe==0) print*,' Done initializing time averaging module'
end subroutine init_time_averages


subroutine read_time_averages_restart(ierr)
!=======================================================================
!       read restart
!=======================================================================
      use pyOM_module   
      use time_averages_module
      implicit none
      integer, intent(out) :: ierr
      integer :: io,n,j,k,nx_,ny_,nz_

       ierr=0
       if (my_pe==0) then 
         print*,' reading data from restart file '
         call get_free_iounit(io,ierr)
         if (ierr/=0) goto 10
         open(io,file='restart_ave.dta',form='unformatted',status='old',err=10)
         read(io,err=10) nx_,ny_,nz_
         if (nx/=nx_ .or. ny/=ny_ .or. nz/= nz_) then 
          print*,' read from restart dimensions: ',nx_,ny_,nz_
          print*,' does not match dimensions   : ',nx,ny,nz
          goto 10
         endif
         read(io,err=10) nitts 
         print*,' number of itts = ',nitts
         do j=1,ny 
          read(io,err=10) umean(:,j,:), vmean(:,j,:), wmean(:,j,:)
          read(io,err=10) bmean(:,j,:), pmean(:,j,:)
          read(io,err=10) uvar(:,j,:), vvar(:,j,:), wvar(:,j,:)
          read(io,err=10) bvar(:,j,:), pvar(:,j,:),uv(:,j,:,:),b3(:,j,:)
 if (diag_eddy_fluxes) then
          read(io,err=10) ub(:,j,:,:), vb(:,j,:,:), wb(:,j,:,:)
          read(io,err=10) ubb(:,j,:,:),vbb(:,j,:,:),wbb(:,j,:,:)
          read(io,err=10) ub3(:,j,:,:),vb3(:,j,:,:),wb3(:,j,:,:)
 endif
 if (diag_eddy_flux_tendency) then
          read(io,err=10) bpx(:,j,:,:),bpy(:,j,:,:)
          read(io,err=10) bfv(:,j,:,:),bfu(:,j,:,:)
          read(io,err=10) uwN(:,j,:,:),vwN(:,j,:,:)
 endif
          do n=1,nr_tr
           read(io,err=10) tmean(:,j,:,n), tvar(:,j,:,n),t3(:,j,:,n)
 if (diag_eddy_fluxes) then
           read(io,err=10) ut(:,j,:,:,n), vt(:,j,:,:,n), wt(:,j,:,:,n)
           read(io,err=10) utt(:,j,:,:,n),vtt(:,j,:,:,n),wtt(:,j,:,:,n)
           read(io,err=10) ut3(:,j,:,:,n),vt3(:,j,:,:,n),wt3(:,j,:,:,n)
 endif
         enddo
 if (diag_potential_vorticity) then
          read(io,err=10) qmean(:,j,:), qvar(:,j,:),q3(:,j,:)
          read(io,err=10) uq(:,j,:,:), vq(:,j,:,:), wq(:,j,:,:)
          read(io,err=10) uqq(:,j,:,:),vqq(:,j,:,:),wqq(:,j,:,:)
          read(io,err=10) uq3(:,j,:,:),vq3(:,j,:,:),wq3(:,j,:,:)
 endif
         enddo
         goto 20
 10      ierr=-1
         print*,' error while reading restart'
 20      print*,' done reading restart'
         close(io)
       endif

      call pe0_send_int(ierr)
      if (ierr/=0) return

      call pe0_send_int(nitts)
      call pe0_send_3d(nx,ny,nz,umean)
      call pe0_send_3d(nx,ny,nz,vmean)
      call pe0_send_3d(nx,ny,nz,wmean)
      call pe0_send_3d(nx,ny,nz,pmean)
      call pe0_send_3d(nx,ny,nz,bmean)
      call pe0_send_3d(nx,ny,nz,uvar)
      call pe0_send_3d(nx,ny,nz,vvar)
      call pe0_send_3d(nx,ny,nz,wvar)
      call pe0_send_3d(nx,ny,nz,bvar)
      call pe0_send_3d(nx,ny,nz,pvar)
      call pe0_send_3d(nx,ny,nz,uv)
      call pe0_send_3d(nx,ny,nz,b3)
 if (diag_eddy_fluxes) then
     do n=1,2
      call pe0_send_3d(nx,ny,nz,ub(:,:,:,n))
      call pe0_send_3d(nx,ny,nz,vb(:,:,:,n))
      call pe0_send_3d(nx,ny,nz,wb(:,:,:,n))
      call pe0_send_3d(nx,ny,nz,ubb(:,:,:,n))
      call pe0_send_3d(nx,ny,nz,vbb(:,:,:,n))
      call pe0_send_3d(nx,ny,nz,wbb(:,:,:,n))
      call pe0_send_3d(nx,ny,nz,ub3(:,:,:,n))
      call pe0_send_3d(nx,ny,nz,vb3(:,:,:,n))
      call pe0_send_3d(nx,ny,nz,wb3(:,:,:,n))
      do k=1,nr_tr
        call pe0_send_3d(nx,ny,nz,ut(:,:,:,n,k))
        call pe0_send_3d(nx,ny,nz,vt(:,:,:,n,k))
        call pe0_send_3d(nx,ny,nz,wt(:,:,:,n,k))
        call pe0_send_3d(nx,ny,nz,utt(:,:,:,n,k))
        call pe0_send_3d(nx,ny,nz,vtt(:,:,:,n,k))
        call pe0_send_3d(nx,ny,nz,wtt(:,:,:,n,k))
        call pe0_send_3d(nx,ny,nz,ut3(:,:,:,n,k))
        call pe0_send_3d(nx,ny,nz,vt3(:,:,:,n,k))
        call pe0_send_3d(nx,ny,nz,wt3(:,:,:,n,k))
      enddo
     enddo
 endif
 if (diag_eddy_flux_tendency) then
     do n=1,3
      call pe0_send_3d(nx,ny,nz,bpx(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,bpy(:,:,:,n) )
     enddo
     do n=1,6
      call pe0_send_3d(nx,ny,nz,bfv(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,bfu(:,:,:,n) )
     enddo
     do n=1,4
      call pe0_send_3d(nx,ny,nz,uwN(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,vwN(:,:,:,n) )
     enddo
 endif
 if (diag_potential_vorticity) then
      call pe0_send_3d(nx,ny,nz,qmean)
      call pe0_send_3d(nx,ny,nz,qvar)
      call pe0_send_3d(nx,ny,nz,q3)
     do n=1,2
      call pe0_send_3d(nx,ny,nz,uq(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,vq(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,wq(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,uqq(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,vqq(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,wqq(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,uq3(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,vq3(:,:,:,n) )
      call pe0_send_3d(nx,ny,nz,wq3(:,:,:,n) )
     enddo
 endif
end subroutine read_time_averages_restart



subroutine write_time_averages_restart(ierr)
!=======================================================================
!       write restart
!=======================================================================
      use pyOM_module   
      use time_averages_module
      implicit none
      integer, intent(out) :: ierr
      integer :: io,n,j,k

      ierr=0
      call pe0_recv_3d(nx,ny,nz,umean)
      call pe0_recv_3d(nx,ny,nz,vmean)
      call pe0_recv_3d(nx,ny,nz,wmean)
      call pe0_recv_3d(nx,ny,nz,pmean)
      call pe0_recv_3d(nx,ny,nz,bmean)
      call pe0_recv_3d(nx,ny,nz,uvar)
      call pe0_recv_3d(nx,ny,nz,vvar)
      call pe0_recv_3d(nx,ny,nz,wvar)
      call pe0_recv_3d(nx,ny,nz,bvar)
      call pe0_recv_3d(nx,ny,nz,pvar)
      call pe0_recv_3d(nx,ny,nz,uv)
      call pe0_recv_3d(nx,ny,nz,b3)
 if (diag_eddy_fluxes) then
     do n=1,2
      call pe0_recv_3d(nx,ny,nz,ub(:,:,:,n))
      call pe0_recv_3d(nx,ny,nz,vb(:,:,:,n))
      call pe0_recv_3d(nx,ny,nz,wb(:,:,:,n))
      call pe0_recv_3d(nx,ny,nz,ubb(:,:,:,n))
      call pe0_recv_3d(nx,ny,nz,vbb(:,:,:,n))
      call pe0_recv_3d(nx,ny,nz,wbb(:,:,:,n))
      call pe0_recv_3d(nx,ny,nz,ub3(:,:,:,n))
      call pe0_recv_3d(nx,ny,nz,vb3(:,:,:,n))
      call pe0_recv_3d(nx,ny,nz,wb3(:,:,:,n))
      do k=1,nr_tr
        call pe0_recv_3d(nx,ny,nz,ut(:,:,:,n,k))
        call pe0_recv_3d(nx,ny,nz,vt(:,:,:,n,k))
        call pe0_recv_3d(nx,ny,nz,wt(:,:,:,n,k))
        call pe0_recv_3d(nx,ny,nz,utt(:,:,:,n,k))
        call pe0_recv_3d(nx,ny,nz,vtt(:,:,:,n,k))
        call pe0_recv_3d(nx,ny,nz,wtt(:,:,:,n,k))
        call pe0_recv_3d(nx,ny,nz,ut3(:,:,:,n,k))
        call pe0_recv_3d(nx,ny,nz,vt3(:,:,:,n,k))
        call pe0_recv_3d(nx,ny,nz,wt3(:,:,:,n,k))
      enddo
     enddo
 endif
 if (diag_eddy_flux_tendency) then
     do n=1,3
      call pe0_recv_3d(nx,ny,nz,bpx(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,bpy(:,:,:,n) )
     enddo
     do n=1,6
      call pe0_recv_3d(nx,ny,nz,bfv(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,bfu(:,:,:,n) )
     enddo
     do n=1,4
      call pe0_recv_3d(nx,ny,nz,uwN(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,vwN(:,:,:,n) )
     enddo
 endif
 if (diag_potential_vorticity) then
      call pe0_recv_3d(nx,ny,nz,qmean)
      call pe0_recv_3d(nx,ny,nz,qvar)
      call pe0_recv_3d(nx,ny,nz,q3)
     do n=1,2
      call pe0_recv_3d(nx,ny,nz,uq(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,vq(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,wq(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,uqq(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,vqq(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,wqq(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,uq3(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,vq3(:,:,:,n) )
      call pe0_recv_3d(nx,ny,nz,wq3(:,:,:,n) )
     enddo
 endif

      if (my_pe==0) then
       print*,' writing restart file for time averages'
       call get_free_iounit(io,ierr)
       if (ierr/=0) goto 10
       open(io,file='restart_ave.dta', form='unformatted',status='unknown',err=10)
       write(io,err=10) nx,ny,nz
       write(io,err=10) nitts
       do j=1,ny
        write(io,err=10) umean(:,j,:),vmean(:,j,:),wmean(:,j,:)
        write(io,err=10) bmean(:,j,:),pmean(:,j,:)
        write(io,err=10) uvar(:,j,:),vvar(:,j,:),wvar(:,j,:)
        write(io,err=10) bvar(:,j,:),pvar(:,j,:),uv(:,j,:,:),b3(:,j,:)
 if (diag_eddy_fluxes) then
        write(io,err=10)  ub(:,j,:,:), vb(:,j,:,:), wb(:,j,:,:)
        write(io,err=10) ubb(:,j,:,:),vbb(:,j,:,:),wbb(:,j,:,:)
        write(io,err=10) ub3(:,j,:,:),vb3(:,j,:,:),wb3(:,j,:,:)
 endif
 if (diag_eddy_flux_tendency) then
        write(io,err=10) bpx(:,j,:,:),bpy(:,j,:,:)
        write(io,err=10) bfv(:,j,:,:),bfu(:,j,:,:)
        write(io,err=10) uwN(:,j,:,:),vwN(:,j,:,:)
 endif
        do k=1,nr_tr
         write(io,err=10) tmean(:,j,:,k),tvar(:,j,:,k),t3(:,j,:,k)
 if (diag_eddy_fluxes) then
         write(io,err=10)  ut(:,j,:,:,k), vt(:,j,:,:,k), wt(:,j,:,:,k)
         write(io,err=10) utt(:,j,:,:,k),vtt(:,j,:,:,k),wtt(:,j,:,:,k)
         write(io,err=10) ut3(:,j,:,:,k),vt3(:,j,:,:,k),wt3(:,j,:,:,k)
 endif
        enddo
 if (diag_potential_vorticity) then
        write(io,err=10)  qmean(:,j,:), qvar(:,j,:), q3(:,j,:)
        write(io,err=10)  uq(:,j,:,:), vq(:,j,:,:), wq(:,j,:,:)
        write(io,err=10) uqq(:,j,:,:),vqq(:,j,:,:),wqq(:,j,:,:)
        write(io,err=10) uq3(:,j,:,:),vq3(:,j,:,:),wq3(:,j,:,:)
 endif
       enddo
       close(io)
       print*,' done '
      endif
      return
 10   ierr=-1
      if (my_pe==0) print*,' error while writing time averages restart '
end subroutine write_time_averages_restart


 subroutine time_averages
!=======================================================================
!        Hauptverteiler function fuer time averages
!=======================================================================
      use pyOM_module   
      use time_averages_module
      implicit none
      integer :: i,j,k,js,je
      real*8 :: fxa
!
!        first calculate auxilliary variables
!
 js=max(2,js_pe); je = min(je_pe,ny -1)

 if  (remove_back_stratification) then
    do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         bs(i,j,k)=b(i,j,k,tau)-b_r(k)
         ps(i,j,k)=p_full(i,j,k,tau)-p_r(k)
        enddo
       enddo
    enddo
 else
    do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         bs(i,j,k)=b(i,j,k,tau)
         ps(i,j,k)=p_full(i,j,k,tau)
        enddo
       enddo
    enddo

    if (enable_back_state) then
       do k=2,nz-1
        do j=js,je 
         do i=2,nx -1
          bs(i,j,k)=bs(i,j,k)+back(i,j,k,tau)
         enddo
        enddo
       enddo
    endif
 endif

 call border_exchg3D(nx,ny,nz,bs,1); call setcyclic3D(nx,ny,nz,bs)
 call border_exchg3D(nx,ny,nz,ps,1); call setcyclic3D(nx,ny,nz,ps)

 if (diag_potential_vorticity) then
!
!       relative potential vorticity
!
      rv=0.0
      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
          rv(i,j,k)=  (v(i+1,j,k,tau)-v(i,j,k,tau) )/dx*maskU(i,j,k)  &
            -(u(i,j+1,k,tau)-u(i,j,k,tau) )/dx*maskV(i,j,k)
        enddo 
       enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,rv,1); call setcyclic3D(nx,ny,nz,rv)
!
!       Ertel potential vorticity  Q N0^2 = b_z (v_x-u_y + f) + u_z b_y - v_z b_x
!
      pv=0.
      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
         fxa= (rv(i,j,k)+rv(i-1,j,k)+rv(i,j-1,k)+rv(i-1,j-1,k))/4.0
         pv(i,j,k)=(fxa+coriolis_t(j)  )*  ((b(i,j,k+1,tau)-b(i,j,k,tau))/dz*maskW(i,j,k)  &
          +(b(i,j,k,tau)-b(i,j,k-1,tau))/dz*maskW(i,j,k-1))/  (maskW(i,j,k)+maskW(i,j,k-1)+epsln) 
         pv(i,j,k)=-N_0**(-2)*pv(i,j,k)
        enddo 
       enddo 
      enddo 
      if (enable_back_state) then
       do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          fxa= (rv(i,j,k)+rv(i-1,j,k)+rv(i,j-1,k)+rv(i-1,j-1,k))/4.0
          pv(i,j,k)=-pv(i,j,k)*N_0**2
          pv(i,j,k)=pv(i,j,k)+ &
            (fxa+coriolis_t(j)  )*  ((back(i,j,k+1,tau)-back(i,j,k,tau))/dz*maskW(i,j,k)  &
           +(back(i,j,k,tau)-back(i,j,k-1,tau))/dz*maskW(i,j,k-1))/  (maskW(i,j,k)+maskW(i,j,k-1)+epsln) 
          pv(i,j,k)=-N_0**(-2)*pv(i,j,k)
         enddo 
        enddo 
       enddo 
      endif
      call border_exchg3D(nx,ny,nz,pv,1); call setcyclic3D(nx,ny,nz,pv)
 endif
!
!       average
!
      nitts=nitts+1      
      call time_averages_means
      call time_averages_eddy_fluxes
      call time_averages_flux_tendency
!
!        write results and restart file
!
 end subroutine time_averages


 subroutine time_averages_means
!=======================================================================
!       sum up the mean variables
!=======================================================================
      use pyOM_module   
      use time_averages_module
      use fcontrol_module
      implicit none
      integer :: i,j,k,js,je
      js=max(2,js_pe); je = min(je_pe,ny -1)
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         umean(i,j,k)=umean(i,j,k)+u(i,j,k,tau)
         vmean(i,j,k)=vmean(i,j,k)+v(i,j,k,tau)
         wmean(i,j,k)=wmean(i,j,k)+w(i,j,k,tau)
         bmean(i,j,k)=bmean(i,j,k)+bs(i,j,k)
         pmean(i,j,k)=pmean(i,j,k)+ps(i,j,k)
         uvar(i,j,k) =uvar(i,j,k) +u(i,j,k,tau)**2
         vvar(i,j,k) =vvar(i,j,k) +v(i,j,k,tau)**2
         wvar(i,j,k) =wvar(i,j,k) +w(i,j,k,tau)**2
         bvar(i,j,k) =bvar(i,j,k) +bs(i,j,k)**2
         b3(i,j,k)    =b3(i,j,k) +bs(i,j,k)**3
         pvar(i,j,k) =pvar(i,j,k) +ps(i,j,k)**2
         uv(i,j,k,1) =uv(i,j,k,1) +u(i  ,j,k,tau)*v(i,j  ,k,tau)
         uv(i,j,k,2) =uv(i,j,k,2) +u(i-1,j,k,tau)*v(i,j  ,k,tau)
         uv(i,j,k,3) =uv(i,j,k,3) +u(i  ,j,k,tau)*v(i,j-1,k,tau)
         uv(i,j,k,4) =uv(i,j,k,4) +u(i-1,j,k,tau)*v(i,j-1,k,tau)
        enddo
       enddo
      enddo
 if (enable_diag_tracer) then
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         tmean(i,j,k,:)=tmean(i,j,k,:)+tr(i,j,k,tau,:)
         tvar(i,j,k,:)=tvar(i,j,k,:)+tr(i,j,k,tau,:)**2
         t3(i,j,k,:)=t3(i,j,k,:)+tr(i,j,k,tau,:)**3
        enddo
       enddo
      enddo
 endif
 if (diag_potential_vorticity) then
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         qmean(i,j,k)=qmean(i,j,k)+pv(i,j,k)
         qvar(i,j,k)=qvar(i,j,k)+pv(i,j,k)**2
         q3(i,j,k)=q3(i,j,k)+pv(i,j,k)**3
        enddo
       enddo
      enddo
 endif
end subroutine time_averages_means


subroutine time_averages_eddy_fluxes
!=======================================================================
!       sum up the eddy and variance fluxes 
!=======================================================================
      use pyOM_module   
      use time_averages_module
      use fcontrol_module
      implicit none
      integer :: i,j,k,js,je

 if (diag_eddy_fluxes) then
      js=max(2,js_pe); je = min(je_pe,ny -1)
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
!        buoyancy eddy fluxes
          ub(i,j,k,1) =ub(i,j,k,1) +u(i,j,k,tau)*bs(i  ,j,k)          
          ub(i,j,k,2) =ub(i,j,k,2) +u(i,j,k,tau)*bs(i+1,j,k)          
          vb(i,j,k,1) =vb(i,j,k,1) +v(i,j,k,tau)*bs(i,j  ,k)          
          vb(i,j,k,2) =vb(i,j,k,2) +v(i,j,k,tau)*bs(i,j+1,k)          
          wb(i,j,k,1) =wb(i,j,k,1) +w(i,j,k,tau)*bs(i,j,k  )          
          wb(i,j,k,2) =wb(i,j,k,2) +w(i,j,k,tau)*bs(i,j,k+1)          
!        buoyancy variance fluxes
          ubb(i,j,k,1)=ubb(i,j,k,1)+u(i,j,k,tau)*bs(i  ,j,k)**2
          ubb(i,j,k,2)=ubb(i,j,k,2)+u(i,j,k,tau)*bs(i+1,j,k)**2
          vbb(i,j,k,1)=vbb(i,j,k,1)+v(i,j,k,tau)*bs(i,j  ,k)**2
          vbb(i,j,k,2)=vbb(i,j,k,2)+v(i,j,k,tau)*bs(i,j+1,k)**2
          wbb(i,j,k,1)=wbb(i,j,k,1)+w(i,j,k,tau)*bs(i,j,k  )**2
          wbb(i,j,k,2)=wbb(i,j,k,2)+w(i,j,k,tau)*bs(i,j,k+1)**2
!        third order fluxes
          ub3(i,j,k,1)=ub3(i,j,k,1)+u(i,j,k,tau)*bs(i  ,j,k)**3
          ub3(i,j,k,2)=ub3(i,j,k,2)+u(i,j,k,tau)*bs(i+1,j,k)**3
          vb3(i,j,k,1)=vb3(i,j,k,1)+v(i,j,k,tau)*bs(i,j  ,k)**3
          vb3(i,j,k,2)=vb3(i,j,k,2)+v(i,j,k,tau)*bs(i,j+1,k)**3
          wb3(i,j,k,1)=wb3(i,j,k,1)+w(i,j,k,tau)*bs(i,j,k  )**3
          wb3(i,j,k,2)=wb3(i,j,k,2)+w(i,j,k,tau)*bs(i,j,k+1)**3
        enddo
       enddo
      enddo
 if (enable_diag_tracer) then
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
!        tracer eddy fluxes
          ut(i,j,k,1,:) =ut(i,j,k,1,:) +u(i,j,k,tau)*tr(i  ,j,k,tau,:)          
          ut(i,j,k,2,:) =ut(i,j,k,2,:) +u(i,j,k,tau)*tr(i+1,j,k,tau,:)          
          vt(i,j,k,1,:) =vt(i,j,k,1,:) +v(i,j,k,tau)*tr(i,j  ,k,tau,:)          
          vt(i,j,k,2,:) =vt(i,j,k,2,:) +v(i,j,k,tau)*tr(i,j+1,k,tau,:)          
          wt(i,j,k,1,:) =wt(i,j,k,1,:)+w(i,j,k,tau)*tr(i,j,k  ,tau,:)          
          wt(i,j,k,2,:) =wt(i,j,k,2,:)+w(i,j,k,tau)*tr(i,j,k+1,tau,:)          
!        tracer variance fluxes
          utt(i,j,k,1,:)=utt(i,j,k,1,:)       +u(i,j,k,tau)*tr(i  ,j,k,tau,:)**2
          utt(i,j,k,2,:)=utt(i,j,k,2,:)       +u(i,j,k,tau)*tr(i+1,j,k,tau,:)**2
          vtt(i,j,k,1,:)=vtt(i,j,k,1,:)       +v(i,j,k,tau)*tr(i,j  ,k,tau,:)**2
          vtt(i,j,k,2,:)=vtt(i,j,k,2,:)       +v(i,j,k,tau)*tr(i,j+1,k,tau,:)**2
          wtt(i,j,k,1,:)=wtt(i,j,k,1,:)       +w(i,j,k,tau)*tr(i,j,k  ,tau,:)**2
          wtt(i,j,k,2,:)=wtt(i,j,k,2,:)       +w(i,j,k,tau)*tr(i,j,k+1,tau,:)**2
!        third order fluxes
          ut3(i,j,k,1,:)=ut3(i,j,k,1,:)      +u(i,j,k,tau)*tr(i  ,j,k,tau,:)**3
          ut3(i,j,k,2,:)=ut3(i,j,k,2,:)      +u(i,j,k,tau)*tr(i+1,j,k,tau,:)**3
          vt3(i,j,k,1,:)=vt3(i,j,k,1,:)      +v(i,j,k,tau)*tr(i,j  ,k,tau,:)**3
          vt3(i,j,k,2,:)=vt3(i,j,k,2,:)      +v(i,j,k,tau)*tr(i,j+1,k,tau,:)**3
          wt3(i,j,k,1,:)=wt3(i,j,k,1,:)      +w(i,j,k,tau)*tr(i,j,k  ,tau,:)**3
          wt3(i,j,k,2,:)=wt3(i,j,k,2,:)      +w(i,j,k,tau)*tr(i,j,k+1,tau,:)**3
        enddo
       enddo
      enddo
 endif
 if (diag_potential_vorticity) then
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
!        pv eddy fluxes
          uq(i,j,k,1) =uq(i,j,k,1) +u(i,j,k,tau)*pv(i  ,j,k)          
          uq(i,j,k,2) =uq(i,j,k,2) +u(i,j,k,tau)*pv(i+1,j,k)          
          vq(i,j,k,1) =vq(i,j,k,1) +v(i,j,k,tau)*pv(i,j  ,k)          
          vq(i,j,k,2) =vq(i,j,k,2) +v(i,j,k,tau)*pv(i,j+1,k)          
          wq(i,j,k,1) =wq(i,j,k,1) +w(i,j,k,tau)*pv(i,j,k  )          
          wq(i,j,k,2) =wq(i,j,k,2) +w(i,j,k,tau)*pv(i,j,k+1)          
!        pv variance fluxes
          uqq(i,j,k,1)=uqq(i,j,k,1)+u(i,j,k,tau)*pv(i  ,j,k)**2
          uqq(i,j,k,2)=uqq(i,j,k,2)+u(i,j,k,tau)*pv(i+1,j,k)**2
          vqq(i,j,k,1)=vqq(i,j,k,1)+v(i,j,k,tau)*pv(i,j  ,k)**2
          vqq(i,j,k,2)=vqq(i,j,k,2)+v(i,j,k,tau)*pv(i,j+1,k)**2
          wqq(i,j,k,1)=wqq(i,j,k,1)+w(i,j,k,tau)*pv(i,j,k  )**2
          wqq(i,j,k,2)=wqq(i,j,k,2)+w(i,j,k,tau)*pv(i,j,k+1)**2
!        third order fluxes
          uq3(i,j,k,1)=uq3(i,j,k,1)+u(i,j,k,tau)*pv(i  ,j,k)**3
          uq3(i,j,k,2)=uq3(i,j,k,2)+u(i,j,k,tau)*pv(i+1,j,k)**3
          vq3(i,j,k,1)=vq3(i,j,k,1)+v(i,j,k,tau)*pv(i,j  ,k)**3
          vq3(i,j,k,2)=vq3(i,j,k,2)+v(i,j,k,tau)*pv(i,j+1,k)**3
          wq3(i,j,k,1)=wq3(i,j,k,1)+w(i,j,k,tau)*pv(i,j,k  )**3
          wq3(i,j,k,2)=wq3(i,j,k,2)+w(i,j,k,tau)*pv(i,j,k+1)**3
        enddo
       enddo
      enddo
 endif
 endif
end subroutine time_averages_eddy_fluxes



subroutine time_averages_flux_tendency
!=======================================================================
!        flux tendencies
!=======================================================================
      use pyOM_module   
      use time_averages_module
      implicit none
      integer :: i,j,k,js,je
      js=max(2,js_pe); je = min(je_pe,ny -1)

 if (diag_eddy_flux_tendency) then
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         bpx(i,j,k,1)=bpx(i,j,k,1)+bs(i  ,j,k)*ps(i  ,j,k)
         bpx(i,j,k,2)=bpx(i,j,k,2)+bs(i+1,j,k)*ps(i  ,j,k)
         bpx(i,j,k,3)=bpx(i,j,k,3)+bs(i  ,j,k)*ps(i+1,j,k)

         bpy(i,j,k,1)=bpy(i,j,k,1)+bs(i,j  ,k)*ps(i,j  ,k)
         bpy(i,j,k,2)=bpy(i,j,k,2)+bs(i,j+1,k)*ps(i,j  ,k)
         bpy(i,j,k,3)=bpy(i,j,k,3)+bs(i,j  ,k)*ps(i,j+1,k)

         bfv(i,j,k,1)=bfv(i,j,k,1) + bs(i  ,j,k)*v(i  ,j  ,k,tau)
         bfv(i,j,k,2)=bfv(i,j,k,2) + bs(i+1,j,k)*v(i  ,j  ,k,tau)
         bfv(i,j,k,3)=bfv(i,j,k,3) + bs(i  ,j,k)*v(i+1,j  ,k,tau)
         bfv(i,j,k,4)=bfv(i,j,k,4) + bs(i  ,j,k)*v(i  ,j-1,k,tau)
         bfv(i,j,k,5)=bfv(i,j,k,5) + bs(i+1,j,k)*v(i  ,j-1,k,tau)
         bfv(i,j,k,6)=bfv(i,j,k,6) + bs(i  ,j,k)*v(i+1,j-1,k,tau)

         bfu(i,j,k,1)=bfu(i,j,k,1) + bs(i,j  ,k)*u(i  ,j  ,k,tau)
         bfu(i,j,k,2)=bfu(i,j,k,2) + bs(i,j+1,k)*u(i  ,j  ,k,tau)
         bfu(i,j,k,3)=bfu(i,j,k,3) + bs(i,j  ,k)*u(i  ,j+1,k,tau)
         bfu(i,j,k,4)=bfu(i,j,k,4) + bs(i,j  ,k)*u(i-1,j  ,k,tau)
         bfu(i,j,k,5)=bfu(i,j,k,5) + bs(i,j+1,k)*u(i-1,j  ,k,tau)
         bfu(i,j,k,6)=bfu(i,j,k,6) + bs(i,j  ,k)*u(i-1,j+1,k,tau)

         uwN(i,j,k,1)=uwN(i,j,k,1) + u(i,j,k,tau)*w(i  ,j,k  ,tau)
         uwN(i,j,k,2)=uwN(i,j,k,2) + u(i,j,k,tau)*w(i+1,j,k  ,tau)
         uwN(i,j,k,3)=uwN(i,j,k,3) + u(i,j,k,tau)*w(i  ,j,k-1,tau)
         uwN(i,j,k,4)=uwN(i,j,k,4) + u(i,j,k,tau)*w(i+1,j,k-1,tau)

         vwN(i,j,k,1)=vwN(i,j,k,1) + v(i,j,k,tau)*w(i,j  ,k  ,tau)
         vwN(i,j,k,2)=vwN(i,j,k,2) + v(i,j,k,tau)*w(i,j+1,k  ,tau)
         vwN(i,j,k,3)=vwN(i,j,k,3) + v(i,j,k,tau)*w(i,j  ,k-1,tau)
         vwN(i,j,k,4)=vwN(i,j,k,4) + v(i,j,k,tau)*w(i,j+1,k-1,tau)
        enddo
       enddo
      enddo
 endif
end subroutine time_averages_flux_tendency



 subroutine time_averages_calc
!=======================================================================
!        calculate time mean diagnostics
!=======================================================================
      use pyOM_module   
      use time_averages_module
      implicit none
      integer :: i,j,k,js,je,n,m
      js=max(2,js_pe); je = min(je_pe,ny -1)
!
!        calculate means
!
      n=max(1,nitts)
      umean=umean*maskU/n
      vmean=vmean*maskV/n
      wmean=wmean*maskW/n
      bmean=bmean*maskT/n
      pmean=pmean*maskT/n
      call border_exchg3D(nx,ny,nz,bmean,1); call setcyclic3D(nx,ny,nz,bmean)
      call border_exchg3D(nx,ny,nz,pmean,1); call setcyclic3D(nx,ny,nz,pmean)
      call border_exchg3D(nx,ny,nz,umean,1); call setcyclic3D(nx,ny,nz,umean)
      call border_exchg3D(nx,ny,nz,vmean,1); call setcyclic3D(nx,ny,nz,vmean)
      do k=1,nr_tr
       tmean(:,:,:,k)=tmean(:,:,:,k)*maskT/n
       call border_exchg3D(nx,ny,nz,tmean(:,:,:,k),1)
       call setcyclic3D(nx,ny,nz,tmean(:,:,:,k))
      enddo
 if (diag_potential_vorticity) then
      qmean=qmean*maskT/n
      call border_exchg3D(nx,ny,nz,qmean,1); call setcyclic3D(nx,ny,nz,qmean)
 endif
!
!       Variances
!
      uvar=uvar/n - umean**2
      vvar=vvar/n - vmean**2
      wvar=wvar/n - wmean**2
      bvar=bvar/n - bmean**2
      pvar=pvar/n - pmean**2
!  (b+b')(b+b')(b+b')=(b^2 + 2bb'+b'^2)(b+b')=b^3 + 2b^2b'+b'^2 b + b^2b'+2bb'^2+b'^3=b^3 + 3bb'^2+b'^3
      b3=b3/n - bmean**3-3*bmean*bvar
      do k=1,nr_tr
       tvar(:,:,:,k)=tvar(:,:,:,k)/n - tmean(:,:,:,k)**2
       t3(:,:,:,k)=t3(:,:,:,k)/n - tmean(:,:,:,k)**3 -3*tmean(:,:,:,k)*tvar(:,:,:,k)
      enddo
 if (diag_potential_vorticity) then
      qvar=qvar/n - qmean**2
      q3=q3/n - qmean**3-3*qmean*qvar
 endif

      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         uv(i,j,k,1)=uv(i,j,k,1)/n +umean(i  ,j,k)*vmean(i,j  ,k)
         uv(i,j,k,2)=uv(i,j,k,2)/n +umean(i-1,j,k)*vmean(i,j  ,k)
         uv(i,j,k,3)=uv(i,j,k,3)/n +umean(i  ,j,k)*vmean(i,j-1,k)
         uv(i,j,k,4)=uv(i,j,k,4)/n +umean(i-1,j,k)*vmean(i,j-1,k)
         uv(i,j,k,1)=(uv(i,j,k,1)+uv(i,j,k,2)    +uv(i,j,k,3)+uv(i,j,k,4))/4.0
        enddo
       enddo
      enddo

 if (diag_eddy_fluxes) then
!
!       Eddy fluxes
!
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
!       buoyancy
         ub(i,j,k,1)=ub(i,j,k,1)/n-umean(i,j,k)*bmean(i ,j,k)
         ub(i,j,k,2)=ub(i,j,k,2)/n-umean(i,j,k)*bmean(i+1,j,k)
         vb(i,j,k,1)=vb(i,j,k,1)/n-vmean(i,j,k)*bmean(i,j,k)
         vb(i,j,k,2)=vb(i,j,k,2)/n-vmean(i,j,k)*bmean(i,j+1,k)
         wb(i,j,k,1)=wb(i,j,k,1)/n-wmean(i,j,k)*bmean(i,j,k)
         wb(i,j,k,2)=wb(i,j,k,2)/n-wmean(i,j,k)*bmean(i,j,k+1)
        enddo
       enddo
      enddo

      do m=1,nr_tr
       do k=2,nz-1
        do j=js,je 
         do i=2,nx -1
!       tracer
          ut(i,j,k,1,m)=ut(i,j,k,1,m)/n-umean(i,j,k)*tmean(i,j,k,m)
          ut(i,j,k,2,m)=ut(i,j,k,2,m)/n-umean(i,j,k)*tmean(i+1,j,k,m)
          vt(i,j,k,1,m)=vt(i,j,k,1,m)/n-vmean(i,j,k)*tmean(i,j,k,m)
          vt(i,j,k,2,m)=vt(i,j,k,2,m)/n-vmean(i,j,k)*tmean(i,j+1,k,m)
          wt(i,j,k,1,m)=wt(i,j,k,1,m)/n-wmean(i,j,k)*tmean(i,j,k,m)
          wt(i,j,k,2,m)=wt(i,j,k,2,m)/n-wmean(i,j,k)*tmean(i,j,k+1,m)
         enddo
        enddo
       enddo
      enddo
 if (diag_potential_vorticity) then
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
!       pv
         uq(i,j,k,1)=uq(i,j,k,1)/n-umean(i,j,k)*qmean(i ,j,k)
         uq(i,j,k,2)=uq(i,j,k,2)/n-umean(i,j,k)*qmean(i+1,j,k)
         vq(i,j,k,1)=vq(i,j,k,1)/n-vmean(i,j,k)*qmean(i,j,k)
         vq(i,j,k,2)=vq(i,j,k,2)/n-vmean(i,j,k)*qmean(i,j+1,k)
         wq(i,j,k,1)=wq(i,j,k,1)/n-wmean(i,j,k)*qmean(i,j,k)
         wq(i,j,k,2)=wq(i,j,k,2)/n-wmean(i,j,k)*qmean(i,j,k+1)
        enddo
       enddo
      enddo
 endif
!
!       Variance fluxes
!
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
!       buoyancy
         ubb(i,j,k,1)=ubb(i,j,k,1)/n-umean(i,j,k)*bmean(i,j,k)**2     -2*bmean(i  ,j,k)*ub(i,j,k,1)
         ubb(i,j,k,2)=ubb(i,j,k,2)/n-umean(i,j,k)*bmean(i+1,j,k)**2   -2*bmean(i+1,j,k)*ub(i,j,k,2)
         vbb(i,j,k,1)=vbb(i,j,k,1)/n-vmean(i,j,k)*bmean(i,j,k)**2     -2*bmean(i,j  ,k)*vb(i,j,k,1)
         vbb(i,j,k,2)=vbb(i,j,k,2)/n-vmean(i,j,k)*bmean(i,j+1,k)**2   -2*bmean(i,j+1,k)*vb(i,j,k,2)
         wbb(i,j,k,1)=wbb(i,j,k,1)/n-wmean(i,j,k)*bmean(i,j,k)**2     -2*bmean(i,j,k  )*wb(i,j,k,1)
         wbb(i,j,k,2)=wbb(i,j,k,2)/n-wmean(i,j,k)*bmean(i,j,k+1)**2   -2*bmean(i,j,k+1)*wb(i,j,k,2)


!       third order fluxes of buoyancy
        ub3(i,j,k,1)=ub3(i,j,k,1)/n-umean(i,j,k)*bmean(i,j,k)**3   &
                 -3*bmean(i,j,k)*ubb(i,j,k,1)   -3*bmean(i,j,k)**2*ub(i,j,k,1)
        ub3(i,j,k,2)=ub3(i,j,k,2)/n-umean(i,j,k)*bmean(i+1,j,k)**3   &
                 -3*bmean(i+1,j,k)*ubb(i,j,k,2) -3*bmean(i+1,j,k)**2*ub(i,j,k,2)

        vb3(i,j,k,1)=vb3(i,j,k,1)/n-vmean(i,j,k)*bmean(i,j,k)**3   &
                 -3*bmean(i,j,k)*vbb(i,j,k,1)   -3*bmean(i,j,k)**2*vb(i,j,k,1)
        vb3(i,j,k,2)=vb3(i,j,k,2)/n-vmean(i,j,k)*bmean(i,j+1,k)**3   &
                 -3*bmean(i,j+1,k)*vbb(i,j,k,2) -3*bmean(i,j+1,k)**2*vb(i,j,k,2)

        wb3(i,j,k,1)=wb3(i,j,k,1)/n-wmean(i,j,k)*bmean(i,j,k)**3   &
                 -3*bmean(i,j,k)*wbb(i,j,k,1)  -3*bmean(i,j,k)**2*wb(i,j,k,1)
        wb3(i,j,k,2)=wb3(i,j,k,2)/n-wmean(i,j,k)*bmean(i,j,k+1)**3   &
                 -3*bmean(i,j,k+1)*wbb(i,j,k,2)-3*bmean(i,j,k+1)**2*wb(i,j,k,2)

        enddo
       enddo
      enddo

 if (diag_potential_vorticity) then
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
!       pv
         uqq(i,j,k,1)=uqq(i,j,k,1)/n-umean(i,j,k)*qmean(i,j,k)**2  -2*qmean(i  ,j,k)*uq(i,j,k,1)
         uqq(i,j,k,2)=uqq(i,j,k,2)/n-umean(i,j,k)*qmean(i+1,j,k)**2-2*qmean(i+1,j,k)*uq(i,j,k,2)
         vqq(i,j,k,1)=vqq(i,j,k,1)/n-vmean(i,j,k)*qmean(i,j,k)**2  -2*qmean(i,j  ,k)*vq(i,j,k,1)
         vqq(i,j,k,2)=vqq(i,j,k,2)/n-vmean(i,j,k)*qmean(i,j+1,k)**2-2*qmean(i,j+1,k)*vq(i,j,k,2)
         wqq(i,j,k,1)=wqq(i,j,k,1)/n-wmean(i,j,k)*qmean(i,j,k)**2  -2*qmean(i,j,k  )*wq(i,j,k,1)
         wqq(i,j,k,2)=wqq(i,j,k,2)/n-wmean(i,j,k)*qmean(i,j,k+1)**2-2*qmean(i,j,k+1)*wq(i,j,k,2)

!       third order fluxes of pv
        uq3(i,j,k,1)=uq3(i,j,k,1)/n-umean(i,j,k)*qmean(i,j,k)**3   &
                 -3*qmean(i,j,k)*uqq(i,j,k,1)  -3*qmean(i,j,k)**2*uq(i,j,k,1)
        uq3(i,j,k,2)=uq3(i,j,k,2)/n-umean(i,j,k)*qmean(i+1,j,k)**3   &
                 -3*qmean(i+1,j,k)*uqq(i,j,k,2) -3*qmean(i+1,j,k)**2*uq(i,j,k,2)

        vq3(i,j,k,1)=vq3(i,j,k,1)/n-vmean(i,j,k)*qmean(i,j,k)**3   &
                 -3*qmean(i,j,k)*vqq(i,j,k,1)  -3*qmean(i,j,k)**2*vq(i,j,k,1)
        vq3(i,j,k,2)=vq3(i,j,k,2)/n-vmean(i,j,k)*qmean(i,j+1,k)**3   &
                 -3*qmean(i,j+1,k)*vqq(i,j,k,2)-3*qmean(i,j+1,k)**2*vq(i,j,k,2)

        wq3(i,j,k,1)=wq3(i,j,k,1)/n-wmean(i,j,k)*qmean(i,j,k)**3   &
                 -3*qmean(i,j,k)*wqq(i,j,k,1)  -3*qmean(i,j,k)**2*wq(i,j,k,1)
        wq3(i,j,k,2)=wq3(i,j,k,2)/n-wmean(i,j,k)*qmean(i,j,k+1)**3   &
                 -3*qmean(i,j,k+1)*wqq(i,j,k,2)-3*qmean(i,j,k+1)**2*wq(i,j,k,2)
        enddo
       enddo
      enddo
 endif

!       tracer
      do m=1,nr_tr
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         utt(i,j,k,1,m)=utt(i,j,k,1,m)/n -umean(i,j,k)*tmean(i,j,k,m)**2 -2*tmean(i  ,j,k,m)*ut(i,j,k,1,m)
         utt(i,j,k,2,m)=utt(i,j,k,2,m)/n -umean(i,j,k)*tmean(i+1,j,k,m)**2 -2*tmean(i+1,j,k,m)*ut(i,j,k,2,m)
         vtt(i,j,k,1,m)=vtt(i,j,k,1,m)/n -vmean(i,j,k)*tmean(i,j,k,m)**2  -2*tmean(i,j  ,k,m)*vt(i,j,k,1,m)
         vtt(i,j,k,2,m)=vtt(i,j,k,2,m)/n -vmean(i,j,k)*tmean(i,j+1,k,m)**2 -2*tmean(i,j+1,k,m)*vt(i,j,k,2,m)
         wtt(i,j,k,1,m)=wtt(i,j,k,1,m)/n -wmean(i,j,k)*tmean(i,j,k,m)**2 -2*tmean(i,j,k  ,m)*wt(i,j,k,1,m)
         wtt(i,j,k,2,m)=wtt(i,j,k,2,m)/n -wmean(i,j,k)*tmean(i,j,k+1,m)**2-2*tmean(i,j,k+1,m)*wt(i,j,k,2,m)
!       third order fluxes of tracer
        ut3(i,j,k,1,m)=ut3(i,j,k,1,m)/n-umean(i,j,k)*tmean(i,j,k,m)**3   &
                 -3*tmean(i,j,k,m)*utt(i,j,k,1,m)     -3*tmean(i,j,k,m)**2*ut(i,j,k,1,m)
        ut3(i,j,k,2,m)=ut3(i,j,k,2,m)/n-umean(i,j,k)*tmean(i+1,j,k,m)**3   &
                 -3*tmean(i+1,j,k,m)*utt(i,j,k,2,m)   -3*tmean(i+1,j,k,m)**2*ut(i,j,k,2,m)

        vt3(i,j,k,1,m)=vt3(i,j,k,1,m)/n-vmean(i,j,k)*tmean(i,j,k,m)**3   &
                 -3*tmean(i,j,k,m)*vtt(i,j,k,1,m)   -3*tmean(i,j,k,m)**2*vt(i,j,k,1,m)
        vt3(i,j,k,2,m)=vt3(i,j,k,2,m)/n-vmean(i,j,k)*tmean(i,j+1,k,m)**3   &
                 -3*tmean(i,j+1,k,m)*vtt(i,j,k,2,m) -3*tmean(i,j+1,k,m)**2*vt(i,j,k,2,m)

        wt3(i,j,k,1,m)=wt3(i,j,k,1,m)/n-wmean(i,j,k)*tmean(i,j,k,m)**3   &
                 -3*tmean(i,j,k,m)*wtt(i,j,k,1,m)   -3*tmean(i,j,k,m)**2*wt(i,j,k,1,m)
        wt3(i,j,k,2,m)=wt3(i,j,k,2,m)/n-wmean(i,j,k)*tmean(i,j,k+1,m)**3   &
                 -3*tmean(i,j,k+1,m)*wtt(i,j,k,2,m)  -3*tmean(i,j,k+1,m)**2*wt(i,j,k,2,m)
        enddo
       enddo
      enddo
      enddo

      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         ub(i,j,k,1)=0.5*(ub(i,j,k,1)+ub(i,j,k,2))
         vb(i,j,k,1)=0.5*(vb(i,j,k,1)+vb(i,j,k,2))
         wb(i,j,k,1)=0.5*(wb(i,j,k,1)+wb(i,j,k,2))
         ubb(i,j,k,1)=0.5*(ubb(i,j,k,1)+ubb(i,j,k,2))/2.0
         vbb(i,j,k,1)=0.5*(vbb(i,j,k,1)+vbb(i,j,k,2))/2.0
         wbb(i,j,k,1)=0.5*(wbb(i,j,k,1)+wbb(i,j,k,2))/2.0
         ub3(i,j,k,1)=0.5*(ub3(i,j,k,1)+ub3(i,j,k,2))/3.0
         vb3(i,j,k,1)=0.5*(vb3(i,j,k,1)+vb3(i,j,k,2))/3.0
         wb3(i,j,k,1)=0.5*(wb3(i,j,k,1)+wb3(i,j,k,2))/3.0
        enddo
       enddo
      enddo
 if (diag_potential_vorticity) then
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         uq(i,j,k,1)=0.5*(uq(i,j,k,1)+uq(i,j,k,2))
         vq(i,j,k,1)=0.5*(vq(i,j,k,1)+vq(i,j,k,2))
         wq(i,j,k,1)=0.5*(wq(i,j,k,1)+wq(i,j,k,2))
         uqq(i,j,k,1)=0.5*(uqq(i,j,k,1)+uqq(i,j,k,2))/2.0
         vqq(i,j,k,1)=0.5*(vqq(i,j,k,1)+vqq(i,j,k,2))/2.0
         wqq(i,j,k,1)=0.5*(wqq(i,j,k,1)+wqq(i,j,k,2))/2.0
         uq3(i,j,k,1)=0.5*(uq3(i,j,k,1)+uq3(i,j,k,2))/3.0
         vq3(i,j,k,1)=0.5*(vq3(i,j,k,1)+vq3(i,j,k,2))/3.0
         wq3(i,j,k,1)=0.5*(wq3(i,j,k,1)+wq3(i,j,k,2))/3.0
        enddo
       enddo
      enddo
 endif

      do m=1,nr_tr
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         ut(i,j,k,1,m)=0.5*(ut(i,j,k,1,m) +ut(i,j,k,2,m))
         vt(i,j,k,1,m)=0.5*(vt(i,j,k,1,m) +vt(i,j,k,2,m))
         wt(i,j,k,1,m)=0.5*(wt(i,j,k,1,m)+wt(i,j,k,2,m))

         utt(i,j,k,1,m)=0.5*(utt(i,j,k,1,m) +utt(i,j,k,2,m))/2.0
         vtt(i,j,k,1,m)=0.5*(vtt(i,j,k,1,m) +vtt(i,j,k,2,m))/2.0
         wtt(i,j,k,1,m)=0.5*(wtt(i,j,k,1,m)+wtt(i,j,k,2,m))/2.0

         ut3(i,j,k,1,m)=0.5*(ut3(i,j,k,1,m) +ut3(i,j,k,2,m))/2.0
         vt3(i,j,k,1,m)=0.5*(vt3(i,j,k,1,m) +vt3(i,j,k,2,m))/2.0
         wt3(i,j,k,1,m)=0.5*(wt3(i,j,k,1,m)+wt3(i,j,k,2,m))/2.0
        enddo
       enddo
      enddo
      enddo
 endif

 if (diag_eddy_flux_tendency) then
!
!       flux tendencies :  geostrophic terms
!
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
          bpx(i,j,k,1)=bpx(i,j,k,1)/n-bmean(i  ,j,k)*pmean(i  ,j,k)
          bpx(i,j,k,2)=bpx(i,j,k,2)/n-bmean(i+1,j,k)*pmean(i  ,j,k)
          bpx(i,j,k,3)=bpx(i,j,k,3)/n-bmean(i  ,j,k)*pmean(i+1,j,k)

          bpy(i,j,k,1)=bpy(i,j,k,1)/n-bmean(i,j  ,k)*pmean(i,j  ,k)
          bpy(i,j,k,2)=bpy(i,j,k,2)/n-bmean(i,j+1,k)*pmean(i,j  ,k)
          bpy(i,j,k,3)=bpy(i,j,k,3)/n-bmean(i,j  ,k)*pmean(i,j+1,k)

          bfv(i,j,k,1)=bfv(i,j,k,1)/n-bmean(i  ,j,k)*vmean(i  ,j  ,k)
          bfv(i,j,k,2)=bfv(i,j,k,2)/n-bmean(i+1,j,k)*vmean(i  ,j  ,k)
          bfv(i,j,k,3)=bfv(i,j,k,3)/n-bmean(i  ,j,k)*vmean(i+1,j  ,k)
          bfv(i,j,k,4)=bfv(i,j,k,4)/n-bmean(i  ,j,k)*vmean(i  ,j-1,k)
          bfv(i,j,k,5)=bfv(i,j,k,5)/n-bmean(i+1,j,k)*vmean(i  ,j-1,k)
          bfv(i,j,k,6)=bfv(i,j,k,6)/n-bmean(i  ,j,k)*vmean(i+1,j-1,k)

          bfu(i,j,k,1)=bfu(i,j,k,1)/n-bmean(i,j  ,k)*umean(i  ,j  ,k)
          bfu(i,j,k,2)=bfu(i,j,k,2)/n-bmean(i,j+1,k)*umean(i  ,j  ,k)
          bfu(i,j,k,3)=bfu(i,j,k,3)/n-bmean(i,j  ,k)*umean(i  ,j+1,k)
          bfu(i,j,k,4)=bfu(i,j,k,4)/n-bmean(i,j  ,k)*umean(i-1,j  ,k)
          bfu(i,j,k,5)=bfu(i,j,k,5)/n-bmean(i,j+1,k)*umean(i-1,j  ,k)
          bfu(i,j,k,6)=bfu(i,j,k,6)/n-bmean(i,j  ,k)*umean(i-1,j+1,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,bpx(:,:,:,1),1)
      call setcyclic3D(nx,ny,nz,bpx(:,:,:,1))
      call border_exchg3D(nx,ny,nz,bpy(:,:,:,1),1)
      call setcyclic3D(nx,ny,nz,bpy(:,:,:,1))
      call border_exchg3D(nx,ny,nz,bfv(:,:,:,1),1)
      call setcyclic3D(nx,ny,nz,bfv(:,:,:,1))
      call border_exchg3D(nx,ny,nz,bfv(:,:,:,4),1)
      call setcyclic3D(nx,ny,nz,bfv(:,:,:,4))
      call border_exchg3D(nx,ny,nz,bfu(:,:,:,1),1)
      call setcyclic3D(nx,ny,nz,bfu(:,:,:,1))
      call border_exchg3D(nx,ny,nz,bfu(:,:,:,4),1)
      call setcyclic3D(nx,ny,nz,bfu(:,:,:,4))

      ugeo1=0;ugeo2=0; vgeo1=0;vgeo2=0
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
         ugeo1(i,j,k)=-(bpx(i+1,j,k,1)-bpx(i,j,k,2)      +bpx(i,j,k,3)-bpx(i,j,k,1))/(2*dx)
         vgeo1(i,j,k)=-(bpy(i,j+1,k,1)-bpy(i,j,k,2)      +bpy(i,j,k,3)-bpy(i,j,k,1))/(2*dx)
         ugeo2(i,j,k)=(bfv(i,j,k,1)+bfv(i,j,k,2)     +bfv(i,j,k,3)+bfv(i+1,j,k,1)   &
                      +bfv(i,j,k,4)+bfv(i,j,k,5)     +bfv(i,j,k,6)+bfv(i+1,j,k,4) )/8.*coriolis_t(j)
         vgeo2(i,j,k)=-(bfu(i,j,k,1)+bfu(i,j,k,2)   +bfu(i,j,k,4)+bfu(i,j,k,5) )/8.*coriolis_t(j)  &
                      -(bfu(i,j+1,k,1)+bfu(i,j+1,k,4)  +bfu(i,j,k,6)+bfu(i,j,k,3))/8.*coriolis_t(j+1)
        enddo
       enddo
      enddo
!
!       flux tendencies:   vertical advection
!
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
          uwN(i,j,k,1)=uwN(i,j,k,1)/n-umean(i,j,k)*wmean(i  ,j,k)
          uwN(i,j,k,2)=uwN(i,j,k,2)/n-umean(i,j,k)*wmean(i+1,j,k)
          uwN(i,j,k,3)=uwN(i,j,k,3)/n-umean(i,j,k)*wmean(i  ,j,k-1)
          uwN(i,j,k,4)=uwN(i,j,k,4)/n-umean(i,j,k)*wmean(i+1,j,k-1)
          vwN(i,j,k,1)=vwN(i,j,k,1)/n-vmean(i,j,k)*wmean(i,j  ,k)
          vwN(i,j,k,2)=vwN(i,j,k,2)/n-vmean(i,j,k)*wmean(i,j+1,k)
          vwN(i,j,k,3)=vwN(i,j,k,3)/n-vmean(i,j,k)*wmean(i,j  ,k-1)
          vwN(i,j,k,4)=vwN(i,j,k,4)/n-vmean(i,j,k)*wmean(i,j+1,k-1)
        enddo
       enddo
      enddo

   if  (remove_back_stratification) then

      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
          uwN(i,j,k,1)=  uwN(i,j,k,1)*(bmean(i,j,k+1)+bmean(i,j,k))/(4*dz)   &
             +uwN(i,j,k,2)*(bmean(i+1,j,k+1)+bmean(i+1,j,k))/(4*dz)   &
             -uwN(i,j,k,3)*(bmean(i,j,k)+bmean(i,j,k-1))/(4*dz)   &
             -uwN(i,j,k,4)*(bmean(i+1,j,k)+bmean(i+1,j,k-1))/(4*dz)   &
             +uwN(i,j,k,1)*(b_r(k+1)+b_r(k))/(4*dz)   +uwN(i,j,k,2)*(b_r(k+1)+b_r(k))/(4*dz)   &
             -uwN(i,j,k,3)*(b_r(k)+b_r(k-1))/(4*dz)   -uwN(i,j,k,4)*(b_r(k)+b_r(k-1))/(4*dz)
          vwN(i,j,k,1)=  vwN(i,j,k,1)*(bmean(i,j,k+1)+bmean(i,j,k))/(4*dz)  &
             +vwN(i,j,k,2)*(bmean(i,j+1,k+1)+bmean(i,j+1,k))/(4*dz)  &
             -vwN(i,j,k,3)*(bmean(i,j,k)+bmean(i,j,k-1))/(4*dz)  &
             -vwN(i,j,k,4)*(bmean(i,j+1,k)+bmean(i,j+1,k-1))/(4*dz)  &
             +vwN(i,j,k,1)*(b_r(k+1)+b_r(k))/(4*dz)  +vwN(i,j,k,2)*(b_r(k+1)+b_r(k))/(4*dz)  &
             -vwN(i,j,k,3)*(b_r(k)+b_r(k-1))/(4*dz)  -vwN(i,j,k,4)*(b_r(k)+b_r(k-1))/(4*dz)
        enddo
       enddo
      enddo
   else
      do k=2,nz-1
       do j=js,je 
        do i=2,nx -1
          uwN(i,j,k,1)= uwN(i,j,k,1)*(bmean(i,j,k+1)+bmean(i,j,k))/(4*dz)   &
             +uwN(i,j,k,2)*(bmean(i+1,j,k+1)+bmean(i+1,j,k))/(4*dz)   &
             -uwN(i,j,k,3)*(bmean(i,j,k)+bmean(i,j,k-1))/(4*dz)   &
             -uwN(i,j,k,4)*(bmean(i+1,j,k)+bmean(i+1,j,k-1))/(4*dz)
          vwN(i,j,k,1)= vwN(i,j,k,1)*(bmean(i,j,k+1)+bmean(i,j,k))/(4*dz)   &
             +vwN(i,j,k,2)*(bmean(i,j+1,k+1)+bmean(i,j+1,k))/(4*dz)   &
             -vwN(i,j,k,3)*(bmean(i,j,k)+bmean(i,j,k-1))/(4*dz)   &
             -vwN(i,j,k,4)*(bmean(i,j+1,k)+bmean(i,j+1,k-1))/(4*dz)
        enddo
       enddo
      enddo
   endif
 endif
!
!       apply  land mask
!
      where (maskU==0) 
        umean=spval; uvar=spval
      end where
      where (maskV==0) 
        vmean=spval; wvar=spval
      end where
      where (maskW==0) 
        wmean=spval; wvar=spval
      end where
      where (maskT==0) 
       bmean=spval;pmean=spval;b3=spval
       bvar=spval;pvar=spval; uv(:,:,:,1)=spval
      end where
 if (diag_eddy_fluxes) then
      where (maskU==0) 
        ub(:,:,:,1)=spval; ubb(:,:,:,1)=spval;ub3(:,:,:,1)=spval
      end where
      where (maskV==0) 
        vb(:,:,:,1)=spval; vbb(:,:,:,1)=spval;vb3(:,:,:,1)=spval
      end where
      where (maskW==0) 
        wb(:,:,:,1)=spval; wbb(:,:,:,1)=spval;wb3(:,:,:,1)=spval
      end where
 endif
 if (diag_potential_vorticity) then
      where (maskT==0) 
       qmean=spval;q3=spval; qvar=spval;
      end where
      where (maskU==0) 
        uq(:,:,:,1)=spval; uqq(:,:,:,1)=spval;uq3(:,:,:,1)=spval
      end where
      where (maskV==0) 
        vq(:,:,:,1)=spval; vqq(:,:,:,1)=spval;vq3(:,:,:,1)=spval
      end where
      where (maskW==0) 
        wq(:,:,:,1)=spval; wqq(:,:,:,1)=spval;wq3(:,:,:,1)=spval
      end where
 endif

 if (diag_eddy_flux_tendency) then
      where (maskU==0) 
        ugeo1=spval; ugeo2=spval; uwN(:,:,:,1)=spval
      end where
      where (maskV==0) 
        vgeo1=spval; vgeo2=spval; vwN(:,:,:,1)=spval
      end where
 endif
      do k=1,nr_tr
       where (maskT==0) 
        tmean(:,:,:,k)=spval;tvar(:,:,:,k)=spval;t3(:,:,:,k)=spval
       end where
 if (diag_eddy_fluxes) then
       where (maskU==0) 
         ut(:,:,:,1,k)=spval; utt(:,:,:,1,k)=spval;ut3(:,:,:,1,k)=spval
       end where
       where (maskV==0) 
         vt(:,:,:,1,k)=spval; vtt(:,:,:,1,k)=spval;vt3(:,:,:,1,k)=spval
       end where
       where (maskW==0) 
         wt(:,:,:,1,k)=spval; wtt(:,:,:,1,k)=spval;wt3(:,:,:,1,k)=spval
       end where
 endif
      enddo
end subroutine time_averages_calc



subroutine time_averages_write
!=======================================================================
!        write time mean diagnostics
!=======================================================================
      use pyOM_module   
      use time_averages_module
      use fcontrol_module
      implicit none
      include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      integer :: tdim,ilen,timeid,varid,dims(4)
      integer :: xtdim,xudim,ytdim,yudim,ztdim,zudim
      real*8 :: fxa,time
      character :: name*64, unit*32
!
!        define netcdf file
!
      if (my_pe==0) then 
       print*,' writing time averages to file time_ave.cdf'
       call def_grid_cdf('time_ave.cdf')
       iret=nf_open('time_ave.cdf',NF_WRITE,ncid)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       call ncredf(ncid, iret)
       iret=nf_inq_dimid(ncid,'xt',xtdim)
       iret=nf_inq_dimid(ncid,'xu',xudim)
       iret=nf_inq_dimid(ncid,'yt',ytdim)
       iret=nf_inq_dimid(ncid,'yu',yudim)
       iret=nf_inq_dimid(ncid,'zt',ztdim)
       iret=nf_inq_dimid(ncid,'zu',zudim)
       iret=nf_inq_dimid(ncid,'Time',tdim)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'um', NCFLOAT,4,dims,iret)
       name='Mean zonal velocity'; unit = 'm/s'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vm', NCFLOAT,4,dims,iret)
       name='Mean meridional velocity'; unit = 'm/s'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wm', NCFLOAT,4,dims,iret)
       name='Mean vertical velocity'; unit = 'm/s'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'bm', NCFLOAT,4,dims,iret)
       name='Mean buoyancy'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'pm', NCFLOAT,4,dims,iret)
       name='Mean pressure'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uu', NCFLOAT,4,dims,iret)
       name='Zonal velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vv', NCFLOAT,4,dims,iret)
       name='Meridional velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uv', NCFLOAT,4,dims,iret)
       name='Cross velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'ww', NCFLOAT,4,dims,iret)
       name='Vertical velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'bb', NCFLOAT,4,dims,iret)
       name='Buoyancy variance'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'b3', NCFLOAT,4,dims,iret)
       name='3. moment buoyancy'; unit = 'm^3/s^6'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'pp', NCFLOAT,4,dims,iret)
       name='Pressure variance'; unit = 'm^4/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

 if (diag_eddy_fluxes) then
       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ub', NCFLOAT,4,dims,iret)
       name='Zonal eddy buoyancy flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vb', NCFLOAT,4,dims,iret)
       name='Meridional eddy buoyancy flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wb', NCFLOAT,4,dims,iret)
       name='Vertical eddy buoyancy flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ubb', NCFLOAT,4,dims,iret)
       name='Zonal buoyancy variance flux'; unit = 'm^3/s^5'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vbb', NCFLOAT,4,dims,iret)
       name='Meridional buoyancy variance flux'; unit = 'm^3/s^5'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wbb', NCFLOAT,4,dims,iret)
       name='Vertical buoyancy variance flux'; unit = 'm^3/s^5'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ub3', NCFLOAT,4,dims,iret)
       name='Zonal buoyancy 3.order flux'; unit = 'm^4/s^7'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vb3', NCFLOAT,4,dims,iret)
       name='Meridional buoyancy 3. order flux'; unit = 'm^4/s^7'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wb3', NCFLOAT,4,dims,iret)
       name='Vertical buoyancy 3. order flux'; unit = 'm^4/s^7'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

 endif

 if (diag_eddy_flux_tendency) then
       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ugeo1', NCFLOAT,4,dims,iret)
       name='Geostr. flux tendency 1'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ugeo2', NCFLOAT,4,dims,iret)
       name='Geostr. flux tendency 2'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vgeo1', NCFLOAT,4,dims,iret)
       name='Geostr. flux tendency 1'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vgeo2', NCFLOAT,4,dims,iret)
       name='Geostr. flux tendency 2'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uwN', NCFLOAT,4,dims,iret)
       name='Vertical flux tendency'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vwN', NCFLOAT,4,dims,iret)
       name='Vertical flux tendency'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)
 endif

 if  (remove_back_stratification) then
       varid = ncvdef (ncid,'b_r', NCFLOAT,1,ztdim,iret)
       name = 'Reference buoyancy profile'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)
 endif
       do n=1,nr_tr
        dims = (/xtdim, ytdim,ztdim, tdim/)
        write(name, '("trm",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name = 'Mean tracer'; unit = ' '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        write(name, '("trvar",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name = 'Tracer variance'; unit = ' '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        write(name, '("tr3",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name = '3. moment tracer'; unit = ' '
        call dvcdf(ncid,varid,name,64,unit,32,spval)
 if (diag_eddy_fluxes) then
        dims = (/xudim, ytdim,ztdim, tdim/)
        write(name, '("utr",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Zonal eddy tracer flux'; unit = 'm/s '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, yudim,ztdim, tdim/)
        write(name, '("vtr",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Meridional eddy tracer flux'; unit = 'm/s '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, ytdim,zudim, tdim/)
        write(name, '("wtr",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Vertical eddy tracer flux'; unit = 'm/s '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xudim, ytdim,ztdim, tdim/)
        write(name, '("utrvar",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Zonal tracer variance flux'; unit = ' m/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, yudim,ztdim, tdim/)
        write(name, '("vtrvar",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Meridional tracer variance flux'; unit = 'm/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, ytdim,zudim, tdim/)
        write(name, '("wtrvar",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Vertical tracer variance flux'; unit = 'm/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xudim, ytdim,ztdim, tdim/)
        write(name, '("ut3_",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Zonal tracer  3.order flux'; unit = ' m/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, yudim,ztdim, tdim/)
        write(name, '("vt3_",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Meridional tracer 3.order flux'; unit = 'm/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, ytdim,zudim, tdim/)
        write(name, '("wt3_",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Vertical tracer 3.order flux'; unit = 'm/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

 endif
       enddo
 if (diag_potential_vorticity) then
       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'qm', NCFLOAT,4,dims,iret)
       name='Ertel PV'; unit = '1/s'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'qq', NCFLOAT,4,dims,iret)
       name='PV variance'; unit = '1/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'q3', NCFLOAT,4,dims,iret)
       name='3. moment pv'; unit = '1/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uq', NCFLOAT,4,dims,iret)
       name='Zonal eddy pv flux'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vq', NCFLOAT,4,dims,iret)
       name='Meridional eddy pv flux'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wq', NCFLOAT,4,dims,iret)
       name='Vertical eddy pv flux'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uqq', NCFLOAT,4,dims,iret)
       name='Zonal pv variance flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vqq', NCFLOAT,4,dims,iret)
       name='Meridional pv variance flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wqq', NCFLOAT,4,dims,iret)
       name='Vertical pv variance flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uq3', NCFLOAT,4,dims,iret)
       name='Zonal pv 3.order flux'; unit = 'm^3/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vq3', NCFLOAT,4,dims,iret)
       name='Meridional pv 3. order flux'; unit = 'm^3/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wq3', NCFLOAT,4,dims,iret)
       name='Vertical pv 3. order flux'; unit = 'm^3/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)
 endif

       iret= nf_put_att_int(ncid,nf_global,'nitts',nf_int,1,nitts)
       call ncendf(ncid, iret)
 if  (remove_back_stratification) then
       iret=nf_inq_varid(ncid,'b_r',varid)
       iret= nf_put_vara_double(ncid,varid,1,nz,b_r)
 endif
       call ncclos (ncid, iret)
      endif ! my_pe ==0
!-----------------------------------------------------------------------
!      write to netcdf file
!-----------------------------------------------------------------------
      do npe=0,n_pes
       if (my_pe==npe) then

         iret=nf_open('time_ave.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)

         iret=nf_inq_dimid(ncid,'Time',tdim)
         iret=nf_inq_dimlen(ncid,tdim,ilen)
         iret=nf_inq_varid(ncid,'Time',timeid)
         if (my_pe==0) then
          ilen=ilen+1
          time = itt*dt !current_time-initial_time
          fxa = time/86400. ! time%days + time%seconds/86400.
          iret= nf_put_vara_double(ncid,timeid,ilen,1,fxa)
         endif

         Corner = (/1,js_pe,1,ilen/); 
         edges  = (/nx ,je_pe-js_pe+1,nz,1/)
         iret=nf_inq_varid(ncid,'um',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    umean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    vmean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'wm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    wmean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,     bmean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'pm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,       pmean(:,js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'uu',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   uvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vv',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    vvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'uv',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   uv(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'ww',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,     wvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,      bvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'b3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,      b3(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'pp',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,      pvar(:,js_pe:je_pe,:))

 if (diag_eddy_fluxes) then
         iret=nf_inq_varid(ncid,'ub',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,     ub(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,     vb(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,       wb(:,js_pe:je_pe,:,1))

         iret=nf_inq_varid(ncid,'ubb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    ubb(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vbb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,     vbb(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wbb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   wbb(:,js_pe:je_pe,:,1))

         iret=nf_inq_varid(ncid,'ub3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,     ub3(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vb3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   vb3(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wb3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,     wb3(:,js_pe:je_pe,:,1))
 endif

 if (diag_eddy_flux_tendency) then
         iret=nf_inq_varid(ncid,'ugeo1',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,     ugeo1(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'ugeo2',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    ugeo2(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vgeo1',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   vgeo1(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vgeo2',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    vgeo2(:,js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'uwN',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,  uwN(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vwN',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   vwN(:,js_pe:je_pe,:,1))
 endif
        do n=1,nr_tr
         write(name, '("trm",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,    tmean(:,js_pe:je_pe,:,n))

         write(name, '("trvar",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,   tvar(:,js_pe:je_pe,:,n))

         write(name, '("tr3",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,    t3(:,js_pe:je_pe,:,n))
 if (diag_eddy_fluxes) then
          write(name, '("utr",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,  ut(:,js_pe:je_pe,:,1,n))
          write(name, '("vtr",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,  vt(:,js_pe:je_pe,:,1,n))
          write(name, '("wtr",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,   wt(:,js_pe:je_pe,:,1,n))

          write(name, '("utrvar",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,  utt(:,js_pe:je_pe,:,1,n))
          write(name, '("vtrvar",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,  vtt(:,js_pe:je_pe,:,1,n))
          write(name, '("wtrvar",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,    wtt(:,js_pe:je_pe,:,1,n))

          write(name, '("ut3_",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,  ut3(:,js_pe:je_pe,:,1,n))
          write(name, '("vt3_",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,   vt3(:,js_pe:je_pe,:,1,n))
          write(name, '("wt3_",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,     wt3(:,js_pe:je_pe,:,1,n))

 endif
         enddo
 if (diag_potential_vorticity) then
         iret=nf_inq_varid(ncid,'qm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,  qmean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'qq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   qvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'q3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    q3(:,js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'uq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,  uq(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,  vq(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   wq(:,js_pe:je_pe,:,1))

         iret=nf_inq_varid(ncid,'uqq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,  uqq(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vqq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,  vqq(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wqq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   wqq(:,js_pe:je_pe,:,1))

         iret=nf_inq_varid(ncid,'uq3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   uq3(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vq3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,   vq3(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wq3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,    wq3(:,js_pe:je_pe,:,1))
 endif
         call ncclos (ncid, iret)
       endif
       call fortran_barrier
      enddo
 end subroutine time_averages_write

module diag_barbi_module
   implicit none
   real*8, allocatable :: phi(:,:),bpt(:,:),wsc(:,:),ptv(:,:)
   real*8, allocatable :: rtr(:,:),psib(:,:),tdt(:,:),S1(:,:),S2(:,:)
   real*8, allocatable :: S3(:,:),S4(:,:),S1gm(:,:),S2gm(:,:),Sr(:,:)
   real*8, parameter :: rho0 = 1024
   real*8, parameter :: grav = 9.81
   real*8,parameter :: spval = -1.0d33
   real*8 :: N_0
   real*8, allocatable ::  b_r(:,:,:,:)
end module diag_barbi_module



subroutine init_diag_barbi
!=======================================================================
!      Initialize diagnostics
!=======================================================================
      use pyOM_module   
      use diag_barbi_module
      use fcontrol_module
      implicit none
      integer :: k
      namelist /diag_barbi/ N_0
      real*8 :: z,L_z

      if (my_pe==0) then
       print*,' Initializing barbi module '
      endif

      allocate(phi(nx,ny) ); phi=0.0
      allocate(psib(nx,ny) ); psib=0.0
      allocate(bpt(nx,ny) ); bpt=0.0
      allocate(wsc(nx,ny) ); wsc=0.0
      allocate(ptv(nx,ny) ); ptv=0.0
      allocate(rtr(nx,ny) ); rtr=0.0
      allocate(tdt(nx,ny) ); tdt=0.0
      allocate(S1(nx,ny) ); S1=0.0
      allocate(S2(nx,ny) ); S2=0.0
      allocate(S3(nx,ny) ); S3=0.0
      allocate(S4(nx,ny) ); S4=0.0
      allocate(S1gm(nx,ny) ); S1gm=0.0
      allocate(S2gm(nx,ny) ); S2gm=0.0
      allocate(Sr(nx,ny) ); Sr=0.0

      allocate(b_r(nx,ny,nz,3)); b_r=0.0

      if (enable_back_state) then
        b_r = 0.0
      else
       open(10,file='namelist',form='formatted',status='old')
       read(10, nml = diag_barbi )
       close(10)
       if (my_pe==0) write(6, nml=diag_barbi)
       L_z = zt(nz )-zt(1)
       do k=1,nz
         z = (zt(k)-zt(1))/L_z
         b_r(:,:,k,:) = -N_0**2*z 
       enddo
      endif

      call diag_barbi_init_cdf

      if (my_pe==0) print*,' Done initializing barbi module'
end subroutine init_diag_barbi


subroutine diag_barbi
   use pyOM_module   
   use diag_barbi_module
   use fcontrol_module
   use bolus_module
   implicit none
   integer :: i,j,k,js,je,n
   real*8 :: fxa,xvec(nx,ny),yvec(nx,ny)
   real*8 :: ubaro(nx,ny),vbaro(nx,ny)
   real*8 :: uu(nx,ny,nz),vv(nx,ny,nz)

   if ( mod(itt,int(snapint/dt))  == 0)  then

      js=max(2,js_pe); je = min(je_pe,ny -1)

      ! baroclinic streamfunction
      do j=js,je
       phi(:,j)=0.0
       if (enable_back_state) then

        do k=1,nz
         fxa =  sign(1d0,coriolis_t(j) )*max(1d-12,abs(coriolis_t(j)) ) 
         phi(:,j)=phi(:,j)+dz*b(:,j,k,tau)*zt(k)*maskT(:,j,k)/fxa 
        enddo
       else
        do k=1,nz
         fxa =  sign(1d0,coriolis_t(j) )*max(1d-12,abs(coriolis_t(j)) ) 
         phi(:,j)=phi(:,j)+dz*(b(:,j,k,tau)-b_r(:,j,k,tau))*zt(k)*maskT(:,j,k)/fxa 
        enddo
       endif
      enddo

      ! barotropic velocity
      do j=js,je
       ubaro(:,j)=0.0; vbaro(:,j)=0.0
       do k=1,nz
         ubaro(:,j)=ubaro(:,j)+dz*u(:,j,k,tau)*maskU(:,j,k) 
         vbaro(:,j)=vbaro(:,j)+dz*v(:,j,k,tau)*maskV(:,j,k) 
       enddo
       where( hu(:,j) /= 0.0) ubaro(:,j)=ubaro(:,j)/hu(:,j)
       where( hv(:,j) /= 0.0) vbaro(:,j)=vbaro(:,j)/hv(:,j)
      enddo
      call border_exchg2D(nx,ny,ubaro,1); call setcyclic2D(nx,ny,ubaro)
      call border_exchg2D(nx,ny,vbaro,1); call setcyclic2D(nx,ny,vbaro)

      ! advection of backgr. and pertub. density by barotropic flow
      do k=1,nz
         uu(:,:,k)=ubaro
         vv(:,:,k)=vbaro      
      enddo
      if (enable_back_state) then
       call diag_barbi_adv(uu,vv,back,S1,.false.)
       call diag_barbi_adv(uu,vv,b,S2,.false.)
      else
       call diag_barbi_adv(uu,vv,b_r,S1,.false.)
       call diag_barbi_adv(uu,vv,b-b_r,S2,.false.)
      endif

      ! advection of backgr. and pertub. density by baroclinic flow
      do k=1,nz
         uu(:,:,k)=u(:,:,k,tau)-ubaro
         vv(:,:,k)=v(:,:,k,tau)-vbaro      
      enddo
      if (enable_back_state) then
       call diag_barbi_adv(uu,vv,back,S3,.false.)
       call diag_barbi_adv(uu,vv,b,S4,.false.)
      else
       call diag_barbi_adv(uu,vv,b_r,S3,.false.)
       call diag_barbi_adv(uu,vv,b-b_r,S4,.false.)
      endif

      ! advection of backgr. and pertub. density by bolus velocity
      if (enable_bolus_velocity) then
       do k=1,nz
        uu(:,:,k)=ub(:,:,k)
        vv(:,:,k)=vb(:,:,k)      
       enddo
       if (enable_back_state) then
        call diag_barbi_adv(uu,vv,back,S1gm,.true.)
        call diag_barbi_adv(uu,vv,b,S2gm,.true.)
       else
        call diag_barbi_adv(uu,vv,b_r,S1gm,.true.)
        call diag_barbi_adv(uu,vv,b-b_r,S2gm,.true.)
       endif
      endif

      ! residual terms
      do j=js,je
       Sr(:,j)=0.0
       do k=1,nz
         Sr(:,j)=Sr(:,j)+dz*(b(:,j,k,taup1)-b(:,j,k,taum1))/c2dt*zt(k)*maskT(:,j,k) 
       enddo
       Sr(:,j) = Sr(:,j)-S1(:,j)-S2(:,j)-S3(:,j)-S4(:,j)-S1gm(:,j)-S2gm(:,j)
      enddo
      call setcyclic2D(nx,ny,Sr)

      ! barotropic streamfunction
      psib(:,js-1)=0.
      do j=js,je_pe
        psib(:,j)=psib(:,j-1)-ubaro(:,j)*dx*hu(:,j)
      enddo
      do n=1,n_pes
       call border_exchg2D(nx,ny,psib,1) 
       if (my_pe == n) then
        do j=js,je_pe
         psib(:,j)=psib(:,j)+psib(:,js-1)
        enddo
       endif
      enddo

      ! bottom pressure torque
      do j=js,je
       xvec(:,j)=0.0
       yvec(:,j)=0.0
       do k=1,nz
        do i=2,nx-1
         xvec(i,j)=xvec(i,j)-(p_full(i+1,j,k,tau)-p_full(i,j,k,tau) )/dx*dz*maskU(i,j,k)
         yvec(i,j)=yvec(i,j)-(p_full(i,j+1,k,tau)-p_full(i,j,k,tau) )/dx*dz*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg2D(nx,ny,xvec,1); call setcyclic2D(nx,ny,xvec)
      call border_exchg2D(nx,ny,yvec,1); call setcyclic2D(nx,ny,yvec)
      call diag_barbi_curl(xvec,yvec,bpt)

      ! planetary vorticity
      do j=js,je
       xvec(:,j)=0.0
       yvec(:,j)=0.0
       do k=1,nz
        do i=2,nx-1
         xvec(i,j)=xvec(i,j)+dz*maskU(i,j,k)*coriolis_t(j)*(v(i,j  ,k,tau)+v(i+1,j  ,k,tau)+ &
                                                            v(i,j-1,k,tau)+v(i+1,j-1,k,tau))/4.0
         yvec(i,j)=yvec(i,j)-dz*maskV(i,j,k)*(coriolis_t(j  )*(u(i-1,j  ,k,tau)+u(i,j  ,k,tau))  &
                                             +coriolis_t(j+1)*(u(i-1,j+1,k,tau)+u(i,j+1,k,tau)))/4.0
        enddo
       enddo
      enddo
      call border_exchg2D(nx,ny,xvec,1); call setcyclic2D(nx,ny,xvec)
      call border_exchg2D(nx,ny,yvec,1); call setcyclic2D(nx,ny,yvec)
      call diag_barbi_curl(xvec,yvec,ptv)

      ! wind stress curl
      call diag_barbi_curl(surface_taux,surface_tauy,wsc)

      ! residual torques
      do j=js,je
       xvec(:,j)=0.0
       yvec(:,j)=0.0
       do k=1,nz
        do i=2,nx-1
         xvec(i,j)=xvec(i,j)+maskU(i,j,k)*fu(i,j,k)*dz
         yvec(i,j)=yvec(i,j)+maskV(i,j,k)*fv(i,j,k)*dz
        enddo
       enddo
      enddo
      call border_exchg2D(nx,ny,xvec,1); call setcyclic2D(nx,ny,xvec)
      call border_exchg2D(nx,ny,yvec,1); call setcyclic2D(nx,ny,yvec)
      call diag_barbi_curl(xvec,yvec,rtr)
      rtr = rtr - wsc  - ptv

      ! time tendendy torque
      do j=js,je
       xvec(:,j)=0.0
       yvec(:,j)=0.0
       do k=1,nz
        do i=2,nx-1
         xvec(i,j)=xvec(i,j)+maskU(i,j,k)*(u(i,j,k,taup1)-u(i,j,k,taum1))/c2dt*dz
         yvec(i,j)=yvec(i,j)+maskV(i,j,k)*(v(i,j,k,taup1)-v(i,j,k,taum1))/c2dt*dz
        enddo
       enddo
      enddo
      call border_exchg2D(nx,ny,xvec,1); call setcyclic2D(nx,ny,xvec)
      call border_exchg2D(nx,ny,yvec,1); call setcyclic2D(nx,ny,yvec)
      call diag_barbi_curl(xvec,yvec,tdt)


      call write_diag_barbi
  endif
end subroutine diag_barbi


subroutine diag_barbi_adv(uu,vv,bb,tend,leapfrog)
   use pyOM_module   
   use diag_barbi_module
   implicit none
   integer :: i,j,k,js,je,ierr
   logical :: leapfrog
   real*8 :: uu(nx,ny,nz),vv(nx,ny,nz),bb(nx,ny,nz,3),tend(nx,ny)
   real*8 :: adv_fe(nx,ny,nz), adv_ft(nx,ny,nz), adv_fn(nx,ny,nz)
   real*8 :: uback(nx,ny,nz),vback(nx,ny,nz),wback(nx,ny,nz)

      js=max(2,js_pe); je = min(je_pe,ny -1)
      do j=max(1,js_pe-1),min(ny,je_pe+1)
       uback(:,j,:)=u(:,j,:,tau); vback(:,j,:)=v(:,j,:,tau); wback(:,j,:)=w(:,j,:,tau);
       u(:,j,:,tau)=uu(:,j,:); v(:,j,:,tau)=vv(:,j,:)
      enddo
      call vertical_velocity(ierr)
      adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0; adv_ft(:,js_pe:je_pe,:)=0
      if (leapfrog) then
        call adv_flux_2th(nx,ny,nz,adv_fe,adv_fn,adv_ft,bb)
      else
        call adv_flux(nx,ny,nz,adv_fe,adv_fn,adv_ft,bb)
      endif
      do j=max(1,js_pe-1),min(ny,je_pe+1)
       u(:,j,:,tau)=uback(:,j,:)
       v(:,j,:,tau)=vback(:,j,:)
       w(:,j,:,tau)=wback(:,j,:)
      enddo
      call border_exchg3D(nx,ny,nz,adv_fn,1)
      call setcyclic3D(nx,ny,nz,adv_fe); 
      call setcyclic3D(nx,ny,nz,adv_fn)
      tend(:,js_pe:je_pe)=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx-1
         tend(i,j)=tend(i,j)+dz*zt(k)*maskT(i,j,k)*(  &
        -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx &
        -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx &
        -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
      call setcyclic2D(nx,ny,tend)
end subroutine diag_barbi_adv


subroutine diag_barbi_curl(xvec,yvec,cvec)
      use pyOM_module   
      use diag_barbi_module
      implicit none
      integer :: i,j,k,js,je
      real*8 :: xvec(nx,ny),yvec(nx,ny),cvec(nx,ny)!,cc(nx,ny)
      js=max(2,js_pe); je = min(je_pe,ny -1)
      do j=js,je
        do i=2,nx-1
         cvec(i,j) = (yvec(i+1,j)-yvec(i,j))/dx-(xvec(i,j+1)-xvec(i,j))/dx
         cvec(i,j) = cvec(i,j) * min( maskU(i,j,nz-1) , maskV(i,j,nz-1) )
        enddo
      enddo
      !call border_exchg2D(nx,ny,cc,1); call setcyclic2D(nx,ny,cc)
      !do j=js,je
      !  do i=2,nx-1
      !   cvec(i,j)=0.25*(cc(i,j)+cc(i-1,j)+cc(i,j-1)+cc(i-1,j-1))
      !  enddo
      !enddo

      call setcyclic2D(nx,ny,cvec)
end subroutine diag_barbi_curl



subroutine diag_barbi_init_cdf
      use pyOM_module   
      use diag_barbi_module
      implicit none
      include "netcdf.inc"
      integer :: iret,ncid,vid,npe,timeid,ilen
      integer :: xtdim,xudim,ytdim,yudim,ztdim,zudim,tdim
      character :: name*64, unit*32
      real*8 :: beta(ny)

      call boundary_conditions

      if (my_pe==0) then 
       print*,' writing to file barbi.cdf'
       call def_grid_cdf('barbi.cdf')
       iret=nf_open('barbi.cdf',NF_WRITE,ncid)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       call ncredf(ncid, iret)
       iret=nf_inq_dimid(ncid,'xt',xtdim)
       iret=nf_inq_dimid(ncid,'xu',xudim)
       iret=nf_inq_dimid(ncid,'yt',ytdim)
       iret=nf_inq_dimid(ncid,'yu',yudim)
       iret=nf_inq_dimid(ncid,'zt',ztdim)
       iret=nf_inq_dimid(ncid,'zu',zudim)
       iret=nf_inq_dimid(ncid,'Time',tdim)

       vid = ncvdef (ncid,'phi', NCFLOAT,3,(/xtdim,ytdim,tdim/),iret)
       name='Baroclinic streamfunction'; unit = 'm^3/s'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'S1', NCFLOAT,3,(/xtdim,ytdim,tdim/),iret)
       name='Barotr. adv. backgr. density'; unit = 'm^3/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'S2', NCFLOAT,3,(/xtdim,ytdim,tdim/),iret)
       name='Barotr. adv. pert. density'; unit = 'm^3/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'S3', NCFLOAT,3,(/xtdim,ytdim,tdim/),iret)
       name='Barocl. adv. backgr. density'; unit = 'm^3/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'S4', NCFLOAT,3,(/xtdim,ytdim,tdim/),iret)
       name='Barocl. adv. pert. density'; unit = 'm^3/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'S1gm', NCFLOAT,3,(/xtdim,ytdim,tdim/),iret)
       name='Bolus. adv. backgr. density'; unit = 'm^3/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'S2gm', NCFLOAT,3,(/xtdim,ytdim,tdim/),iret)
       name='Bolus. adv. pert. density'; unit = 'm^3/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'Sr', NCFLOAT,3,(/xtdim,ytdim,tdim/),iret)
       name='Residual forcing'; unit = 'm^3/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'psi', NCFLOAT,3,(/xudim,yudim,tdim/),iret)
       name='Barotropic streamfunction'; unit = 'm^3/s'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'bpt', NCFLOAT,3,(/xudim,yudim,tdim/),iret)
       name='Bottom pressure torque'; unit = 'm/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'wsc', NCFLOAT,3,(/xudim,yudim,tdim/),iret)
       name='Wind stress curl'; unit = 'm/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'ptv', NCFLOAT,3,(/xudim,yudim,tdim/),iret)
       name='Planetary vorticity'; unit = 'm/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'rtr', NCFLOAT,3,(/xudim,yudim,tdim/),iret)
       name='Residual torque'; unit = 'm/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'tdt', NCFLOAT,3,(/xudim,yudim,tdim/),iret)
       name='time tendency torque'; unit = 'm/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'h', NCFLOAT,2,(/xtdim,ytdim/),iret)
       name='water depth'; unit = 'm'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'taux', NCFLOAT,2,(/xudim,ytdim/),iret)
       name='zonal wind stress'; unit = 'm^2/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'tauy', NCFLOAT,2,(/xtdim,yudim/),iret)
       name='meridional wind stress'; unit = 'm^2/s^2'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'f', NCFLOAT,1,ytdim,iret)
       name='Coriolis frequency'; unit = '1/s'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'N', NCFLOAT,1,ytdim,iret)
       name='Stability frequency'; unit = '1/s'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       vid = ncvdef (ncid,'beta', NCFLOAT,1,ytdim,iret)
       name='beta              '; unit = '1/ms'
       call dvcdf(ncid,vid,name,64,unit,32,spval)

       call ncendf(ncid, iret)

       iret=nf_inq_varid(ncid,'f',vid)
       iret= nf_put_vara_double(ncid,vid,1,ny,coriolis_t)

       beta(:) = (coriolis_t(2)-coriolis_t(1))/dx
       iret=nf_inq_varid(ncid,'beta',vid)
       iret= nf_put_vara_double(ncid,vid,1,ny,beta)

       if (enable_back_state) then
        beta(:) = sqrt( -(back(nx/2,ny/2,nz-1,1)-back(nx/2,ny/2,nz-2,1))/dz )
       else
        beta(:) =  N_0 
       endif
       iret=nf_inq_varid(ncid,'N',vid)
       iret= nf_put_vara_double(ncid,vid,1,ny,beta)

       iret=nf_inq_varid(ncid,'h',vid)
       iret= nf_put_vara_double(ncid,vid,(/1,1/),(/nx,ny/),ht)

       iret=nf_inq_varid(ncid,'taux',vid)
       iret= nf_put_vara_double(ncid,vid,(/1,1/),(/nx,ny/),surface_taux)

       iret=nf_inq_varid(ncid,'tauy',vid)
       iret= nf_put_vara_double(ncid,vid,(/1,1/),(/nx,ny/),surface_tauy)

       call ncclos(ncid, iret)
      endif
end subroutine diag_barbi_init_cdf




subroutine write_diag_barbi
   use pyOM_module   
   use diag_barbi_module
   use fcontrol_module
   implicit none
   include "netcdf.inc"
   integer :: iret,ncid,vid,npe,timeid,ilen
   integer :: xtdim,xudim,ytdim,yudim,ztdim,zudim,tdim
   real*8 :: fxa,time

     do npe=0,n_pes
       if (my_pe==npe) then

         iret=nf_open('barbi.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)

         iret=nf_inq_dimid(ncid,'Time',tdim)
         iret=nf_inq_dimlen(ncid,tdim,ilen)
         iret=nf_inq_varid(ncid,'Time',timeid)
         if (my_pe==0) then
          ilen=ilen+1
          time = itt*dt !current_time-initial_time
          fxa = time/86400. ! time%days + time%seconds/86400.
          iret= nf_put_vara_double(ncid,timeid,ilen,1,fxa)
         endif

         iret=nf_inq_varid(ncid,'phi',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),phi(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'S1',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),S1(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'S2',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),S2(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'S3',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),S3(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'S4',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),S4(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'S1gm',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),S1gm(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'S2gm',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),S2gm(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'Sr',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),Sr(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'psi',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),psib(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'bpt',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),bpt(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'wsc',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),wsc(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'ptv',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),ptv(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'rtr',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),rtr(:,js_pe:je_pe))

         iret=nf_inq_varid(ncid,'tdt',vid)
         iret= nf_put_vara_double(ncid,vid,(/1,js_pe,ilen/),(/nx,je_pe-js_pe+1,1/),tdt(:,js_pe:je_pe))

         call ncclos (ncid, iret)
       endif
       call fortran_barrier
      enddo
end subroutine write_diag_barbi

!=======================================================================
!       Integrate particles
!       linked in the code in driver.f90 only
!=======================================================================


 module particle_module
      implicit none
      integer :: nptraj 
      real*8, allocatable  :: pxyz(:,:),puvw(:,:),ptr(:,:)
      integer, allocatable :: pijk(:,:)
      real*8, allocatable  :: mu(:),muu(:)
      real*8, allocatable  :: mv(:),mvv(:)
      real*8, allocatable  :: mw(:),mww(:)
      integer :: counter
 
      logical, allocatable :: particle_active(:)
      integer, allocatable :: particle_pe(:)
      integer :: mmax
      real*8, allocatable  :: ulen(:,:),vlen(:,:),wlen(:,:)
      logical ::  particle_buoyancy = .false.
      logical ::  particle_averages = .false.
 end module particle_module


subroutine init_particle
!=======================================================================
!      initialize the particles
!=======================================================================
      use pyOM_module   
      use particle_module
      implicit none 
      integer :: i,j,k,indp,n
      logical :: file_exists = .false.
    
      if (my_pe==0) then
       print*,''
       print*,' Initializing particle module '
       print*,''
       if (n_pes>1) print*,'WARNNING: floats do not work with PE>1'
       print*,''
      endif

      mmax = 20
      if (my_pe==0)  print*,' Euler forward time step for particles ',dt/mmax,' s'

!-----------------------------------------------------------------------
!    read restart file
!-----------------------------------------------------------------------
       if (my_pe==0) then
       inquire( FILE='restart_float.dta', EXIST=file_exists )
       if (file_exists) then 
         call particle_read_restart()
       else
!-----------------------------------------------------------------------
!     initialize new set of particles 
!-----------------------------------------------------------------------
        print*,' cannot read restart file '
        nptraj=100
        allocate( pxyz(3,nptraj), pijk(3,nptraj),puvw(3,nptraj) )
!        call seed_particles_randomly
        call seed_particles_regular
        do n=1,nptraj
          i = indp (pxyz(1,n), xu, nx )
          if (xu(i) > pxyz(1,n)) then
            pijk(1,n) = i
          else
            pijk(1,n) = i+1
          endif
          j = indp (pxyz(2,n), yu, ny )
          if (yu(j) > pxyz(2,n)) then
            pijk(2,n) = j
          else
           pijk(2,n) = j+1
          endif
          k = indp (pxyz(3,n), zw, nz)
          if (zw(k) > pxyz(3,n)) then
           pijk(3,n) = k
          else
           pijk(3,n) = k+1
          endif
        enddo
       endif
      endif
!-----------------------------------------------------------------------
!    communicate particles to other pes
!-----------------------------------------------------------------------
      call fortran_barrier
      call bcast_integer(nptraj,1,0)
      if (my_pe/=0)   allocate( pxyz(3,nptraj), pijk(3,nptraj) ,puvw(3,nptraj))
      allocate(particle_active(nptraj),particle_pe(nptraj) )
      call bcast_real(pxyz,3*nptraj,0)
      call bcast_integer(pijk,3*nptraj,0)
      puvw=0.
 if (particle_buoyancy) then
       allocate( ptr(2,nptraj) ); ptr=0.
 endif

 if  (particle_averages) then
      allocate( mu(nptraj) ); mu=0.
      allocate( muu(nptraj) ); muu=0.
      allocate( mv(nptraj) ); mv=0.
      allocate( mvv(nptraj) ); mvv=0.
      allocate( mw(nptraj) ); mw=0.
      allocate( mww(nptraj) ); mww=0.
      counter=0
 endif
 call particle_init_cdf()
 end subroutine init_particle


 
 subroutine integrate_particle
!=======================================================================
!       integrate particles
!=======================================================================
      use pyOM_module   
      use particle_module
      use fcontrol_module
      implicit none 
      integer :: i,j,k,n,m
      real*8 :: xe,xw,yn,ys,zu,zl,dv,th,tf
      real*8 :: xeyszu,xeyszl,xeynzu,xeynzl
      real*8 :: xwyszu,xwyszl,xwynzu,xwynzl
      real*8 :: uuh,vvh,wwh,xold,yold,zold
      real*8 :: uuf,vvf,wwf,uu,vv,ww
      real*8 :: bbf,bbh
      integer, external :: ilim,jlim,klim

      do m=1,mmax
       call particle_inside_pe_domain()
       do n=1,nptraj
        th= (m-1.)/mmax;  tf = 1.-th;
        if (particle_active(n)) then
 if  (particle_buoyancy) then
 !-----------------------------------------------------------------------
 !        interpolate buoyancy on particle
 !-----------------------------------------------------------------------
           i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
           if (pxyz(1,n) > xt(i) )  i=i+1
           xe = (xt(i) - pxyz(1,n)); xw = (pxyz(1,n)-xt(i-1))
           if (pxyz(2,n) > yt(j) )  j=j+1
           yn = (yt(j) - pxyz(2,n)); ys = (pxyz(2,n) - yt(j-1))
           if (pxyz(3,n) > zt(k) )  k=k+1
           zu = (zt(k) - pxyz(3,n)); zl = (pxyz(3,n)-zt(k-1))
 
           if (maskT(ilim(i+1),j,k)==0) then; xe=dx;xw=0; endif
           if (maskT(i-1,j,k)==0) then; xe=0;xw=dx; endif
           if (maskT(i,jlim(j+1),k)==0) then; yn=dx;ys=0; endif
           if (maskT(i,j-1,k)==0) then; yn=0;ys=dx; endif
           if (maskT(i,j,klim(k+1))==0) then; zu=dz;zl=0; endif
           if (maskT(i,j,k-1)==0) then; zu=0;zl=dz; endif
 
           dv = 1./(dx*dx*dz)
           xeyszu = xe*ys*zu*dv; xwyszu = xw*ys*zu*dv
           xeyszl = xe*ys*zl*dv; xwyszl = xw*ys*zl*dv
           xeynzu = xe*yn*zu*dv; xwynzu = xw*yn*zu*dv
           xeynzl = xe*yn*zl*dv; xwynzl = xw*yn*zl*dv

           bbh=b(i-1,j  ,k-1,tau  )*xeyszu+b(i,j  ,k-1,tau  )*xwyszu  &
              +b(i-1,j  ,k  ,tau  )*xeyszl+b(i,j  ,k  ,tau  )*xwyszl  &
              +b(i-1,j-1,k-1,tau  )*xeynzu+b(i,j-1,k-1,tau  )*xwynzu  &
              +b(i-1,j-1,k  ,tau  )*xeynzl+b(i,j-1,k  ,tau  )*xwynzl
           bbf=b(i-1,j  ,k-1,taup1)*xeyszu+b(i,j  ,k-1,taup1)*xwyszu  &
              +b(i-1,j  ,k  ,taup1)*xeyszl+b(i,j  ,k  ,taup1)*xwyszl  &
              +b(i-1,j-1,k-1,taup1)*xeynzu+b(i,j-1,k-1,taup1)*xwynzu  &
              +b(i-1,j-1,k  ,taup1)*xeynzl+b(i,j-1,k  ,taup1)*xwynzl
           ptr(1,n)=th*bbh+tf*bbf

           ptr(2,n) =p_full(i-1,j  ,k-1,tau  )*xeyszu+p_full(i,j  ,k-1,tau  )*xwyszu   &
              +p_full(i-1,j  ,k  ,tau  )*xeyszl+p_full(i,j  ,k  ,tau  )*xwyszl   &
              +p_full(i-1,j-1,k-1,tau  )*xeynzu+p_full(i,j-1,k-1,tau  )*xwynzu   &
              +p_full(i-1,j-1,k  ,tau  )*xeynzl+p_full(i,j-1,k  ,tau  )*xwynzl   
 
 endif
!-----------------------------------------------------------------------
!            pijk gives tracer box of the particle, 
!            find u-box and distances to borders, account for free slip
!-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          xe = (xu(i) - pxyz(1,n)); xw = (pxyz(1,n)-xu(i-1))
          if (pxyz(2,n) > yt(j) )  j=j+1
          yn = (yt(j) - pxyz(2,n)); ys = (pxyz(2,n) - yt(j-1))
          if (pxyz(3,n) > zt(k) )  k=k+1
          zu = (zt(k) - pxyz(3,n)); zl = (pxyz(3,n)-zt(k-1))

          if (maskT(i,jlim(j+1),k)==0) then; yn=dx;ys=0; endif
          if (maskT(i,j-1,k)==0) then; yn=0;ys=dx; endif
          if (maskT(i,j,klim(k+1))==0) then; zu=dz;zl=0; endif
          if (maskT(i,j,k-1)==0) then; zu=0;zl=dz; endif

          dv = 1./(dx*dx*dz)
          xeyszu = xe*ys*zu*dv; xwyszu = xw*ys*zu*dv
          xeyszl = xe*ys*zl*dv; xwyszl = xw*ys*zl*dv
          xeynzu = xe*yn*zu*dv; xwynzu = xw*yn*zu*dv
          xeynzl = xe*yn*zl*dv; xwynzl = xw*yn*zl*dv
!-----------------------------------------------------------------------
!           interpolate u on particle position
!-----------------------------------------------------------------------
          uuh=u(i-1,j  ,k-1,tau  )*xeyszu+u(i,j  ,k-1,tau  )*xwyszu  &
             +u(i-1,j  ,k  ,tau  )*xeyszl+u(i,j  ,k  ,tau  )*xwyszl  &
             +u(i-1,j-1,k-1,tau  )*xeynzu+u(i,j-1,k-1,tau  )*xwynzu  &
             +u(i-1,j-1,k  ,tau  )*xeynzl+u(i,j-1,k  ,tau  )*xwynzl   
          uuf=u(i-1,j  ,k-1,taup1)*xeyszu+u(i,j  ,k-1,taup1)*xwyszu  &
             +u(i-1,j  ,k  ,taup1)*xeyszl+u(i,j  ,k  ,taup1)*xwyszl  &
             +u(i-1,j-1,k-1,taup1)*xeynzu+u(i,j-1,k-1,taup1)*xwynzu  &
             +u(i-1,j-1,k  ,taup1)*xeynzl+u(i,j-1,k  ,taup1)*xwynzl
      if (enable_back_state .and. enable_back_zonal_flow ) then
          uuh=uuh  &
             +u0(i-1,j  ,k-1  )*xeyszu+u0(i,j  ,k-1  )*xwyszu  &
             +u0(i-1,j  ,k    )*xeyszl+u0(i,j  ,k    )*xwyszl  &
             +u0(i-1,j-1,k-1  )*xeynzu+u0(i,j-1,k-1  )*xwynzu  &
             +u0(i-1,j-1,k    )*xeynzl+u0(i,j-1,k    )*xwynzl   
          uuf=uuf  &
             +u0(i-1,j  ,k-1)*xeyszu+u0(i,j  ,k-1)*xwyszu  &
             +u0(i-1,j  ,k  )*xeyszl+u0(i,j  ,k  )*xwyszl  &
             +u0(i-1,j-1,k-1)*xeynzu+u0(i,j-1,k-1)*xwynzu  &
             +u0(i-1,j-1,k  )*xeynzl+u0(i,j-1,k  )*xwynzl
      endif
          uu=th*uuh+tf*uuf
!-----------------------------------------------------------------------
!           find v-box and distances to borders, account for free slip
!-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          if (pxyz(1,n) > xt(i) )  i=i+1
          xe = (xt(i) - pxyz(1,n)); xw = (pxyz(1,n)-xt(i-1))
          yn = (yu(j) - pxyz(2,n)); ys = (pxyz(2,n) - yu(j-1))
          if (pxyz(3,n) > zt(k) )  k=k+1
          zu = (zt(k) - pxyz(3,n)); zl = (pxyz(3,n)-zt(k-1))

          if (maskT(ilim(i+1),j,k)==0) then; xe=dx;xw=0; endif
          if (maskT(i-1,j,k)==0) then; xe=0;xw=dx; endif
          if (maskT(i,j,klim(k+1))==0) then; zu=dz;zl=0; endif
          if (maskT(i,j,k-1)==0) then; zu=0;zl=dz; endif

          dv = 1./(dx*dx*dz)
          xeyszu = xe*ys*zu*dv; xwyszu = xw*ys*zu*dv
          xeyszl = xe*ys*zl*dv; xwyszl = xw*ys*zl*dv
          xeynzu = xe*yn*zu*dv; xwynzu = xw*yn*zu*dv
          xeynzl = xe*yn*zl*dv; xwynzl = xw*yn*zl*dv
!-----------------------------------------------------------------------
!           interpolate v on particle position
!-----------------------------------------------------------------------
          vvh=v(i-1,j  ,k-1,tau  )*xeyszu+v(i,j  ,k-1,tau  )*xwyszu  &
             +v(i-1,j  ,k  ,tau  )*xeyszl+v(i,j  ,k  ,tau  )*xwyszl  &
             +v(i-1,j-1,k-1,tau  )*xeynzu+v(i,j-1,k-1,tau  )*xwynzu  &
             +v(i-1,j-1,k  ,tau  )*xeynzl+v(i,j-1,k  ,tau  )*xwynzl
          vvf=v(i-1,j  ,k-1,taup1)*xeyszu+v(i,j  ,k-1,taup1)*xwyszu  &
             +v(i-1,j  ,k  ,taup1)*xeyszl+v(i,j  ,k  ,taup1)*xwyszl  &
             +v(i-1,j-1,k-1,taup1)*xeynzu+v(i,j-1,k-1,taup1)*xwynzu  &
             +v(i-1,j-1,k  ,taup1)*xeynzl+v(i,j-1,k  ,taup1)*xwynzl
      if (enable_back_state .and. enable_back_meridional_flow ) then
          vvh=vvh  &
             +u0(i-1,j  ,k-1 )*xeyszu+u0(i,j  ,k-1 )*xwyszu  &
             +u0(i-1,j  ,k   )*xeyszl+u0(i,j  ,k   )*xwyszl  &
             +u0(i-1,j-1,k-1 )*xeynzu+u0(i,j-1,k-1 )*xwynzu  &
             +u0(i-1,j-1,k   )*xeynzl+u0(i,j-1,k   )*xwynzl
          vvf=vvf  &
             +u0(i-1,j  ,k-1)*xeyszu+u0(i,j  ,k-1)*xwyszu  &
             +u0(i-1,j  ,k  )*xeyszl+u0(i,j  ,k  )*xwyszl  &
             +u0(i-1,j-1,k-1)*xeynzu+u0(i,j-1,k-1)*xwynzu  &
             +u0(i-1,j-1,k  )*xeynzl+u0(i,j-1,k  )*xwynzl
      endif
          vv=th*vvh+tf*vvf
!-----------------------------------------------------------------------
!           find w-box and distances to borders, account for free slip
!-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          if (pxyz(1,n) > xt(i) )  i=i+1
          xe = (xt(i) - pxyz(1,n)); xw = (pxyz(1,n)-xt(i-1))
          if (pxyz(2,n) > yt(j) )  j=j+1
          yn = (yt(j) - pxyz(2,n)); ys = (pxyz(2,n) - yt(j-1))
          zu = (zw(k) - pxyz(3,n)); zl = (pxyz(3,n)-zw(k-1))

          if (maskT(ilim(i+1),j,k)==0) then; xe=dx;xw=0; endif
          if (maskT(i-1,j,k)==0) then; xe=0;xw=dx; endif
          if (maskT(i,jlim(j+1),k)==0) then; yn=dx;ys=0; endif
          if (maskT(i,j-1,k)==0) then; yn=0;ys=dx; endif

          dv = 1./(dx*dx*dz)
          xeyszu = xe*ys*zu*dv; xwyszu = xw*ys*zu*dv
          xeyszl = xe*ys*zl*dv; xwyszl = xw*ys*zl*dv
          xeynzu = xe*yn*zu*dv; xwynzu = xw*yn*zu*dv
          xeynzl = xe*yn*zl*dv; xwynzl = xw*yn*zl*dv
!-----------------------------------------------------------------------
!           interpolate w on particle position
!-----------------------------------------------------------------------
          wwh=w(i-1,j  ,k-1,tau  )*xeyszu+w(i,j  ,k-1,tau  )*xwyszu  &
             +w(i-1,j  ,k  ,tau  )*xeyszl+w(i,j  ,k  ,tau  )*xwyszl  &
             +w(i-1,j-1,k-1,tau  )*xeynzu+w(i,j-1,k-1,tau  )*xwynzu  &
             +w(i-1,j-1,k  ,tau  )*xeynzl+w(i,j-1,k  ,tau  )*xwynzl
         if (.not. enable_hydrostatic ) then
          wwf=w(i-1,j  ,k-1,taup1)*xeyszu+w(i,j  ,k-1,taup1)*xwyszu  &
             +w(i-1,j  ,k  ,taup1)*xeyszl+w(i,j  ,k  ,taup1)*xwyszl  &
             +w(i-1,j-1,k-1,taup1)*xeynzu+w(i,j-1,k-1,taup1)*xwynzu  &
             +w(i-1,j-1,k  ,taup1)*xeynzl+w(i,j-1,k  ,taup1)*xwynzl
          ww=th*wwh+tf*wwf
         else
          ww=wwh
         endif
!-----------------------------------------------------------------------
!         integrate the particle trajectory forward for one time step
!-----------------------------------------------------------------------
          xold=pxyz(1,n); yold=pxyz(2,n); zold=pxyz(3,n)
          pxyz(1,n) = pxyz(1,n) + dt*uu/mmax
          pxyz(2,n) = pxyz(2,n) + dt*vv/mmax
          pxyz(3,n) = pxyz(3,n) + dt*ww/mmax
          puvw(1,n)=uu; puvw(2,n)=vv; puvw(3,n)=ww
!-----------------------------------------------------------------------
!           update index of bounding tracer volume
!-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          if (pxyz(1,n) >= xu(i)) then
            pijk(1,n) = i + 1
          else if (pxyz(1,n) < xu(i-1)) then
            pijk(1,n) = i - 1
          endif
          if (enable_cyclic_x .and. pijk(1,n)==nx ) then
             pijk(1,n)=2; pxyz(1,n)=pxyz(1,n)-dx*(nx -2)
          endif
          if (enable_cyclic_x .and. pijk(1,n)==1) then
            pijk(1,n)=nx -1; pxyz(1,n)=pxyz(1,n)+dx*(nx -2)
          endif

          if (pxyz(2,n) >= yu(j)) then
            pijk(2,n) = j + 1
          else if (pxyz(2,n) < yu(j-1)) then
            pijk(2,n) = j - 1
          endif
          if (enable_cyclic_y .and. pijk(2,n)==ny ) then
             pijk(2,n)=2; pxyz(2,n)=pxyz(2,n)-dx*(ny -2)
          endif
          if (enable_cyclic_y .and. pijk(2,n)==1) then
            pijk(2,n)=ny -1; pxyz(2,n)=pxyz(2,n)+dx*(ny -2)
          endif

          if (pxyz(3,n) >= zw(k)) then
            pijk(3,n) = k + 1
          else if (pxyz(3,n) < zw(k-1)) then
            pijk(3,n) = k - 1
          endif
!-----------------------------------------------------------------------
!         constrain particles vertically to lie within ocean
!-----------------------------------------------------------------------
          if (pijk(3,n) /= k) then
            if (pijk(3,n) > k .and. maskT(i,j,k+1) ==0.) then
              pxyz(3,n) = zold
              pijk(3,n) = k
            endif
            if (pijk(3,n) < k .and. maskT(i,j,k-1) ==0.) then
              pxyz(3,n) = zold
              pijk(3,n) = k
            endif
          endif
!-----------------------------------------------------------------------
!         constrain particles longitudinally to stay within ocean 
!-----------------------------------------------------------------------
          if (pijk(1,n) /= i) then
            if (pijk(1,n) > i .and. maskT(i+1,j,k) ==0.) then
              pxyz(1,n) = xold
              pijk(1,n) = i
            else if (pijk(1,n) < i .and. maskT(i-1,j,k) ==0.) then
              pxyz(1,n) = xold
              pijk(1,n) = i
            endif 
          endif 
!-----------------------------------------------------------------------
!         constrain particles latitudinally to stay within ocean 
!-----------------------------------------------------------------------
          if (pijk(2,n) /= j) then
            if (pijk(2,n) > j .and. maskT(i,j+1,k) == 0. ) then
              pxyz(2,n) = yold
              pijk(2,n) = j
            else if (pijk(2,n) < j .and. maskT(i,j-1,k) == 0.) then
              pxyz(2,n) = yold
              pijk(2,n) = j
            endif 
          endif 
        endif ! particle_active
!-----------------------------------------------------------------------
!      average some quantitites
!-----------------------------------------------------------------------

 if  (particle_averages) then
         mu(n)=mu(n)+uu
         muu(n)=muu(n)+uu**2
         mv(n)=mv(n)+vv
         mvv(n)=mvv(n)+vv**2
         mw(n)=mw(n)+ww
         mww(n)=mww(n)+ww**2
 endif
   enddo ! nptraj
 if  (particle_averages) then
        counter=counter+1
 endif
       call particle_distribute
      enddo ! m

!-----------------------------------------------------------------------
!      write particle positions to netcdf file
!-----------------------------------------------------------------------
      if ( mod(itt,int(snapint/dt))  == 0)  then

 if  (particle_averages) then
          mu=mu/counter; muu=muu/counter-mu**2
          mv=mv/counter; mvv=mvv/counter-mv**2
          mw=mw/counter; mww=mww/counter-mw**2
 endif
        call particle_write_cdf()

 if  (particle_averages) then
        counter=0; mu=0;muu=0;mv=0;mvv=0;mw=0;mww=0
 endif
      endif
 end subroutine integrate_particle





 subroutine particle_write_cdf
!=======================================================================
!       integrate particles
!=======================================================================
      use pyOM_module   
      use particle_module
      use fcontrol_module
      implicit none 
      include "netcdf.inc"
      integer :: ncid,iret,xid,yid,zid,timedim,ilen,timeid
      integer :: uid,vid,wid,bid,pid,uuid,vvid,wwid,n
      real*8 :: fxa,time
      real*8, parameter :: spval = -1.0d33
      if (my_pe==0) then
         print*,'writing particles to file float.cdf'
         iret=nf_open('float.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_varid(ncid,'x_pos',xid)
         iret=nf_inq_varid(ncid,'y_pos',yid)
         iret=nf_inq_varid(ncid,'z_pos',zid)
         iret=nf_inq_varid(ncid,'u',uid)
         iret=nf_inq_varid(ncid,'v',vid)
         iret=nf_inq_varid(ncid,'w',wid)
         iret=nf_inq_varid(ncid,'uu',uuid)
         iret=nf_inq_varid(ncid,'vv',vvid)
         iret=nf_inq_varid(ncid,'ww',wwid)
 if (particle_buoyancy) then
          iret=nf_inq_varid(ncid,'b',bid)
          iret=nf_inq_varid(ncid,'p',pid)
 endif
         iret=nf_inq_dimid(ncid,'Time',timedim)
         iret=nf_inq_dimlen(ncid, timedim,ilen)
         iret=nf_inq_varid(ncid,'Time',timeid)
         ilen=ilen+1
        time = itt*dt
        fxa = time/86400.0
         iret= nf_put_vara_double(ncid,timeid,ilen,1,fxa)
         do n=1,nptraj
        iret= nf_put_vara_double(ncid,xid,(/n,ilen/),(/1,1/),pxyz(1,n))
        iret= nf_put_vara_double(ncid,yid,(/n,ilen/),(/1,1/),pxyz(2,n))
        iret= nf_put_vara_double(ncid,zid,(/n,ilen/),(/1,1/),pxyz(3,n))
 if  (particle_averages) then
         iret= nf_put_vara_double(ncid,uid,(/n,ilen/),(/1,1/),mu(n))
         iret= nf_put_vara_double(ncid,vid,(/n,ilen/),(/1,1/),mv(n))
         iret= nf_put_vara_double(ncid,wid,(/n,ilen/),(/1,1/),mw(n))
         iret= nf_put_vara_double(ncid,uuid,(/n,ilen/),(/1,1/),muu(n))
         iret= nf_put_vara_double(ncid,vvid,(/n,ilen/),(/1,1/),mvv(n))
         iret= nf_put_vara_double(ncid,wwid,(/n,ilen/),(/1,1/),mww(n))
 else
        iret= nf_put_vara_double(ncid,uid,(/n,ilen/),(/1,1/),puvw(1,n))
        iret= nf_put_vara_double(ncid,vid,(/n,ilen/),(/1,1/),puvw(2,n))
        iret= nf_put_vara_double(ncid,wid,(/n,ilen/),(/1,1/),puvw(3,n))
 endif
 if (particle_buoyancy) then
         iret= nf_put_vara_double(ncid,bid,(/n,ilen/),(/1,1/),ptr(1,n))
         iret= nf_put_vara_double(ncid,pid,(/n,ilen/),(/1,1/),ptr(2,n))
 endif
         enddo
         call ncclos (ncid, iret)
       endif
       call fortran_barrier

 end subroutine particle_write_cdf




subroutine particle_init_cdf
      use pyOM_module   
      use particle_module
      use fcontrol_module
      implicit none 
      include "netcdf.inc"
      integer :: iret,dims(2),xid,yid,zid,uid,vid,wid,bid,pid
      integer :: ncid,Timedim,Timeid,pdim,uuid,vvid,wwid
      character :: name*24, unit*16
      real*8, parameter :: spval = -1.0d33

!-----------------------------------------------------------------------
!     define output file
!-----------------------------------------------------------------------
      if (my_pe==0) then
       ncid = nccre ('float.cdf', NCCLOB, iret)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       Timedim = ncddef(ncid, 'Time', nf_unlimited, iret)
       pdim    = ncddef(ncid, 'Number', nptraj, iret)
       timeid  = ncvdef (ncid,'Time', NCFLOAT,1,timedim,iret)
       dims = (/pdim,Timedim/)
       xid  = ncvdef (ncid,'x_pos', NCFLOAT,2,dims,iret)
       yid  = ncvdef (ncid,'y_pos', NCFLOAT,2,dims,iret)
       zid  = ncvdef (ncid,'z_pos', NCFLOAT,2,dims,iret)
       uid  = ncvdef (ncid,'u', NCFLOAT,2,dims,iret)
       vid  = ncvdef (ncid,'v', NCFLOAT,2,dims,iret)
       wid  = ncvdef (ncid,'w', NCFLOAT,2,dims,iret)
 if  (particle_averages) then
        uuid  = ncvdef (ncid,'uu', NCFLOAT,2,dims,iret)
        vvid  = ncvdef (ncid,'vv', NCFLOAT,2,dims,iret)
        wwid  = ncvdef (ncid,'ww', NCFLOAT,2,dims,iret)
 endif
 if (particle_buoyancy) then
        pid  = ncvdef (ncid,'p', NCFLOAT,2,dims,iret)
        bid  = ncvdef (ncid,'b', NCFLOAT,2,dims,iret)
 endif
       name = 'Time '; unit = 'days'
       call ncaptc(ncid, timeid, 'long_name', NCCHAR, 24, name, iret) 
       call ncaptc(ncid, timeid, 'units',     NCCHAR, 16, unit, iret) 
       call ncaptc(ncid, Timeid,'time_origin',NCCHAR, 20,'01-JAN-1900 00:00:00', iret)
       name = 'X position'; unit = 'm'
       call dvcdf(ncid,xid,name,24,unit,16,spval)
       name = 'Y position'; unit = 'm'
       call dvcdf(ncid,yid,name,24,unit,16,spval)
       name = 'Z position'; unit = 'm'
       call dvcdf(ncid,zid,name,24,unit,16,spval)
       name = 'zonal velocity'; unit = 'm/s'
       call dvcdf(ncid,uid,name,24,unit,16,spval)
       name = 'meridional velocity'; unit = 'm/s'
       call dvcdf(ncid,vid,name,24,unit,16,spval)
       name = 'vertical velocity'; unit = 'm/s'
       call dvcdf(ncid,wid,name,24,unit,16,spval)
 if (particle_buoyancy) then
        name = 'buoyancy'; unit = 'm/s^2'
        call dvcdf(ncid,bid,name,24,unit,16,spval)
        name = 'pressure'; unit = 'm^2/s'
        call dvcdf(ncid,pid,name,24,unit,16,spval)
 endif
 if  (particle_averages) then
        name = 'zonal velocity variance'; unit = 'm^2/s^2'
        call dvcdf(ncid,uuid,name,24,unit,16,spval)
        name = 'meridional velocity variance'; unit = 'm^2/s^2'
        call dvcdf(ncid,vvid,name,24,unit,16,spval)
        name = 'vertical velocity variance'; unit = 'm^2/s^2'
        call dvcdf(ncid,wwid,name,24,unit,16,spval)
 endif
       call ncclos (ncid, iret)
      endif

      if (my_pe==0)  then
       print*,' Done initializing time averaging module'
      endif
end subroutine particle_init_cdf


subroutine particle_write_restart(ierr)
      use pyOM_module   
      use particle_module
      use fcontrol_module
      implicit none 
      integer :: n,io,ierr
!-----------------------------------------------------------------------
!    write restart file
!-----------------------------------------------------------------------
   ierr=0
   if (my_pe==0) then
      print*,'writing restart file for particles'
      call get_free_iounit(io)
      open(io,file='restart_float.dta',form='unformatted',status='unknown')
      write(io) nptraj
      do n=1,nptraj
       write(io) pijk(1:3,n),pxyz(1:3,n),puvw(1:3,n)
      enddo
      close(io)
      print*,' done writing restart'
  endif
 end subroutine particle_write_restart


subroutine particle_read_restart
      use pyOM_module   
      use particle_module
      use fcontrol_module
      implicit none 
      integer :: n,io
 if (my_pe==0) then
        print*,' reading data from restart file '
        call get_free_iounit(io)
        open(io,file='restart_float.dta',form='unformatted',   status='old')
        read(io) nptraj
        allocate( pxyz(3,nptraj), pijk(3,nptraj),puvw(3,nptraj) )
        print*,' number of particles = ',nptraj
        do n=1,nptraj
         read(io) pijk(1:3,n),pxyz(1:3,n),puvw(1:3,n)
        enddo
        close(io)
        print*,' done reading restart'
 endif
end subroutine particle_read_restart


 subroutine particle_inside_pe_domain()
!=======================================================================
!       is particle inside domain of pe?
!=======================================================================
      use pyOM_module   
      use particle_module
      implicit none 
      integer :: n

      do n=1,nptraj
       if (pijk(2,n)>=js_pe .and. pijk(2,n)<=je_pe) then
        particle_active(n) = .true. 
        particle_pe(n)=my_pe
       else
        particle_active(n) = .false.
        particle_pe(n)=-1
       endif
      enddo
      call global_max_int(particle_pe,nptraj)
 end subroutine particle_inside_pe_domain


 subroutine particle_distribute
!=======================================================================
!     distribute particles to all pes
!=======================================================================
      use pyOM_module   
      use particle_module
      implicit none 
      integer :: n
      call fortran_barrier()
      do n=1,nptraj
       if (particle_pe(n)>=0) then
        call bcast_real(    pxyz(3,n),3,particle_pe(n))
        call bcast_integer(pijk(3,n),3,particle_pe(n))
      elseif (my_pe==0) then
        print*,' WARNING : particle #',n,' is out of domain.', ' pxyz= ',pxyz(:,n),' pijk= ',pijk(:,n), &
                ' particle PE=',particle_pe(n)
      endif
      enddo
 end subroutine particle_distribute


 subroutine seed_particles_randomly
!=======================================================================
!      seed the particles
!=======================================================================
      use pyOM_module   
      use particle_module
      implicit none 
      real:: fxa,xs,xe,ys,ye,zs,ze ! mit absicht nciht real*8
      integer :: n
!#ifdef two_dim
!      xs=xt(2); xe=xt(nx -1)
!      ys=yt(2);
!      zs=zt(2); ze=zt(nz-1)
!      do n=1,nptraj
!        pxyz(2,n) = ys
!        call random_number(fxa)
!        pxyz(1,n) = xs+fxa*(xe-xs)
!        call random_number(fxa)
!        pxyz(3,n) = zs+fxa*(ze-zs)
!!      enddo
!#else
      xs=xt(2); xe=xt(nx-1)
      ys=xt(2); ye=yt(ny-1)
      zs=zt(2); ze=zt(nz-1)
      do n=1,nptraj
       call random_number(fxa)
       pxyz(1,n) = xs+fxa*(xe-xs)
       call random_number(fxa)
       pxyz(2,n) = ys+fxa*(ye-ys)
       call random_number(fxa)
       pxyz(3,n) = zs+fxa*(ze-zs)
      enddo
!#endif
 end subroutine seed_particles_randomly


 subroutine seed_particles_regular
!=======================================================================
!      seed the particles
!=======================================================================
      use pyOM_module   
      use particle_module
      implicit none 
      real*8 :: cubr,distx,disty,distz
      integer :: n
      real*8 :: xs,xe,ys,ye,zs,ze
      logical :: two_dimx = .false.
      logical :: two_dimy = .true.

 if (two_dimx) then
      xs=xt(2); xe=xt(nx -1)
      ys=yt(ny/2);
      zs=zt(2); ze=zt(nz-1)
      cubr       = float(nptraj)**0.5
      distx      = (xe - xs)/cubr
      distz      = (ze - zs)/cubr
      pxyz(1,1) = .5*distx + xs
      pxyz(2,1) =  ys
      pxyz(3,1) = .5*distz + zs
      do n=2,nptraj
        pxyz(1,n) = pxyz(1,n-1)
        pxyz(2,n) = pxyz(2,n-1)
        pxyz(3,n) = pxyz(3,n-1)
        pxyz(1,n)  = pxyz(1,n) + distx
        if (pxyz(1,n) > xe) then
         pxyz(1,n) = xs + (pxyz(1,n)-xe)
         pxyz(2,n) = ys
         pxyz(3,n) = pxyz(3,n) + distz
       endif
      enddo
 elseif (two_dimy) then

      xs=0.5*xt(nx);
      ys=yt(2); ye=yt(ny-1)
      zs=zt(2); ze=zt(nz-1)
      cubr       = float(nptraj)**0.5
      disty      = (ye - ys)/cubr
      distz      = (ze - zs)/cubr
      pxyz(1,1) =  xs
      pxyz(2,1) = .5*disty + ys
      pxyz(3,1) = .5*distz + zs
      do n=2,nptraj
        pxyz(1,n) = pxyz(1,n-1)
        pxyz(2,n) = pxyz(2,n-1)
        pxyz(3,n) = pxyz(3,n-1)
        pxyz(2,n)  = pxyz(2,n) + disty
        if (pxyz(2,n) > ye) then
         pxyz(2,n) = ys + (pxyz(2,n)-ye)
         pxyz(1,n) = xs
         pxyz(3,n) = pxyz(3,n) + distz
       endif
      enddo
 else

      xs=xt(2); xe=xt(nx -1)
      ys=yt(2); ye=yt(ny -1)
      zs=zt(2); ze=zt(nz-1)
      cubr       = float(nptraj)**0.333333
      distx      = (xe - xs)/cubr
      disty      = (ye - ys)/cubr
      distz      = (ze - zs)/cubr
      pxyz(1,1) = .5*distx + xs
      pxyz(2,1) = .5*disty + ys
      pxyz(3,1) = .5*distz + zs
      do n=2,nptraj
        pxyz(1,n) = pxyz(1,n-1)
        pxyz(2,n) = pxyz(2,n-1)
        pxyz(3,n) = pxyz(3,n-1)
        pxyz(1,n)  = pxyz(1,n) + distx
        if (pxyz(1,n) > xe) then
         pxyz(1,n) = xs + (pxyz(1,n)-xe)
         pxyz(2,n) = pxyz(2,n) + disty
         if (pxyz(2,n) > ye) then
          pxyz(2,n) = ys + (pxyz(2,n)-ye)
          pxyz(3,n) = pxyz(3,n) + distz
         endif
        endif
      enddo
 endif
 end subroutine seed_particles_regular


 function ilim(i)
      use pyOM_module   
      implicit none 
      integer :: i ,ilim
      if (enable_cyclic_x) then
        ilim=i
        if (i>nx ) ilim=i-(nx -2)
        if (i<1) ilim=i+(nx -2)
      else
        ilim=max(1,min(nx ,i))
      endif
 end function ilim

 function jlim(j)
      use pyOM_module   
      implicit none 
      integer :: j ,jlim
      if (enable_cyclic_y) then
        jlim=j
        if (j>ny ) jlim=j-(ny -2)
        if (j<1) jlim=j+(ny -2)
      else
        jlim=max(1,min(ny ,j))
      endif
 end function jlim

 function klim(k)
      use pyOM_module   
      implicit none 
      integer :: k ,klim
      klim=max(1,min(nz,k))
 end function klim


 integer function indp (value, array, ia)
!
!=======================================================================
!
!     indp = index of nearest data point within "array" corresponding to
!            "value".
!
!     inputs:
!
!     value  = arbitrary data...same units as elements in "array"
!     array  = array of data points  (must be monotonically increasing)
!     ia     = dimension of "array"
!
!     output:
!
!     indp =  index of nearest data point to "value"
!             if "value" is outside the domain of "array" then indp = 1
!             or "ia" depending on whether array(1) or array(ia) is
!             closest to "value"
!
!             note: if "array" is dimensioned array(0:ia) in the calling
!                   program, then the returned index should be reduced
!                   by one to account for the zero base.
!
!     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
!
!     example:
!
!     let model depths be defined by the following:
!     parameter (km=5)
!     dimension z(km)
!     data z /5.0, 10.0, 50.0, 100.0, 250.0/
!
!     k1 = indp (12.5, z, km)
!     k2 = indp (0.0, z, km)
!
!     k1 would be set to 2, & k2 would be set to 1 so that
!     z(k1) would be the nearest data point to 12.5 and z(k2) would
!     be the nearest data point to 0.0
!
!=======================================================================
!
      implicit none
      integer :: i,ia,ii
      integer :: stdout=6
      real*8, dimension(ia) ::  array
      real*8 :: value
!
      do i=2,ia
        if (array(i) .lt. array(i-1)) then
         write (stdout,*)  &
        ' => Error: array must be monotonically increasing in "indp"'   &
     ,  '           when searching for nearest element to value=',value 
          write (stdout,*) '           array(i) < array(i-1) for i=',i 
          write (stdout,*) '           array(i) for i=1..ia follows:'
          do ii=1,ia
            write (stdout,*) 'i=',ii, ' array(i)=',array(ii)
          enddo
          stop
       endif
      enddo
      if (value .lt. array(1) .or. value .gt. array(ia)) then
        if (value .lt. array(1))  indp = 1
        if (value .gt. array(ia)) indp = ia
        return
      else
        do i=2,ia
          if (value .le. array(i)) then
            indp = i
            if (array(i)-value .gt. value-array(i-1)) indp = i-1
            go to 101
          endif
        enddo
101     continue
      endif
 end function indp

!=======================================================================
!  idealised Southern Ocean and gyre circulation
!======================================================================= 


module config_module
 ! use this module only locally in this file
 implicit none
 real*8,parameter :: hRESOLVE = 0.5   ! 1 in original model
 real*8,parameter :: vRESOLVE = 1.0   ! 1 in original model
 real*8,parameter :: N_0     = 0.004
 real*8,parameter :: pi      = 3.14159265358979323846264338327950588
 real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
 real*8,parameter :: radius  = 6370.0e3
 real*8,parameter :: tau0 = 0.2, rho_0 = 1024.0
end module config_module


subroutine set_parameter
 ! ----------------------------------
 !       set here main parameter
 ! ----------------------------------
 use pyOM_module   
 use fcontrol_module
 use config_module
 implicit none
      nx   = 128*hRESOLVE 
      nz   = 20 *vRESOLVE;
      ny   = 256*hRESOLVE
      dx    = 20e3/hRESOLVE
      dz    = 50.0 /vRESOLVE
      dt    = 1200.0/hRESOLVE

      K_h=0000.0 /hRESOLVE
      A_h=0000.0 /hRESOLVE
!      A_h=10000.0!/hRESOLVE  ! for coarse model version
      Ahbi  = 5e11/hRESOLVE**2
      Khbi  = Ahbi

      K_v=1.0e-4/vRESOLVE
      A_v=10.e-4/vRESOLVE
      cdbot = 2e-5*vRESOLVE

      eps2D_sor = 1e-9

      enable_noslip               = .true.
      enable_cyclic_x             = .true.
      enable_bottom_stress        = .true.
      enable_biharmonic_friction  = .true.  ! was on in original model
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .true.  
      !enable_pv_mixing            = .true.   ! was off in original model

      !enable_vert_friction_trm = .true. ! for coarse model version
      !K_gm=2000.0 ! for coarse model version

      enable_diag_zonalave = .true.
      !enable_diag_timeave  = .true.
      runlen = 365*86400.   ! was  one year in original model
      snapint = 3.*86400.     ! was 3 days in original model
end subroutine set_parameter


subroutine set_coriolis
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: j
 real*8:: f0,beta
 f0 = -1e-4
 beta = -2*f0/(yt(ny)-yt(1))
 do j=1,ny
    coriolis_t(j) = f0 + beta*yt(j)
 enddo
end subroutine set_coriolis


subroutine initial_conditions
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: i,j,k
 real*8 :: bstar,B0,x,y
 do j=1,ny
   call b_surface(bstar,j)
   do k=1,nz
     do i=1,nx
         x=float(i)/float(nx)
         y = (yt(j)-yt(2))/ (yt(ny-1)-yt(2))
         B0=0.0e-3*sin(x*8.5*pi)*exp(-(y-0.5)**2/0.5**2)
         b(i,j,k,:)  = (1*bstar+B0-N_0**2*zt(k))*maskT(i,j,k)
     enddo
   enddo
 enddo
end subroutine initial_conditions


subroutine b_surface(bstar,j)
 use pyOM_module   
 use config_module   
 implicit none
 integer :: j
 real*8 :: db,bstar,y2,L_y
 L_y = yt(ny )-yt(1)
 db = -30e-3
 bstar=db
 if (yt(j)<L_y/4.0) then
       bstar=db*yt(j)/(L_y/4.0)
 endif
 y2=L_y*(1-0.25)
 if (yt(j)>y2) then
       bstar=db*(1-(yt(j)-y2)/(yt(ny )-y2) )
 endif
end subroutine b_surface


subroutine boundary_conditions
 ! ----------------------------------
 !    add here boundary conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: i,j
 real*8 :: L_y,y,t_rest,bstar
 L_y = yt(ny )-yt(1)
 t_rest=30*86400
 do j=1,ny 
   call b_surface(bstar,j)
   do i=1,nx 
     y = yu(j)/L_y
     !if (y<=0.25) surface_taux(i,j) = tau0/rho_0*sin(4*pi*y)*maskU(i,j,nz-1)
     !if (y> 0.25) surface_taux(i,j) = tau0/rho_0*(cos(3*pi*(y-0.25)/0.75)*maskU(i,j,nz-1)-1)

     y=(yu(j)/L_y-0.5)*2  ! -1:1
     if (y>=0) surface_taux(i,j) = -cos(2*pi*y)*(1-exp(-(y/0.25)**2))*(1-exp(-((y-1)/0.25)**2) )
     if (y< 0) surface_taux(i,j) = -cos(1.5*pi*y)*(1-exp(-(y/0.35)**2))

     surface_taux(i,j) = surface_taux(i,j)*tau0/rho_0*maskU(i,j,nz-1)

     surface_flux(i,j)=dz/t_rest*(bstar-b(i,j,nz-1,tau)) 
   enddo
 enddo
end subroutine boundary_conditions

subroutine topography
 ! ----------------------------------
 !      Add here topography  
 ! ----------------------------------
 use pyOM_module   
 implicit none
 integer :: i,j
 real*8 :: L_x,L_y
 L_y = yt(ny )-yt(1)
 do j=1,ny 
    if (yt(j)>L_y/4.0) then
          maskT(1:2,j,:)=0.0
          maskT(nx-1:nx,j,:)=0.0
    endif
 enddo
end subroutine topography

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
! Wide eddying channel with restoring zones at side walls
! Experiment CHANNEL in Eden (2010), Ocean modeling 32 (2010) 58-71
!=======================================================================

module config_module
 ! use this module only locally in this file
 implicit none
 real*8,parameter :: hRESOLVE = 0.5  ! 2 in original model 
 real*8,parameter :: vRESOLVE = 1.0  ! 2 in original model
 real*8,parameter :: rho_0 =1024.0, g=9.81
 real*8,parameter :: M_0     = sqrt(1e-5*0.1/rho_0*g)
 real*8,parameter :: N_0     = 0.004
 real*8,parameter :: pi      = 3.14159265358979323846264338327950588
 real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
 real*8,parameter :: radius  = 6370.0e3,degtom = radius/180.0*pi
end module config_module

subroutine set_parameter
 ! ----------------------------------
 !       set here main parameter
 ! ----------------------------------
 use pyOM_module
 use fcontrol_module
 use config_module
 implicit none
 nx = 128*hRESOLVE 
 nx=3
 nz = 20 *vRESOLVE;
 ny = 128*hRESOLVE
 dx = 1./3.*degtom*cos(30./180.*pi)/hRESOLVE
 dz = 100.0 /vRESOLVE
 dt = 2400.0/hRESOLVE
 K_h=000.0 /hRESOLVE
 K_v=1.0e-4/vRESOLVE
 A_h=0000.0/hRESOLVE
 A_v=10.e-4/vRESOLVE
 !enable_quicker_advection    = .true.  ! was off in original model
 enable_biharmonic_friction  = .true.  ! was enabled in original model
 enable_biharmonic_diffusion = .true.
 Ahbi  = 5e11/hRESOLVE**2
 Khbi  = Ahbi
 enable_interior_stress      = .true.
 cdint = 1e-7
 eps2D_sor = 1e-9
 enable_noslip               = .true.
 enable_cyclic_x             = .true.
 enable_hydrostatic          = .true.
 enable_pv_mixing            = .true.  ! was off in original model

 !enable_vert_friction_trm = .true.  ! this was all off in original model
 !enable_beta_term_forcing = .true.
 !K_gm = 2000.0
 !A_h = K_gm                  

 runlen   = 365.0*86400.0 * 10000 ! 1 year in original model
 snapint  = 3.0*86400.0

 !enable_diag_quasi_stokes = .true.
end subroutine set_parameter


subroutine set_coriolis
 use pyOM_module   
 use config_module
 implicit none
 integer :: j
 real*8 :: phi0 
 phi0 = 10.0 /180. *pi
 do j=1,ny
      coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
 enddo
end subroutine set_coriolis


subroutine initial_conditions
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module
 use config_module
 implicit none
 integer :: i,j,k
 real*8 :: B0,x,y
 do k=1,nz
   do j=1,ny
      do i=1,nx
         x=float(i)/float(nx)
         y = (yt(j)-yt(2))/ (yt(ny-1)-yt(2))
         B0=M_0**2*yt(j)+0.5e-3*sin(x*8.5*pi)*exp(-(y-0.5)**2/0.5**2)
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
     enddo
   enddo
 enddo
end subroutine initial_conditions



subroutine restoring_zones
 ! ----------------------------------
 !      add here restoring zones
 ! ----------------------------------
 use pyOM_module
 use config_module
 implicit none
 integer :: i,j,k,js,je, spg_width 
 real :: T_rest=1./(5.*86400),B0

 spg_width=3*hRESOLVE
 js=max(2,js_pe); je = min(je_pe,ny-1)
 if (my_blk_j==1) then
    do k=1,nz
      do j=2,spg_width+1
         B0=yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt*t_rest/(j-1.)*(B0-b(:,j,k,taum1))
      enddo
    enddo
 endif
 if (my_blk_j==n_pes_j) then
   do k=1,nz
      do j=ny-1,ny-spg_width,-1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt* t_rest/(-1.*(j-ny))*(B0-b(:,j,k,taum1))
      enddo
   enddo
 endif
end subroutine restoring_zones


subroutine boundary_conditions
end subroutine boundary_conditions

subroutine topography
end subroutine topography

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources

 module fcontrol_module
!=======================================================================
!     simple control of integration length and configuration
!=======================================================================
      implicit none
      integer :: itt,enditt
      real*8  :: runlen,snapint
      logical :: enable_diag_zonalave  = .false.
      logical :: enable_diag_timeave   = .false.
      logical :: enable_diag_particle  = .false.
      logical :: enable_bolus_velocity = .false.
      logical :: enable_pv_mixing      = .false.
      logical :: enable_diag_barbi     = .false.
      logical :: enable_diag_quasi_stokes  = .false.
      character*80 :: snap_file = 'pyOM.cdf'
 end module fcontrol_module

 program main
!=======================================================================
!      Top level driver for fortran
!=======================================================================
      use pyOM_module   
      use fcontrol_module
      use timing_module
      implicit none
      integer :: ierr,otaum1,n,io
!---------------------------------------------------------------------------------
!       Initialize MPI setting
!---------------------------------------------------------------------------------
      print '(a,f5.3)' ,'here is pyOM version ',version
      call mpi_init(ierr)
      call my_mpi_init(my_comm,ierr)
!---------------------------------------------------------------------------------
!      Initialize model
!---------------------------------------------------------------------------------
      call tic('setup')
      itt=0
      call setup
      if (enable_pv_mixing)      call init_pv_mixing
      if (enable_bolus_velocity) call init_bolus
      if (enable_diag_particle)  call init_particle
      if (enable_diag_zonalave)  call init_zonal_averages
      if (enable_diag_timeave)   call init_time_averages
      if (enable_diag_barbi)     call init_diag_barbi
      if (enable_diag_quasi_stokes)  call init_quasi_stokes
!---------------------------------------------------------------------------------
!---------------------------------------------------------------------------------
      enditt = itt+runlen/dt
      if (my_pe==0) then
        print'(a,e8.2,a)',' integration for ',runlen,' s'
        print'(a,i10,a,i10)',' from time step ',itt,' to ',enditt
        print'(a,e8.2,a)',' snapshot intervall is ',snapint,' s'
        print'(a,i8,a)',' this is any ',int(snapint/dt),' time steps'
      endif
      call toc('setup')

      call tic('main loop')
!---------------------------------------------------------------------------------
!      Begin main model loop
!---------------------------------------------------------------------------------
 10   continue
      call boundary_conditions
      if (enable_hydrostatic)       call vertical_velocity(ierr)

      call tic('buoyancy')
      call integrate_buoyancy(ierr)

      call restoring_zones
      if (enable_back_state)        call background_state_buoyancy(ierr)
      if (enable_hydrostatic)       call convection(ierr) 
      if (enable_diag_tracer)  then
                 call integrate_tracer(ierr)
                 if (enable_isopycnal_diffusion) call isopycnal_diffusion(ierr)
                 call tracer_sources
      endif
      call toc('buoyancy')

      call tic('momentum')
      call momentum_tendency(ierr)
      if (enable_pv_mixing)         call pv_mixing_main(ierr)
      if (enable_bolus_velocity)    call bolus_velocity
      if (enable_vert_friction_trm) call vert_friction_trm(ierr)
      call momentum_restoring_zones()       
      if (enable_back_state)        call background_state_momentum(ierr)
      call toc('momentum')

      call tic('pressure')
      call solve_pressure(ierr)
      call toc('pressure')

      call integrate(ierr)

      call tic('diagnose')
      call diagnose
      if (enable_diag_tracer)   call diag_tracer
      if (enable_diag_particle) call integrate_particle
      if (enable_diag_zonalave) call zonal_averages
      if (enable_diag_timeave)  call time_averages
      if (enable_diag_barbi)    call diag_barbi
      if (enable_diag_quasi_stokes)  call quasi_stokes
      if (enable_pv_mixing)     call pv_mixing_diag
      call toc('diagnose')

      otaum1=taum1; taum1= tau; tau  = taup1; taup1= otaum1
      if (itt < enditt) then
         itt=itt+1
         goto 10
      endif
      call toc('main loop')
!---------------------------------------------------------------------------------
!       End main model loop
!---------------------------------------------------------------------------------
      call write_restart(itt,'restart.dta')
      if (enable_diag_tracer)   call tracer_write_restart('tracer_restart.dta')
      if (enable_diag_particle) call particle_write_restart(ierr)
      if (enable_diag_quasi_stokes)  then 
        call quasi_stokes_write_restart()
        call quasi_stokes_write_cdf()
      endif
      if (enable_diag_timeave) then
       call write_time_averages_restart(ierr)
       call time_averages_calc
       call time_averages_write
      endif

      if (my_pe==0) then
       call get_free_iounit(n,ierr)
       open(n,file='ritt',form='formatted',status='unknown')
       write(n,*) itt
       close(n)
      endif
!--------------------------------------------------------------
!     show timing results here
!--------------------------------------------------------------
      do n = 0,n_pes
       call fortran_barrier
       if (my_pe == n) then
        print*,''
        print*,'Timing summary for PE #',my_pe 
        print*,' costs for measuring      = ',timing_secs('tictoc'),' s'
        print*,' setup time summary       = ',timing_secs('setup'),' s'
        print*,' main loop time summary   = ',timing_secs('main loop') ,' s'
        print*,' buoyancy time summary    = ',timing_secs('buoyancy') ,' s'
        print*,' momentum time summary    = ',timing_secs('momentum') ,' s'
        print*,' pressure time summary    = ',timing_secs('pressure') ,' s'
        print*,' diagnostics time summary = ',timing_secs('diagnose') ,' s'
       endif
      enddo

   call mpi_finalize(ierr)
 end program main



 subroutine setup
!=======================================================================
!      setup everything
!=======================================================================
      use pyOM_module   
      use fcontrol_module
      implicit none
      integer :: i,j,k,n,ierr
      logical :: file_exists = .false.
! ----------------------------------
!       Set main parameter
! ----------------------------------
      call set_parameter
! ----------------------------------
!       Some more or less useful output
! ----------------------------------
      if (my_pe==0) then
       print*,''
       print'(a,i4,a,i4,a,i4)',' grid size    : nx=',nx,' ny=',ny,' nz=',nz
       print'(a,e8.2,a,e8.2,a)',' grid spacing : Delta x =',dx,'m  Delta z =',dz,'m'
       print'(a,e8.2,a,e8.2,a,e8.2,a)',' domain size  : ',nx*dx,'m X ',ny*dx,'m X ',nz*dz,'m'
       print'(a,e8.2,a)',' time step    : ',dt,'s'
       print'(a,e8.2,a)',' lateral  diffusivity : K_h=',K_h,' m^2/s'
       print'(a,e8.2,a)',' vertical diffusivity : K_v=',K_v,' m^2/s'
       print'(a,e8.2,a)',' lateral  viscosity   : A_h=',A_h,' m^2/s'
       print'(a,e8.2,a)',' vertical viscosity   : A_v=',A_v,' m^2/s'
      endif

       c2dt=dt
! ----------------------------------
!      time step splitting for explicit free surface
! ----------------------------------
       dtex=dx/sqrt(9.81*(nz-2)*dz ) /4.
       n=nint(dt/dtex)
       dtex=dt/n
       if (my_pe==0.and.enable_expl_free_surf) then
        print*,' free surface time step : ',dtex,' s'
       endif
! ----------------------------------
!      domain decomposition for each PE
! ----------------------------------
      if (n_pes>1) then
       n_pes_j = n_pes
       j_blk = (ny-1)/n_pes_j + 1    ! j-extent of each block
       my_blk_j = my_pe + 1 ! number of PE in j-dir.
       js_pe = (my_blk_j-1)*j_blk + 1
       je_pe = min(my_blk_j*j_blk,ny)
! ----------------------------------
!      check for incorrect domain decomposition
! ----------------------------------
       if (my_blk_j==n_pes_j .and. js_pe>=je_pe-2) then
        print*,' ERROR: on PE: ', my_pe
        print*,' domain decompositon impossible in j-direction'
        print*,' choose other number of PEs in j-direction'
        call halt_stop(' ... ')
       endif
      else
       n_pes_j = n_pes
       j_blk = ny
       my_blk_j = 1 
       js_pe = 1
       je_pe = ny
      endif
! ----------------------------------
!      print out the PE decomposition, let all PEs talk
! ----------------------------------
      if (my_pe==0) print*,' Domain decomposition:'
      do n=0,n_pes-1
       if (my_pe==n) then
         print*,''
         print*,' sub domain for PE #',n
         print*,' my_blk_j=',my_blk_j
         print*,' js_pe=',js_pe,' je_pe=',je_pe
         print*,''
       endif
      enddo
! ----------------------------------
!      allocate work space
! ----------------------------------
      call allocate_work_space
! ----------------------------------
!      setup grid
! ----------------------------------
      xt(1)=0.0
      xu(1)=xt(1)+dx/2.0
      do i=2,nx
        xt(i)=xt(i-1)+dx
        xu(i)=xu(i-1)+dx
      enddo
      yt(1)=0.0
      yu(1)=yt(1)+dx/2.0
      do i=2,ny
        yt(i)=yt(i-1)+dx
        yu(i)=yu(i-1)+dx
      enddo
      zw(1)=0
      zt(1)=zw(1)-dz/2.0
      do k=2,nz
        zt(k)=zt(k-1)+dz
        zw(k)=zw(k-1)+dz
      enddo
      zt=zt-dz*(nz-2)
      zw=zw-dz*(nz-2)
! ----------------------------------
!      set coriolis parameter
! ----------------------------------
      call set_coriolis()
! ----------------------------------
!      Land mask
! ----------------------------------
      maskT=0.0
      maskT(2:nx-1,2:ny-1,2:nz-1)=1.0
      call topography
      if (enable_cyclic_x) maskT(1,:,:)=0.0
      if (enable_cyclic_x) maskT(nx,:,:)=0.0
      if (enable_cyclic_y) maskT(:,1,:)=0.0
      if (enable_cyclic_y) maskT(:,ny,:)=0.0
      call setcyclic3D(nx,ny,nz,maskT)
      maskU=maskT
      do i=1,nx-1
       maskU(i,:,:)=min(maskT(i,:,:),maskT(i+1,:,:))
      enddo
      call setcyclic3D(nx,ny,nz,maskU)
      maskV=maskT
      do j=1,ny-1
       maskV(:,j,:)=min(maskT(:,j,:),maskT(:,j+1,:))
      enddo
      call setcyclic3D(nx,ny,nz,maskV)
      maskW=maskT
      do k=1,nz-1
       maskW(:,:,k)=min(maskT(:,:,k),maskT(:,:,k+1))
      enddo
      call setcyclic3D(nx,ny,nz,maskW)
! ----------------------------------
!     depth 
! ----------------------------------
      ht=0.0;hu=0.0;hv=0.0 
      do k=1,nz
       ht=ht+maskT(:,:,k)*dz
       hu=hu+masku(:,:,k)*dz
       hv=hv+maskv(:,:,k)*dz
      enddo
      do k=nz,1,-1
       where (maskU(:,:,k)>0) k_bottom_u=k
       where (maskV(:,:,k)>0) k_bottom_v=k
      enddo
! ----------------------------------
!     coefficients for poisson solver
! ----------------------------------
      call make_coef2d(ierr)
      if (.not.enable_hydrostatic) call make_coef3d(ierr)
! ----------------------------------
!   initial conditions 
! ----------------------------------
      if (my_pe==0) print*,' using initial conditions '
      call initial_conditions
      inquire( FILE='restart.dta', EXIST=file_exists )
      if (file_exists) then 
        call read_restart(itt,'restart.dta')
      else
       call exchg_prog3Dfield_complete(nx,ny,nz,b)
       call exchg_prog3Dfield_complete(nx,ny,nz,u)
       call exchg_prog3Dfield_complete(nx,ny,nz,v)
       call exchg_prog3Dfield_complete(nx,ny,nz,w)
       call exchg_prog3Dfield_complete(nx,ny,nz,p_full)
       call exchg_prog2Dfield_complete(nx,ny,eta)
       call exchg_3Dfield_complete(nx,ny,nz,psi)
       if (enable_expl_free_surf) then
         call exchg_prog2Dfield_complete(nx,ny,bu)
         call exchg_prog2Dfield_complete(nx,ny,bv)
       endif
      endif
! ----------------------------------
!   initialize diagnostic       
! ----------------------------------
      if (my_pe==0) call init_snap_cdf()
! ----------------------------------
!  passive tracer stuff
! ----------------------------------
      if (my_pe==0 .and. enable_diag_tracer) call init_tracer_diag()
      inquire(FILE='tracer_restart.dta', EXIST=file_exists )
      if (file_exists) call tracer_read_restart('tracer_restart.dta')
  end subroutine setup



 subroutine allocate_work_space
!=======================================================================
!      Allocate memory for all arrays in main module
!=======================================================================
      use pyOM_module   
      implicit none
      allocate(zt(nz),zw(nz),xt(nx ),xu(nx ),yt(ny ),yu(ny ) )
      taum1=1; tau=2; taup1=3
      allocate( u(nx ,ny ,nz,3) ); u=0.
      allocate( v(nx ,ny ,nz,3) ); v=0.
      allocate( w(nx ,ny ,nz,3) ); w=0.
      allocate( b(nx ,ny ,nz,3)   ); b=0.
      allocate( K_b(nx ,ny ,nz)  );    K_b=0.
      allocate( p_hydro(nx ,ny ,nz) ); p_hydro=0.
      allocate( p_full(nx ,ny ,nz,3)  ); p_full=0.
      allocate( p_surf(nx ,ny )     ); p_surf=0.
      allocate( psi(nx ,ny ,nz)     ); psi=0.
      allocate( eta(nx ,ny ,3)    ); eta=0.
      allocate( maskT(nx ,ny ,nz)   ); maskT=0.
      allocate( maskU(nx ,ny ,nz)   ); maskU=0.
      allocate( maskV(nx ,ny ,nz)   ); maskV=0.
      allocate( maskW(nx ,ny ,nz)   ); maskW=0.
      allocate( fu(nx ,ny ,nz)      ); fu=0.
      allocate( fv(nx ,ny ,nz)      ); fv=0.
      allocate( fw(nx ,ny ,nz)      ); fw=0.
      allocate( surface_flux(nx ,ny )  ); surface_flux=0.
      allocate( bottom_flux(nx ,ny )  ); bottom_flux=0.
      allocate( surface_taux(nx ,ny ) ); surface_taux=0.
      allocate( surface_tauy(nx ,ny ) ); surface_tauy=0.
      allocate( bottom_taux(nx ,ny ) ); bottom_taux=0.
      allocate( bottom_tauy(nx ,ny ) ); bottom_tauy=0.
      allocate(coriolis_t(ny ), coriolis_hor(ny ) )
      coriolis_t=0.;coriolis_hor=0.
      allocate( hu(nx ,ny ),hv(nx ,ny ),ht(nx ,ny ))
      hu=0.;hv=0.;ht=0.
      allocate( cf2D(nx ,ny ,3,3) )
      if (.not.enable_hydrostatic) then
        allocate( cf3D(nx ,ny ,nz,3,3,3))
      endif
      if (enable_expl_free_surf) then
       allocate( bu(nx ,ny ,3)    ); bu=0.
       allocate( bv(nx ,ny ,3)    ); bv=0.
      endif
      allocate( k_bottom_u(nx,ny) ); k_bottom_u=0
      allocate( k_bottom_v(nx,ny) ); k_bottom_v=0
      if (enable_vert_friction_trm) then
        allocate( a_trm(nx,ny,nz) ); a_trm=0.
      endif
      if  (enable_back_state) then
        allocate( back(nx,ny,nz,3) ); back=0.
        allocate( u0(nx,ny,nz) ); u0=0.
      endif
      if (enable_diag_tracer) then
         allocate( tr(nx,ny,nz,3,nt) ); tr=0.0
      endif
 end subroutine allocate_work_space

!=======================================================================
!       zonal averaging diagnostics
!       linked in the code in driver only
!=======================================================================
! 
!  Reference buoyancy profile given by N_0  has to be set
! 
!  Note that the damping time scales of the resoring zones have to 
!  be adjusted in subroutine init_zonal_averages to match 
!  the setting in  subroutine restoring_zones

module zonal_averages_module
!=======================================================================
!       Module for zonal mean diagnostics
!=======================================================================
      implicit none
      real*8, allocatable, dimension(:,:) :: ulen,vlen,wlen,blen
      real*8, allocatable, dimension(:,:) :: um,vm,wm,bm,pm
      real*8, allocatable, dimension(:,:,:)   :: vb2,wb2 ,tm
      real*8, allocatable, dimension(:,:,:,:) :: vt2,wt2 
      real*8, allocatable, dimension(:,:) :: eke,bws,epe,T2,T4u,T4v,T4
      real*8, allocatable, dimension(:,:) :: mke,mpe,bwq,rest,restm
      real*8, allocatable, dimension(:,:) :: eps_b,eps_u,eps_v
      real*8, allocatable, dimension(:,:) :: eps_kh,eps_kv
      real*8, allocatable, dimension(:,:) :: vps,wps,veke,weke,vepe,wepe
      real*8, allocatable, dimension(:,:) :: vv,vvb,ageo,vw,ageo2,uv,vvu
      real*8, allocatable, dimension(:,:) :: agev1,agev2
      real*8, allocatable, dimension(:,:) :: mpv_qg,mpv_er,mrv_er
      real*8, allocatable, dimension(:,:,:) :: vq_qg,vq_er,wq_er,wq_qg
      real*8, allocatable, dimension(:,:) :: vvq_qg,vvq_er
      real*8, allocatable, dimension(:) :: b_r, p_r

      integer :: nr_var = 5  ! highest moment to be calculated
      integer :: nr_tr  = 0  ! numbers of tracers to be considered
      real*8, allocatable, dimension(:) :: t_rest
      real*8,parameter :: epsln     = 1.0d-20
      real*8,parameter :: spval = -1.0d33
      real*8,parameter :: N_0 = 0.004

      logical :: diag_eddy_fluxes          = .true.
      logical :: diag_eddy_flux_tendency   = .false.
      logical :: diag_energy_budget        = .false.
      logical :: diag_potential_vorticity  = .false.
end module zonal_averages_module



subroutine zonal_averages
!=======================================================================
!      Verteiler function
!=======================================================================
      use pyOM_module   
      use zonal_averages_module
      use fcontrol_module
      implicit none
      if ( mod(itt,int(snapint/dt))  == 0)  then
       call zonal_averages_means
       if (diag_eddy_fluxes) call zonal_averages_eddy_fluxes
       if (diag_energy_budget) call zonal_averages_energy
       if (diag_eddy_flux_tendency) call zonal_averages_flux_tendency
       if (diag_potential_vorticity) call zonal_averages_pv_fluxes
       call zonal_averages_write
      endif
end subroutine zonal_averages



subroutine init_zonal_averages
!=======================================================================
!      Initialize zonal mean diagnostics
!=======================================================================
      use pyOM_module   
      use zonal_averages_module
      use fcontrol_module
      implicit none
      include "netcdf.inc"
      integer :: i,j,k,js,je,n
      integer :: ncid,iret
      integer :: z_tdim,z_udim,itimedim,varid
      integer :: lat_tdim,lat_udim, dims(4)
      character :: name*64, unit*32
      if (my_pe==0) then
       print*,' Initializing zonal averaging module '
       print*,' using background stability freq. ', N_0,'1/s'
      endif

      allocate( b_r(nz) ); b_r=0.0
      allocate( p_r(nz) ); p_r=0.0
      b_r = -zt*N_0**2
      p_r(nz) = 0
      do k=nz-1,1,-1
       p_r(k)=p_r(k+1)+0.5*(b_r(k+1)+b_r(k))*dz
      enddo


      if (enable_diag_tracer)   nr_tr = nt

      if (my_pe==0) then
       print*,' found ',nr_tr,' tracer '
      endif

      allocate( um(ny ,nz) ); um=0.0
      allocate( vm(ny ,nz) ); vm=0.0
      allocate( wm(ny ,nz) ); wm=0.0
      allocate( bm(ny ,nz) ); bm=0.0
      allocate( pm(ny ,nz) ); pm=0.0
      allocate( tm(ny ,nz,nr_tr) ); tm=0.0

    if (diag_eddy_fluxes) then
      allocate( vb2(ny ,nz,1:nr_var) ); vb2=0.0
      allocate( wb2(ny ,nz,1:nr_var) ); wb2=0.0
      allocate( vt2(ny ,nz,nr_tr,1:nr_var) ); vt2=0.0
      allocate( wt2(ny ,nz,nr_tr,1:nr_var) ); wt2=0.0
    endif

    if (diag_energy_budget) then
      allocate( eke(ny ,nz) ); eke=0.0
      allocate( epe(ny ,nz) ); epe=0.0
      allocate( mke(ny ,nz) ); mke=0.0
      allocate( mpe(ny ,nz) ); mpe=0.0
      allocate( bws(ny ,nz) ); bws=0.0
      allocate( bwq(ny ,nz) ); bwq=0.0
      allocate( T2 (ny ,nz) ); T2=0.0
      allocate( T4u(ny ,nz) ); T4u=0.0
      allocate( T4v(ny ,nz) ); T4v=0.0
      allocate( T4(ny ,nz) );  T4=0.0

      allocate( eps_b(ny ,nz) ); eps_b=0.0
      allocate( eps_u(ny ,nz) ); eps_u=0.0
      allocate( eps_v(ny ,nz) ); eps_v=0.0
      allocate( eps_kh(ny ,nz)); eps_kh=0.0
      allocate( eps_kv(ny ,nz)); eps_kv=0.0
      allocate( rest(ny ,nz) );  rest=0.0
      allocate( restm(ny ,nz) ); restm=0.0

      allocate( vps(ny ,nz) ); vps=0.0
      allocate( wps(ny ,nz) ); wps=0.0
      allocate( veke(ny ,nz) ); veke=0.0
      allocate( weke(ny ,nz) ); weke=0.0
      allocate( vepe(ny ,nz) ); vepe=0.0
      allocate( wepe(ny ,nz) ); wepe=0.0
     endif

     if (diag_eddy_flux_tendency) then
      allocate( vv(ny ,nz)  ); vv  =0.0
      allocate( vvb(ny ,nz) ); vvb =0.0
      allocate( ageo(ny ,nz)); ageo=0.0
      allocate( ageo2(ny ,nz));ageo2=0.0
      allocate( vw(ny ,nz)  ); vw  =0.0
      allocate( uv(ny ,nz)  ); uv  =0.0
      allocate( vvu(ny ,nz)  ); vvu  =0.0
      allocate( agev1(ny ,nz));agev1=0.0
      allocate( agev2(ny ,nz));agev2=0.0
     endif

     if (diag_potential_vorticity) then
      allocate( mpv_qg(ny ,nz)  ); mpv_qg=0.0
      allocate( mpv_er(ny ,nz)  ); mpv_er=0.0
      allocate( mrv_er(ny ,nz)  ); mrv_er=0.0
      allocate( vq_qg(ny ,nz,1:nr_var)  );  vq_qg=0.0
      allocate( vq_er(ny ,nz,1:nr_var)  );  vq_er=0.0
      allocate( wq_qg(ny ,nz,1:nr_var)  );  wq_qg=0.0
      allocate( wq_er(ny ,nz,1:nr_var)  );  wq_er=0.0
      allocate( vvq_er(ny ,nz)  ); vvq_er=0.0
      allocate( vvq_qg(ny ,nz)  ); vvq_qg=0.0
     endif

      allocate( ulen(ny ,nz) ); ulen=0.0
      allocate( vlen(ny ,nz) ); vlen=0.0
      allocate( wlen(ny ,nz) ); wlen=0.0
      allocate( blen(ny ,nz) ); blen=0.0

      js=max(2,js_pe); je = min(je_pe,ny -1)
      do j=js,je
       do i=2,nx -1
        ulen(j,:)=ulen(j,:)+dx*maskU(i,j,:)
        vlen(j,:)=vlen(j,:)+dx*maskV(i,j,:)
        wlen(j,:)=wlen(j,:)+dx*maskW(i,j,:)
        blen(j,:)=blen(j,:)+dx*maskT(i,j,:)
       enddo 
      enddo 
!       Restoring time scale for buffer zone
      allocate( t_rest(ny )); t_rest=0.
!      do j=2,3+1
!        t_rest(j)= 1./(5*85400)/(j-1.)
!      enddo
!      do j=ny -1,ny -3,-1
!        t_rest(j)= 1./(5*85400)/(-1.*(j-ny ))
!      enddo

    if (my_pe==0) then 

      call def_grid_cdf('zonal_ave.cdf')
      iret=nf_open('zonal_ave.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'yu',lat_udim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'um', NCFLOAT,3,dims,iret)
      name = 'Zonal mean zonal velocity'; unit = 'm/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vm', NCFLOAT,3,dims,iret)
      name = 'Zonal mean meridional velocity'; unit = 'm/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'wm', NCFLOAT,3,dims,iret)
      name = 'Zonal mean vertical velocity'; unit = 'm/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'bm', NCFLOAT,3,dims,iret)
      name = 'Zonal mean buoyancy'; unit = 'm/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'pm', NCFLOAT,3,dims,iret)
      name = 'Zonal mean pressure'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      do n=1,nr_tr
       dims = (/lat_tdim, z_tdim, iTimedim,1/)
       write(name, '("trm",i2)') n; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       name = 'zonal mean tracer'; unit = ' '
       call dvcdf(ncid,varid,name,64,unit,32,spval)
      enddo

    if (diag_eddy_fluxes) then
      do k=1,nr_var
       write(unit, '("m**",i2,"/s**",i2)')k+1,2*k+1
       dims = (/lat_udim, z_tdim, iTimedim,1/)
       write(name, '("vb_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Meridional buoyancy ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/lat_tdim, z_udim, iTimedim,1/)
       write(name, '("wb_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Vertical buoyancy ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       do n=1,nr_tr
        unit = 'm/s'
        dims = (/lat_udim, z_tdim, iTimedim,1/)
        write(name, '("vt",i2,"_",i2)')n,k;call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
        write(name, '("Meridional ",i2,". moment tracer flux")')k
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/lat_tdim, z_udim, iTimedim,1/)
        write(name, '("wt",i2,"_",i2)')n,k;call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
        write(name, '("Vertical ",i2,". moment tracer flux")')k
        call dvcdf(ncid,varid,name,64,unit,32,spval)
       enddo
      enddo
     endif

    if (diag_energy_budget) then
      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'eke', NCFLOAT,3,dims,iret)
      name = 'Eddy kinetic energy'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mke', NCFLOAT,3,dims,iret)
      name = 'Mean kinetic energy'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'epe', NCFLOAT,3,dims,iret)
      name = 'Eddy potential energy'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mpe', NCFLOAT,3,dims,iret)
      name = 'Mean potential energy'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'bws', NCFLOAT,3,dims,iret)
      name = 'EKE production (EPE->EKE)'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'bwq', NCFLOAT,3,dims,iret)
      name = 'MPE production (MPE->MKE)'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'T2', NCFLOAT,3,dims,iret)
      name = 'MPE production (EPE->MPE)'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'T4', NCFLOAT,3,dims,iret)
      name = 'MKE production (EKE->MKE)'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'eps_b', NCFLOAT,3,dims,iret)
      name = 'EPE dissipation'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'eps_kh', NCFLOAT,3,dims,iret)
      name = 'Horizontal EKE dissipation'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'eps_kv', NCFLOAT,3,dims,iret)
      name = 'Vertical EKE dissipation'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'rest', NCFLOAT,3,dims,iret)
      name = 'EPE dissipation by nudging'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'restm', NCFLOAT,3,dims,iret)
      name = 'MPE dissipation by nudging'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vps', NCFLOAT,3,dims,iret)
      name = 'Meridional wave radiation'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'wps', NCFLOAT,3,dims,iret)
      name = 'Vertical wave radiation'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'veke', NCFLOAT,3,dims,iret)
      name = 'Meridional EKE advection'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'weke', NCFLOAT,3,dims,iret)
      name = 'Vertical EKE advection'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vepe', NCFLOAT,3,dims,iret)
      name = 'Meridional EPE advection'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'wepe', NCFLOAT,3,dims,iret)
      name = 'Vertical EPE advection'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)
     endif

    if (diag_eddy_flux_tendency) then
      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vv', NCFLOAT,3,dims,iret)
      name = 'Meridional velocity variance'; unit = 'm^2/s^2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vvb', NCFLOAT,3,dims,iret)
      name = 'Triple variance flux'; unit = 'm^3/s^4'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'ageo', NCFLOAT,3,dims,iret)
      name = 'Ageostrophic terms'; unit = 'm^2/s^4'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'ageo2', NCFLOAT,3,dims,iret)
      name = 'Ageostrophic (beta) term'; unit = 'm^2/s^4'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'vw', NCFLOAT,3,dims,iret)
      name = 'Velocity correlation'; unit = 'm^2/s^4'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'uv', NCFLOAT,3,dims,iret)
      name = 'Velocity correlation'; unit = 'm^2/s^2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vvu', NCFLOAT,3,dims,iret)
      name = 'Flux of velocity correlation'; unit = 'm^3/s^3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'agev1', NCFLOAT,3,dims,iret)
      name = 'Ageostrophic term 1'; unit = 'm^2/s^3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'agev2', NCFLOAT,3,dims,iret)
      name = 'Ageostrophic term 2'; unit = 'm^2/s^3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)
     endif

     if (diag_potential_vorticity) then
      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mpv_qg', NCFLOAT,3,dims,iret)
      name = 'Potential vorticity (QG)'; unit = '1/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vvq_qg', NCFLOAT,3,dims,iret)
      name = 'Triple var. flux of PV (QG)'; unit = 'm/s^2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mpv_er', NCFLOAT,3,dims,iret)
      name = 'Potential vorticity (Ertel)'; unit = '1/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mrv_er', NCFLOAT,3,dims,iret)
      name = 'Relative vorticity (Ertel)'; unit = '1/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vvq_er', NCFLOAT,3,dims,iret)
      name = 'Triple var. flux of PV (Ertel)'; unit = 'm^2/s^3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      do k=1,nr_var
       write(unit, '("m**",i2,"/s**",i2)')k,k+1

       dims = (/lat_udim, z_tdim, iTimedim,1/)
       write(name, '("vq_qg_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Meridional PV (QG) ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/lat_udim, z_tdim, iTimedim,1/)
       write(name, '("vq_er_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Meridional PV (Ertel) ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/lat_tdim, z_udim, iTimedim,1/)
       write(name, '("wq_qg_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Vertical PV (QG) ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/lat_tdim, z_udim, iTimedim,1/)
       write(name, '("wq_er_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Vertical PV (Ertel) ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

      enddo
     endif
      varid = ncvdef (ncid,'b_r', NCFLOAT,1,z_tdim,iret)
      name = 'Reference buoyancy profile'; unit = 'm/s^2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      call ncendf(ncid, iret)
      iret= nf_put_vara_double(ncid,varid,1,nz,b_r)

      call ncclos (ncid, iret)
    endif ! my_pe ==0
    if (my_pe==0) print*,' Done initializing zonal averaging module'
  end subroutine init_zonal_averages



 subroutine zonal_averages_write
!======================================================================
!       compute zonal mean diagnostics
!=======================================================================
      use pyOM_module   
      use zonal_averages_module
      use fcontrol_module
      implicit none
      include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4),m
      integer :: itdimid,ilen,itimeid
      integer :: trmid(nr_tr),varid
      real*8 :: fxa,time
      character :: name*64
!-----------------------------------------------------------------------
!      write to netcdf file
!-----------------------------------------------------------------------
      do npe=0,n_pes
       if (my_pe==npe) then

         iret=nf_open('zonal_ave.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         do n=1,nr_tr
          write(name, '("trm",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,trmid(n))
         enddo

         iret=nf_inq_dimid(ncid,'Time',itdimid)
         iret=nf_inq_dimlen(ncid, itdimid,ilen)
         iret=nf_inq_varid(ncid,'Time',itimeid)
         if (my_pe==0) then
          ilen=ilen+1
          time = dt*itt !current_time-initial_time
          fxa = time/86400. ! time%days + time%seconds/86400.
          iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
         endif

         Corner = (/js_pe,1,ilen,1/); 
         edges  = (/je_pe-js_pe+1,nz,1,1/)
         iret=nf_inq_varid(ncid,'um',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, um(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, vm(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'wm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, wm(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, bm(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'pm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, pm(js_pe:je_pe,:))
         do n=1,nr_tr
          iret= nf_put_vara_double(ncid,trmid(n),corner,edges, tm(js_pe:je_pe,:,n))
         enddo

    if (diag_eddy_fluxes) then
         do m=1,nr_var
          write(name, '("vb_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,     vb2(js_pe:je_pe,:,m))
          write(name, '("wb_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,  wb2(js_pe:je_pe,:,m))
          do n=1,nr_tr
           write(name, '("vt",i2,"_",i2)')n,m;
           call replace_space_zero(name)
           iret=nf_inq_varid(ncid,name,varid)
           iret= nf_put_vara_double(ncid,varid,corner,edges,  vt2(js_pe:je_pe,:,n,m))
           write(name, '("wt",i2,"_",i2)')n,m;
           call replace_space_zero(name)
           iret=nf_inq_varid(ncid,name,varid)
           iret= nf_put_vara_double(ncid,varid,corner,edges,  wt2(js_pe:je_pe,:,n,m))
          enddo
         enddo
      endif

      if (diag_energy_budget) then
         iret=nf_inq_varid(ncid,'eke',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   eke(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'mke',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   mke(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'epe',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   epe(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'mpe',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  mpe(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bws',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  bws(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bwq',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  bwq(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'T2',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  T2(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'T4',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, T4u(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'T4v',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, T4v(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'eps_b',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, eps_b(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'eps_kh',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  eps_kh(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'eps_kv',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  eps_kv(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'rest',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  rest(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'restm',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   restm(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vps',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   vps(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'wps',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  wps(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'veke',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, veke(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'weke',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  weke(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vepe',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   vepe(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'wepe',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  wepe(js_pe:je_pe,:))
       endif

      if (diag_eddy_flux_tendency) then
         iret=nf_inq_varid(ncid,'vv',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,    vv(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vvb',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   vvb(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vw',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  vw(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'ageo',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  ageo(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'ageo2',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  ageo2(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'uv',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, uv(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vvu',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, vvu(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'agev1',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, agev1(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'agev2',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, agev2(js_pe:je_pe,:))
        endif

        if (diag_potential_vorticity) then
         iret=nf_inq_varid(ncid,'mpv_qg',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   mpv_qg(js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'mpv_er',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,   mpv_er(js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'mrv_er',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,  mrv_er(js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'vvq_er',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, vvq_er(js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'vvq_qg',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges, vvq_qg(js_pe:je_pe,:))

         do m=1,nr_var

          write(name, '("vq_qg_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret=nf_put_vara_double(ncid,varid,corner,edges, vq_qg(js_pe:je_pe,:,m))

          write(name, '("wq_qg_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret=nf_put_vara_double(ncid,varid,corner,edges,  wq_qg(js_pe:je_pe,:,m))

          write(name, '("vq_er_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret=nf_put_vara_double(ncid,varid,corner,edges,  vq_er(js_pe:je_pe,:,m))

          write(name, '("wq_er_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret=nf_put_vara_double(ncid,varid,corner,edges, wq_er(js_pe:je_pe,:,m))

         enddo
        endif

         call ncclos (ncid, iret)
       endif
       call fortran_barrier
      enddo
      end subroutine zonal_averages_write


  subroutine zonal_averages_means
!=======================================================================
!       get zonal means
!=======================================================================
      use pyOM_module   
      use zonal_averages_module
      use fcontrol_module
      implicit none
      integer :: i,j,js,je,n

      js=max(2,js_pe); je = min(je_pe,ny -1)
      um=0.0;vm=0.0;wm=0.0;bm=0.0;tm=0.0
      do j=js,je 
        do i=2,nx -1
         um(j,:)=um(j,:)+u(i,j,:,tau)*dx*maskU(i,j,:) 
         vm(j,:)=vm(j,:)+v(i,j,:,tau)*dx*maskV(i,j,:) 
         wm(j,:)=wm(j,:)+w(i,j,:,tau)*dx*maskW(i,j,:) 
         bm(j,:)=bm(j,:)+b(i,j,:,  tau)*dx*maskT(i,j,:) 
         pm(j,:)=pm(j,:)+p_full(i,j,:,tau)*dx*maskT(i,j,:) 
        enddo 
      enddo 

    if (enable_diag_tracer) then
      do j=js,je 
        do i=2,nx -1
         do n=1,nr_tr
          tm(j,:,n)=tm(j,:,n)+tr(i,j,:,tau,n)*dx*maskT(i,j,:) 
         enddo
        enddo 
      enddo 
    endif

      where (ulen/=0); um=um/ulen; elsewhere; um=spval ; end where
      where (vlen/=0); vm=vm/vlen; elsewhere; vm=spval ; end where
      where (wlen/=0); wm=wm/wlen; elsewhere; wm=spval ; end where
      where (blen/=0); bm=bm/blen; elsewhere; bm=spval ; end where
      where (blen/=0); pm=pm/blen; elsewhere; pm=spval ; end where
      call border_exchg_merid(ny,nz,um,1)
      call border_exchg_merid(ny,nz,vm,1)
      call border_exchg_merid(ny,nz,wm,1)
      call border_exchg_merid(ny,nz,bm,1)
      call border_exchg_merid(ny,nz,pm,1)
      do n=1,nr_tr
        where (blen/=0); tm(:,:,n)=tm(:,:,n)/blen
        elsewhere; tm(:,:,n)=spval;end where
        call border_exchg_merid(ny,nz,tm(:,:,n),1)
      enddo
 end subroutine zonal_averages_means



  subroutine zonal_averages_eddy_fluxes
!=======================================================================
!       compute zonal mean eddy fluxes
!=======================================================================
      use pyOM_module   
      use zonal_averages_module
      use fcontrol_module
      implicit none
      integer :: i,j,k,js,je,m,n

      js=max(2,js_pe); je = min(je_pe,ny -1)
      vb2=0.0;wb2=0.0;vt2=0.0;wt2=0.0
      do m=1,nr_var
        do j=js,je 
         do k=1,nz
          do i=2,nx -1
           vb2(j,k,m)=vb2(j,k,m)+v(i,j,k,tau)*dx*maskV(i,j,k)   &
           *.5/m*( (b(i,j  ,k,tau)-bm(j  ,k))**m + (b(i,j+1,k,tau)-bm(j+1,k))**m  )
          enddo
         enddo
         do k=1,nz-1
          do i=2,nx -1
           wb2(j,k,m)=wb2(j,k,m)+w(i,j,k,tau)*dx*maskW(i,j,k)    &
            *.5/m*( (b(i,j,k  ,tau)-bm(j,k  ))**m + (b(i,j,k+1,tau)-bm(j,k+1))**m )
          enddo
         enddo
       enddo
       where (vlen/=0); vb2(:,:,m)=vb2(:,:,m)/vlen; 
       elsewhere; vb2(:,:,m)=spval; end where
       where (wlen/=0); wb2(:,:,m)=wb2(:,:,m)/wlen; 
       elsewhere; wb2(:,:,m)=spval; end where

 if (enable_diag_tracer) then
        do n=1,nr_tr
          do j=js,je 
           do k=1,nz
            do i=2,nx -1
             vt2(j,k,n,m)=vt2(j,k,n,m)+v(i,j,k,tau)*dx*maskV(i,j,k)   &
             *.5/m*( (tr(i,j  ,k,tau,n)-tm(j  ,k,n))**m  + (tr(i,j+1,k,tau,n)-tm(j+1,k,n))**m )
            enddo
           enddo
           do k=1,nz-1
            do i=2,nx -1
             wt2(j,k,n,m)=wt2(j,k,n,m)+w(i,j,k,tau)*dx*maskW(i,j,k)   &
             *.5/m*( (tr(i,j,k  ,tau,n)-tm(j,k  ,n))**m + (tr(i,j,k+1,tau,n)-tm(j,k+1,n))**m )
            enddo
           enddo
          enddo ! j
          where (vlen/=0); vt2(:,:,n,m)=vt2(:,:,n,m)/vlen; 
          elsewhere; vt2(:,:,n,m)=spval; end where
          where (wlen/=0); wt2(:,:,n,m)=wt2(:,:,n,m)/wlen; 
          elsewhere; wt2(:,:,n,m)=spval; end where
        enddo ! n
 endif
      enddo ! m
 end subroutine zonal_averages_eddy_fluxes





 subroutine zonal_averages_pv_fluxes
!=======================================================================
!       compute zonal mean potential vorticity
!=======================================================================
      use pyOM_module   
      use zonal_averages_module
      implicit none
      integer :: i,j,k,js,je,m
      real*8 :: pv_qg(nx ,ny ,nz),f0,y0,ps(nx ,ny ,nz)
      real*8 :: rv_qg(nx ,ny ,nz),pv_er(nx ,ny ,nz)
      real*8 :: rv(nx ,ny ,nz),fxa,beta

      f0 = coriolis_t(ny /2); y0 = yt(ny /2)
      js=max(2,js_pe); je = min(je_pe,ny -1)
!
!       relative potential vorticity
!
      rv=0.0
      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
          rv(i,j,k)=(v(i+1,j,k,tau)-v(i,j,k,tau) )/dx*maskU(i,j,k) &
                   -(u(i,j+1,k,tau)-u(i,j,k,tau) )/dx*maskV(i,j,k)
        enddo 
       enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,rv,1)
!
!       Ertel potential vorticity  Q N0^2 = b_z (v_x-u_y + f) + u_z b_y - v_z b_x
!
      pv_er=0.
      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
         fxa= (rv(i,j,k)+rv(i-1,j,k)+rv(i,j-1,k)+rv(i-1,j-1,k))/4.0
         pv_er(i,j,k)=(fxa+coriolis_t(j)  )*  ((b(i,j,k+1,tau)-b(i,j,k,tau))/dz*maskW(i,j,k)   &
                  +(b(i,j,k,tau)-b(i,j,k-1,tau))/dz*maskW(i,j,k-1))/ (maskW(i,j,k)+maskW(i,j,k-1)+epsln) 
         pv_er(i,j,k)=-N_0**(-2)*pv_er(i,j,k)
        enddo 
       enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,pv_er,1); call setcyclic3D(nx,ny,nz,pv_er)
!
!       QG streamfunction
!
      psi=0.0
      do k=1,nz
       do j=js,je 
        ps(:,j,k)=(p_full(:,j,k,tau)-p_r(k))/f0
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,ps,1); call setcyclic3D(nx,ny,nz,ps)
!
!       QG relative potential vorticity
!
      rv_qg=0.
      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
         rv_qg(i,j,k)= ((ps(i,j+1,k)-ps(i,j,k))/dx*maskV(i,j  ,k)-(ps(i,j,k)-ps(i,j-1,k))/dx*maskV(i,j-1,k))/dx  &
         +((ps(i+1,j,k)-ps(i,j,k))/dx*maskU(i-1,j,k) -(ps(i,j,k)-ps(i-1,j,k))/dx*maskU(i-1,j,k))/dx
        enddo 
       enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,rv_qg,1); call setcyclic3D(nx,ny,nz,rv_qg)
!
!       add QG planetary and stretching term to relative vorticity
!
      pv_qg=0.
      do j=js,je 
       beta = (coriolis_t(j+1)-coriolis_t(j))/dx
       pv_qg(:,j,:)=rv_qg(:,j,:)+beta*(yt(j)-y0)
       do k=2,nz-1
         pv_qg(:,j,k)=pv_qg(:,j,k)+f0**2/N_0**2* ((ps(:,j,k+1)-ps(:,j,k))/dz*maskW(:,j,k)   &
          -(ps(:,j,k)-ps(:,j,k-1))/dz*maskW(:,j,k-1))/dz
       enddo 
       k=2
       pv_qg(:,j,k)=pv_qg(:,j,k)+f0**2/N_0**2* ((ps(:,j,k+1)-ps(:,j,k))/dz*maskW(:,j,k)  &
          -(b(:,j,k,tau)-bm(j,k))*maskT(i,j,k) )/dz
       k=nz-1
       pv_qg(:,j,k)=pv_qg(:,j,k)+f0**2/N_0**2* ((b(:,j,k,tau)-bm(j,k))*maskT(:,j,k)   &
          -(ps(:,j,k)-ps(:,j,k-1))/dz*maskW(:,j,k-1))/dz
      enddo 
      call border_exchg3D(nx,ny,nz,pv_qg,1); call setcyclic3D(nx,ny,nz,pv_qg)
!
!       mean QG and Ertel PV
!
      mpv_qg=0.
      do j=js,je 
        do i=2,nx -1
         mpv_qg(j,:)=mpv_qg(j,:)+pv_qg(i,j,:)*dx*maskT(i,j,:) 
         mpv_er(j,:)=mpv_er(j,:)+pv_er(i,j,:)*dx*maskT(i,j,:) 
         mrv_er(j,:)=mrv_er(j,:)+rv(i,j,:)*dx*maskT(i,j,:) 
        enddo 
      enddo 
      where (blen/=0); mpv_qg=mpv_qg/blen; 
      elsewhere; mpv_qg=spval ; end where
      where (blen/=0); mpv_er=mpv_er/blen; 
      elsewhere; mpv_er=spval ; end where
      where (vlen/=0); mrv_er=mrv_er/vlen; 
      elsewhere; mrv_er=spval ; end where
      call border_exchg_merid(ny,nz,mpv_qg,1)
      call border_exchg_merid(ny,nz,mpv_er,1)
      call border_exchg_merid(ny,nz,mrv_er,1)
!
!       meridional and vertical fluxes of PV
!
      vq_qg=0.;vq_er=0.; wq_qg=0.;wq_er=0.; 
      do m=1,nr_var
        do j=js,je 
         do k=1,nz
          do i=2,nx -1
           vq_qg(j,k,m)=vq_qg(j,k,m)+v(i,j,k,tau)*dx*maskV(i,j,k)   &
           *.5/m*( (pv_qg(i,j  ,k)-mpv_qg(j  ,k))**m + (pv_qg(i,j+1,k)-mpv_qg(j+1,k))**m  )
           vq_er(j,k,m)=vq_er(j,k,m)+v(i,j,k,tau)*dx*maskV(i,j,k)   &
           *.5/m*( (pv_er(i,j  ,k)-mpv_er(j  ,k))**m + (pv_er(i,j+1,k)-mpv_er(j+1,k))**m  )
          enddo
         enddo
         do k=1,nz-1
          do i=2,nx -1
           wq_qg(j,k,m)=wq_qg(j,k,m)+w(i,j,k,tau)*dx*maskW(i,j,k)    &
            *.5/m*( (pv_qg(i,j,k  )-mpv_qg(j,k  ))**m  + (pv_qg(i,j,k+1)-mpv_qg(j,k+1))**m )
           wq_er(j,k,m)=wq_er(j,k,m)+w(i,j,k,tau)*dx*maskW(i,j,k)    &
            *.5/m*( (pv_er(i,j,k  )-mpv_er(j,k  ))**m + (pv_er(i,j,k+1)-mpv_er(j,k+1))**m )
          enddo
         enddo
       enddo
       where (vlen/=0); vq_qg(:,:,m)=vq_qg(:,:,m)/vlen; 
       elsewhere; vq_qg(:,:,m)=spval; end where
       where (wlen/=0); wq_qg(:,:,m)=wq_qg(:,:,m)/wlen; 
       elsewhere; wq_qg(:,:,m)=spval; end where
       where (vlen/=0); vq_er(:,:,m)=vq_er(:,:,m)/vlen; 
       elsewhere; vq_er(:,:,m)=spval; end where
       where (wlen/=0); wq_er(:,:,m)=wq_er(:,:,m)/wlen; 
       elsewhere; wq_er(:,:,m)=spval; end where
      enddo
!
!      triple flux of PV (for eddy pv flux tendency)
!
      vvq_qg=0.;vvq_er=0.
      do j=js,je 
       do k=1,nz
        do i=2,nx -1
         vvq_qg(j,k)=vvq_qg(j,k) +(v(i,j,k,tau)-vm(j,k))**2*dx*maskV(i,j,k)   &
           *((pv_qg(i,j  ,k)-mpv_qg(j  ,k)) +(pv_qg(i,j+1,k)-mpv_qg(j+1,k)))/2.
         vvq_er(j,k)=vvq_er(j,k) +(v(i,j,k,tau)-vm(j,k))**2*dx*maskV(i,j,k)   &
           *((pv_er(i,j  ,k)-mpv_er(j  ,k)) +(pv_er(i,j+1,k)-mpv_er(j+1,k)))/2.
        enddo
       enddo
      enddo
      where (vlen/=0); vvq_qg(:,:)=vvq_qg(:,:)/vlen; 
      elsewhere; vvq_qg(:,:)=spval; end where
      where (vlen/=0); vvq_er(:,:)=vvq_er(:,:)/vlen; 
      elsewhere; vvq_er(:,:)=spval; end where
 end subroutine zonal_averages_pv_fluxes



 subroutine zonal_averages_flux_tendency
!=======================================================================
!        eddy flux balance :  (v'b')_t = - v'^2 b_y + ...
!=======================================================================
      use pyOM_module   
      use zonal_averages_module
      implicit none
      integer :: i,j,k,js,je
      real*8 :: fxa,a(nx ,ny ,nz),beta

      js=max(2,js_pe); je = min(je_pe,ny -1)
      vv=0.;vvb=0.;vw=0.0; ageo=0.0; ageo2=0.
      do j=js,je 
         beta = (coriolis_t(j+1)-coriolis_t(j))/dx
        do k=2,nz-1
         do i=2,nx -1
          vv(j,k)=vv(j,k)+maskV(i,j,k)*dx*(v(i,j,k,tau)-vm(j,k))**2
          vvb(j,k)=vvb(j,k)+maskV(i,j,k)*dx*   (v(i,j,k,tau)-vm(j,k))**2  &
              *0.5*( b(i,j,k,tau)-bm(j,k)+b(i,j+1,k,tau)-bm(j+1,k))
          vw(j,k)=vw(j,k)+maskW(i,j,k)* N_0**2*dx* 0.5*( (v(i,j  ,k,tau)-vm(j  ,k))*maskV(i,j  ,k)  &
                   +(v(i,j-1,k,tau)-vm(j-1,k))*maskV(i,j-1,k)) *(w(i,j,k,tau)-wm(j,k))
          ageo(j,k)=ageo(j,k)+maskV(i,j,k)*dx*0.5*( b(i,j,k,tau)-bm(j,k)+b(i,j+1,k,tau)-bm(j+1,k))   &
              *( (p_full(i,j+1,k,tau)-pm(j+1,k) -p_full(i,j  ,k,tau)+pm(j  ,k))/dx   &
          +(coriolis_t(j    )*(u(i-1,j  ,k,tau)-um(j,k)  +u(i  ,j  ,k,tau)-um(j,k))    &
           +coriolis_t(j+1  )*(u(i-1,j+1,k,tau)-um(j+1,k) +u(i  ,j+1,k,tau)-um(j+1,k)))/4.0  )
          ageo2(j,k)=ageo2(j,k)+maskV(i,j,k)*dx* 0.5*( b(i,j,k,tau)-bm(j,k)+b(i,j+1,k,tau)-bm(j+1,k))*(   &
          +(beta*(yt(j  )-yt(ny /2))*(u(i-1,j  ,k,tau)-um(j,k)    +u(i  ,j  ,k,tau)-um(j,k))   &
           +beta*(yt(j+1)-yt(ny /2))*(u(i-1,j+1,k,tau)-um(j+1,k)+u(i  ,j+1,k,tau)-um(j+1,k)))/4.0)
         enddo 
        enddo 
      enddo 
      where (vlen/=0); vv=vv/vlen; elsewhere; vv=spval; end where
      where (vlen/=0); vvb=vvb/vlen; elsewhere; vvb=spval; end where
      where (wlen/=0); vw=vw/wlen; elsewhere; vw=spval; end where
      where (vlen/=0); ageo=ageo/vlen;elsewhere;ageo=spval; end where
      where (vlen/=0);ageo2=ageo2/vlen;elsewhere;ageo2=spval;end where

!
!        tendency of cross correlation u'v' 
!
      uv=0.;vvu=0.
      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
         fxa=0.5*(u(i,j,k,tau)-um(j,k)+u(i,j+1,k,tau)-um(j+1,k) )   &
                 *0.5*(v(i,j,k,tau)-vm(j,k)+v(i+1,j,k,tau)-vm(j,k) )
         uv(j,k)=uv(j,k)+maskV(i,j,k)*dx*fxa
         vvu(j,k)=vvu(j,k)+maskV(i,j,k)*dx*fxa *0.5*(v(i,j,k,tau)+v(i+1,j,k,tau))
        enddo 
       enddo 
      enddo 
      where (vlen/=0);uv=uv/vlen;elsewhere;uv=spval;end where
      where (vlen/=0);vvu=vvu/vlen;elsewhere;vvu=spval;end where

      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
          a(i,j,k)= maskU(i,j,k)*(  coriolis_t(j)*(v(i,j  ,k,tau)+v(i+1,j  ,k,tau)+  &
           v(i,j-1,k,tau)+v(i+1,j-1,k,tau))/4.0 -(p_full(i+1,j,k,tau)-p_full(i,j,k,tau))/dx )
        enddo 
       enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,a,1); call setcyclic3D(nx,ny,nz,a)
      agev1=0.
      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
         agev1(j,k)=agev1(j,k)+maskV(i,j,k)*dx* 0.5*(a(i,j,k)+a(i,j+1,k))*  &
          0.5*(v(i,j,k,tau)-vm(j,k)+v(i+1,j,k,tau)-vm(j,k))
        enddo 
       enddo 
      enddo 
      where (vlen/=0);agev1=agev1/vlen;elsewhere;agev1=spval;end where

      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
          a(i,j,k)= maskV(i,j,k)*( -(coriolis_t(j  )*(u(i-1,j  ,k,tau)+u(i,j  ,k,tau))  &
           +coriolis_t(j+1)*(u(i-1,j+1,k,tau)+u(i,j+1,k,tau)))/4.0  &
          -(p_full(i,j+1,k,tau)-p_full(i,j,k,tau))/dx) 
        enddo 
       enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,a,1); call setcyclic3D(nx,ny,nz,a)
      agev2=0.
      do j=js,je 
       do k=2,nz-1
        do i=2,nx -1
         agev2(j,k)=agev2(j,k)+maskU(i,j,k)*dx* 0.5*(a(i,j,k)+a(i+1,j,k))*  &
          0.5*(u(i,j,k,tau)-um(j,k)+u(i,j+1,k,tau)-um(j+1,k))
        enddo 
       enddo 
      enddo 
      where (vlen/=0);agev2=agev2/vlen;elsewhere;agev2=spval;end where

 end subroutine zonal_averages_flux_tendency







 subroutine zonal_averages_energy
!=======================================================================
!       compute zonal mean energy budget
!=======================================================================
      use pyOM_module   
      use zonal_averages_module
      implicit none

      integer :: i,j,k,js,je
      real*8 :: a(ny ,nz),bs(nx ,ny ,nz),bms(ny ,nz)
      real*8 :: bss(nx ,ny ,nz),del2(nx ,ny ,nz),us(nx ,ny ,nz)

      js=max(2,js_pe); je = min(je_pe,ny -1)
      bs=0.0;bms=0.0;bss=0.  ! buoyancy deviation from reference state
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
           bs(i,j,k)=(b(i,j,k,tau)-b_r(k))*maskT(i,j,k)
         enddo 
        enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,bs,1); call setcyclic3D(nx,ny,nz,bs)
      do j=js,je 
        do i=2,nx -1
         bms(j,:)=bms(j,:)+bs(i,j,:)*dx*maskT(i,j,:) 
        enddo 
      enddo 
      where (blen/=0) bms=bms/blen
      call border_exchg_merid(ny,nz,bms,1)
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
           bss(i,j,k)=(bs(i,j,k)-bms(j,k))*maskT(i,j,k)
         enddo 
        enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,bss,1); call setcyclic3D(nx,ny,nz,bss)
!-----------------------------------------------------------------------
!       Mean energy
!-----------------------------------------------------------------------
      where (vlen==0); vm=0; end where
      where (wlen==0); wm=0; end where
      call border_exchg_merid(ny,nz,vm,1)
      call border_exchg_merid(ny,nz,wm,1)

      do j=js,je 
        do k=2,nz-1
         mke(j,k)=um(j,k)**2/2+(0.5*(vm(j,k)+vm(j-1,k)))**2/2.
         mpe(j,k)=bms(j,k)**2/2/N_0**2
         bwq(j,k)= 0.25*wm(j,k  )*(bms(j,k  )+bms(j,k+1)) +0.25*wm(j,k-1)*(bms(j,k-1)+bms(j,k  ))
        enddo
      enddo
      where (blen==0); mke=spval; end where
      where (blen==0); mpe=spval; end where
      where (blen==0); bwq=spval; end where

      where (vlen==0); vm=spval; end where
      where (wlen==0); wm=spval; end where
      call border_exchg_merid(ny,nz,vm,1)
      call border_exchg_merid(ny,nz,wm,1)
!-----------------------------------------------------------------------
!        Eddy energy
!-----------------------------------------------------------------------
      eke=0.0;bws=0.0;epe=0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          eke(j,k)=eke(j,k)+dx*( ( 0.5*((u(i  ,j,k,tau)-um(j  ,k))*maskU(i  ,j,k)   &
                  +(u(i-1,j,k,tau)-um(j  ,k))*maskU(i-1,j,k) ) )**2/2   &
           +( 0.5*((v(i,j-1,k,tau)-vm(j-1,k))*maskV(i,j-1,k)   &
                  +(v(i,j-1,k,tau)-vm(j  ,k))*maskV(i,j  ,k) ) )**2/2  )
          epe(j,k)=epe(j,k)+dx*bss(i,j,k)**2/2/N_0**2

          bws(j,k)=bws(j,k)+dx*( (w(i,j,k  ,tau)-wm(j,k  ))*0.25*maskW(i,j,k  )*  &
               (bss(i,j,k  )+bss(i,j,k+1)) +(w(i,j,k-1,tau)-wm(j,k-1))*0.25*maskW(i,j,k-1)*  &
               (bss(i,j,k-1)+bss(i,j,k  ))    )
         enddo 
        enddo 
      enddo 
      where (blen/=0); eke=eke/blen; elsewhere; eke=spval; end where
      where (blen/=0); epe=epe/blen; elsewhere; epe=spval; end where
      where (blen/=0); bws=bws/blen; elsewhere; bws=spval; end where
!-----------------------------------------------------------------------
!        Baroclinic instability term
!-----------------------------------------------------------------------
      a=0.0 ! v'b' bar b_y /N_0**2 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          a(j,k)=a(j,k)+dx/N_0**2*(  (v(i,j,k,tau)-vm(j,k))*  &
            0.5*(bss(i,j,k)+bss(i,j+1,k))*(bms(j+1,k)-bms(j,k))/dx    )*maskV(i,j,k)
         enddo 
        enddo 
      enddo 
      where (vlen/=0) a=a/vlen
      call border_exchg_merid(ny,nz,a,1)
      do j=js,je 
        do k=2,nz-1
         T2(j,k)=0.5*( a(j-1,k)+a(j,k))
        enddo 
      enddo 

      a=0.0 ! w'b' bar b_z /N_0**2 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          a(j,k)=a(j,k)+dx/N_0**2*(  (w(i,j,k,tau)-wm(j,k))*   &
            0.5*(bss(i,j,k)+bss(i,j,k+1))*( bms(j,k+1)-bms(j,k))/dz     )*maskW(i,j,k)
         enddo 
        enddo 
      enddo 
      where (wlen/=0) a=a/wlen
      do j=js,je 
        do k=2,nz-1
         T2(j,k)=T2(j,k)+0.5*(a(j,k-1)+a(j,k))
        enddo 
      enddo 
      where (blen==0); T2 =spval; end where

!-----------------------------------------------------------------------
!       Shear instability terms
!-----------------------------------------------------------------------
      a=0.0; 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1 ! bar(u' v') bar u_y    
          a(j,k)=a(j,k)+dx*(  0.5*( u(i,j,k,tau)-um(j,k) + u(i,j+1,k,tau)-um(j+1,k))   &
             *0.5*( v(i,j,k,tau)-vm(j,k) + v(i+1,j,k,tau)-vm(j,k))   &
             *(um(j+1,k)-um(j,k))/dx   )*maskU(i,j,k)*maskU(i,j+1,k)
         enddo 
        enddo 
      enddo 
      where (ulen/=0) a=a/ulen
      call border_exchg_merid(ny,nz,a,1)
      do j=js,je 
        do k=2,nz-1
         T4u(j,k)=0.5*( a(j-1,k)+a(j,k))
        enddo 
      enddo 

      a=0.0; 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1 ! bar(u' w') bar u_z
          a(j,k)=a(j,k)+dx*(   0.5*( u(i,j,k,tau)-um(j,k) + u(i,j,k+1,tau)-um(j,k+1))   &
             *0.5*( w(i,j,k,tau)-wm(j,k) + w(i+1,j,k,tau)-wm(j,k))   &
             *(um(j,k+1)-um(j,k))/dz   )*maskU(i,j,k)*maskU(i,j,k+1)
         enddo 
        enddo 
      enddo 
      where (ulen/=0) a=a/ulen
      do j=js,je 
        do k=2,nz-1
         T4u(j,k)=T4u(j,k)+0.5*( a(j,k)+a(j,k-1))
        enddo 
      enddo 
!       where (blen==0); T4u=spval; end where

      a=0.0; 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1 ! bar(v' v') bar v_y
          a(j,k)=a(j,k)+dx*(  0.5*( v(i,j,k,tau)-vm(j,k) + v(i,j-1,k,tau)-vm(j-1,k))   &
             *0.5*( v(i,j,k,tau)-vm(j,k) + v(i,j-1,k,tau)-vm(j-1,k))   &
             *(vm(j,k)-vm(j-1,k))/dx    )*maskV(i,j,k)*maskV(i,j-1,k)
         enddo 
        enddo 
      enddo 
      where (vlen/=0) a=a/vlen
      do j=js,je 
        do k=2,nz-1
         T4v(j,k)=a(j,k)
        enddo 
      enddo 

      a=0.0; 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1 ! bar(v' w') bar v_z
          a(j,k)=a(j,k)+dx*(  0.5*( v(i,j,k,tau)-vm(j,k) + v(i,j,k+1,tau)-vm(j,k+1))   &
             *0.5*( w(i,j,k,tau)-wm(j,k) + w(i,j+1,k,tau)-wm(j+1,k))   &
             *(vm(j,k+1)-vm(j,k))/dz     )*maskV(i,j,k)*maskV(i,j,k+1)
         enddo 
        enddo 
      enddo 
      where (vlen/=0) a=a/vlen
      call border_exchg_merid(ny,nz,a,1)
      do j=js,je 
        do k=2,nz-1
         T4v(j,k)=T4v(j,k)+(a(j,k)+a(j,k-1)+a(j-1,k)+a(j-1,k-1))/4.0
        enddo 
      enddo 
      T4u=T4u+T4v
      where (blen==0); T4u=spval; end where
      where (blen==0); T4v=spval; end where
!-----------------------------------------------------------------------
!        Dissipation of EKE:  M'_u**2   M'_v**2
!-----------------------------------------------------------------------
      eps_kh = 0.
      if (enable_biharmonic_friction) then
        do j=js,je 
         do k=2,nz-1
          do i=2,nx -1
            us(i,j,k)=(u(i,j,k,tau)-um(j,k))*maskU(i,j,k)
          enddo 
         enddo 
        enddo 
        call border_exchg3D(nx,ny,nz,us,1); call setcyclic3D(nx,ny,nz,us)
        call biha_diss_u(us,del2)
        eps_u=0.0;
        do j=js,je 
         do k=2,nz-1
          do i=2,nx -1
           eps_u(j,k)=eps_u(j,k)+dx*del2(i,j,k)**2*maskU(i,j,k)
          enddo 
         enddo 
        enddo 
        do j=js,je 
         do k=2,nz-1
          do i=2,nx -1
            us(i,j,k)=(v(i,j,k,tau)-vm(j,k))*maskV(i,j,k)
          enddo 
         enddo 
        enddo 
        call border_exchg3D(nx,ny,nz,us,1); call setcyclic3D(nx,ny,nz,us)
        call biha_diss_v(us,del2)
        eps_v=0.0;
        do j=js,je 
         do k=2,nz-1
          do i=2,nx -1
           eps_v(j,k)=eps_v(j,k)+dx*del2(i,j,k)**2*maskV(i,j,k)
          enddo 
         enddo 
        enddo 
        call border_exchg_merid(ny,nz,eps_v,1)
        eps_kh=0
        do j=js,je 
         do k=2,nz-1
          eps_kh(j,k)=eps_u(j,k)+0.5*(eps_v(j,k)+eps_v(j-1,k))
         enddo 
        enddo 
      endif

!        add here dissipation by harmonic friction

      where (blen/=0); eps_kh=eps_kh/blen; 
      elsewhere; eps_kh=spval; end where
!-----------------------------------------------------------------------
!        Dissipation of EKE:  A_v (u'_z)**2  +A_v (v'_z)**2 
!-----------------------------------------------------------------------
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
           us(i,j,k)=(u(i,j,k,tau)-um(j,k))*maskU(i,j,k)
         enddo 
        enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,us,1); call setcyclic3D(nx,ny,nz,us)
      eps_u=0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          eps_u(j,k)=eps_u(j,k)+dx*A_v*( 0.5*(us(i,j,k+1)-us(i,j,k  ))/dz*maskW(i,j,k  )   &
           +0.5*(us(i,j,k  )-us(i,j,k-1))/dz*maskW(i,j,k-1)    )**2         
         enddo 
        enddo 
      enddo 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
           us(i,j,k)=(v(i,j,k,tau)-vm(j,k))*maskV(i,j,k)
         enddo 
        enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,us,1); call setcyclic3D(nx,ny,nz,us)
      eps_v=0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          eps_v(j,k)=eps_v(j,k)+dx*A_v*( 0.5*(us(i,j,k+1)-us(i,j,k  ))/dz*maskW(i,j,k  )   &
           +0.5*(us(i,j,k  )-us(i,j,k-1))/dz*maskW(i,j,k-1)   )**2         
         enddo 
        enddo 
      enddo 
      call border_exchg_merid(ny,nz,eps_v,1)
      eps_kv=0
      do j=js,je 
        do k=2,nz-1
         eps_kv(j,k)=eps_u(j,k)+0.5*(eps_v(j,k)+eps_v(j-1,k))
        enddo 
      enddo 
!
!        Dissipation of EKE by bottom stress
!
      if (enable_bottom_stress) then
        eps_u=0.;eps_v=0.
        do j=js,je 
         do i=2,nx -1
          k=max(1,k_bottom_u(i,j))
          eps_u(j,k)=eps_u(j,k)    +dx*cdbot*(u(i,j,k,tau)-um(j,k))**2*masku(i,j,k)
          k=max(1,k_bottom_v(i,j))
          eps_v(j,k)=eps_v(j,k)   +dx*cdbot*(v(i,j,k,tau)-vm(j,k))**2*maskV(i,j,k)
         enddo
        enddo
        do j=js,je 
         do k=2,nz-1
          eps_kv(j,k)=eps_kv(j,k)    +eps_u(j,k)+0.5*(eps_v(j,k)+eps_v(j-1,k))
         enddo 
        enddo 
      endif
!
!        Dissipation of EKE by interior stress
!
      if (enable_interior_stress) then
        eps_u=0.;eps_v=0.
        do k=2,nz-1
         do j=js,je 
          do i=2,nx -1
           eps_u(j,k)=eps_u(j,k)   +dx*cdint*(u(i,j,k,tau)-um(j,k))**2*masku(i,j,k)
           eps_v(j,k)=eps_v(j,k)   +dx*cdint*(v(i,j,k,tau)-vm(j,k))**2*maskV(i,j,k)
          enddo
         enddo
        enddo
        do k=2,nz-1
         do j=js,je 
           eps_kv(j,k)=eps_kv(j,k)+     eps_u(j,k)+0.5*(eps_v(j,k)+eps_v(j-1,k))
         enddo 
        enddo 
      endif

      where (blen/=0); eps_kv=eps_kv/blen; 
      elsewhere; eps_kv=spval; end where
!-----------------------------------------------------------------------
!        Dissipation of EPE:  K_v (b'_z)**2 /N**2 +  M'_b**2
!-----------------------------------------------------------------------
      eps_b=0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          eps_b(j,k)=eps_b(j,k)+dx/N_0**2*( +0.5*(K_v+K_b(i,j,k  ))   &
             *(bss(i,j,k+1)-bss(i,j,k))/dz *(b(i,j,k+1,tau)-b(i,j,k,tau))/dz*maskW(i,j,k)    &
           +0.5*(K_v+K_b(i,j,k-1)) *(bss(i,j,k)-bss(i,j,k-1))/dz   &
             *(b(i,j,k,tau)-b(i,j,k-1,tau))/dz*maskW(i,j,k-1)     )
!     &       (K_v+0.5*(K_b(i,j,k)+K_b(i,j,k-1)) )
!     &        *( (b(i,j,k+1,tau)-b(i,j,k-1,tau))/(2*dz) )**2
         enddo 
        enddo 
      enddo 
      if (enable_biharmonic_diffusion) then
        call biha_diss_b(bss,del2)
        do j=js,je 
         do k=2,nz-1
          do i=2,nx -1
           eps_b(j,k)=eps_b(j,k)+dx/N_0**2*del2(i,j,k)**2*maskT(i,j,k)
          enddo 
         enddo 
        enddo 
      endif
      where (blen/=0); eps_b=eps_b/blen; 
      elsewhere; eps_b=spval; end where
!-----------------------------------------------------------------------
!        Dissipation of EPE due to buffer zones
!-----------------------------------------------------------------------
      rest =0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          rest (j,k)=rest (j,k)+dx/N_0**2*( bss(i,j,k)*b(i,j,k,tau)*t_rest(j)*maskT(i,j,k)  )
         enddo 
        enddo 
      enddo 
      where (blen/=0); rest =rest /blen; 
      elsewhere; rest =spval; end where

      restm =0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          restm(j,k)=restm(j,k)+dx/N_0**2*(  bms(j,k)*b(i,j,k,tau)*t_rest(j)*maskT(i,j,k)  )
         enddo 
        enddo 
      enddo 
      where (blen/=0); restm=restm/blen; 
      elsewhere; restm=spval; end where
!-----------------------------------------------------------------------
!        EKE radiation  vp wp
!-----------------------------------------------------------------------
      vps=0.0; wps=0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          vps(j,k)=vps(j,k)+dx*( ( v(i,j,k,tau)-vm(j,k) )*  &
             0.5*(p_full(i,j,k,tau)+p_full(i,j+1,k,tau))*maskV(i,j,k)     )
          wps(j,k)=wps(j,k)+dx*( ( w(i,j,k,tau)-wm(j,k) )*  &
             0.5*(p_full(i,j,k,tau)+p_full(i,j,k+1,tau))*maskW(i,j,k)     )
         enddo 
        enddo 
      enddo 
      where (vlen/=0); vps  =vps  /vlen; 
      elsewhere; vps  =spval; end where
      where (wlen/=0); wps  =wps  /wlen; 
      elsewhere; wps  =spval; end where
!-----------------------------------------------------------------------
!        EKE advection
!-----------------------------------------------------------------------
      del2=0 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
           del2(i,j,k)= ( 0.5*((u(i  ,j,k,tau)-um(j  ,k))*maskU(i  ,j,k)   &
                  +(u(i-1,j,k,tau)-um(j  ,k))*maskU(i-1,j,k) ) )**2/2   &
           +( 0.5*((v(i,j-1,k,tau)-vm(j-1,k))*maskV(i,j-1,k)   &
                  +(v(i,j-1,k,tau)-vm(j  ,k))*maskV(i,j  ,k) ) )**2/2
         enddo 
        enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,del2,1); call setcyclic3D(nx,ny,nz,del2)

      veke=0.0; weke=0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          veke(j,k)=veke(j,k)+dx*(v(i,j,k,tau)*maskV(i,j,k)*   &
             0.5*(del2(i,j,k)+del2(i,j+1,k))*maskV(i,j,k)     )
          weke(j,k)=weke(j,k)+dx*(  w(i,j,k,tau)*maskW(i,j,k)*  &
             0.5*(del2(i,j,k)+del2(i,j,k+1))*maskW(i,j,k)         )
         enddo 
        enddo 
      enddo 
      where (vlen/=0); veke =veke /vlen; 
      elsewhere; veke =spval; end where
      where (wlen/=0); weke =weke /wlen; 
      elsewhere; weke =spval; end where
!-----------------------------------------------------------------------
!        EPE advection
!-----------------------------------------------------------------------
      del2=0 
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
           del2(i,j,k)= bss(i,j,k)**2/2/N_0**2
         enddo 
        enddo 
      enddo 
      call border_exchg3D(nx,ny,nz,del2,1); call setcyclic3D(nx,ny,nz,del2)

      vepe=0.0; wepe=0.0;
      do j=js,je 
        do k=2,nz-1
         do i=2,nx -1
          vepe(j,k)=vepe(j,k)+dx*(  v(i,j,k,tau)*maskV(i,j,k)*   &
             0.5*(del2(i,j,k)+del2(i,j+1,k))*maskV(i,j,k)                     )
          wepe(j,k)=wepe(j,k)+dx*( w(i,j,k,tau)*maskW(i,j,k)*   &
             0.5*(del2(i,j,k)+del2(i,j,k+1))*maskW(i,j,k)          )
         enddo 
        enddo 
      enddo 
      where (vlen/=0); vepe =vepe /vlen; 
      elsewhere; vepe =spval; end where
      where (wlen/=0); wepe =wepe /wlen; 
      elsewhere; wepe =spval; end where
 end subroutine zonal_averages_energy




 subroutine biha_diss_b(var,del2)
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      real*8 :: var(nx ,ny ,nz) 
      real*8 :: diff_fe(nx ,ny ,nz), diff_fn(nx ,ny ,nz) 
      real*8 :: del2(nx ,ny ,nz),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,ny -1)
      diffx = sqrt(abs(Khbi)); diff_fe=0.0;diff_fn=0.0
      do k=1,nz
       do j=js,je
        do i=1,nx -1
         diff_fe(i,j,k)=diffx*(var(i+1,j,k)-var(i,j,k))/dx     *maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,diff_fe,1); call setcyclic3D(nx,ny,nz,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=1,nx 
         diff_fn(i,j,k)=diffx*(var(i,j+1,k)-var(i,j,k))/dx       *maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,diff_fn,1); call setcyclic3D(nx,ny,nz,diff_fn)
      del2=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,del2,1); call setcyclic3D(nx,ny,nz,del2)
  end subroutine biha_diss_b




 subroutine biha_diss_u (var,del2)
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      real*8 :: var(nx ,ny ,nz) 
      real*8 :: diff_fe(nx ,ny ,nz), diff_fn(nx ,ny ,nz) 
      real*8 :: del2(nx ,ny ,nz),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k) = (diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k) = (diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,ny -1)
      diffx = sqrt(abs(ahbi)); diff_fe=0.0;diff_fn=0.0
      do k=1,nz
       do j=js,je
        do i=1,nx -1
         diff_fe(i,j,k)=diffx*(var(i+1,j,k)-var(i,j,k))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,diff_fe,1); call setcyclic3D(nx,ny,nz,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=1,nx 
         diff_fn(i,j,k)=diffx*(var(i,j+1,k)-var(i,j,k))/dx     *maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js-1,je
         diff_fn(:,j,:)=diff_fn(:,j,:)-2*diffx*var(:,j,:)/dx *(1-maskU(:,j+1,:))*maskU(:,j,:)   &
                                      +2*diffx*var(:,j+1,:)/dx *(1-maskU(:,j,:))*maskU(:,j+1,:)
       enddo
      endif
      call border_exchg3D(nx,ny,nz,diff_fn,1); call setcyclic3D(nx,ny,nz,diff_fn)
      del2=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,del2,1); call setcyclic3D(nx,ny,nz,del2)
 end subroutine biha_diss_u




 subroutine biha_diss_v (var,del2)
      use pyOM_module   
      implicit none
      integer :: i,j,k,js,je
      real*8 :: var(nx ,ny ,nz) 
      real*8 :: diff_fe(nx ,ny ,nz), diff_fn(nx ,ny ,nz) 
      real*8 :: del2(nx ,ny ,nz),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,ny -1)
      diffx = sqrt(abs(ahbi)); diff_fe=0.0;diff_fn=0.0
      do k=1,nz
       do j=js,je
        do i=1,nx -1
         diff_fe(i,j,k)=diffx*(var(i+1,j,k)-var(i,j,k))/dx  *maskV(i,j,k)*maskV(i+1,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do i=1,nx -1
         diff_fe(i,:,:)=diff_fe(i,:,:)-2*diffx*var(i,:,:)/dx    *(1-maskV(i+1,:,:))*maskV(i,:,:)  &
                                      +2*diffx*var(i+1,:,:)/dx  *(1-maskV(i,:,:))*maskV(i+1,:,:)
       enddo
      endif
      call border_exchg3D(nx,ny,nz,diff_fe,1); call setcyclic3D(nx,ny,nz,diff_fe)
      do k=1,nz-1
       do j=js,je
        do i=1,nx 
         diff_fn(i,j,k)=diffx*(var(i,j+1,k)-var(i,j,k))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,diff_fn,1); call setcyclic3D(nx,ny,nz,diff_fn)
      del2=0.0
      do k=2,nz-1
       do j=js,je
        do i=2,nx -1
         del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(nx,ny,nz,del2,1); call setcyclic3D(nx,ny,nz,del2)
 end subroutine biha_diss_v

    

!=======================================================================
!      account for static instabilities
!=======================================================================

 subroutine convection(ierr)
   use pyOM_module   
   implicit none
   integer, intent(out) :: ierr
   integer :: i,j,k,js,je

   ierr = 0
   js=max(2,js_pe); je = min(je_pe,ny-1)
   K_b(:,js:je,:) = 0.0

   if (enable_back_state) then
    do j=js,je
      do k=1,nz-1
        do i=2,nx
           if ( b(i,j,k+1,taum1)+back(i,j,k+1,taum1) >  &
                b(i,j,k   ,taum1) +back(i,j,k,taum1) )   K_b(i,j,k)=1000.*maskW(i,j,k)
        enddo
      enddo
    enddo
    b(:,js:je,:,taup1) = b(:,js:je,:,taup1) + back(:,js:je,:,taup1)
    call implicit_tracer_mix(nx,ny,nz,b,K_b)
    b(:,js:je,:,taup1) = b(:,js:je,:,taup1) - back(:,js:je,:,taup1)
   else
    do j=js,je
      do k=1,nz-1
        do i=2,nx
         if (b(i,j,k+1,taum1) > b(i,j,k,taum1)) K_b(i,j,k)=1000.*maskW(i,j,k)
        enddo
      enddo
    enddo
    call implicit_tracer_mix(nx,ny,nz,b,K_b)
   endif

 end subroutine convection


 subroutine implicit_tracer_mix(nx_,ny_,nz_,var,K_vert)
   !   T_n+1 = T_n+1(1 + c2dt* (K (T_n+1)_z )_z )
   use pyOM_module   
   implicit none
   integer :: nx_,ny_,nz_
   integer :: j,k,js,je
   real*8 :: var(nx_,ny_,nz_,3),K_vert(nx_,ny_,nz_)
   real*8 :: a(nx,nz),bb(nx,nz),c(nx,nz),bet(nx)
   real*8 :: pu(nx,nz),gam(nx,nz),fxa, r(nx,nz)

      js=max(2,js_pe); je = min(je_pe,ny-1)
      fxa = c2dt/dz**2

      do j=js,je
       bb(:,1) = 1+fxa*K_vert(:,j,1)
       c(:,1)  =  -fxa*K_vert(:,j,1)
       do k=2,nz-1
        a(:,k)  =  -fxa *   K_vert(:,j,k-1)
        bb(:,k) = 1+fxa * ( K_vert(:,j,k)+K_vert(:,j,k-1) )
        c(:,k)  =  -fxa *   K_vert(:,j,k)
       enddo
       a(:,nz)  =  -fxa * K_vert(:,j,nz-1)
       bb(:,nz) = 1+fxa * K_vert(:,j,nz-1) 

       pu=0.0;gam=0.0
       r=var(:,j,:,taup1)
       r(:,nz-1)=r(:,nz-1) !  +aidif_tracer*surface_flux(:,j)*c2dt/dz
       bet=bb(:,1)
       where (bet/=0.0) pu(:,1)=r(:,1)/bet
       do k=2,nz
        where (bet/=0.0) gam(:,k)=c(:,k-1)/bet
        bet=bb(:,k)-a(:,k)*gam(:,k)
        where(bet/=0.0) pu(:,k)=(r(:,k)-a(:,k)*pu(:,k-1))/bet
       enddo
       do k=nz-1,1,-1
        pu(:,k)=pu(:,k)-gam(:,k+1)*pu(:,k+1)
       enddo
       var(:,j,:,taup1)=pu
      enddo
  end subroutine implicit_tracer_mix

!=======================================================================
!     Templates for setup
!     Exp. Disturb in Olbers and Eden, JPO, 2003
!     Long Rossby wave propagation
!=======================================================================

subroutine set_parameter
 ! ----------------------------------
 !       set here main parameter
 ! ----------------------------------
 use pyOM_module
 use fcontrol_module
 implicit none
 nx=20;nz=12;ny=20
 dx=2.0*60*1852.0
 dz=500.0
 dt=3600.0*2
 K_h=00.0
 K_v=1.e-4
 A_h=2e3
 A_v=1.e-3
 eps2D_sor = 1e-12
 enable_noslip               = .true.
 enable_hydrostatic          = .true.
 enable_quicker_advection    = .true.
 enable_quicker_mom_advection= .true.
 enable_back_state           = .true.
 runlen=10*365.0*86400.
 snapint = 5.0*86400.
end subroutine set_parameter


subroutine set_coriolis
   use pyOM_module   
   implicit none
   integer :: j
   real*8,parameter :: pi=3.1415   
   real*8,parameter :: radius  = 6370.0e3   ! earth radius
   real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
   real*8,parameter :: phi0 = 30.0 /180. *pi
   do j=1,ny
    coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
   enddo
end subroutine set_coriolis

subroutine initial_conditions
 use pyOM_module
 implicit none
 integer :: i,j,k
 real*8 :: x,y,B0,N_0
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
  N_0     = 2.6e-3
  do k=1,nz
    do j=1,ny
       do i=1,nx
         back(i,j,k,:) = -N_0**2*zt(k)*maskT(i,j,k)
         x=(float(i)/float(nx)-0.5)*2.
         y=(float(j)/float(ny)-0.5)*2.
         B0 = 1e-5*exp(-(x-0.6)**2*10.)*exp(-(y)**2*10.) *exp(-(zt(nz)-zt(k))/500. )
         b(i,j,k,:) = B0*maskT(i,j,k)
       enddo
   enddo
 enddo
end subroutine initial_conditions

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine boundary_conditions
end subroutine boundary_conditions

subroutine topography
end subroutine topography

subroutine tracer_sources
end subroutine tracer_sources

!=======================================================================
!  idealised Southern Ocean, channel with prescribed stratification
!======================================================================= 


module config_module
 ! use this module only locally in this file
 implicit none
 real*8,parameter :: hRESOLVE = 2.0   ! 1 in original model
 real*8,parameter :: vRESOLVE = 2.0   ! 1 in original model
 real*8,parameter :: pi      = 3.14159265358979323846264338327950588
 real*8,parameter :: omega   = pi/43082.0 ! earth rotation freq. in 1/s
 real*8,parameter :: radius  = 6370.0e3

 real*8 :: N_0     = 0.002
 real*8 :: tau0 = 0.02,  K0gm = 2000.0, h0 = 0.25
end module config_module


subroutine set_parameter
 ! ----------------------------------
 !       set here main parameter
 ! ----------------------------------
 use pyOM_module   
 use fcontrol_module
 use config_module
 implicit none
 namelist /acc_wind/ N_0,tau0,K0gm,h0

      open(10,file='namelist',form='formatted',status='old')
      read(10, nml = acc_wind )
      close(10)
      if (my_pe==0) write(6, nml=acc_wind)
  
      nx   = 31*hRESOLVE
      nz   = 40*vRESOLVE
      ny   = 16*hRESOLVE
      dx    = 80e3/hRESOLVE
      dz    = 100.0/vRESOLVE
      dt    = 12e3/hRESOLVE

      K_h=0000.0 
      A_h=2000.0/hRESOLVE

      K_v=10e-4/vRESOLVE
      A_v=10e-4/vRESOLVE

      eps2D_sor = 1e-9

      !enable_noslip               = .true.
      enable_bottom_noslip        = .true.
      enable_cyclic_x             = .true.
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .true.  

      enable_bolus_velocity  = .true. 
      K_gm=K0gm
      runlen = 365*86400.*20   
      snapint =  365./12.*86400.     

      enable_back_state = .true.
      enable_diag_barbi = .true.

end subroutine set_parameter


subroutine set_coriolis
 use pyOM_module   
 use config_module   
 implicit none
 integer :: j
 real*8:: phi0 
 phi0 = 50.0 /180. *pi
 do j=1,ny
      coriolis_t(j) = 2*omega*sin(phi0) + 2*omega*cos(phi0)/radius*yt(j)
 enddo
end subroutine set_coriolis


subroutine initial_conditions
 ! ----------------------------------
 !      add here initial conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: i,j,k
 back=0.
 do k=1,nz
    back(:,:,k,1)=(back(:,:,k,1)-N_0**2*zt(k))*maskT(:,:,k)
 enddo
 back(:,:,:,2)=back(:,:,:,1)
 back(:,:,:,3)=back(:,:,:,1)
end subroutine initial_conditions



subroutine boundary_conditions
 ! ----------------------------------
 !    add here boundary conditions
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: i,j
 real*8 :: L_y,y,t_rest,bstar
 L_y = yt(ny )-yt(1)
 do j=1,ny 
   do i=1,nx 
    y = yu(j)/L_y
    surface_taux(i,j) = tau0*1e-3*sin(pi*y)*maskU(i,j,nz-1)
   enddo
 enddo
end subroutine boundary_conditions

subroutine topography
 ! ----------------------------------
 !      Add here topography  
 ! ----------------------------------
 use pyOM_module   
 use config_module   
 implicit none
 integer :: i,j,k
 real*8 :: L_x
 L_x = xt(nx-1 )-xt(2)
 do j=1,ny 
   do i=1,nx 
     k=  nint(nz*h0*(1 + sin(4*pi*xt(i)/L_x))/2.0 )+1
     k=min(nz,max(1,k))
     maskT(i,j,1:k) = 0.0
   enddo
 enddo
end subroutine topography

subroutine restoring_zones
end subroutine restoring_zones

subroutine momentum_restoring_zones
end subroutine momentum_restoring_zones

subroutine tracer_sources
end subroutine tracer_sources
